/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/network","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/process","fs","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/platform/extensions/common/extensions","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/codicons","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/performance","vs/editor/common/core/range","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/assert","vs/base/common/decorators","path","net","vs/editor/common/core/position","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/server/node/extensionHostConnection","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","http","yauzl","yazl","zlib","vs/server/node/server.main"],ve=function(oe){for(var e=[],b=0,t=oe.length;b<t;b++)e[b]=pe[oe[b]];return e};define(pe[132],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class b{static get(){const D=new Map,C=new Map,k=new Map,E=new Map;function p(v,h){v.has(h.detail)||v.set(h.detail,-h.timestamp)}function S(v,h){const I=v.get(h.detail);!I||I>=0||v.set(h.detail,I+h.timestamp)}const T=oe.getStats().slice(0).sort((v,h)=>v.timestamp-h.timestamp);for(const v of T)switch(v.type){case 10:p(D,v);break;case 11:case 12:S(D,v);break;case 21:p(C,v);break;case 22:S(C,v);break;case 33:p(k,v);break;case 34:S(k,v);break;case 31:p(E,v);break;case 32:S(E,v);break}let R=0;k.forEach(v=>R+=v);function w(v){const h=[];return v.forEach((I,y)=>h.push([y,I])),h}return{amdLoad:w(D),amdInvoke:w(C),nodeRequire:w(k),nodeEval:w(E),nodeRequireTotal:R}}static toMarkdownTable(D,C){let k="";const E=[];return D.forEach((p,S)=>{E[S]=p.length}),C.forEach(p=>{p.forEach((S,T)=>{typeof S=="undefined"&&(S=p[T]="-");const R=S.toString().length;E[T]=Math.max(R,E[T])})}),D.forEach((p,S)=>{k+=`| ${p+" ".repeat(E[S]-p.toString().length)} `}),k+=`|
`,D.forEach((p,S)=>{k+=`| ${"-".repeat(E[S])} `}),k+=`|
`,C.forEach(p=>{p.forEach((S,T)=>{typeof S!="undefined"&&(k+=`| ${S+" ".repeat(E[T]-S.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=b}),define(pe[82],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function b(D,C){if(!D)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=b;function t(D,C="Unreachable"){throw new Error(C)}e.assertNever=t}),define(pe[40],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function b(k){return k?k.replace(/\$\((.*?)\)/g,(E,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=b;class t{constructor(E,p,S){this.id=E,this.definition=p,this.description=S,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(k,E){const p=["codicon","codicon-"+k];return E&&p.push("codicon-modifier-"+E),p}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function p(R){if(R instanceof t)return["codicon","codicon-"+R.id];const w=E.exec(R.id);if(!w)return p(t.error);const[,v,h]=w,I=["codicon","codicon-"+v];return h&&I.push("codicon-modifier-"+h.substr(1)),I}k.asClassNameArray=p;function S(R){return p(R).join(" ")}k.asClassName=S;function T(R){return"."+p(R).join(".")}k.asCSSSelector=T})(C=e.CSSIcon||(e.CSSIcon={}))}),define(pe[83],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(k){return(E,p,S)=>{let T=null,R=null;if(typeof S.value=="function"?(T="value",R=S.value):typeof S.get=="function"&&(T="get",R=S.get),!R)throw new Error("not supported");S[T]=k(R,p)}}e.createDecorator=b;function t(k,E,p){let S=null,T=null;if(typeof p.value=="function"?(S="value",T=p.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",T=p.get),!T)throw new Error("not supported");const R=`$memoize$${E}`;p[S]=function(...w){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,w)}),this[R]}}e.memoize=t;function D(k,E,p){return b((S,T)=>{const R=`$debounce$${T}`,w=`$debounce$result$${T}`;return function(...v){this[w]||(this[w]=p?p():void 0),clearTimeout(this[R]),E&&(this[w]=E(this[w],...v),v=[this[w]]),this[R]=setTimeout(()=>{S.apply(this,v),this[w]=p?p():void 0},k)}})}e.debounce=D;function C(k,E,p){return b((S,T)=>{const R=`$throttle$timer$${T}`,w=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,h=`$throttle$pending$${T}`;return function(...I){if(this[w]||(this[w]=p?p():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),E&&(this[w]=E(this[w],...I)),this[h])return;const y=this[v]+k;y<=Date.now()?(this[v]=Date.now(),S.apply(this,[this[w]]),this[w]=p?p():void 0):(this[h]=!0,this[R]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),S.apply(this,[this[w]]),this[w]=p?p():void 0},y-Date.now()))}})}e.throttle=C}),define(pe[11],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?u.isErrorNoTelemetry(r)?new u(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=b,e.errorHandler=new b;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function D(f){p(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function C(f){p(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=C;function k(f){if(f instanceof Error){const{name:r,message:o}=f,n=f.stacktrace||f.stack;return{$isError:!0,name:r,message:o,stack:n,noTelemetry:u.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=k;const E="Canceled";function p(f){return f instanceof S?!0:f instanceof Error&&f.name===E&&f.message===E}e.isCancellationError=p;class S extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=S;function T(){const f=new Error(E);return f.name=f.message,f}e.canceled=T;function R(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=R;function w(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=w;function v(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(f){const r=new Error(`${f} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function I(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=I;class y extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=y;class d extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=d;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class u extends Error{constructor(r){super(r);this.name="CodeExpectedError"}static fromError(r){if(r instanceof u)return r;const o=new u;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class l extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(pe[18],ve([0,1,11]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,Z=0){return j[j.length-(1+Z)]}e.tail=t;function D(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=D;function C(j,Z,ne=(z,V)=>z===V){if(j===Z)return!0;if(!j||!Z||j.length!==Z.length)return!1;for(let z=0,V=j.length;z<V;z++)if(!ne(j[z],Z[z]))return!1;return!0}e.equals=C;function k(j,Z){const ne=j.length-1;Z<ne&&(j[Z]=j[ne]),j.pop()}e.removeFastWithoutKeepingOrder=k;function E(j,Z,ne){return p(j.length,z=>ne(j[z],Z))}e.binarySearch=E;function p(j,Z){let ne=0,z=j-1;for(;ne<=z;){const V=(ne+z)/2|0,$=Z(V);if($<0)ne=V+1;else if($>0)z=V-1;else return V}return-(ne+1)}e.binarySearch2=p;function S(j,Z){let ne=0,z=j.length;if(z===0)return 0;for(;ne<z;){const V=Math.floor((ne+z)/2);Z(j[V])?z=V:ne=V+1}return ne}e.findFirstInSorted=S;function T(j,Z,ne){if(j=j|0,j>=Z.length)throw new TypeError("invalid index");const z=Z[Math.floor(Z.length*Math.random())],V=[],$=[],x=[];for(const le of Z){const ge=ne(le,z);ge<0?V.push(le):ge>0?$.push(le):x.push(le)}return j<V.length?T(j,V,ne):j<V.length+x.length?x[0]:T(j-(V.length+x.length),$,ne)}e.quickSelect=T;function R(j,Z){const ne=[];let z;for(const V of j.slice(0).sort(Z))!z||Z(z[0],V)!==0?(z=[V],ne.push(z)):z.push(V);return ne}e.groupBy=R;function w(j,Z,ne){const z=[];function V(le,ge,Pe){if(ge===0&&Pe.length===0)return;const ke=z[z.length-1];ke&&ke.start+ke.deleteCount===le?(ke.deleteCount+=ge,ke.toInsert.push(...Pe)):z.push({start:le,deleteCount:ge,toInsert:Pe})}let $=0,x=0;for(;;){if($===j.length){V($,0,Z.slice(x));break}if(x===Z.length){V($,j.length-$,[]);break}const le=j[$],ge=Z[x],Pe=ne(le,ge);Pe===0?($+=1,x+=1):Pe<0?(V($,1,[]),$+=1):Pe>0&&(V($,0,[ge]),x+=1)}return z}e.sortedDiff=w;function v(j,Z,ne){const z=w(j,Z,ne),V=[],$=[];for(const x of z)V.push(...j.slice(x.start,x.start+x.deleteCount)),$.push(...x.toInsert);return{removed:V,added:$}}e.delta=v;function h(j,Z,ne){if(ne===0)return[];const z=j.slice(0,ne).sort(Z);return y(j,Z,z,ne,j.length),z}e.top=h;function I(j,Z,ne,z,V){return ne===0?Promise.resolve([]):new Promise(($,x)=>{(async()=>{const le=j.length,ge=j.slice(0,ne).sort(Z);for(let Pe=ne,ke=Math.min(ne+z,le);Pe<le;Pe=ke,ke=Math.min(ke+z,le)){if(Pe>ne&&await new Promise(Me=>setTimeout(Me)),V&&V.isCancellationRequested)throw new b.CancellationError;y(j,Z,ge,Pe,ke)}return ge})().then($,x)})}e.topAsync=I;function y(j,Z,ne,z,V){for(const $=ne.length;z<V;z++){const x=j[z];if(Z(x,ne[$-1])<0){ne.pop();const le=S(ne,ge=>Z(x,ge)<0);ne.splice(le,0,x)}}}function d(j){return j.filter(Z=>!!Z)}e.coalesce=d;function g(j){let Z=0;for(let ne=0;ne<j.length;ne++)j[ne]&&(j[Z]=j[ne],Z+=1);j.length=Z}e.coalesceInPlace=g;function u(j,Z,ne){j.splice(ne,0,j.splice(Z,1)[0])}e.move=u;function l(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=l;function f(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=f;function r(j,Z=ne=>ne){const ne=new Set;return j.filter(z=>{const V=Z(z);return ne.has(V)?!1:(ne.add(V),!0)})}e.distinct=r;function o(j){const Z=new Set;return ne=>{const z=j(ne);return Z.has(z)?!1:(Z.add(z),!0)}}e.uniqueFilter=o;function n(j,Z){const ne=i(j,Z);if(ne!==-1)return j[ne]}e.findLast=n;function i(j,Z){for(let ne=j.length-1;ne>=0;ne--){const z=j[ne];if(Z(z))return ne}return-1}e.lastIndex=i;function s(j,Z){return j.length>0?j[0]:Z}e.firstOrDefault=s;function a(j,Z){return j.length>0?j[j.length-1]:Z}e.lastOrDefault=a;function c(j,Z,ne=(z,V)=>z===V){let z=0;for(let V=0,$=Math.min(j.length,Z.length);V<$&&ne(j[V],Z[V]);V++)z++;return z}e.commonPrefixLength=c;function m(j){return[].concat(...j)}e.flatten=m;function P(j,Z){let ne=typeof Z=="number"?j:0;typeof Z=="number"?ne=j:(ne=0,Z=j);const z=[];if(ne<=Z)for(let V=ne;V<Z;V++)z.push(V);else for(let V=ne;V>Z;V--)z.push(V);return z}e.range=P;function _(j,Z,ne){return j.reduce((z,V)=>(z[Z(V)]=ne?ne(V):V,z),Object.create(null))}e.index=_;function W(j,Z){return j.push(Z),()=>K(j,Z)}e.insert=W;function K(j,Z){const ne=j.indexOf(Z);if(ne>-1)return j.splice(ne,1),Z}e.remove=K;function se(j,Z,ne){const z=j.slice(0,Z),V=j.slice(Z);return z.concat(ne,V)}e.arrayInsert=se;function F(j,Z){let ne;if(typeof Z=="number"){let z=Z;ne=()=>{const V=Math.sin(z++)*179426549;return V-Math.floor(V)}}else ne=Math.random;for(let z=j.length-1;z>0;z-=1){const V=Math.floor(ne()*(z+1)),$=j[z];j[z]=j[V],j[V]=$}}e.shuffle=F;function Q(j,Z){const ne=j.indexOf(Z);ne>-1&&(j.splice(ne,1),j.unshift(Z))}e.pushToStart=Q;function re(j,Z){const ne=j.indexOf(Z);ne>-1&&(j.splice(ne,1),j.push(Z))}e.pushToEnd=re;function G(j,Z){for(const ne of Z)j.push(ne)}e.pushMany=G;function de(j,Z){return Array.isArray(j)?j.map(Z):Z(j)}e.mapArrayOrNot=de;function J(j){return Array.isArray(j)?j:[j]}e.asArray=J;function U(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=U;function O(j,Z){for(const ne of j){const z=Z(ne);if(z!==void 0)return z}}e.mapFind=O;function B(j,Z,ne){const z=ce(j,Z),V=j.length,$=ne.length;j.length=V+$;for(let x=V-1;x>=z;x--)j[x+$]=j[x];for(let x=0;x<$;x++)j[x+z]=ne[x]}e.insertInto=B;function X(j,Z,ne,z){const V=ce(j,Z),$=j.splice(V,ne);return B(j,V,z),$}e.splice=X;function ce(j,Z){return Z<0?Math.max(Z+j.length,0):Math.min(Z,j.length)}var ue;(function(j){function Z(V){return V<0}j.isLessThan=Z;function ne(V){return V>0}j.isGreaterThan=ne;function z(V){return V===0}j.isNeitherLessOrGreaterThan=z,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ue=e.CompareResult||(e.CompareResult={}));function Y(j,Z){return(ne,z)=>Z(j(ne),j(z))}e.compareBy=Y;function ie(...j){return(Z,ne)=>{for(const z of j){const V=z(Z,ne);if(!ue.isNeitherLessOrGreaterThan(V))return V}return ue.neitherLessOrGreaterThan}}e.tieBreakComparators=ie;const L=(j,Z)=>j-Z;e.numberComparator=L;function N(j,Z){if(j.length===0)return;let ne=j[0];for(let z=1;z<j.length;z++){const V=j[z];Z(V,ne)>0&&(ne=V)}return ne}e.findMaxBy=N;function q(j,Z){if(j.length===0)return;let ne=j[0];for(let z=1;z<j.length;z++){const V=j[z];Z(V,ne)>=0&&(ne=V)}return ne}e.findLastMaxBy=q;function te(j,Z){return N(j,(ne,z)=>-Z(ne,z))}e.findMinBy=te;class fe{constructor(Z){this.items=Z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Z){let ne=this.firstIdx;for(;ne<this.items.length&&Z(this.items[ne]);)ne++;const z=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,z}takeFromEndWhile(Z){let ne=this.lastIdx;for(;ne>=0&&Z(this.items[ne]);)ne--;const z=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Z=this.items[this.firstIdx];return this.firstIdx++,Z}removeLast(){const Z=this.items[this.lastIdx];return this.lastIdx--,Z}takeCount(Z){const ne=this.items.slice(this.firstIdx,this.firstIdx+Z);return this.firstIdx+=Z,ne}}e.ArrayQueue=fe;class ye{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(ne=>(Z(ne),!0))}toArray(){const Z=[];return this.iterate(ne=>(Z.push(ne),!0)),Z}filter(Z){return new ye(ne=>this.iterate(z=>Z(z)?ne(z):!0))}map(Z){return new ye(ne=>this.iterate(z=>ne(Z(z))))}some(Z){let ne=!1;return this.iterate(z=>(ne=Z(z),!ne)),ne}findFirst(Z){let ne;return this.iterate(z=>Z(z)?(ne=z,!1):!0),ne}findLast(Z){let ne;return this.iterate(z=>(Z(z)&&(ne=z),!0)),ne}findLastMaxBy(Z){let ne,z=!0;return this.iterate(V=>((z||ue.isGreaterThan(Z(V,ne)))&&(z=!1,ne=V),!0)),ne}}e.CallbackIterable=ye,ye.empty=new ye(j=>{})}),define(pe[64],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(t){const D=this;let C=!1,k;return function(){return C||(C=!0,k=t.apply(D,arguments)),k}}e.once=b}),define(pe[45],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(t){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=D;const C=Object.freeze([]);function k(){return C}t.empty=k;function*E(o){yield o}t.single=E;function p(o){return o||C}t.from=p;function S(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=S;function T(o){return o[Symbol.iterator]().next().value}t.first=T;function R(o,n){for(const i of o)if(n(i))return!0;return!1}t.some=R;function w(o,n){for(const i of o)if(n(i))return i}t.find=w;function*v(o,n){for(const i of o)n(i)&&(yield i)}t.filter=v;function*h(o,n){let i=0;for(const s of o)yield n(s,i++)}t.map=h;function*I(...o){for(const n of o)for(const i of n)yield i}t.concat=I;function*y(o){for(const n of o)for(const i of n)yield i}t.concatNested=y;function d(o,n,i){let s=i;for(const a of o)s=n(s,a);return s}t.reduce=d;function g(o,n){let i=0;for(const s of o)n(s,i++)}t.forEach=g;function*u(o,n,i=o.length){for(n<0&&(n+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);n<i;n++)yield o[n]}t.slice=u;function l(o,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,o];const s=o[Symbol.iterator]();for(let a=0;a<n;a++){const c=s.next();if(c.done)return[i,t.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=l;function f(o){return l(o)[0]}t.collect=f;function r(o,n,i=(s,a)=>s===a){const s=o[Symbol.iterator](),a=n[Symbol.iterator]();for(;;){const c=s.next(),m=a.next();if(c.done!==m.done)return!1;if(c.done)return!0;if(!i(c.value,m.value))return!1}}t.equals=r})(b=e.Iterable||(e.Iterable={}))}),define(pe[65],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(r,o=!1){let n=0;const i=r.length;let s="",a=0,c=16,m=0;function P(re){let G=0,de=0;for(;G<re;){const J=r.charCodeAt(n);if(J>=48&&J<=57)de=de*16+J-48;else if(J>=65&&J<=70)de=de*16+J-65+10;else if(J>=97&&J<=102)de=de*16+J-97+10;else break;n++,G++}return G<re&&(de=-1),de}function _(re){n=re,s="",a=0,c=16,m=0}function W(){const re=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&S(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&S(r.charCodeAt(n)))for(n++;n<r.length&&S(r.charCodeAt(n));)n++;else return m=3,r.substring(re,n);let G=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&S(r.charCodeAt(n))){for(n++;n<r.length&&S(r.charCodeAt(n));)n++;G=n}else m=3;return r.substring(re,G)}function K(){let re="",G=n;for(;;){if(n>=i){re+=r.substring(G,n),m=2;break}const de=r.charCodeAt(n);if(de===34){re+=r.substring(G,n),n++;break}if(de===92){if(re+=r.substring(G,n),n++,n>=i){m=2;break}switch(r.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const U=P(4);U>=0?re+=String.fromCharCode(U):m=4;break}default:m=5}G=n;continue}if(de>=0&&de<=31)if(p(de)){re+=r.substring(G,n),m=2;break}else m=6;n++}return re}function se(){if(s="",m=0,a=n,n>=i)return a=i,c=17;let re=r.charCodeAt(n);if(E(re)){do n++,s+=String.fromCharCode(re),re=r.charCodeAt(n);while(E(re));return c=15}if(p(re))return n++,s+=String.fromCharCode(re),re===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),c=14;switch(re){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,s=K(),c=10;case 47:{const G=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<i&&!p(r.charCodeAt(n));)n++;return s=r.substring(G,n),c=12}if(r.charCodeAt(n+1)===42){n+=2;const de=i-1;let J=!1;for(;n<de;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,J=!0;break}n++}return J||(n++,m=1),s=r.substring(G,n),c=13}return s+=String.fromCharCode(re),n++,c=16}case 45:if(s+=String.fromCharCode(re),n++,n===i||!S(r.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=W(),c=11;default:for(;n<i&&F(re);)n++,re=r.charCodeAt(n);if(a!==n){switch(s=r.substring(a,n),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(re),n++,c=16}}function F(re){if(E(re)||p(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let re;do re=se();while(re>=12&&re<=15);return re}return{setPosition:_,getPosition:()=>n,scan:o?Q:se,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>m}}e.createScanner=k;function E(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function p(r){return r===10||r===13||r===8232||r===8233}function S(r){return r>=48&&r<=57}var T;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(T||(T={}));function R(r,o){const n=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(P,_,W,K){a.value=P,a.offset=_,a.length=W,a.type=K,a.colonOffset=void 0,s=a}try{u(r,{onObjectBegin:(P,_)=>{if(o<=P)throw i;s=void 0,c=o>P,n.push("")},onObjectProperty:(P,_,W)=>{if(o<_||(m(P,_,W,"property"),n[n.length-1]=P,o<=_+W))throw i},onObjectEnd:(P,_)=>{if(o<=P)throw i;s=void 0,n.pop()},onArrayBegin:(P,_)=>{if(o<=P)throw i;s=void 0,n.push(0)},onArrayEnd:(P,_)=>{if(o<=P)throw i;s=void 0,n.pop()},onLiteralValue:(P,_,W)=>{if(o<_||(m(P,_,W,f(P)),o<=_+W))throw i},onSeparator:(P,_,W)=>{if(o<=_)throw i;if(P===":"&&s&&s.type==="property")s.colonOffset=_,c=!1,s=void 0;else if(P===","){const K=n[n.length-1];typeof K=="number"?n[n.length-1]=K+1:(c=!0,n[n.length-1]=""),s=void 0}}})}catch(P){if(P!==i)throw P}return{path:n,previousNode:s,isAtPropertyKey:c,matches:P=>{let _=0;for(let W=0;_<P.length&&W<n.length;W++)if(P[_]===n[W]||P[_]==="*")_++;else if(P[_]!=="**")return!1;return _===P.length}}}e.getLocation=R;function w(r,o=[],n=C.DEFAULT){let i=null,s=[];const a=[];function c(P){Array.isArray(s)?s.push(P):i!==null&&(s[i]=P)}return u(r,{onObjectBegin:()=>{const P={};c(P),a.push(s),s=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const P=[];c(P),a.push(s),s=P,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:c,onError:(P,_,W)=>{o.push({error:P,offset:_,length:W})}},n),s[0]}e.parse=w;function v(r,o=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(P){i.type==="property"&&(i.length=P-i.offset,i=i.parent)}function a(P){return i.children.push(P),P}u(r,{onObjectBegin:P=>{i=a({type:"object",offset:P,length:-1,parent:i,children:[]})},onObjectProperty:(P,_,W)=>{i=a({type:"property",offset:_,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:P,offset:_,length:W,parent:i})},onObjectEnd:(P,_)=>{i.length=P+_-i.offset,i=i.parent,s(P+_)},onArrayBegin:(P,_)=>{i=a({type:"array",offset:P,length:-1,parent:i,children:[]})},onArrayEnd:(P,_)=>{i.length=P+_-i.offset,i=i.parent,s(P+_)},onLiteralValue:(P,_,W)=>{a({type:f(P),offset:_,length:W,parent:i,value:P}),s(_+W)},onSeparator:(P,_,W)=>{i.type==="property"&&(P===":"?i.colonOffset=_:P===","&&s(_))},onError:(P,_,W)=>{o.push({error:P,offset:_,length:W})}},n);const m=i.children[0];return m&&delete m.parent,m}e.parseTree=v;function h(r,o){if(!r)return;let n=r;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function I(r){if(!r.parent||!r.parent.children)return[];const o=I(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=I;function y(r){switch(r.type){case"array":return r.children.map(y);case"object":{const o=Object.create(null);for(const n of r.children){const i=n.children[1];i&&(o[n.children[0].value]=y(i))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=y;function d(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=d;function g(r,o,n=!1){if(d(r,o,n)){const i=r.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const a=g(i[s],o,n);if(a)return a}return r}}e.findNodeAtOffset=g;function u(r,o,n=C.DEFAULT){const i=k(r,!1);function s(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(Y){return Y?ie=>Y(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(o.onObjectBegin),m=a(o.onObjectProperty),P=s(o.onObjectEnd),_=s(o.onArrayBegin),W=s(o.onArrayEnd),K=a(o.onLiteralValue),se=a(o.onSeparator),F=s(o.onComment),Q=a(o.onError),re=n&&n.disallowComments,G=n&&n.allowTrailingComma;function de(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:re||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(Y){case 12:case 13:re?J(10):F();break;case 16:J(1);break;case 15:case 14:break;default:return Y}}}function J(Y,ie=[],L=[]){if(Q(Y),ie.length+L.length>0){let N=i.getToken();for(;N!==17;){if(ie.indexOf(N)!==-1){de();break}else if(L.indexOf(N)!==-1)break;N=de()}}}function U(Y){const ie=i.getTokenValue();return Y?K(ie):m(ie),de(),!0}function O(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(J(2),Y=0)}catch{J(2)}K(Y);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return de(),!0}function B(){return i.getToken()!==10?(J(3,[],[2,5]),!1):(U(!1),i.getToken()===6?(se(":"),de(),ue()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function X(){c(),de();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||J(4,[],[]),se(","),de(),i.getToken()===2&&G)break}else Y&&J(6,[],[]);B()||J(4,[],[2,5]),Y=!0}return P(),i.getToken()!==2?J(7,[2],[]):de(),!0}function ce(){_(),de();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||J(4,[],[]),se(","),de(),i.getToken()===4&&G)break}else Y&&J(6,[],[]);ue()||J(4,[],[4,5]),Y=!0}return W(),i.getToken()!==4?J(8,[4],[]):de(),!0}function ue(){switch(i.getToken()){case 3:return ce();case 1:return X();case 10:return U(!0);default:return O()}}return de(),i.getToken()===17?n.allowEmptyContent?!0:(J(4,[],[]),!1):ue()?(i.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=u;function l(r,o){const n=k(r),i=[];let s,a=0,c;do switch(c=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==c&&i.push(r.substring(a,c)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return i.join("")}e.stripComments=l;function f(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(pe[133],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new b(()=>D(this.getValue()))}}e.Lazy=b}),define(pe[2],ve([0,1,64,45]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(a){C=a}if(e.setDisposableTracker=k,D){const a="__is_disposable_tracked__";k(new class{trackDisposable(c){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[a]||console.log(m)},3e3)}setParent(c,m){if(c&&c!==u.None)try{c[a]=!0}catch{}}markAsDisposed(c){if(c&&c!==u.None)try{c[a]=!0}catch{}}markAsSingleton(c){}})}function E(a){return C?.trackDisposable(a),a}function p(a){C?.markAsDisposed(a)}function S(a,c){C?.setParent(a,c)}function T(a,c){if(!!C)for(const m of a)C.setParent(m,c)}function R(a){return C?.markAsSingleton(a),a}e.markAsSingleton=R;class w extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=w;function v(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=v;function h(a){if(t.Iterable.is(a)){const c=[];for(const m of a)if(m)try{m.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new w(c);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=h;function I(a){for(const c of a)v(c)&&c.dispose();return[]}e.disposeIfDisposable=I;function y(...a){const c=d(()=>h(a));return T(a,c),c}e.combinedDisposable=y;function d(a){const c=E({dispose:(0,b.once)(()=>{p(c),a()})});return c}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return S(c,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new g,E(this),S(this._store,this)}dispose(){p(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&S(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&S(c,null),c}}e.MutableDisposable=l;class f{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(c){let m=c;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,p(this))},this}}e.SafeDisposable=r;class o{constructor(){this.references=new Map}acquire(c,...m){let P=this.references.get(c);P||(P={counter:0,object:this.createReferencedObject(c,...m)},this.references.set(c,P));const{object:_}=P,W=(0,b.once)(()=>{--P.counter==0&&(this.destroyReferencedObject(c,P.object),this.references.delete(c))});return P.counter++,{object:_,dispose:W}}}e.ReferenceCollection=o;class n{constructor(c){this.referenceCollection=c}async acquire(c,...m){const P=this.referenceCollection.acquire(c,...m);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(_){throw P.dispose(),_}}}e.AsyncReferenceCollection=n;class i{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=i;function s(a){const c=new g;try{a(c)}finally{c.dispose()}}e.disposeOnReturn=s}),define(pe[134],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(C){this.element=C,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class t{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let C=this._first;for(;C!==b.Undefined;){const k=C.next;C.prev=b.Undefined,C.next=b.Undefined,C=k}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const E=new b(C);if(this._first===b.Undefined)this._first=E,this._last=E;else if(k){const S=this._last;this._last=E,E.prev=S,S.next=E}else{const S=this._first;this._first=E,E.next=S,S.prev=E}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(E))}}shift(){if(this._first!==b.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==b.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==b.Undefined&&C.next!==b.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===b.Undefined&&C.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):C.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):C.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==b.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(pe[135],ve([1]),e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(j,Z){for(var ne=0;ne<Z.length;ne++){var z=Z[ne];z.enumerable=z.enumerable||!1,z.configurable=!0,"value"in z&&(z.writable=!0),Object.defineProperty(j,z.key,z)}}function b(j,Z,ne){return Z&&e(j.prototype,Z),ne&&e(j,ne),Object.defineProperty(j,"prototype",{writable:!1}),j}function t(j,Z){if(!!j){if(typeof j=="string")return D(j,Z);var ne=Object.prototype.toString.call(j).slice(8,-1);if(ne==="Object"&&j.constructor&&(ne=j.constructor.name),ne==="Map"||ne==="Set")return Array.from(j);if(ne==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ne))return D(j,Z)}}function D(j,Z){(Z==null||Z>j.length)&&(Z=j.length);for(var ne=0,z=new Array(Z);ne<Z;ne++)z[ne]=j[ne];return z}function C(j,Z){var ne=typeof Symbol!="undefined"&&j[Symbol.iterator]||j["@@iterator"];if(ne)return(ne=ne.call(j)).next.bind(ne);if(Array.isArray(j)||(ne=t(j))||Z&&j&&typeof j.length=="number"){ne&&(j=ne);var z=0;return function(){return z>=j.length?{done:!0}:{done:!1,value:j[z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=k();function E(j){oe.defaults=j}var p=/[&<>"']/,S=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Z){return w[Z]};function h(j,Z){if(Z){if(p.test(j))return j.replace(S,v)}else if(T.test(j))return j.replace(R,v);return j}var I=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function y(j){return j.replace(I,function(Z,ne){return ne=ne.toLowerCase(),ne==="colon"?":":ne.charAt(0)==="#"?ne.charAt(1)==="x"?String.fromCharCode(parseInt(ne.substring(2),16)):String.fromCharCode(+ne.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(j,Z){j=typeof j=="string"?j:j.source,Z=Z||"";var ne={replace:function(V,$){return $=$.source||$,$=$.replace(d,"$1"),j=j.replace(V,$),ne},getRegex:function(){return new RegExp(j,Z)}};return ne}var u=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(j,Z,ne){if(j){var z;try{z=decodeURIComponent(y(ne)).replace(u,"").toLowerCase()}catch{return null}if(z.indexOf("javascript:")===0||z.indexOf("vbscript:")===0||z.indexOf("data:")===0)return null}Z&&!l.test(ne)&&(ne=s(Z,ne));try{ne=encodeURI(ne).replace(/%25/g,"%")}catch{return null}return ne}var r={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(j,Z){r[" "+j]||(o.test(j)?r[" "+j]=j+"/":r[" "+j]=P(j,"/",!0)),j=r[" "+j];var ne=j.indexOf(":")===-1;return Z.substring(0,2)==="//"?ne?Z:j.replace(n,"$1")+Z:Z.charAt(0)==="/"?ne?Z:j.replace(i,"$1")+Z:j+Z}var a={exec:function(){}};function c(j){for(var Z=1,ne,z;Z<arguments.length;Z++){ne=arguments[Z];for(z in ne)Object.prototype.hasOwnProperty.call(ne,z)&&(j[z]=ne[z])}return j}function m(j,Z){var ne=j.replace(/\|/g,function($,x,le){for(var ge=!1,Pe=x;--Pe>=0&&le[Pe]==="\\";)ge=!ge;return ge?"|":" |"}),z=ne.split(/ \|/),V=0;if(z[0].trim()||z.shift(),z.length>0&&!z[z.length-1].trim()&&z.pop(),z.length>Z)z.splice(Z);else for(;z.length<Z;)z.push("");for(;V<z.length;V++)z[V]=z[V].trim().replace(/\\\|/g,"|");return z}function P(j,Z,ne){var z=j.length;if(z===0)return"";for(var V=0;V<z;){var $=j.charAt(z-V-1);if($===Z&&!ne)V++;else if($!==Z&&ne)V++;else break}return j.slice(0,z-V)}function _(j,Z){if(j.indexOf(Z[1])===-1)return-1;for(var ne=j.length,z=0,V=0;V<ne;V++)if(j[V]==="\\")V++;else if(j[V]===Z[0])z++;else if(j[V]===Z[1]&&(z--,z<0))return V;return-1}function W(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function K(j,Z){if(Z<1)return"";for(var ne="";Z>1;)Z&1&&(ne+=j),Z>>=1,j+=j;return ne+j}function se(j,Z,ne,z){var V=Z.href,$=Z.title?h(Z.title):null,x=j[1].replace(/\\([\[\]])/g,"$1");if(j[0].charAt(0)!=="!"){z.state.inLink=!0;var le={type:"link",raw:ne,href:V,title:$,text:x,tokens:z.inlineTokens(x,[])};return z.state.inLink=!1,le}return{type:"image",raw:ne,href:V,title:$,text:h(x)}}function F(j,Z){var ne=j.match(/^(\s+)(?:```)/);if(ne===null)return Z;var z=ne[1];return Z.split(`
`).map(function(V){var $=V.match(/^\s+/);if($===null)return V;var x=$[0];return x.length>=z.length?V.slice(z.length):V}).join(`
`)}var Q=function(){function j(ne){this.options=ne||oe.defaults}var Z=j.prototype;return Z.space=function(z){var V=this.rules.block.newline.exec(z);if(V&&V[0].length>0)return{type:"space",raw:V[0]}},Z.code=function(z){var V=this.rules.block.code.exec(z);if(V){var $=V[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:V[0],codeBlockStyle:"indented",text:this.options.pedantic?$:P($,`
`)}}},Z.fences=function(z){var V=this.rules.block.fences.exec(z);if(V){var $=V[0],x=F($,V[3]||"");return{type:"code",raw:$,lang:V[2]?V[2].trim():V[2],text:x}}},Z.heading=function(z){var V=this.rules.block.heading.exec(z);if(V){var $=V[2].trim();if(/#$/.test($)){var x=P($,"#");(this.options.pedantic||!x||/ $/.test(x))&&($=x.trim())}var le={type:"heading",raw:V[0],depth:V[1].length,text:$,tokens:[]};return this.lexer.inline(le.text,le.tokens),le}},Z.hr=function(z){var V=this.rules.block.hr.exec(z);if(V)return{type:"hr",raw:V[0]}},Z.blockquote=function(z){var V=this.rules.block.blockquote.exec(z);if(V){var $=V[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:V[0],tokens:this.lexer.blockTokens($,[]),text:$}}},Z.list=function(z){var V=this.rules.block.list.exec(z);if(V){var $,x,le,ge,Pe,ke,Me,Be,me,be,we,Oe,Ne=V[1].trim(),Je=Ne.length>1,We={type:"list",raw:"",ordered:Je,start:Je?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=Je?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=Je?Ne:"[*+-]");for(var qe=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");z&&(Oe=!1,!(!(V=qe.exec(z))||this.rules.block.hr.test(z)));){if($=V[0],z=z.substring($.length),Be=V[2].split(`
`,1)[0],me=z.split(`
`,1)[0],this.options.pedantic?(ge=2,we=Be.trimLeft()):(ge=V[2].search(/[^ ]/),ge=ge>4?1:ge,we=Be.slice(ge),ge+=V[1].length),ke=!1,!Be&&/^ *$/.test(me)&&($+=me+`
`,z=z.substring(me.length+1),Oe=!0),!Oe)for(var je=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),He=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");z&&(be=z.split(`
`,1)[0],Be=be,this.options.pedantic&&(Be=Be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(je.test(Be)||He.test(z)));){if(Be.search(/[^ ]/)>=ge||!Be.trim())we+=`
`+Be.slice(ge);else if(!ke)we+=`
`+Be;else break;!ke&&!Be.trim()&&(ke=!0),$+=be+`
`,z=z.substring(be.length+1)}We.loose||(Me?We.loose=!0:/\n *\n *$/.test($)&&(Me=!0)),this.options.gfm&&(x=/^\[[ xX]\] /.exec(we),x&&(le=x[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:$,task:!!x,checked:le,loose:!1,text:we}),We.raw+=$}We.items[We.items.length-1].raw=$.trimRight(),We.items[We.items.length-1].text=we.trimRight(),We.raw=We.raw.trimRight();var Ke=We.items.length;for(Pe=0;Pe<Ke;Pe++){this.lexer.state.top=!1,We.items[Pe].tokens=this.lexer.blockTokens(We.items[Pe].text,[]);var ae=We.items[Pe].tokens.filter(function(Te){return Te.type==="space"}),Ce=ae.every(function(Te){for(var Ae=Te.raw.split(""),Fe=0,Ue=C(Ae),xe;!(xe=Ue()).done;){var Qe=xe.value;if(Qe===`
`&&(Fe+=1),Fe>1)return!0}return!1});!We.loose&&ae.length&&Ce&&(We.loose=!0,We.items[Pe].loose=!0)}return We}},Z.html=function(z){var V=this.rules.block.html.exec(z);if(V){var $={type:"html",raw:V[0],pre:!this.options.sanitizer&&(V[1]==="pre"||V[1]==="script"||V[1]==="style"),text:V[0]};return this.options.sanitize&&($.type="paragraph",$.text=this.options.sanitizer?this.options.sanitizer(V[0]):h(V[0]),$.tokens=[],this.lexer.inline($.text,$.tokens)),$}},Z.def=function(z){var V=this.rules.block.def.exec(z);if(V){V[3]&&(V[3]=V[3].substring(1,V[3].length-1));var $=V[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$,raw:V[0],href:V[2],title:V[3]}}},Z.table=function(z){var V=this.rules.block.table.exec(z);if(V){var $={type:"table",header:m(V[1]).map(function(Me){return{text:Me}}),align:V[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:V[3]&&V[3].trim()?V[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($.header.length===$.align.length){$.raw=V[0];var x=$.align.length,le,ge,Pe,ke;for(le=0;le<x;le++)/^ *-+: *$/.test($.align[le])?$.align[le]="right":/^ *:-+: *$/.test($.align[le])?$.align[le]="center":/^ *:-+ *$/.test($.align[le])?$.align[le]="left":$.align[le]=null;for(x=$.rows.length,le=0;le<x;le++)$.rows[le]=m($.rows[le],$.header.length).map(function(Me){return{text:Me}});for(x=$.header.length,ge=0;ge<x;ge++)$.header[ge].tokens=[],this.lexer.inline($.header[ge].text,$.header[ge].tokens);for(x=$.rows.length,ge=0;ge<x;ge++)for(ke=$.rows[ge],Pe=0;Pe<ke.length;Pe++)ke[Pe].tokens=[],this.lexer.inline(ke[Pe].text,ke[Pe].tokens);return $}}},Z.lheading=function(z){var V=this.rules.block.lheading.exec(z);if(V){var $={type:"heading",raw:V[0],depth:V[2].charAt(0)==="="?1:2,text:V[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Z.paragraph=function(z){var V=this.rules.block.paragraph.exec(z);if(V){var $={type:"paragraph",raw:V[0],text:V[1].charAt(V[1].length-1)===`
`?V[1].slice(0,-1):V[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Z.text=function(z){var V=this.rules.block.text.exec(z);if(V){var $={type:"text",raw:V[0],text:V[0],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},Z.escape=function(z){var V=this.rules.inline.escape.exec(z);if(V)return{type:"escape",raw:V[0],text:h(V[1])}},Z.tag=function(z){var V=this.rules.inline.tag.exec(z);if(V)return!this.lexer.state.inLink&&/^<a /i.test(V[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(V[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(V[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(V[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:V[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):h(V[0]):V[0]}},Z.link=function(z){var V=this.rules.inline.link.exec(z);if(V){var $=V[2].trim();if(!this.options.pedantic&&/^</.test($)){if(!/>$/.test($))return;var x=P($.slice(0,-1),"\\");if(($.length-x.length)%2==0)return}else{var le=_(V[2],"()");if(le>-1){var ge=V[0].indexOf("!")===0?5:4,Pe=ge+V[1].length+le;V[2]=V[2].substring(0,le),V[0]=V[0].substring(0,Pe).trim(),V[3]=""}}var ke=V[2],Me="";if(this.options.pedantic){var Be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);Be&&(ke=Be[1],Me=Be[3])}else Me=V[3]?V[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test($)?ke=ke.slice(1):ke=ke.slice(1,-1)),se(V,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},V[0],this.lexer)}},Z.reflink=function(z,V){var $;if(($=this.rules.inline.reflink.exec(z))||($=this.rules.inline.nolink.exec(z))){var x=($[2]||$[1]).replace(/\s+/g," ");if(x=V[x.toLowerCase()],!x||!x.href){var le=$[0].charAt(0);return{type:"text",raw:le,text:le}}return se($,x,$[0],this.lexer)}},Z.emStrong=function(z,V,$){$===void 0&&($="");var x=this.rules.inline.emStrong.lDelim.exec(z);if(!!x&&!(x[3]&&$.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=x[1]||x[2]||"";if(!le||le&&($===""||this.rules.inline.punctuation.exec($))){var ge=x[0].length-1,Pe,ke,Me=ge,Be=0,me=x[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,V=V.slice(-1*z.length+ge);(x=me.exec(V))!=null;)if(Pe=x[1]||x[2]||x[3]||x[4]||x[5]||x[6],!!Pe){if(ke=Pe.length,x[3]||x[4]){Me+=ke;continue}else if((x[5]||x[6])&&ge%3&&!((ge+ke)%3)){Be+=ke;continue}if(Me-=ke,!(Me>0)){if(ke=Math.min(ke,ke+Me+Be),Math.min(ge,ke)%2){var be=z.slice(1,ge+x.index+ke);return{type:"em",raw:z.slice(0,ge+x.index+ke+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var we=z.slice(2,ge+x.index+ke-1);return{type:"strong",raw:z.slice(0,ge+x.index+ke+1),text:we,tokens:this.lexer.inlineTokens(we,[])}}}}}},Z.codespan=function(z){var V=this.rules.inline.code.exec(z);if(V){var $=V[2].replace(/\n/g," "),x=/[^ ]/.test($),le=/^ /.test($)&&/ $/.test($);return x&&le&&($=$.substring(1,$.length-1)),$=h($,!0),{type:"codespan",raw:V[0],text:$}}},Z.br=function(z){var V=this.rules.inline.br.exec(z);if(V)return{type:"br",raw:V[0]}},Z.del=function(z){var V=this.rules.inline.del.exec(z);if(V)return{type:"del",raw:V[0],text:V[2],tokens:this.lexer.inlineTokens(V[2],[])}},Z.autolink=function(z,V){var $=this.rules.inline.autolink.exec(z);if($){var x,le;return $[2]==="@"?(x=h(this.options.mangle?V($[1]):$[1]),le="mailto:"+x):(x=h($[1]),le=x),{type:"link",raw:$[0],text:x,href:le,tokens:[{type:"text",raw:x,text:x}]}}},Z.url=function(z,V){var $;if($=this.rules.inline.url.exec(z)){var x,le;if($[2]==="@")x=h(this.options.mangle?V($[0]):$[0]),le="mailto:"+x;else{var ge;do ge=$[0],$[0]=this.rules.inline._backpedal.exec($[0])[0];while(ge!==$[0]);x=h($[0]),$[1]==="www."?le="http://"+x:le=x}return{type:"link",raw:$[0],text:x,href:le,tokens:[{type:"text",raw:x,text:x}]}}},Z.inlineText=function(z,V){var $=this.rules.inline.text.exec(z);if($){var x;return this.lexer.state.inRawBlock?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($[0]):h($[0]):$[0]:x=h(this.options.smartypants?V($[0]):$[0]),{type:"text",raw:$[0],text:x}}},j}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=g(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=g(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=g(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=g(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=g(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=c({},re),re.gfm=c({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=g(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=c({},re.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:g(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=g(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=g(re._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=g(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=g(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=g(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=g(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=g(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=g(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=g(G.reflink).replace("label",G._label).replace("ref",re._label).getRegex(),G.nolink=g(G.nolink).replace("ref",re._label).getRegex(),G.reflinkSearch=g(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=c({},G),G.pedantic=c({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=c({},G.normal,{escape:g(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),G.gfm.url=g(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=c({},G.gfm,{br:g(G.br).replace("{2,}","*").getRegex(),text:g(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function de(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(j){var Z="",ne,z,V=j.length;for(ne=0;ne<V;ne++)z=j.charCodeAt(ne),Math.random()>.5&&(z="x"+z.toString(16)),Z+="&#"+z+";";return Z}var U=function(){function j(ne){this.tokens=[],this.tokens.links=Object.create(null),this.options=ne||oe.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var z={block:re.normal,inline:G.normal};this.options.pedantic?(z.block=re.pedantic,z.inline=G.pedantic):this.options.gfm&&(z.block=re.gfm,this.options.breaks?z.inline=G.breaks:z.inline=G.gfm),this.tokenizer.rules=z}j.lex=function(z,V){var $=new j(V);return $.lex(z)},j.lexInline=function(z,V){var $=new j(V);return $.inlineTokens(z)};var Z=j.prototype;return Z.lex=function(z){z=z.replace(/\r\n|\r/g,`
`),this.blockTokens(z,this.tokens);for(var V;V=this.inlineQueue.shift();)this.inlineTokens(V.src,V.tokens);return this.tokens},Z.blockTokens=function(z,V){var $=this;V===void 0&&(V=[]),this.options.pedantic?z=z.replace(/\t/g,"    ").replace(/^ +$/gm,""):z=z.replace(/^( *)(\t+)/gm,function(Me,Be,me){return Be+"    ".repeat(me.length)});for(var x,le,ge,Pe;z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(x=Me.call({lexer:$},z,V))?(z=z.substring(x.raw.length),V.push(x),!0):!1}))){if(x=this.tokenizer.space(z)){z=z.substring(x.raw.length),x.raw.length===1&&V.length>0?V[V.length-1].raw+=`
`:V.push(x);continue}if(x=this.tokenizer.code(z)){z=z.substring(x.raw.length),le=V[V.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+x.raw,le.text+=`
`+x.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(x);continue}if(x=this.tokenizer.fences(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.heading(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.hr(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.blockquote(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.list(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.html(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.def(z)){z=z.substring(x.raw.length),le=V[V.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+x.raw,le.text+=`
`+x.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[x.tag]||(this.tokens.links[x.tag]={href:x.href,title:x.title});continue}if(x=this.tokenizer.table(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.lheading(z)){z=z.substring(x.raw.length),V.push(x);continue}if(ge=z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Be=z.slice(1),me=void 0;$.options.extensions.startBlock.forEach(function(be){me=be.call({lexer:this},Be),typeof me=="number"&&me>=0&&(Me=Math.min(Me,me))}),Me<1/0&&Me>=0&&(ge=z.substring(0,Me+1))}(),this.state.top&&(x=this.tokenizer.paragraph(ge))){le=V[V.length-1],Pe&&le.type==="paragraph"?(le.raw+=`
`+x.raw,le.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(x),Pe=ge.length!==z.length,z=z.substring(x.raw.length);continue}if(x=this.tokenizer.text(z)){z=z.substring(x.raw.length),le=V[V.length-1],le&&le.type==="text"?(le.raw+=`
`+x.raw,le.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(x);continue}if(z){var ke="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,V},Z.inline=function(z,V){this.inlineQueue.push({src:z,tokens:V})},Z.inlineTokens=function(z,V){var $=this;V===void 0&&(V=[]);var x,le,ge,Pe=z,ke,Me,Be;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)me.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,ke.index)+"["+K("a",ke[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,ke.index)+"["+K("a",ke[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,ke.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;z;)if(Me||(Be=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(x=we.call({lexer:$},z,V))?(z=z.substring(x.raw.length),V.push(x),!0):!1}))){if(x=this.tokenizer.escape(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.tag(z)){z=z.substring(x.raw.length),le=V[V.length-1],le&&x.type==="text"&&le.type==="text"?(le.raw+=x.raw,le.text+=x.text):V.push(x);continue}if(x=this.tokenizer.link(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.reflink(z,this.tokens.links)){z=z.substring(x.raw.length),le=V[V.length-1],le&&x.type==="text"&&le.type==="text"?(le.raw+=x.raw,le.text+=x.text):V.push(x);continue}if(x=this.tokenizer.emStrong(z,Pe,Be)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.codespan(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.br(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.del(z)){z=z.substring(x.raw.length),V.push(x);continue}if(x=this.tokenizer.autolink(z,J)){z=z.substring(x.raw.length),V.push(x);continue}if(!this.state.inLink&&(x=this.tokenizer.url(z,J))){z=z.substring(x.raw.length),V.push(x);continue}if(ge=z,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Oe=z.slice(1),Ne=void 0;$.options.extensions.startInline.forEach(function(Je){Ne=Je.call({lexer:this},Oe),typeof Ne=="number"&&Ne>=0&&(we=Math.min(we,Ne))}),we<1/0&&we>=0&&(ge=z.substring(0,we+1))}(),x=this.tokenizer.inlineText(ge,de)){z=z.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(Be=x.raw.slice(-1)),Me=!0,le=V[V.length-1],le&&le.type==="text"?(le.raw+=x.raw,le.text+=x.text):V.push(x);continue}if(z){var be="Infinite loop on byte: "+z.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return V},b(j,null,[{key:"rules",get:function(){return{block:re,inline:G}}}]),j}(),O=function(){function j(ne){this.options=ne||oe.defaults}var Z=j.prototype;return Z.code=function(z,V,$){var x=(V||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(z,x);le!=null&&le!==z&&($=!0,z=le)}return z=z.replace(/\n$/,"")+`
`,x?'<pre><code class="'+this.options.langPrefix+h(x,!0)+'">'+($?z:h(z,!0))+`</code></pre>
`:"<pre><code>"+($?z:h(z,!0))+`</code></pre>
`},Z.blockquote=function(z){return`<blockquote>
`+z+`</blockquote>
`},Z.html=function(z){return z},Z.heading=function(z,V,$,x){if(this.options.headerIds){var le=this.options.headerPrefix+x.slug($);return"<h"+V+' id="'+le+'">'+z+"</h"+V+`>
`}return"<h"+V+">"+z+"</h"+V+`>
`},Z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Z.list=function(z,V,$){var x=V?"ol":"ul",le=V&&$!==1?' start="'+$+'"':"";return"<"+x+le+`>
`+z+"</"+x+`>
`},Z.listitem=function(z){return"<li>"+z+`</li>
`},Z.checkbox=function(z){return"<input "+(z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Z.paragraph=function(z){return"<p>"+z+`</p>
`},Z.table=function(z,V){return V&&(V="<tbody>"+V+"</tbody>"),`<table>
<thead>
`+z+`</thead>
`+V+`</table>
`},Z.tablerow=function(z){return`<tr>
`+z+`</tr>
`},Z.tablecell=function(z,V){var $=V.header?"th":"td",x=V.align?"<"+$+' align="'+V.align+'">':"<"+$+">";return x+z+("</"+$+`>
`)},Z.strong=function(z){return"<strong>"+z+"</strong>"},Z.em=function(z){return"<em>"+z+"</em>"},Z.codespan=function(z){return"<code>"+z+"</code>"},Z.br=function(){return this.options.xhtml?"<br/>":"<br>"},Z.del=function(z){return"<del>"+z+"</del>"},Z.link=function(z,V,$){if(z=f(this.options.sanitize,this.options.baseUrl,z),z===null)return $;var x='<a href="'+h(z)+'"';return V&&(x+=' title="'+V+'"'),x+=">"+$+"</a>",x},Z.image=function(z,V,$){if(z=f(this.options.sanitize,this.options.baseUrl,z),z===null)return $;var x='<img src="'+z+'" alt="'+$+'"';return V&&(x+=' title="'+V+'"'),x+=this.options.xhtml?"/>":">",x},Z.text=function(z){return z},j}(),B=function(){function j(){}var Z=j.prototype;return Z.strong=function(z){return z},Z.em=function(z){return z},Z.codespan=function(z){return z},Z.del=function(z){return z},Z.html=function(z){return z},Z.text=function(z){return z},Z.link=function(z,V,$){return""+$},Z.image=function(z,V,$){return""+$},Z.br=function(){return""},j}(),X=function(){function j(){this.seen={}}var Z=j.prototype;return Z.serialize=function(z){return z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Z.getNextSafeSlug=function(z,V){var $=z,x=0;if(this.seen.hasOwnProperty($)){x=this.seen[z];do x++,$=z+"-"+x;while(this.seen.hasOwnProperty($))}return V||(this.seen[z]=x,this.seen[$]=0),$},Z.slug=function(z,V){V===void 0&&(V={});var $=this.serialize(z);return this.getNextSafeSlug($,V.dryrun)},j}(),ce=function(){function j(ne){this.options=ne||oe.defaults,this.options.renderer=this.options.renderer||new O,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new X}j.parse=function(z,V){var $=new j(V);return $.parse(z)},j.parseInline=function(z,V){var $=new j(V);return $.parseInline(z)};var Z=j.prototype;return Z.parse=function(z,V){V===void 0&&(V=!0);var $="",x,le,ge,Pe,ke,Me,Be,me,be,we,Oe,Ne,Je,We,qe,je,He,Ke,ae,Ce=z.length;for(x=0;x<Ce;x++){if(we=z[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(ae=this.options.extensions.renderers[we.type].call({parser:this},we),ae!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){$+=ae||"";continue}switch(we.type){case"space":continue;case"hr":{$+=this.renderer.hr();continue}case"heading":{$+=this.renderer.heading(this.parseInline(we.tokens),we.depth,y(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{$+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(me="",Be="",Pe=we.header.length,le=0;le<Pe;le++)Be+=this.renderer.tablecell(this.parseInline(we.header[le].tokens),{header:!0,align:we.align[le]});for(me+=this.renderer.tablerow(Be),be="",Pe=we.rows.length,le=0;le<Pe;le++){for(Me=we.rows[le],Be="",ke=Me.length,ge=0;ge<ke;ge++)Be+=this.renderer.tablecell(this.parseInline(Me[ge].tokens),{header:!1,align:we.align[ge]});be+=this.renderer.tablerow(Be)}$+=this.renderer.table(me,be);continue}case"blockquote":{be=this.parse(we.tokens),$+=this.renderer.blockquote(be);continue}case"list":{for(Oe=we.ordered,Ne=we.start,Je=we.loose,Pe=we.items.length,be="",le=0;le<Pe;le++)qe=we.items[le],je=qe.checked,He=qe.task,We="",qe.task&&(Ke=this.renderer.checkbox(je),Je?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=Ke+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=Ke+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:Ke}):We+=Ke),We+=this.parse(qe.tokens,Je),be+=this.renderer.listitem(We,He,je);$+=this.renderer.list(be,Oe,Ne);continue}case"html":{$+=this.renderer.html(we.text);continue}case"paragraph":{$+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(be=we.tokens?this.parseInline(we.tokens):we.text;x+1<Ce&&z[x+1].type==="text";)we=z[++x],be+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);$+=V?this.renderer.paragraph(be):be;continue}default:{var Te='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return $},Z.parseInline=function(z,V){V=V||this.renderer;var $="",x,le,ge,Pe=z.length;for(x=0;x<Pe;x++){if(le=z[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(ge=this.options.extensions.renderers[le.type].call({parser:this},le),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){$+=ge||"";continue}switch(le.type){case"escape":{$+=V.text(le.text);break}case"html":{$+=V.html(le.text);break}case"link":{$+=V.link(le.href,le.title,this.parseInline(le.tokens,V));break}case"image":{$+=V.image(le.href,le.title,le.text);break}case"strong":{$+=V.strong(this.parseInline(le.tokens,V));break}case"em":{$+=V.em(this.parseInline(le.tokens,V));break}case"codespan":{$+=V.codespan(le.text);break}case"br":{$+=V.br();break}case"del":{$+=V.del(this.parseInline(le.tokens,V));break}case"text":{$+=V.text(le.text);break}default:{var ke='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return $},j}();function ue(j,Z,ne){if(typeof j=="undefined"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof Z=="function"&&(ne=Z,Z=null),Z=c({},ue.defaults,Z||{}),W(Z),ne){var z=Z.highlight,V;try{V=U.lex(j,Z)}catch(ge){return ne(ge)}var $=function(Pe){var ke;if(!Pe)try{Z.walkTokens&&ue.walkTokens(V,Z.walkTokens),ke=ce.parse(V,Z)}catch(Me){Pe=Me}return Z.highlight=z,Pe?ne(Pe):ne(null,ke)};if(!z||z.length<3||(delete Z.highlight,!V.length))return $();var x=0;ue.walkTokens(V,function(ge){ge.type==="code"&&(x++,setTimeout(function(){z(ge.text,ge.lang,function(Pe,ke){if(Pe)return $(Pe);ke!=null&&ke!==ge.text&&(ge.text=ke,ge.escaped=!0),x--,x===0&&$()})},0))}),x===0&&$();return}try{var le=U.lex(j,Z);return Z.walkTokens&&ue.walkTokens(le,Z.walkTokens),ce.parse(le,Z)}catch(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+h(ge.message+"",!0)+"</pre>";throw ge}}ue.options=ue.setOptions=function(j){return c(ue.defaults,j),E(ue.defaults),ue},ue.getDefaults=k,ue.defaults=oe.defaults,ue.use=function(){for(var j=arguments.length,Z=new Array(j),ne=0;ne<j;ne++)Z[ne]=arguments[ne];var z=c.apply(void 0,[{}].concat(Z)),V=ue.defaults.extensions||{renderers:{},childTokens:{}},$;Z.forEach(function(x){if(x.extensions&&($=!0,x.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Pe=V.renderers?V.renderers[ge.name]:null;Pe?V.renderers[ge.name]=function(){for(var ke=arguments.length,Me=new Array(ke),Be=0;Be<ke;Be++)Me[Be]=arguments[Be];var me=ge.renderer.apply(this,Me);return me===!1&&(me=Pe.apply(this,Me)),me}:V.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");V[ge.level]?V[ge.level].unshift(ge.tokenizer):V[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?V.startBlock?V.startBlock.push(ge.start):V.startBlock=[ge.start]:ge.level==="inline"&&(V.startInline?V.startInline.push(ge.start):V.startInline=[ge.start]))}ge.childTokens&&(V.childTokens[ge.name]=ge.childTokens)})),x.renderer&&function(){var ge=ue.defaults.renderer||new O,Pe=function(Be){var me=ge[Be];ge[Be]=function(){for(var be=arguments.length,we=new Array(be),Oe=0;Oe<be;Oe++)we[Oe]=arguments[Oe];var Ne=x.renderer[Be].apply(ge,we);return Ne===!1&&(Ne=me.apply(ge,we)),Ne}};for(var ke in x.renderer)Pe(ke);z.renderer=ge}(),x.tokenizer&&function(){var ge=ue.defaults.tokenizer||new Q,Pe=function(Be){var me=ge[Be];ge[Be]=function(){for(var be=arguments.length,we=new Array(be),Oe=0;Oe<be;Oe++)we[Oe]=arguments[Oe];var Ne=x.tokenizer[Be].apply(ge,we);return Ne===!1&&(Ne=me.apply(ge,we)),Ne}};for(var ke in x.tokenizer)Pe(ke);z.tokenizer=ge}(),x.walkTokens){var le=ue.defaults.walkTokens;z.walkTokens=function(ge){x.walkTokens.call(this,ge),le&&le.call(this,ge)}}$&&(z.extensions=V),ue.setOptions(z)})},ue.walkTokens=function(j,Z){for(var ne=function(){var x=V.value;switch(Z.call(ue,x),x.type){case"table":{for(var le=C(x.header),ge;!(ge=le()).done;){var Pe=ge.value;ue.walkTokens(Pe.tokens,Z)}for(var ke=C(x.rows),Me;!(Me=ke()).done;)for(var Be=Me.value,me=C(Be),be;!(be=me()).done;){var we=be.value;ue.walkTokens(we.tokens,Z)}break}case"list":{ue.walkTokens(x.items,Z);break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[x.type]?ue.defaults.extensions.childTokens[x.type].forEach(function(Oe){ue.walkTokens(x[Oe],Z)}):x.tokens&&ue.walkTokens(x.tokens,Z)}},z=C(j),V;!(V=z()).done;)ne()},ue.parseInline=function(j,Z){if(typeof j=="undefined"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");Z=c({},ue.defaults,Z||{}),W(Z);try{var ne=U.lexInline(j,Z);return Z.walkTokens&&ue.walkTokens(ne,Z.walkTokens),ce.parseInline(ne,Z)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+h(z.message+"",!0)+"</pre>";throw z}},ue.Parser=ce,ue.parser=ce.parse,ue.Renderer=O,ue.TextRenderer=B,ue.Lexer=U,ue.lexer=U.lex,ue.Tokenizer=Q,ue.Slugger=X,ue.parse=ue;var Y=ue.options,ie=ue.setOptions,L=ue.use,N=ue.walkTokens,q=ue.parseInline,te=ue,fe=ce.parse,ye=U.lex;oe.Lexer=U,oe.Parser=ce,oe.Renderer=O,oe.Slugger=X,oe.TextRenderer=B,oe.Tokenizer=Q,oe.getDefaults=k,oe.lexer=ye,oe.marked=ue,oe.options=Y,oe.parse=te,oe.parseInline=q,oe.parser=fe,oe.setOptions=ie,oe.use=L,oe.walkTokens=N,Object.defineProperty(oe,"__esModule",{value:!0})}),function(){function oe(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(p){C.push(p,Date.now())}function E(){const p=[];for(let S=0;S<C.length;S+=2)p.push({name:C[S],startTime:C[S+1]});return p}return{mark:k,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function b(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=b(t))}(),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var t in b)(typeof exports=="object"?exports:oe)[t]=b[t]}}(typeof self!="undefined"?self:this,function(){return function(oe){var e={};function b(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return oe[t].call(D.exports,D,D.exports,b),D.l=!0,D.exports}return b.m=oe,b.c=e,b.d=function(t,D,C){b.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:C})},b.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},b.t=function(t,D){if(1&D&&(t=b(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var C=Object.create(null);if(b.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var k in t)b.d(C,k,function(E){return t[E]}.bind(null,k));return C},b.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return b.d(D,"a",D),D},b.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},b.p="",b(b.s=0)}([function(oe,e,b){(function(t){var D;e=oe.exports=L,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],p=e.src=[],S=0,T=S++;p[T]="0|[1-9]\\d*";var R=S++;p[R]="[0-9]+";var w=S++;p[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=S++;p[v]="("+p[T]+")\\.("+p[T]+")\\.("+p[T]+")";var h=S++;p[h]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var I=S++;p[I]="(?:"+p[T]+"|"+p[w]+")";var y=S++;p[y]="(?:"+p[R]+"|"+p[w]+")";var d=S++;p[d]="(?:-("+p[I]+"(?:\\."+p[I]+")*))";var g=S++;p[g]="(?:-?("+p[y]+"(?:\\."+p[y]+")*))";var u=S++;p[u]="[0-9A-Za-z-]+";var l=S++;p[l]="(?:\\+("+p[u]+"(?:\\."+p[u]+")*))";var f=S++,r="v?"+p[v]+p[d]+"?"+p[l]+"?";p[f]="^"+r+"$";var o="[v=\\s]*"+p[h]+p[g]+"?"+p[l]+"?",n=S++;p[n]="^"+o+"$";var i=S++;p[i]="((?:<|>)?=?)";var s=S++;p[s]=p[R]+"|x|X|\\*";var a=S++;p[a]=p[T]+"|x|X|\\*";var c=S++;p[c]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[d]+")?"+p[l]+"?)?)?";var m=S++;p[m]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[g]+")?"+p[l]+"?)?)?";var P=S++;p[P]="^"+p[i]+"\\s*"+p[c]+"$";var _=S++;p[_]="^"+p[i]+"\\s*"+p[m]+"$";var W=S++;p[W]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=S++;p[K]="(?:~>?)";var se=S++;p[se]="(\\s*)"+p[K]+"\\s+",E[se]=new RegExp(p[se],"g");var F=S++;p[F]="^"+p[K]+p[c]+"$";var Q=S++;p[Q]="^"+p[K]+p[m]+"$";var re=S++;p[re]="(?:\\^)";var G=S++;p[G]="(\\s*)"+p[re]+"\\s+",E[G]=new RegExp(p[G],"g");var de=S++;p[de]="^"+p[re]+p[c]+"$";var J=S++;p[J]="^"+p[re]+p[m]+"$";var U=S++;p[U]="^"+p[i]+"\\s*("+o+")$|^$";var O=S++;p[O]="^"+p[i]+"\\s*("+r+")$|^$";var B=S++;p[B]="(\\s*)"+p[i]+"\\s*("+o+"|"+p[c]+")",E[B]=new RegExp(p[B],"g");var X=S++;p[X]="^\\s*("+p[c]+")\\s+-\\s+("+p[c]+")\\s*$";var ce=S++;p[ce]="^\\s*("+p[m]+")\\s+-\\s+("+p[m]+")\\s*$";var ue=S++;p[ue]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)D(Y,p[Y]),E[Y]||(E[Y]=new RegExp(p[Y]));function ie(me,be){if(me instanceof L)return me;if(typeof me!="string"||me.length>C||!(be?E[n]:E[f]).test(me))return null;try{return new L(me,be)}catch{return null}}function L(me,be){if(me instanceof L){if(me.loose===be)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof L))return new L(me,be);D("SemVer",me,be),this.loose=be;var we=me.trim().match(be?E[n]:E[f]);if(!we)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ne=+Oe;if(Ne>=0&&Ne<k)return Ne}return Oe}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ie,e.valid=function(me,be){var we=ie(me,be);return we?we.version:null},e.clean=function(me,be){var we=ie(me.trim().replace(/^[=v]+/,""),be);return we?we.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(me){return D("SemVer.compare",this.version,this.loose,me),me instanceof L||(me=new L(me,this.loose)),this.compareMain(me)||this.comparePre(me)},L.prototype.compareMain=function(me){return me instanceof L||(me=new L(me,this.loose)),q(this.major,me.major)||q(this.minor,me.minor)||q(this.patch,me.patch)},L.prototype.comparePre=function(me){if(me instanceof L||(me=new L(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var be=0;do{var we=this.prerelease[be],Oe=me.prerelease[be];if(D("prerelease compare",be,we,Oe),we===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(we===void 0)return-1;if(we!==Oe)return q(we,Oe)}while(++be)},L.prototype.inc=function(me,be){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,be,we,Oe){typeof we=="string"&&(Oe=we,we=void 0);try{return new L(me,we).inc(be,Oe).version}catch{return null}},e.diff=function(me,be){if(j(me,be))return null;var we=ie(me),Oe=ie(be);if(we.prerelease.length||Oe.prerelease.length){for(var Ne in we)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&we[Ne]!==Oe[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in we)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&we[Ne]!==Oe[Ne])return Ne},e.compareIdentifiers=q;var N=/^[0-9]+$/;function q(me,be){var we=N.test(me),Oe=N.test(be);return we&&Oe&&(me=+me,be=+be),we&&!Oe?-1:Oe&&!we?1:me<be?-1:me>be?1:0}function te(me,be,we){return new L(me,we).compare(new L(be,we))}function fe(me,be,we){return te(me,be,we)>0}function ye(me,be,we){return te(me,be,we)<0}function j(me,be,we){return te(me,be,we)===0}function Z(me,be,we){return te(me,be,we)!==0}function ne(me,be,we){return te(me,be,we)>=0}function z(me,be,we){return te(me,be,we)<=0}function V(me,be,we,Oe){var Ne;switch(be){case"===":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),Ne=me===we;break;case"!==":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),Ne=me!==we;break;case"":case"=":case"==":Ne=j(me,we,Oe);break;case"!=":Ne=Z(me,we,Oe);break;case">":Ne=fe(me,we,Oe);break;case">=":Ne=ne(me,we,Oe);break;case"<":Ne=ye(me,we,Oe);break;case"<=":Ne=z(me,we,Oe);break;default:throw new TypeError("Invalid operator: "+be)}return Ne}function $(me,be){if(me instanceof $){if(me.loose===be)return me;me=me.value}if(!(this instanceof $))return new $(me,be);D("comparator",me,be),this.loose=be,this.parse(me),this.semver===x?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(me,be){return q(be,me)},e.major=function(me,be){return new L(me,be).major},e.minor=function(me,be){return new L(me,be).minor},e.patch=function(me,be){return new L(me,be).patch},e.compare=te,e.compareLoose=function(me,be){return te(me,be,!0)},e.rcompare=function(me,be,we){return te(be,me,we)},e.sort=function(me,be){return me.sort(function(we,Oe){return e.compare(we,Oe,be)})},e.rsort=function(me,be){return me.sort(function(we,Oe){return e.rcompare(we,Oe,be)})},e.gt=fe,e.lt=ye,e.eq=j,e.neq=Z,e.gte=ne,e.lte=z,e.cmp=V,e.Comparator=$;var x={};function le(me,be){if(me instanceof le)return me.loose===be?me:new le(me.raw,be);if(me instanceof $)return new le(me.value,be);if(!(this instanceof le))return new le(me,be);if(this.loose=be,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function ge(me){return!me||me.toLowerCase()==="x"||me==="*"}function Pe(me,be,we,Oe,Ne,Je,We,qe,je,He,Ke,ae,Ce){return((be=ge(we)?"":ge(Oe)?">="+we+".0.0":ge(Ne)?">="+we+"."+Oe+".0":">="+be)+" "+(qe=ge(je)?"":ge(He)?"<"+(+je+1)+".0.0":ge(Ke)?"<"+je+"."+(+He+1)+".0":ae?"<="+je+"."+He+"."+Ke+"-"+ae:"<="+qe)).trim()}function ke(me,be){for(var we=0;we<me.length;we++)if(!me[we].test(be))return!1;if(be.prerelease.length){for(we=0;we<me.length;we++)if(D(me[we].semver),me[we].semver!==x&&me[we].semver.prerelease.length>0){var Oe=me[we].semver;if(Oe.major===be.major&&Oe.minor===be.minor&&Oe.patch===be.patch)return!0}return!1}return!0}function Me(me,be,we){try{be=new le(be,we)}catch{return!1}return be.test(me)}function Be(me,be,we,Oe){var Ne,Je,We,qe,je;switch(me=new L(me,Oe),be=new le(be,Oe),we){case">":Ne=fe,Je=z,We=ye,qe=">",je=">=";break;case"<":Ne=ye,Je=ne,We=fe,qe="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(me,be,Oe))return!1;for(var He=0;He<be.set.length;++He){var Ke=be.set[He],ae=null,Ce=null;if(Ke.forEach(function(Te){Te.semver===x&&(Te=new $(">=0.0.0")),ae=ae||Te,Ce=Ce||Te,Ne(Te.semver,ae.semver,Oe)?ae=Te:We(Te.semver,Ce.semver,Oe)&&(Ce=Te)}),ae.operator===qe||ae.operator===je||(!Ce.operator||Ce.operator===qe)&&Je(me,Ce.semver)||Ce.operator===je&&We(me,Ce.semver))return!1}return!0}$.prototype.parse=function(me){var be=this.loose?E[U]:E[O],we=me.match(be);if(!we)throw new TypeError("Invalid comparator: "+me);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new L(we[2],this.loose):this.semver=x},$.prototype.toString=function(){return this.value},$.prototype.test=function(me){return D("Comparator.test",me,this.loose),this.semver===x||(typeof me=="string"&&(me=new L(me,this.loose)),V(me,this.operator,this.semver,this.loose))},$.prototype.intersects=function(me,be){if(!(me instanceof $))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new le(me.value,be),Me(this.value,we,be);if(me.operator==="")return we=new le(this.value,be),Me(me.semver,we,be);var Oe=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Je=this.semver.version===me.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),qe=V(this.semver,"<",me.semver,be)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),je=V(this.semver,">",me.semver,be)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Oe||Ne||Je&&We||qe||je},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(me){var be=this.loose;me=me.trim(),D("range",me,be);var we=be?E[ce]:E[X];me=me.replace(we,Pe),D("hyphen replace",me),me=me.replace(E[B],"$1$2$3"),D("comparator trim",me,E[B]),me=(me=(me=me.replace(E[se],"$1~")).replace(E[G],"$1^")).split(/\s+/).join(" ");var Oe=be?E[U]:E[O],Ne=me.split(" ").map(function(Je){return function(We,qe){return D("comp",We),We=function(je,He){return je.trim().split(/\s+/).map(function(Ke){return function(ae,Ce){D("caret",ae,Ce);var Te=Ce?E[J]:E[de];return ae.replace(Te,function(Ae,Fe,Ue,xe,Qe){var Ze;return D("caret",ae,Ae,Fe,Ue,xe,Qe),ge(Fe)?Ze="":ge(Ue)?Ze=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ge(xe)?Ze=Fe==="0"?">="+Fe+"."+Ue+".0 <"+Fe+"."+(+Ue+1)+".0":">="+Fe+"."+Ue+".0 <"+(+Fe+1)+".0.0":Qe?(D("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Ze=Fe==="0"?Ue==="0"?">="+Fe+"."+Ue+"."+xe+Qe+" <"+Fe+"."+Ue+"."+(+xe+1):">="+Fe+"."+Ue+"."+xe+Qe+" <"+Fe+"."+(+Ue+1)+".0":">="+Fe+"."+Ue+"."+xe+Qe+" <"+(+Fe+1)+".0.0"):(D("no pr"),Ze=Fe==="0"?Ue==="0"?">="+Fe+"."+Ue+"."+xe+" <"+Fe+"."+Ue+"."+(+xe+1):">="+Fe+"."+Ue+"."+xe+" <"+Fe+"."+(+Ue+1)+".0":">="+Fe+"."+Ue+"."+xe+" <"+(+Fe+1)+".0.0"),D("caret return",Ze),Ze})}(Ke,He)}).join(" ")}(We,qe),D("caret",We),We=function(je,He){return je.trim().split(/\s+/).map(function(Ke){return function(ae,Ce){var Te=Ce?E[Q]:E[F];return ae.replace(Te,function(Ae,Fe,Ue,xe,Qe){var Ze;return D("tilde",ae,Ae,Fe,Ue,xe,Qe),ge(Fe)?Ze="":ge(Ue)?Ze=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ge(xe)?Ze=">="+Fe+"."+Ue+".0 <"+Fe+"."+(+Ue+1)+".0":Qe?(D("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Ze=">="+Fe+"."+Ue+"."+xe+Qe+" <"+Fe+"."+(+Ue+1)+".0"):Ze=">="+Fe+"."+Ue+"."+xe+" <"+Fe+"."+(+Ue+1)+".0",D("tilde return",Ze),Ze})}(Ke,He)}).join(" ")}(We,qe),D("tildes",We),We=function(je,He){return D("replaceXRanges",je,He),je.split(/\s+/).map(function(Ke){return function(ae,Ce){ae=ae.trim();var Te=Ce?E[_]:E[P];return ae.replace(Te,function(Ae,Fe,Ue,xe,Qe,Ze){D("xRange",ae,Ae,Fe,Ue,xe,Qe,Ze);var tt=ge(Ue),it=tt||ge(xe),rt=it||ge(Qe);return Fe==="="&&rt&&(Fe=""),tt?Ae=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&rt?(it&&(xe=0),rt&&(Qe=0),Fe===">"?(Fe=">=",it?(Ue=+Ue+1,xe=0,Qe=0):rt&&(xe=+xe+1,Qe=0)):Fe==="<="&&(Fe="<",it?Ue=+Ue+1:xe=+xe+1),Ae=Fe+Ue+"."+xe+"."+Qe):it?Ae=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":rt&&(Ae=">="+Ue+"."+xe+".0 <"+Ue+"."+(+xe+1)+".0"),D("xRange return",Ae),Ae})}(Ke,He)}).join(" ")}(We,qe),D("xrange",We),We=function(je,He){return D("replaceStars",je,He),je.trim().replace(E[ue],"")}(We,qe),D("stars",We),We}(Je,be)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(Je){return!!Je.match(Oe)})),Ne=Ne.map(function(Je){return new $(Je,be)})},le.prototype.intersects=function(me,be){if(!(me instanceof le))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Oe){return me.set.some(function(Ne){return Ne.every(function(Je){return Oe.intersects(Je,be)})})})})},e.toComparators=function(me,be){return new le(me,be).set.map(function(we){return we.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},le.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new L(me,this.loose));for(var be=0;be<this.set.length;be++)if(ke(this.set[be],me))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(me,be,we){var Oe=null,Ne=null;try{var Je=new le(be,we)}catch{return null}return me.forEach(function(We){Je.test(We)&&(Oe&&Ne.compare(We)!==-1||(Ne=new L(Oe=We,we)))}),Oe},e.minSatisfying=function(me,be,we){var Oe=null,Ne=null;try{var Je=new le(be,we)}catch{return null}return me.forEach(function(We){Je.test(We)&&(Oe&&Ne.compare(We)!==1||(Ne=new L(Oe=We,we)))}),Oe},e.validRange=function(me,be){try{return new le(me,be).range||"*"}catch{return null}},e.ltr=function(me,be,we){return Be(me,be,"<",we)},e.gtr=function(me,be,we){return Be(me,be,">",we)},e.outside=Be,e.prerelease=function(me,be){var we=ie(me,be);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(me,be,we){return me=new le(me,we),be=new le(be,we),me.intersects(be)},e.coerce=function(me){if(me instanceof L)return me;if(typeof me!="string")return null;var be=me.match(E[W]);return be==null?null:ie((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,b(1))},function(oe,e){var b,t,D=oe.exports={};function C(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function E(y){if(b===setTimeout)return setTimeout(y,0);if((b===C||!b)&&setTimeout)return b=setTimeout,setTimeout(y,0);try{return b(y,0)}catch{try{return b.call(null,y,0)}catch{return b.call(this,y,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:C}catch{b=C}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var p,S=[],T=!1,R=-1;function w(){T&&p&&(T=!1,p.length?S=p.concat(S):R=-1,S.length&&v())}function v(){if(!T){var y=E(w);T=!0;for(var d=S.length;d;){for(p=S,S=[];++R<d;)p&&p[R].run();R=-1,d=S.length}p=null,T=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(y)}}function h(y,d){this.fun=y,this.array=d}function I(){}D.nextTick=function(y){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];S.push(new h(y,d)),S.length!==1||T||E(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=I,D.addListener=I,D.once=I,D.off=I,D.removeListener=I,D.removeAllListeners=I,D.emit=I,D.prependListener=I,D.prependOnceListener=I,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(pe[136],ve([0,1]),function(oe,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,p,S){this.level=E,this.key=p,this.value=S,this.forward=[]}}const D=void 0;class C{constructor(E,p=2**16){this.comparator=E,this[b]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(E){return Boolean(C._search(this,E,this.comparator))}get(E){return C._search(this,E,this.comparator)?.value}set(E,p){return C._insert(this,E,p,this.comparator)&&(this._size+=1),this}delete(E){const p=C._delete(this,E,this.comparator);return p&&(this._size-=1),p}forEach(E,p){let S=this._header.forward[0];for(;S;)E.call(p,S.value,S.key,this),S=S.forward[0]}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",p=this._header.forward[0];for(;p;)E+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return E}static _search(E,p,S){let T=E._header;for(let R=E._level-1;R>=0;R--)for(;T.forward[R]&&S(T.forward[R].key,p)<0;)T=T.forward[R];if(T=T.forward[0],T&&S(T.key,p)===0)return T}static _insert(E,p,S,T){const R=[];let w=E._header;for(let v=E._level-1;v>=0;v--){for(;w.forward[v]&&T(w.forward[v].key,p)<0;)w=w.forward[v];R[v]=w}if(w=w.forward[0],w&&T(w.key,p)===0)return w.value=S,!1;{const v=C._randomLevel(E);if(v>E._level){for(let h=E._level;h<v;h++)R[h]=E._header;E._level=v}w=new t(v,p,S);for(let h=0;h<v;h++)w.forward[h]=R[h].forward[h],R[h].forward[h]=w;return!0}}static _randomLevel(E,p=.5){let S=1;for(;Math.random()<p&&S<E._maxLevel;)S+=1;return S}static _delete(E,p,S){const T=[];let R=E._header;for(let w=E._level-1;w>=0;w--){for(;R.forward[w]&&S(R.forward[w].key,p)<0;)R=R.forward[w];T[w]=R}if(R=R.forward[0],!R||S(R.key,p)!==0)return!1;for(let w=0;w<E._level&&T[w].forward[w]===R;w++)T[w].forward[w]=R.forward[w];for(;E._level>0&&E._header.forward[E._level-1]===D;)E._level-=1;return!0}}e.SkipList=C}),define(pe[46],ve([0,1,11,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(l){const f=l;return f?typeof f.read=="function":!1}e.isReadable=D;function C(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=C;function k(l){const f=l;return f?C(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=k;function E(l,f){return new p(l,f)}e.newWriteableStream=E;class p{constructor(f,r){this.reducer=f,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(r=>r(f))}emitError(f){this.listeners.error.length===0?(0,b.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(r=>r(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,r){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(f,r){if(this.state.destroyed)return;let o;switch(f){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(r);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,f){const r=[];let o;for(;(o=l.read())!==null;)r.push(o);return f(r)}e.consumeReadable=S;function T(l,f,r){const o=[];let n;for(;(n=l.read())!==null&&o.length<r;)o.push(n);return n===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return l.read()}}}e.peekReadable=T;function R(l,f){return new Promise((r,o)=>{const n=[];w(l,{onData:i=>{f&&n.push(i)},onError:i=>{f?o(i):r(void 0)},onEnd:()=>{r(f?f(n):void 0)}})})}e.consumeStream=R;function w(l,f){let r=!1;return l.on("error",o=>{r||f.onError(o)}),l.on("end",()=>{r||f.onEnd()}),l.on("data",o=>{r||f.onData(o)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=w;function v(l,f){return new Promise((r,o)=>{const n=new t.DisposableStore,i=[],s=m=>{if(i.push(m),i.length>f)return n.dispose(),l.pause(),r({stream:l,buffer:i,ended:!1})},a=m=>o(m),c=()=>r({stream:l,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),n.add((0,t.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),n.add((0,t.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=v;function h(l,f){const r=E(f);return r.end(l),r}e.toStream=h;function I(){const l=E(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=I;function y(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=y;function d(l,f,r){const o=E(r);return w(l,{onData:n=>o.write(f.data(n)),onError:n=>o.error(f.error?f.error(n):n),onEnd:()=>o.end()}),o}e.transform=d;function g(l,f,r){let o=!1;return{read:()=>{const n=f.read();return o?n:(o=!0,n!==null?r([l,n]):l)}}}e.prefixedReadable=g;function u(l,f,r){let o=!1;const n=E(r);return w(f,{onData:i=>o?n.write(i):(o=!0,n.write(r([l,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(l)),n.end()}}),n}e.prefixedStream=u}),define(pe[16],ve([0,1,46]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,C;class k{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return t?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return t&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,P){return!(P?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(m)):(D||(D=new TextEncoder),new k(D.encode(m)))}static fromByteArray(m){const P=k.alloc(m.length);for(let _=0,W=m.length;_<W;_++)P.buffer[_]=m[_];return P}static concat(m,P){if(typeof P=="undefined"){P=0;for(let K=0,se=m.length;K<se;K++)P+=m[K].byteLength}const _=k.alloc(P);let W=0;for(let K=0,se=m.length;K<se;K++){const F=m[K];_.set(F,W),W+=F.byteLength}return _}clone(){const m=k.alloc(this.byteLength);return m.set(this),m}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(m,P){return new k(this.buffer.subarray(m,P))}set(m,P){if(m instanceof k)this.buffer.set(m.buffer,P);else if(m instanceof Uint8Array)this.buffer.set(m,P);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),P);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return S(this.buffer,m)}writeUInt32BE(m,P){T(this.buffer,m,P)}readUInt32LE(m){return R(this.buffer,m)}writeUInt32LE(m,P){w(this.buffer,m,P)}readUInt8(m){return v(this.buffer,m)}writeUInt8(m,P){h(this.buffer,m,P)}}e.VSBuffer=k;function E(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0}e.readUInt16LE=E;function p(c,m,P){c[P+0]=m&255,m=m>>>8,c[P+1]=m&255}e.writeUInt16LE=p;function S(c,m){return c[m]*2**24+c[m+1]*2**16+c[m+2]*2**8+c[m+3]}e.readUInt32BE=S;function T(c,m,P){c[P+3]=m,m=m>>>8,c[P+2]=m,m=m>>>8,c[P+1]=m,m=m>>>8,c[P]=m}e.writeUInt32BE=T;function R(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0|c[m+2]<<16>>>0|c[m+3]<<24>>>0}e.readUInt32LE=R;function w(c,m,P){c[P+0]=m&255,m=m>>>8,c[P+1]=m&255,m=m>>>8,c[P+2]=m&255,m=m>>>8,c[P+3]=m&255}e.writeUInt32LE=w;function v(c,m){return c[m]}e.readUInt8=v;function h(c,m,P){c[P]=m}e.writeUInt8=h;function I(c){return b.consumeReadable(c,m=>k.concat(m))}e.readableToBuffer=I;function y(c){return b.toReadable(c)}e.bufferToReadable=y;function d(c){return b.consumeStream(c,m=>k.concat(m))}e.streamToBuffer=d;async function g(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await d(c.stream)])}e.bufferedStreamToBuffer=g;function u(c){return b.toStream(c,m=>k.concat(m))}e.bufferToStream=u;function l(c){return b.transform(c,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.streamToBufferReadableStream=l;function f(c){return b.newWriteableStream(m=>k.concat(m),c)}e.newWriteableBufferStream=f;function r(c,m){return b.prefixedReadable(c,m,P=>k.concat(P))}e.prefixedBufferReadable=r;function o(c,m){return b.prefixedStream(c,m,P=>k.concat(P))}e.prefixedBufferStream=o;function n(c){let m=0,P=0,_=0;const W=new Uint8Array(Math.floor(c.length/4*3)),K=F=>{switch(P){case 3:W[_++]=m|F,P=0;break;case 2:W[_++]=m|F>>>2,m=F<<6,P=3;break;case 1:W[_++]=m|F>>>4,m=F<<4,P=2;break;default:m=F<<2,P=1}};for(let F=0;F<c.length;F++){const Q=c.charCodeAt(F);if(Q>=65&&Q<=90)K(Q-65);else if(Q>=97&&Q<=122)K(Q-97+26);else if(Q>=48&&Q<=57)K(Q-48+52);else if(Q===43||Q===45)K(62);else if(Q===47||Q===95)K(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${c[F]}`)}}const se=_;for(;P>0;)K(0);return k.wrap(W).slice(0,se)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},m=!0,P=!1){const _=P?s:i;let W="";const K=c.byteLength%3;let se=0;for(;se<c.byteLength-K;se+=3){const F=c[se+0],Q=c[se+1],re=c[se+2];W+=_[F>>>2],W+=_[(F<<4|Q>>>4)&63],W+=_[(Q<<2|re>>>6)&63],W+=_[re&63]}if(K===1){const F=c[se+0];W+=_[F>>>2],W+=_[F<<4&63],m&&(W+="==")}else if(K===2){const F=c[se+0],Q=c[se+1];W+=_[F>>>2],W+=_[(F<<4|Q>>>4)&63],W+=_[Q<<2&63],m&&(W+="=")}return W}e.encodeBase64=a}),define(pe[12],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function b(o){return typeof o=="string"}e.isString=b;function t(o){return Array.isArray(o)&&o.every(n=>b(n))}e.isStringArray=t;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function C(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=C;function k(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=k;function E(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=E;function p(o){return o===!0||o===!1}e.isBoolean=p;function S(o){return typeof o=="undefined"}e.isUndefined=S;function T(o){return!R(o)}e.isDefined=T;function R(o){return S(o)||o===null}e.isUndefinedOrNull=R;function w(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=w;function v(o){if(R(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function h(...o){const n=[];for(let i=0;i<o.length;i++){const s=o[i];if(R(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(s)}return n}e.assertAllDefined=h;const I=Object.prototype.hasOwnProperty;function y(o){if(!D(o))return!1;for(const n in o)if(I.call(o,n))return!1;return!0}e.isEmptyObject=y;function d(o){return typeof o=="function"}e.isFunction=d;function g(...o){return o.length>0&&o.every(d)}e.areFunctions=g;function u(o,n){const i=Math.min(o.length,n.length);for(let s=0;s<i;s++)l(o[s],n[s])}e.validateConstraints=u;function l(o,n){if(b(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(d(n)){try{if(o instanceof n)return}catch{}if(!R(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function f(o){return o===null?void 0:o}e.withNullAsUndefined=f;function r(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=r}),define(pe[22],ve([0,1,12]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(u=>{d[u]&&typeof d[u]=="object"?g[u]=t(d[u]):g[u]=d[u]}),g}e.deepClone=t;function D(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const u=g.shift();Object.freeze(u);for(const l in u)if(C.call(u,l)){const f=u[l];typeof f=="object"&&!Object.isFrozen(f)&&!(0,b.isTypedArray)(f)&&g.push(f)}}return d}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(d,g){return E(d,g,new Set)}e.cloneAndChange=k;function E(d,g,u){if((0,b.isUndefinedOrNull)(d))return d;const l=g(d);if(typeof l!="undefined")return l;if(Array.isArray(d)){const f=[];for(const r of d)f.push(E(r,g,u));return f}if((0,b.isObject)(d)){if(u.has(d))throw new Error("Cannot clone recursive data-structure");u.add(d);const f={};for(const r in d)C.call(d,r)&&(f[r]=E(d[r],g,u));return u.delete(d),f}return d}function p(d,g,u=!0){return(0,b.isObject)(d)?((0,b.isObject)(g)&&Object.keys(g).forEach(l=>{l in d?u&&((0,b.isObject)(d[l])&&(0,b.isObject)(g[l])?p(d[l],g[l],u):d[l]=g[l]):d[l]=g[l]}),d):g}e.mixin=p;function S(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let u,l;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(u=0;u<d.length;u++)if(!S(d[u],g[u]))return!1}else{const f=[];for(l in d)f.push(l);f.sort();const r=[];for(l in g)r.push(l);if(r.sort(),!S(f,r))return!1;for(u=0;u<f.length;u++)if(!S(d[f[u]],g[f[u]]))return!1}return!0}e.equals=S;function T(d){const g=new Set;return JSON.stringify(d,(u,l)=>{if((0,b.isObject)(l)||Array.isArray(l)){if(g.has(l))return"[Circular]";g.add(l)}return l})}e.safeStringify=T;function R(d,g){const u=Object.create(null);return!d||!g||Object.keys(g).forEach(f=>{const r=d[f],o=g[f];S(r,o)||(u[f]=o)}),u}e.distinct=R;function w(d,g){const u=g.toLowerCase(),l=Object.keys(d).find(f=>f.toLowerCase()===u);return l?d[l]:d[g]}e.getCaseInsensitive=w;function v(d,g){const u=Object.create(null);for(const[l,f]of Object.entries(d))g(l,f)&&(u[l]=f);return u}e.filter=v;function h(d){let g=[],u=Object.getPrototypeOf(d);for(;Object.prototype!==u;)g=g.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return g}e.getAllPropertyNames=h;function I(d){const g=[];for(const u of h(d))typeof d[u]=="function"&&g.push(u);return g}e.getAllMethodNames=I;function y(d,g){const u=f=>function(){const r=Array.prototype.slice.call(arguments,0);return g(f,r)},l={};for(const f of d)l[f]=u(f);return l}e.createProxyObject=y}),define(pe[23],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return b.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(E){for(let p=0;p<E.length;p++)E[p]=Math.floor(Math.random()*256);return E};const C=new Uint8Array(16),k=[];for(let E=0;E<256;E++)k.push(E.toString(16).padStart(2,"0"));return function(){D(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let p=0,S="";return S+=k[C[p++]],S+=k[C[p++]],S+=k[C[p++]],S+=k[C[p++]],S+="-",S+=k[C[p++]],S+=k[C[p++]],S+="-",S+=k[C[p++]],S+=k[C[p++]],S+="-",S+=k[C[p++]],S+=k[C[p++]],S+="-",S+=k[C[p++]],S+=k[C[p++]],S+=k[C[p++]],S+=k[C[p++]],S+=k[C[p++]],S+=k[C[p++]],S}}()}),function(){"use strict";function oe(e,b,t,D){function C(h){return new Promise(I=>t.exists(h,I))}function k(h){return new Promise((I,y)=>{const d=new Date;t.utimes(h,d,d,g=>g?y(g):I())})}function E(h){return new Promise((I,y)=>t.mkdir(h,{recursive:!0},d=>d&&d.code!=="EEXIST"?y(d):I(h)))}function p(h){return new Promise((I,y)=>t.rm(h,{recursive:!0,force:!0,maxRetries:3},d=>d?y(d):I()))}function S(h){return new Promise((I,y)=>t.readFile(h,"utf8",(d,g)=>d?y(d):I(g)))}function T(h,I){return new Promise((y,d)=>t.writeFile(h,I,"utf8",g=>g?d(g):y()))}function R(h){const I=b.join(h,"languagepacks.json");try{return e(I)}catch{}}function w(h,I){try{for(;I;){if(h[I])return I;{const y=I.lastIndexOf("-");if(y>0)I=I.substring(0,y);else return}}}catch(y){console.error("Resolving language pack configuration failed.",y)}}function v(h,I,y,d){if(d==="pseudo")return Promise.resolve({locale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:d,availableLanguages:{}});if(d&&(d==="en"||d==="en-us"))return Promise.resolve({locale:d,availableLanguages:{}});const g=d;D.mark("code/willGenerateNls");const u=function(l){return D.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!h)return u(g);const l=R(I);if(!l||(d=w(l,d),!d))return u(g);const f=l[d];let r;return!f||typeof f.hash!="string"||!f.translations||typeof(r=f.translations.vscode)!="string"?u(g):C(r).then(o=>{if(!o)return u(g);const n=f.hash+"."+d,i=b.join(I,"clp",n),s=b.join(i,h),a=b.join(i,"tcf.json"),c=b.join(i,"corrupted.info"),m={locale:g,availableLanguages:{"*":d},_languagePackId:n,_translationsConfigFile:a,_cacheRoot:i,_resolvedLanguagePackCoreLocation:s,_corruptedFile:c};return C(c).then(P=>{let _;return P?_=p(i):_=Promise.resolve(void 0),_.then(()=>C(s).then(W=>W?(k(s).catch(()=>{}),D.mark("code/didGenerateNls"),m):E(s).then(()=>Promise.all([S(y),S(r)])).then(K=>{const se=JSON.parse(K[0]),F=JSON.parse(K[1]).contents,Q=Object.keys(se.bundles),re=[];for(const G of Q){const de=se.bundles[G],J=Object.create(null);for(const U of de){const O=se.keys[U],B=se.messages[U],X=F[U];let ce;if(X){ce=[];for(let ue=0;ue<O.length;ue++){const Y=O[ue],ie=typeof Y=="string"?Y:Y.key;let L=X[ie];L===void 0&&(L=B[ue]),ce.push(L)}}else ce=B;J[U]=ce}re.push(T(b.join(s,G.replace(/\//g,"!")+".nls.json"),JSON.stringify(J)))}return re.push(T(a,JSON.stringify(f.translations))),Promise.all(re)}).then(()=>(D.mark("code/didGenerateNls"),m)).catch(K=>(console.error("Generating translation files failed.",K),u(d)))))})})}catch(l){return console.error("Generating translation files failed.",l),u(d)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(pe[137],ve([0,84,29,47]),function(e,b,t,D){return oe(e.__$__nodeRequire,b,t,D)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),b=require("fs"),t=require("../common/performance");module.exports=oe(require,e,b,t)}else throw new Error("Unknown context")}(),define(pe[138],ve([0,1,30]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const E=k.replace(/\-/g,":").toLowerCase();return!t.has(E)}function C(){const k=(0,b.networkInterfaces)();for(const E in k){const p=k[E];if(p){for(const{mac:S}of p)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(pe[139],ve([0,1,85]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,p,S,T=1){let R=!1;return new Promise(w=>{const v=setTimeout(()=>{if(!R)return R=!0,w(0)},S);D(E,p,T,h=>{if(!R)return R=!0,clearTimeout(v),w(h)})})}e.findFreePort=t;function D(E,p,S,T){if(p===0)return T(0);const R=new b.Socket;R.once("connect",()=>(k(R),D(E+S,p-1,S,T))),R.once("data",()=>{}),R.once("error",w=>(k(R),w.code!=="ECONNREFUSED"?D(E+S,p-1,S,T):T(E))),R.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(E,p,S){let T=!1,R,w=1;const v=b.createServer({pauseOnConnect:!0});function h(I,y){T||(T=!0,v.removeAllListeners(),v.close(),R&&clearTimeout(R),y(I))}return new Promise(I=>{R=setTimeout(()=>{h(0,I)},S),v.on("listening",()=>{h(E,I)}),v.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&w<p?(E++,w++,v.listen(E,"127.0.0.1")):h(0,I)}),v.on("close",()=>{h(0,I)}),v.listen(E,"127.0.0.1")})}e.findFreePortFaster=C;function k(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(p){console.error(p)}}}),define(pe[86],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new b(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return b.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return b.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return b.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){const k=D.lineNumber|0,E=C.lineNumber|0;if(k===E){const p=D.column|0,S=C.column|0;return p-S}return k-E}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new b(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=b}),define(pe[48],ve([0,1,86]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,k,E,p){C>E||C===E&&k>p?(this.startLineNumber=E,this.startColumn=p,this.endLineNumber=C,this.endColumn=k):(this.startLineNumber=C,this.startColumn=k,this.endLineNumber=E,this.endColumn=p)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,k){return!(k.lineNumber<C.startLineNumber||k.lineNumber>C.endLineNumber||k.lineNumber===C.startLineNumber&&k.column<C.startColumn||k.lineNumber===C.endLineNumber&&k.column>C.endColumn)}static strictContainsPosition(C,k){return!(k.lineNumber<C.startLineNumber||k.lineNumber>C.endLineNumber||k.lineNumber===C.startLineNumber&&k.column<=C.startColumn||k.lineNumber===C.endLineNumber&&k.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,k){return!(k.startLineNumber<C.startLineNumber||k.endLineNumber<C.startLineNumber||k.startLineNumber>C.endLineNumber||k.endLineNumber>C.endLineNumber||k.startLineNumber===C.startLineNumber&&k.startColumn<C.startColumn||k.endLineNumber===C.endLineNumber&&k.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,k){return!(k.startLineNumber<C.startLineNumber||k.endLineNumber<C.startLineNumber||k.startLineNumber>C.endLineNumber||k.endLineNumber>C.endLineNumber||k.startLineNumber===C.startLineNumber&&k.startColumn<=C.startColumn||k.endLineNumber===C.endLineNumber&&k.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,k){let E,p,S,T;return k.startLineNumber<C.startLineNumber?(E=k.startLineNumber,p=k.startColumn):k.startLineNumber===C.startLineNumber?(E=k.startLineNumber,p=Math.min(k.startColumn,C.startColumn)):(E=C.startLineNumber,p=C.startColumn),k.endLineNumber>C.endLineNumber?(S=k.endLineNumber,T=k.endColumn):k.endLineNumber===C.endLineNumber?(S=k.endLineNumber,T=Math.max(k.endColumn,C.endColumn)):(S=C.endLineNumber,T=C.endColumn),new t(E,p,S,T)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,k){let E=C.startLineNumber,p=C.startColumn,S=C.endLineNumber,T=C.endColumn;const R=k.startLineNumber,w=k.startColumn,v=k.endLineNumber,h=k.endColumn;return E<R?(E=R,p=w):E===R&&(p=Math.max(p,w)),S>v?(S=v,T=h):S===v&&(T=Math.min(T,h)),E>S||E===S&&p>T?null:new t(E,p,S,T)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,k){return!!C&&!!k&&C.startLineNumber===k.startLineNumber&&C.startColumn===k.startColumn&&C.endLineNumber===k.endLineNumber&&C.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new b.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new b.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,k){return new t(this.startLineNumber,this.startColumn,C,k)}setStartPosition(C,k){return new t(C,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(C){return new t(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,k=C){return new t(C.lineNumber,C.column,k.lineNumber,k.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,k){return!(C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<k.startColumn||k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<C.startColumn)}static areIntersecting(C,k){return!(C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<=k.startColumn||k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,k){if(C&&k){const S=C.startLineNumber|0,T=k.startLineNumber|0;if(S===T){const R=C.startColumn|0,w=k.startColumn|0;if(R===w){const v=C.endLineNumber|0,h=k.endLineNumber|0;if(v===h){const I=C.endColumn|0,y=k.endColumn|0;return I-y}return v-h}return R-w}return S-T}return(C?1:0)-(k?1:0)}static compareRangesUsingEnds(C,k){return C.endLineNumber===k.endLineNumber?C.endColumn===k.endColumn?C.startLineNumber===k.startLineNumber?C.startColumn-k.startColumn:C.startLineNumber-k.startLineNumber:C.endColumn-k.endColumn:C.endLineNumber-k.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=t}),define(pe[140],ve([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(pe[141],ve([0,1,140]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,C=D*24,k=C*7,E=C*30,p=C*365;function S(R,w,v){typeof R!="number"&&(R=R.getTime());const h=Math.round((new Date().getTime()-R)/1e3);if(h<-30)return(0,b.localize)(0,null,S(new Date().getTime()+h*1e3,!1));if(h<30)return(0,b.localize)(1,null);let I;return h<t?(I=h,w?I===1?v?(0,b.localize)(2,null,I):(0,b.localize)(3,null,I):v?(0,b.localize)(4,null,I):(0,b.localize)(5,null,I):I===1?v?(0,b.localize)(6,null,I):(0,b.localize)(7,null,I):v?(0,b.localize)(8,null,I):(0,b.localize)(9,null,I)):h<D?(I=Math.floor(h/t),w?I===1?v?(0,b.localize)(10,null,I):(0,b.localize)(11,null,I):v?(0,b.localize)(12,null,I):(0,b.localize)(13,null,I):I===1?v?(0,b.localize)(14,null,I):(0,b.localize)(15,null,I):v?(0,b.localize)(16,null,I):(0,b.localize)(17,null,I)):h<C?(I=Math.floor(h/D),w?I===1?v?(0,b.localize)(18,null,I):(0,b.localize)(19,null,I):v?(0,b.localize)(20,null,I):(0,b.localize)(21,null,I):I===1?v?(0,b.localize)(22,null,I):(0,b.localize)(23,null,I):v?(0,b.localize)(24,null,I):(0,b.localize)(25,null,I)):h<k?(I=Math.floor(h/C),w?I===1?(0,b.localize)(26,null,I):(0,b.localize)(27,null,I):I===1?(0,b.localize)(28,null,I):(0,b.localize)(29,null,I)):h<E?(I=Math.floor(h/k),w?I===1?v?(0,b.localize)(30,null,I):(0,b.localize)(31,null,I):v?(0,b.localize)(32,null,I):(0,b.localize)(33,null,I):I===1?v?(0,b.localize)(34,null,I):(0,b.localize)(35,null,I):v?(0,b.localize)(36,null,I):(0,b.localize)(37,null,I)):h<p?(I=Math.floor(h/E),w?I===1?v?(0,b.localize)(38,null,I):(0,b.localize)(39,null,I):v?(0,b.localize)(40,null,I):(0,b.localize)(41,null,I):I===1?v?(0,b.localize)(42,null,I):(0,b.localize)(43,null,I):v?(0,b.localize)(44,null,I):(0,b.localize)(45,null,I)):(I=Math.floor(h/p),w?I===1?v?(0,b.localize)(46,null,I):(0,b.localize)(47,null,I):v?(0,b.localize)(48,null,I):(0,b.localize)(49,null,I):I===1?v?(0,b.localize)(50,null,I):(0,b.localize)(51,null,I):v?(0,b.localize)(52,null,I):(0,b.localize)(53,null,I))}e.fromNow=S;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(pe[142],ve([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(pe[38],ve([0,1,18,12,142]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(R,w){return w&&(R.stack||R.stacktrace)?D.localize(0,null,E(R),k(R.stack)||k(R.stacktrace)):E(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function E(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?D.localize(1,null,R.message):R.message||D.localize(2,null)}function p(R=null,w=!1){if(!R)return D.localize(3,null);if(Array.isArray(R)){const v=b.coalesce(R),h=p(v[0],w);return v.length>1?D.localize(4,null,h,v.length):h}if(t.isString(R))return R;if(R.detail){const v=R.detail;if(v.error)return C(v.error,w);if(v.exception)return C(v.exception,w)}return R.stack?C(R,w):R.message?R.message:D.localize(5,null)}e.toErrorMessage=p;function S(R){const w=R;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=S;function T(R,w){let v;return typeof R=="string"?v=new Error(R):v=R,v.actions=w,v}e.createErrorWithActions=T}),define(pe[143],ve([8,9]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(pe[144],ve([0,1,143]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(D){switch(D){case 1:return(0,b.localize)(0,null);case 2:return(0,b.localize)(1,null);case 3:return(0,b.localize)(2,null);case 4:return(0,b.localize)(3,null);case 5:return(0,b.localize)(4,null);case 6:return(0,b.localize)(5,null);case 7:return(0,b.localize)(6,null);case 8:return(0,b.localize)(7,null);case 9:return(0,b.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(pe[145],ve([8,9]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(pe[3],ve([0,1,145]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,C=!1,k=!1,E=!1,p=!1,S=!1,T=!1,R=!1,w=!1,v,h=t,I,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string",u=g&&d?.type==="renderer";if(typeof navigator=="object"&&!u)y=navigator.userAgent,D=y.indexOf("Windows")>=0,C=y.indexOf("Macintosh")>=0,R=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=y.indexOf("Linux")>=0,S=!0,v=b.getConfiguredDefaultLocale(b.localize(0,null))||t,h=v;else if(typeof d=="object"){D=d.platform==="win32",C=d.platform==="darwin",k=d.platform==="linux",E=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,T=g,w=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=t,h=t;const c=d.env.VSCODE_NLS_CONFIG;if(c)try{const m=JSON.parse(c),P=m.availableLanguages["*"];v=m.locale,h=P||t,I=m._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var l;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function f(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let r=0;C?r=1:D?r=3:k&&(r=2),e.isWindows=D,e.isMacintosh=C,e.isLinux=k,e.isLinuxSnap=E,e.isNative=p,e.isElectron=T,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isCI=w,e.platform=r,e.userAgent=y,e.language=h;var o;(function(c){function m(){return e.language}c.value=m;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=P;function _(){return e.language==="en"}c.isDefault=_})(o=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=I,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let _=0,W=c.length;_<W;_++){const K=c[_];if(K.id===P.data.vscodeScheduleAsyncWork){c.splice(_,1),K.callback();return}}});let m=0;return P=>{const _=++m;c.push({id:_,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return c=>setTimeout(c)})();var n;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||R?2:D?1:3;let i=!0,s=!1;function a(){if(!s){s=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,i=new Uint16Array(c.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[28],ve([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof b.globals.vscode!="undefined"&&typeof b.globals.vscode.process!="undefined"){const D=b.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[6],ve([0,1,28]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,C=90,k=122,E=46,p=47,S=92,T=58,R=63;class w extends Error{constructor(l,f,r){let o;typeof f=="string"&&f.indexOf("not ")===0?(o="must not be",f=f.replace(/^not /,"")):o="must be";const n=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${n} ${o} of type ${f}`;i+=`. Received type ${typeof r}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function v(u,l){if(typeof u!="string")throw new w(l,"string",u)}function h(u){return u===p||u===S}function I(u){return u===p}function y(u){return u>=t&&u<=C||u>=D&&u<=k}function d(u,l,f,r){let o="",n=0,i=-1,s=0,a=0;for(let c=0;c<=u.length;++c){if(c<u.length)a=u.charCodeAt(c);else{if(r(a))break;a=p}if(r(a)){if(!(i===c-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const m=o.lastIndexOf(f);m===-1?(o="",n=0):(o=o.slice(0,m),n=o.length-1-o.lastIndexOf(f)),i=c,s=0;continue}else if(o.length!==0){o="",n=0,i=c,s=0;continue}}l&&(o+=o.length>0?`${f}..`:"..",n=2)}else o.length>0?o+=`${f}${u.slice(i+1,c)}`:o=u.slice(i+1,c),n=c-i-1;i=c,s=0}else a===E&&s!==-1?++s:s=-1}return o}function g(u,l){if(l===null||typeof l!="object")throw new w("pathObject","Object",l);const f=l.dir||l.root,r=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${r}`:`${f}${u}${r}`:r}e.win32={resolve(...u){let l="",f="",r=!1;for(let o=u.length-1;o>=-1;o--){let n;if(o>=0){if(n=u[o],v(n,"path"),n.length===0)continue}else l.length===0?n=b.cwd():(n=b.env[`=${l}`]||b.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===S)&&(n=`${l}\\`));const i=n.length;let s=0,a="",c=!1;const m=n.charCodeAt(0);if(i===1)h(m)&&(s=1,c=!0);else if(h(m))if(c=!0,h(n.charCodeAt(1))){let P=2,_=P;for(;P<i&&!h(n.charCodeAt(P));)P++;if(P<i&&P!==_){const W=n.slice(_,P);for(_=P;P<i&&h(n.charCodeAt(P));)P++;if(P<i&&P!==_){for(_=P;P<i&&!h(n.charCodeAt(P));)P++;(P===i||P!==_)&&(a=`\\\\${W}\\${n.slice(_,P)}`,s=P)}}}else s=1;else y(m)&&n.charCodeAt(1)===T&&(a=n.slice(0,2),s=2,i>2&&h(n.charCodeAt(2))&&(c=!0,s=3));if(a.length>0)if(l.length>0){if(a.toLowerCase()!==l.toLowerCase())continue}else l=a;if(r){if(l.length>0)break}else if(f=`${n.slice(s)}\\${f}`,r=c,c&&l.length>0)break}return f=d(f,!r,"\\",h),r?`${l}\\${f}`:`${l}${f}`||"."},normalize(u){v(u,"path");const l=u.length;if(l===0)return".";let f=0,r,o=!1;const n=u.charCodeAt(0);if(l===1)return I(n)?"\\":u;if(h(n))if(o=!0,h(u.charCodeAt(1))){let s=2,a=s;for(;s<l&&!h(u.charCodeAt(s));)s++;if(s<l&&s!==a){const c=u.slice(a,s);for(a=s;s<l&&h(u.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&!h(u.charCodeAt(s));)s++;if(s===l)return`\\\\${c}\\${u.slice(a)}\\`;s!==a&&(r=`\\\\${c}\\${u.slice(a,s)}`,f=s)}}}else f=1;else y(n)&&u.charCodeAt(1)===T&&(r=u.slice(0,2),f=2,l>2&&h(u.charCodeAt(2))&&(o=!0,f=3));let i=f<l?d(u.slice(f),!o,"\\",h):"";return i.length===0&&!o&&(i="."),i.length>0&&h(u.charCodeAt(l-1))&&(i+="\\"),r===void 0?o?`\\${i}`:i:o?`${r}\\${i}`:`${r}${i}`},isAbsolute(u){v(u,"path");const l=u.length;if(l===0)return!1;const f=u.charCodeAt(0);return h(f)||l>2&&y(f)&&u.charCodeAt(1)===T&&h(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,f;for(let n=0;n<u.length;++n){const i=u[n];v(i,"path"),i.length>0&&(l===void 0?l=f=i:l+=`\\${i}`)}if(l===void 0)return".";let r=!0,o=0;if(typeof f=="string"&&h(f.charCodeAt(0))){++o;const n=f.length;n>1&&h(f.charCodeAt(1))&&(++o,n>2&&(h(f.charCodeAt(2))?++o:r=!1))}if(r){for(;o<l.length&&h(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(u,l){if(v(u,"from"),v(l,"to"),u===l)return"";const f=e.win32.resolve(u),r=e.win32.resolve(l);if(f===r||(u=f.toLowerCase(),l=r.toLowerCase(),u===l))return"";let o=0;for(;o<u.length&&u.charCodeAt(o)===S;)o++;let n=u.length;for(;n-1>o&&u.charCodeAt(n-1)===S;)n--;const i=n-o;let s=0;for(;s<l.length&&l.charCodeAt(s)===S;)s++;let a=l.length;for(;a-1>s&&l.charCodeAt(a-1)===S;)a--;const c=a-s,m=i<c?i:c;let P=-1,_=0;for(;_<m;_++){const K=u.charCodeAt(o+_);if(K!==l.charCodeAt(s+_))break;K===S&&(P=_)}if(_!==m){if(P===-1)return r}else{if(c>m){if(l.charCodeAt(s+_)===S)return r.slice(s+_+1);if(_===2)return r.slice(s+_)}i>m&&(u.charCodeAt(o+_)===S?P=_:_===2&&(P=3)),P===-1&&(P=0)}let W="";for(_=o+P+1;_<=n;++_)(_===n||u.charCodeAt(_)===S)&&(W+=W.length===0?"..":"\\..");return s+=P,W.length>0?`${W}${r.slice(s,a)}`:(r.charCodeAt(s)===S&&++s,r.slice(s,a))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===S){if(l.charCodeAt(1)===S){const f=l.charCodeAt(2);if(f!==R&&f!==E)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(y(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===S)return`\\\\?\\${l}`;return u},dirname(u){v(u,"path");const l=u.length;if(l===0)return".";let f=-1,r=0;const o=u.charCodeAt(0);if(l===1)return h(o)?u:".";if(h(o)){if(f=r=1,h(u.charCodeAt(1))){let s=2,a=s;for(;s<l&&!h(u.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&h(u.charCodeAt(s));)s++;if(s<l&&s!==a){for(a=s;s<l&&!h(u.charCodeAt(s));)s++;if(s===l)return u;s!==a&&(f=r=s+1)}}}}else y(o)&&u.charCodeAt(1)===T&&(f=l>2&&h(u.charCodeAt(2))?3:2,r=f);let n=-1,i=!0;for(let s=l-1;s>=r;--s)if(h(u.charCodeAt(s))){if(!i){n=s;break}}else i=!1;if(n===-1){if(f===-1)return".";n=f}return u.slice(0,n)},basename(u,l){l!==void 0&&v(l,"ext"),v(u,"path");let f=0,r=-1,o=!0,n;if(u.length>=2&&y(u.charCodeAt(0))&&u.charCodeAt(1)===T&&(f=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let i=l.length-1,s=-1;for(n=u.length-1;n>=f;--n){const a=u.charCodeAt(n);if(h(a)){if(!o){f=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===l.charCodeAt(i)?--i==-1&&(r=n):(i=-1,r=s))}return f===r?r=s:r===-1&&(r=u.length),u.slice(f,r)}for(n=u.length-1;n>=f;--n)if(h(u.charCodeAt(n))){if(!o){f=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":u.slice(f,r)},extname(u){v(u,"path");let l=0,f=-1,r=0,o=-1,n=!0,i=0;u.length>=2&&u.charCodeAt(1)===T&&y(u.charCodeAt(0))&&(l=r=2);for(let s=u.length-1;s>=l;--s){const a=u.charCodeAt(s);if(h(a)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),a===E?f===-1?f=s:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||o===-1||i===0||i===1&&f===o-1&&f===r+1?"":u.slice(f,o)},format:g.bind(null,"\\"),parse(u){v(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const f=u.length;let r=0,o=u.charCodeAt(0);if(f===1)return h(o)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(h(o)){if(r=1,h(u.charCodeAt(1))){let P=2,_=P;for(;P<f&&!h(u.charCodeAt(P));)P++;if(P<f&&P!==_){for(_=P;P<f&&h(u.charCodeAt(P));)P++;if(P<f&&P!==_){for(_=P;P<f&&!h(u.charCodeAt(P));)P++;P===f?r=P:P!==_&&(r=P+1)}}}}else if(y(o)&&u.charCodeAt(1)===T){if(f<=2)return l.root=l.dir=u,l;if(r=2,h(u.charCodeAt(2))){if(f===3)return l.root=l.dir=u,l;r=3}}r>0&&(l.root=u.slice(0,r));let n=-1,i=r,s=-1,a=!0,c=u.length-1,m=0;for(;c>=r;--c){if(o=u.charCodeAt(c),h(o)){if(!a){i=c+1;break}continue}s===-1&&(a=!1,s=c+1),o===E?n===-1?n=c:m!==1&&(m=1):n!==-1&&(m=-1)}return s!==-1&&(n===-1||m===0||m===1&&n===s-1&&n===i+1?l.base=l.name=u.slice(i,s):(l.name=u.slice(i,n),l.base=u.slice(i,s),l.ext=u.slice(n,s))),i>0&&i!==r?l.dir=u.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",f=!1;for(let r=u.length-1;r>=-1&&!f;r--){const o=r>=0?u[r]:b.cwd();v(o,"path"),o.length!==0&&(l=`${o}/${l}`,f=o.charCodeAt(0)===p)}return l=d(l,!f,"/",I),f?`/${l}`:l.length>0?l:"."},normalize(u){if(v(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===p,f=u.charCodeAt(u.length-1)===p;return u=d(u,!l,"/",I),u.length===0?l?"/":f?"./":".":(f&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return v(u,"path"),u.length>0&&u.charCodeAt(0)===p},join(...u){if(u.length===0)return".";let l;for(let f=0;f<u.length;++f){const r=u[f];v(r,"path"),r.length>0&&(l===void 0?l=r:l+=`/${r}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(v(u,"from"),v(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const f=1,r=u.length,o=r-f,n=1,i=l.length-n,s=o<i?o:i;let a=-1,c=0;for(;c<s;c++){const P=u.charCodeAt(f+c);if(P!==l.charCodeAt(n+c))break;P===p&&(a=c)}if(c===s)if(i>s){if(l.charCodeAt(n+c)===p)return l.slice(n+c+1);if(c===0)return l.slice(n+c)}else o>s&&(u.charCodeAt(f+c)===p?a=c:c===0&&(a=0));let m="";for(c=f+a+1;c<=r;++c)(c===r||u.charCodeAt(c)===p)&&(m+=m.length===0?"..":"/..");return`${m}${l.slice(n+a)}`},toNamespacedPath(u){return u},dirname(u){if(v(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===p;let f=-1,r=!0;for(let o=u.length-1;o>=1;--o)if(u.charCodeAt(o)===p){if(!r){f=o;break}}else r=!1;return f===-1?l?"/":".":l&&f===1?"//":u.slice(0,f)},basename(u,l){l!==void 0&&v(l,"ext"),v(u,"path");let f=0,r=-1,o=!0,n;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let i=l.length-1,s=-1;for(n=u.length-1;n>=0;--n){const a=u.charCodeAt(n);if(a===p){if(!o){f=n+1;break}}else s===-1&&(o=!1,s=n+1),i>=0&&(a===l.charCodeAt(i)?--i==-1&&(r=n):(i=-1,r=s))}return f===r?r=s:r===-1&&(r=u.length),u.slice(f,r)}for(n=u.length-1;n>=0;--n)if(u.charCodeAt(n)===p){if(!o){f=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":u.slice(f,r)},extname(u){v(u,"path");let l=-1,f=0,r=-1,o=!0,n=0;for(let i=u.length-1;i>=0;--i){const s=u.charCodeAt(i);if(s===p){if(!o){f=i+1;break}continue}r===-1&&(o=!1,r=i+1),s===E?l===-1?l=i:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||r===-1||n===0||n===1&&l===r-1&&l===f+1?"":u.slice(l,r)},format:g.bind(null,"/"),parse(u){v(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const f=u.charCodeAt(0)===p;let r;f?(l.root="/",r=1):r=0;let o=-1,n=0,i=-1,s=!0,a=u.length-1,c=0;for(;a>=r;--a){const m=u.charCodeAt(a);if(m===p){if(!s){n=a+1;break}continue}i===-1&&(s=!1,i=a+1),m===E?o===-1?o=a:c!==1&&(c=1):o!==-1&&(c=-1)}if(i!==-1){const m=n===0&&f?1:n;o===-1||c===0||c===1&&o===i-1&&o===n+1?l.base=l.name=u.slice(m,i):(l.name=u.slice(m,o),l.base=u.slice(m,i),l.ext=u.slice(o,i))}return n>0?l.dir=u.slice(0,n-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[66],ve([0,1,6]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(T){const R=(0,b.extname)(T),w=t[R.toLowerCase()];return w!==void 0?w:k(T)}e.getMediaOrTextMime=C;function k(T){const R=(0,b.extname)(T);return D[R.toLowerCase()]}e.getMediaMime=k;function E(T){for(const R in D)if(D[R]===T)return R}e.getExtensionForMimeType=E;const p=/^(.+)\/(.+?)(;.+)?$/;function S(T,R){const w=p.exec(T);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:R?void 0:T}e.normalizeMimeType=S}),define(pe[56],ve([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(E,...p){const S=p.reduce((w,v)=>(w[v]=!0,w),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(w=>!S[w]).forEach(w=>{for(let v=0;v<T.length;v++)if(w.search(T[v])!==-1){delete E[w];break}})}e.sanitizeProcessEnvironment=C;function k(E){!E||(delete E.DEBUG,b.isMacintosh&&delete E.DYLD_LIBRARY_PATH,b.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(pe[146],ve([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=b.globals.performance&&typeof b.globals.performance.now=="function";class D{constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=D}),define(pe[7],ve([0,1,11,64,2,134,146]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const E=!1,p=!1;var S;(function(a){a.None=()=>D.Disposable.None;function c(N){if(p){const{onListenerDidAdd:q}=N,te=h.create();let fe=0;N.onListenerDidAdd=()=>{++fe==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),q?.()}}}function m(N){return(q,te=null,fe)=>{let ye=!1,j;return j=N(Z=>{if(!ye)return j?j.dispose():ye=!0,q.call(te,Z)},null,fe),ye&&j.dispose(),j}}a.once=m;function P(N,q,te){return Q((fe,ye=null,j)=>N(Z=>fe.call(ye,q(Z)),null,j),te)}a.map=P;function _(N,q,te){return Q((fe,ye=null,j)=>N(Z=>{q(Z),fe.call(ye,Z)},null,j),te)}a.forEach=_;function W(N,q,te){return Q((fe,ye=null,j)=>N(Z=>q(Z)&&fe.call(ye,Z),null,j),te)}a.filter=W;function K(N){return N}a.signal=K;function se(...N){return(q,te=null,fe)=>(0,D.combinedDisposable)(...N.map(ye=>ye(j=>q.call(te,j),null,fe)))}a.any=se;function F(N,q,te,fe){let ye=te;return P(N,j=>(ye=q(ye,j),ye),fe)}a.reduce=F;function Q(N,q){let te;const fe={onFirstListenerAdd(){te=N(ye.fire,ye)},onLastListenerRemove(){te?.dispose()}};q||c(fe);const ye=new y(fe);return q?.add(ye),ye.event}function re(N,q,te=100,fe=!1,ye,j){let Z,ne,z,V=0;const $={leakWarningThreshold:ye,onFirstListenerAdd(){Z=N(le=>{V++,ne=q(ne,le),fe&&!z&&(x.fire(ne),ne=void 0),clearTimeout(z),z=setTimeout(()=>{const ge=ne;ne=void 0,z=void 0,(!fe||V>1)&&x.fire(ge),V=0},te)})},onLastListenerRemove(){Z.dispose()}};j||c($);const x=new y($);return j?.add(x),x.event}a.debounce=re;function G(N,q=(fe,ye)=>fe===ye,te){let fe=!0,ye;return W(N,j=>{const Z=fe||!q(j,ye);return fe=!1,ye=j,Z},te)}a.latch=G;function de(N,q,te){return[a.filter(N,q,te),a.filter(N,fe=>!q(fe),te)]}a.split=de;function J(N,q=!1,te=[]){let fe=te.slice(),ye=N(ne=>{fe?fe.push(ne):Z.fire(ne)});const j=()=>{fe?.forEach(ne=>Z.fire(ne)),fe=null},Z=new y({onFirstListenerAdd(){ye||(ye=N(ne=>Z.fire(ne)))},onFirstListenerDidAdd(){fe&&(q?setTimeout(j):j())},onLastListenerRemove(){ye&&ye.dispose(),ye=null}});return Z.event}a.buffer=J;class U{constructor(q){this.event=q,this.disposables=new D.DisposableStore}map(q){return new U(P(this.event,q,this.disposables))}forEach(q){return new U(_(this.event,q,this.disposables))}filter(q){return new U(W(this.event,q,this.disposables))}reduce(q,te){return new U(F(this.event,q,te,this.disposables))}latch(){return new U(G(this.event,void 0,this.disposables))}debounce(q,te=100,fe=!1,ye){return new U(re(this.event,q,te,fe,ye,this.disposables))}on(q,te,fe){return this.event(q,te,fe)}once(q,te,fe){return m(this.event)(q,te,fe)}dispose(){this.disposables.dispose()}}function O(N){return new U(N)}a.chain=O;function B(N,q,te=fe=>fe){const fe=(...ne)=>Z.fire(te(...ne)),ye=()=>N.on(q,fe),j=()=>N.removeListener(q,fe),Z=new y({onFirstListenerAdd:ye,onLastListenerRemove:j});return Z.event}a.fromNodeEventEmitter=B;function X(N,q,te=fe=>fe){const fe=(...ne)=>Z.fire(te(...ne)),ye=()=>N.addEventListener(q,fe),j=()=>N.removeEventListener(q,fe),Z=new y({onFirstListenerAdd:ye,onLastListenerRemove:j});return Z.event}a.fromDOMEventEmitter=X;function ce(N){return new Promise(q=>m(N)(q))}a.toPromise=ce;function ue(N,q){return q(void 0),N(te=>q(te))}a.runAndSubscribe=ue;function Y(N,q){let te=null;function fe(j){te?.dispose(),te=new D.DisposableStore,q(j,te)}fe(void 0);const ye=N(j=>fe(j));return(0,D.toDisposable)(()=>{ye.dispose(),te?.dispose()})}a.runAndSubscribeWithStore=Y;class ie{constructor(q,te){this.obs=q,this._counter=0,this._hasChanged=!1;const fe={onFirstListenerAdd:()=>{q.addObserver(this)},onLastListenerRemove:()=>{q.removeObserver(this)}};te||c(fe),this.emitter=new y(fe),te&&te.add(this.emitter)}beginUpdate(q){this._counter++}handleChange(q,te){this._hasChanged=!0}endUpdate(q){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(N,q){return new ie(N,q).emitter.event}a.fromObservable=L})(S=e.Event||(e.Event={}));class T{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${T._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}T._idPool=0;let R=-1;function w(a){const c=R;return R=a,{dispose(){R=c}}}e.setGlobalLeakWarningThreshold=w;class v{constructor(c,m=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,m){let P=R;if(typeof this.customThreshold=="number"&&(P=this.customThreshold),P<=0||m<P)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let W,K=0;for(const[se,F]of this._stacks)(!W||K<F)&&(W=se,K=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${K}):`),console.warn(W)}return()=>{const W=this._stacks.get(c.value)||0;this._stacks.set(c.value,W-1)}}}class h{constructor(c){this.value=c}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class I{constructor(c,m,P){this.callback=c,this.callbackThis=m,this.stack=P,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class y{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=R>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const m of c)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,m,P)=>{this._listeners||(this._listeners=new C.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let W,K;this._leakageMon&&this._listeners.size>=30&&(K=h.create(),W=this._leakageMon.check(K,this._listeners.size+1)),E&&(K=K??h.create());const se=new I(c,m,K),F=this._listeners.push(se);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,m);const Q=se.subscription.set(()=>{W?.(),this._disposed||(F(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return P instanceof D.DisposableStore?P.add(Q):Array.isArray(P)&&P.push(Q),Q}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const m of this._listeners)this._deliveryQueue.push(this,m,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class d{constructor(){this._queue=new C.LinkedList}get size(){return this._queue.size}push(c,m,P){this._queue.push(new u(c,m,P))}clear(c){const m=new C.LinkedList;for(const P of this._queue)P.emitter!==c&&m.push(P);this._queue=m}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(m){(0,b.onUnexpectedError)(m)}}}}e.EventDeliveryQueue=d;class g extends d{clear(c){this._queue.clear()}}class u{constructor(c,m,P){this.emitter=c,this.listener=m,this.event=P}}class l extends y{async fireAsync(c,m,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,c]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[_,W]=this._asyncDeliveryQueue.shift(),K=[],se={...W,token:m,waitUntil:F=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");P&&(F=P(F,_.callback)),K.push(F)}};try{_.invoke(se)}catch(F){(0,b.onUnexpectedError)(F);continue}Object.freeze(K),await Promise.allSettled(K).then(F=>{for(const Q of F)Q.status==="rejected"&&(0,b.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=l;class f extends y{constructor(c){super(c);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=f;class r extends f{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=r;class o extends y{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]})}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const m={event:c,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const P=()=>{this.hasListeners&&this.unhook(m);const _=this.events.indexOf(m);this.events.splice(_,1)};return(0,D.toDisposable)((0,t.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(m=>this.emitter.fire(m))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(c){return(m,P,_)=>c(W=>{const K=this.buffers[this.buffers.length-1];K?K.push(()=>m.call(P,W)):m.call(P,W)},void 0,_)}bufferEvents(c){const m=[];this.buffers.push(m);const P=c();return this.buffers.pop(),m.forEach(_=>_()),P}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=D.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(pe[20],ve([0,1,7]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,p){const S=setTimeout(E.bind(p),0);return{dispose(){clearTimeout(S)}}});var D;(function(E){function p(S){return S===E.None||S===E.Cancelled||S instanceof C?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}E.isCancellationToken=p,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(pe[147],ve([0,1,20]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new b.CancellationTokenSource,p=this.task(E.token);return this.result={promise:p,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class D{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const p=JSON.stringify(E);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=D;class C{constructor(E){this.fn=E,this._map=new Map}get cachedValues(){return this._map}get(E){if(this._map.has(E))return this._map.get(E);const p=this.fn(E);return this._map.set(E,p),p}}e.CachedFunction=C}),define(pe[87],ve([0,1,7,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=k=>({onDidChange:b.Event.None,value:k});e.staticObservableValue=D;class C extends t.Disposable{constructor(E){super();this._value=E,this.changeEmitter=this._register(new b.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}}e.MutableObservableValue=C}),define(pe[15],ve([0,1,147,133]),function(oe,e,b,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function E(ae,...Ce){return Ce.length===0?ae:ae.replace(k,function(Te,Ae){const Fe=parseInt(Ae,10);return isNaN(Fe)||Fe<0||Fe>=Ce.length?Te:Ce[Fe]})}e.format=E;const p=/{([^}]+)}/g;function S(ae,Ce){return ae.replace(p,(Te,Ae)=>Ce[Ae]??Te)}e.format2=S;function T(ae){return ae.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function R(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function w(ae,Ce){let Te=0;const Ae=Ce.charCodeAt(0);for(let Fe=ae.length-1;Fe>=0;Fe--)ae.charCodeAt(Fe)===Ae&&Te++;return Te}e.count=w;function v(ae,Ce,Te="\u2026"){return ae.length<=Ce?ae:`${ae.substr(0,Ce)}${Te}`}e.truncate=v;function h(ae,Ce=" "){const Te=I(ae,Ce);return y(Te,Ce)}e.trim=h;function I(ae,Ce){if(!ae||!Ce)return ae;const Te=Ce.length;if(Te===0||ae.length===0)return ae;let Ae=0;for(;ae.indexOf(Ce,Ae)===Ae;)Ae=Ae+Te;return ae.substring(Ae)}e.ltrim=I;function y(ae,Ce){if(!ae||!Ce)return ae;const Te=Ce.length,Ae=ae.length;if(Te===0||Ae===0)return ae;let Fe=Ae,Ue=-1;for(;Ue=ae.lastIndexOf(Ce,Fe-1),!(Ue===-1||Ue+Te!==Fe);){if(Ue===0)return"";Fe=Ue}return ae.substring(0,Fe)}e.rtrim=y;function d(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(ae){return ae.replace(/\*/g,"")}e.stripWildcards=g;function u(ae,Ce,Te={}){if(!ae)throw new Error("Cannot create regex from empty string");Ce||(ae=R(ae)),Te.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let Ae="";return Te.global&&(Ae+="g"),Te.matchCase||(Ae+="i"),Te.multiline&&(Ae+="m"),Te.unicode&&(Ae+="u"),new RegExp(ae,Ae)}e.createRegExp=u;function l(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function f(ae){return!!ae.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function r(ae){return(ae.global?"g":"")+(ae.ignoreCase?"i":"")+(ae.multiline?"m":"")+(ae.unicode?"u":"")}e.regExpFlags=r;function o(ae){return ae.split(/\r\n|\r|\n/)}e.splitLines=o;function n(ae){for(let Ce=0,Te=ae.length;Ce<Te;Ce++){const Ae=ae.charCodeAt(Ce);if(Ae!==32&&Ae!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function i(ae,Ce=0,Te=ae.length){for(let Ae=Ce;Ae<Te;Ae++){const Fe=ae.charCodeAt(Ae);if(Fe!==32&&Fe!==9)return ae.substring(Ce,Ae)}return ae.substring(Ce,Te)}e.getLeadingWhitespace=i;function s(ae,Ce=ae.length-1){for(let Te=Ce;Te>=0;Te--){const Ae=ae.charCodeAt(Te);if(Ae!==32&&Ae!==9)return Te}return-1}e.lastNonWhitespaceIndex=s;function a(ae,Ce,Te){const Ae=[];let Fe=0;for(const Ue of ae.matchAll(Ce)){if(Ae.push(ae.slice(Fe,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Fe=Ue.index+Ue[0].length,Ae.push(Te(Ue[0],...Ue.slice(1),Ue.index,ae,Ue.groups))}return Ae.push(ae.slice(Fe)),Promise.all(Ae).then(Ue=>Ue.join(""))}e.replaceAsync=a;function c(ae,Ce){return ae<Ce?-1:ae>Ce?1:0}e.compare=c;function m(ae,Ce,Te=0,Ae=ae.length,Fe=0,Ue=Ce.length){for(;Te<Ae&&Fe<Ue;Te++,Fe++){const Ze=ae.charCodeAt(Te),tt=Ce.charCodeAt(Fe);if(Ze<tt)return-1;if(Ze>tt)return 1}const xe=Ae-Te,Qe=Ue-Fe;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstring=m;function P(ae,Ce){return _(ae,Ce,0,ae.length,0,Ce.length)}e.compareIgnoreCase=P;function _(ae,Ce,Te=0,Ae=ae.length,Fe=0,Ue=Ce.length){for(;Te<Ae&&Fe<Ue;Te++,Fe++){let Ze=ae.charCodeAt(Te),tt=Ce.charCodeAt(Fe);if(Ze===tt)continue;if(Ze>=128||tt>=128)return m(ae.toLowerCase(),Ce.toLowerCase(),Te,Ae,Fe,Ue);K(Ze)&&(Ze-=32),K(tt)&&(tt-=32);const it=Ze-tt;if(it!==0)return it}const xe=Ae-Te,Qe=Ue-Fe;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstringIgnoreCase=_;function W(ae){return ae>=48&&ae<=57}e.isAsciiDigit=W;function K(ae){return ae>=97&&ae<=122}e.isLowerAsciiLetter=K;function se(ae){return ae>=65&&ae<=90}e.isUpperAsciiLetter=se;function F(ae,Ce){return ae.length===Ce.length&&_(ae,Ce)===0}e.equalsIgnoreCase=F;function Q(ae,Ce){const Te=Ce.length;return Ce.length>ae.length?!1:_(ae,Ce,0,Te)===0}e.startsWithIgnoreCase=Q;function re(ae,Ce){const Te=Math.min(ae.length,Ce.length);let Ae;for(Ae=0;Ae<Te;Ae++)if(ae.charCodeAt(Ae)!==Ce.charCodeAt(Ae))return Ae;return Te}e.commonPrefixLength=re;function G(ae,Ce){const Te=Math.min(ae.length,Ce.length);let Ae;const Fe=ae.length-1,Ue=Ce.length-1;for(Ae=0;Ae<Te;Ae++)if(ae.charCodeAt(Fe-Ae)!==Ce.charCodeAt(Ue-Ae))return Ae;return Te}e.commonSuffixLength=G;function de(ae){return 55296<=ae&&ae<=56319}e.isHighSurrogate=de;function J(ae){return 56320<=ae&&ae<=57343}e.isLowSurrogate=J;function U(ae,Ce){return(ae-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=U;function O(ae,Ce,Te){const Ae=ae.charCodeAt(Te);if(de(Ae)&&Te+1<Ce){const Fe=ae.charCodeAt(Te+1);if(J(Fe))return U(Ae,Fe)}return Ae}e.getNextCodePoint=O;function B(ae,Ce){const Te=ae.charCodeAt(Ce-1);if(J(Te)&&Ce>1){const Ae=ae.charCodeAt(Ce-2);if(de(Ae))return U(Ae,Te)}return Te}class X{constructor(Ce,Te=0){this._str=Ce,this._len=Ce.length,this._offset=Te}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=B(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=O(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=X;class ce{constructor(Ce,Te=0){this._iterator=new X(Ce,Te)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=Oe.getInstance(),Te=this._iterator,Ae=Te.offset;let Fe=Ce.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const Ue=Te.offset,xe=Ce.getGraphemeBreakType(Te.nextCodePoint());if(be(Fe,xe)){Te.setOffset(Ue);break}Fe=xe}return Te.offset-Ae}prevGraphemeLength(){const Ce=Oe.getInstance(),Te=this._iterator,Ae=Te.offset;let Fe=Ce.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const Ue=Te.offset,xe=Ce.getGraphemeBreakType(Te.prevCodePoint());if(be(xe,Fe)){Te.setOffset(Ue);break}Fe=xe}return Ae-Te.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ce;function ue(ae,Ce){return new ce(ae,Ce).nextGraphemeLength()}e.nextCharLength=ue;function Y(ae,Ce){return new ce(ae,Ce).prevGraphemeLength()}e.prevCharLength=Y;function ie(ae,Ce){Ce>0&&J(ae.charCodeAt(Ce))&&Ce--;const Te=Ce+ue(ae,Ce);return[Te-Y(ae,Te),Te]}e.getCharContainingOffset=ie;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function N(ae){return L.test(ae)}e.containsRTL=N;const q=/^[\t\n\r\x20-\x7E]*$/;function te(ae){return q.test(ae)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(ae){return e.UNUSUAL_LINE_TERMINATORS.test(ae)}e.containsUnusualLineTerminators=fe;function ye(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.isFullWidthCharacter=ye;function j(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.isEmojiImprecise=j;function Z(ae,Ce){if(ae.length<Ce)return ae;const Te=/\b/g;let Ae=0;for(;Te.test(ae)&&!(ae.length-Te.lastIndex<Ce);)Ae=Te.lastIndex,Te.lastIndex+=1;return ae.substring(Ae).replace(/^\s/,"")}e.lcut=Z;const ne=/\x1B\x5B[12]?K/g,z=/\x1b\[\d+m/g,V=/\x1b\[0?m/g;function $(ae){return ae&&(ae=ae.replace(ne,""),ae=ae.replace(z,""),ae=ae.replace(V,"")),ae}e.removeAnsiEscapeCodes=$,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function x(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.startsWithUTF8BOM=x;function le(ae){return x(ae)?ae.substr(1):ae}e.stripUTF8BOM=le;function ge(ae,Ce){if(!ae||!Ce||ae.length<Ce.length)return!1;const Te=Ce.length,Ae=ae.toLowerCase();let Fe=0,Ue=-1;for(;Fe<Te;){const xe=Ae.indexOf(Ce[Fe],Ue+1);if(xe<0)return!1;Ue=xe,Fe++}return!0}e.fuzzyContains=ge;function Pe(ae,Ce=!1){return ae?(Ce&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.containsUppercaseCharacter=Pe;function ke(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.uppercaseFirstLetter=ke;function Me(ae,Ce=1){if(Ce===0)return"";let Te=-1;do Te=ae.indexOf(`
`,Te+1),Ce--;while(Ce>0&&Te>=0);return Te===-1?ae:(ae[Te-1]==="\r"&&Te--,ae.substr(0,Te))}e.getNLines=Me;function Be(ae){const Ce=90-65+1;return ae=ae%(2*Ce),ae<Ce?String.fromCharCode(97+ae):String.fromCharCode(65+ae-Ce)}e.singleLetterHash=Be;function me(ae){return Oe.getInstance().getGraphemeBreakType(ae)}e.getGraphemeBreakType=me;function be(ae,Ce){return ae===0?Ce!==5&&Ce!==7:ae===2&&Ce===3?!1:ae===4||ae===2||ae===3||Ce===4||Ce===2||Ce===3?!0:!(ae===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ae===11||ae===9)&&(Ce===9||Ce===10)||(ae===12||ae===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ae===1||ae===13&&Ce===14||ae===6&&Ce===6)}var we;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(we=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Ne()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Te=this._data,Ae=Te.length/3;let Fe=1;for(;Fe<=Ae;)if(Ce<Te[3*Fe])Fe=2*Fe;else if(Ce>Te[3*Fe+1])Fe=2*Fe+1;else return Te[3*Fe+2];return 0}}Oe._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(ae,Ce){if(ae===0)return 0;const Te=We(ae,Ce);if(Te!==void 0)return Te;const Ae=new X(Ce,ae);return Ae.prevCodePoint(),Ae.offset}e.getLeftDeleteOffset=Je;function We(ae,Ce){const Te=new X(Ce,ae);let Ae=Te.prevCodePoint();for(;qe(Ae)||Ae===65039||Ae===8419;){if(Te.offset===0)return;Ae=Te.prevCodePoint()}if(!j(Ae))return;let Fe=Te.offset;return Fe>0&&Te.prevCodePoint()===8205&&(Fe=Te.offset),Fe}function qe(ae){return 127995<=ae&&ae<=127999}var je;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class He{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return He.cache.get(Array.from(Ce))}static getLocales(){return He._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,D=He,He.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new b.LRUCachedFunction(ae=>{function Ce(tt){const it=new Map;for(let rt=0;rt<tt.length;rt+=2)it.set(tt[rt],tt[rt+1]);return it}function Te(tt,it){const rt=new Map(tt);for(const[ft,gt]of it)rt.set(ft,gt);return rt}function Ae(tt,it){if(!tt)return it;const rt=new Map;for(const[ft,gt]of tt)it.has(ft)&&rt.set(ft,gt);return rt}const Fe=D.ambiguousCharacterData.getValue();let Ue=ae.filter(tt=>!tt.startsWith("_")&&tt in Fe);Ue.length===0&&(Ue=["_default"]);let xe;for(const tt of Ue){const it=Ce(Fe[tt]);xe=Ae(xe,it)}const Qe=Ce(Fe._common),Ze=Te(Qe,xe);return new He(Ze)}),He._locales=new t.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(ae=>!ae.startsWith("_")));class Ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ke.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ke.getData().has(Ce)}static get codePoints(){return Ke.getData()}}e.InvisibleCharacters=Ke,Ke._data=void 0}),define(pe[35],ve([0,1,6,3,15,12]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function E(s){return s.replace(/[\\/]/g,b.posix.sep)}e.toSlashes=E;function p(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function S(s,a=b.posix.sep){if(!s)return"";const c=s.length,m=s.charCodeAt(0);if(k(m)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let _=3;const W=_;for(;_<c&&!k(s.charCodeAt(_));_++);if(W!==_&&!k(s.charCodeAt(_+1))){for(_+=1;_<c;_++)if(k(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,a)}}return a}else if(d(m)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let P=s.indexOf("://");if(P!==-1){for(P+=3;P<c;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1)}return""}e.getRoot=S;function T(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let c=2;const m=c;for(;c<s.length&&(a=s.charCodeAt(c),a!==92);c++);return!(m===c||(a=s.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,a=t.isWindows){const c=a?R:w;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||a&&v.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function I(s,a,c){const m=s===a;return!c||m?m:!s||!a?!1:(0,D.equalsIgnoreCase)(s,a)}e.isEqual=I;function y(s,a,c,m=b.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let _=a.length;return a.charAt(a.length-1)===m&&_--,s.charAt(_)===m}return a.charAt(a.length-1)!==m&&(a+=m),s.indexOf(a)===0}e.isEqualOrParent=y;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function g(s,a){return t.isWindows&&s.endsWith(":")&&(s+=b.sep),(0,b.isAbsolute)(s)||(s=(0,b.join)(a,s)),s=(0,b.normalize)(s),t.isWindows?(s=(0,D.rtrim)(s,b.sep),s.endsWith(":")&&(s+=b.sep)):(s=(0,D.rtrim)(s,b.sep),s||(s=b.sep)),s}e.sanitizeFilePath=g;function u(s){const a=(0,b.normalize)(s);return t.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===b.posix.sep}e.isRootOrDriveLetter=u;function l(s,a=t.isWindows){return a?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function f(s){return l(s)?s[0]:void 0}e.getDriveLetter=f;function r(s,a,c){return a.length>s.length?-1:s===a?0:(c&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=r;function o(s){const a=s.split(":");let c,m,P;for(const _ of a){const W=Number(_);(0,C.isNumber)(W)?m===void 0?m=W:P===void 0&&(P=W):c=c?[c,_].join(":"):_}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:m!==void 0?m:void 0,column:P!==void 0?P:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,c=8){let m="";for(let _=0;_<c;_++)m+=n.charAt(Math.floor(Math.random()*n.length));let P;return a?P=`${a}-${m}`:P=m,s?(0,b.join)(s,P):P}e.randomPath=i}),define(pe[88],ve([0,1,15]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return D(d,0)}e.hash=t;function D(d,g){switch(typeof d){case"object":return d===null?C(349,g):Array.isArray(d)?p(d,g):S(d,g);case"string":return E(d,g);case"boolean":return k(d,g);case"number":return C(d,g);case"undefined":return C(937,g);default:return C(617,g)}}e.doHash=D;function C(d,g){return(g<<5)-g+d|0}e.numberHash=C;function k(d,g){return C(d?433:863,g)}function E(d,g){g=C(149417,g);for(let u=0,l=d.length;u<l;u++)g=C(d.charCodeAt(u),g);return g}e.stringHash=E;function p(d,g){return g=C(104579,g),d.reduce((u,l)=>D(l,u),g)}function S(d,g){return g=C(181387,g),Object.keys(d).sort().reduce((u,l)=>(u=E(l,u),D(d[l],u)),g)}class T{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=D(g,this._value),this._value}}e.Hasher=T;var R;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function w(d,g,u=32){const l=u-g,f=~((1<<l)-1);return(d<<g|(f&d)>>>l)>>>0}function v(d,g=0,u=d.byteLength,l=0){for(let f=0;f<u;f++)d[g+f]=l}function h(d,g,u="0"){for(;d.length<g;)d=u+d;return d}function I(d,g=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(u=>u.toString(16).padStart(2,"0")).join(""):h((d>>>0).toString(16),g/4)}e.toHexString=I;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const u=g.length;if(u===0)return;const l=this._buff;let f=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=g.charCodeAt(0),n=0);;){let i=o;if(b.isHighSurrogate(o))if(n+1<u){const s=g.charCodeAt(n+1);b.isLowSurrogate(s)?(n++,i=b.computeCodePoint(o,s)):i=65533}else{r=o;break}else b.isLowSurrogate(o)&&(i=65533);if(f=this._push(l,f,i),n++,n<u)o=g.charCodeAt(n);else break}this._buffLen=f,this._leftoverHighSurrogate=r}_push(g,u,l){return l<128?g[u++]=l:l<2048?(g[u++]=192|(l&1984)>>>6,g[u++]=128|(l&63)>>>0):l<65536?(g[u++]=224|(l&61440)>>>12,g[u++]=128|(l&4032)>>>6,g[u++]=128|(l&63)>>>0):(g[u++]=240|(l&1835008)>>>18,g[u++]=128|(l&258048)>>>12,g[u++]=128|(l&4032)>>>6,g[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),I(this._h0)+I(this._h1)+I(this._h2)+I(this._h3)+I(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=y._bigBlock32,u=this._buffDV;for(let c=0;c<64;c+=4)g.setUint32(c,u.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)g.setUint32(c,w(g.getUint32(c-12,!1)^g.getUint32(c-32,!1)^g.getUint32(c-56,!1)^g.getUint32(c-64,!1),1),!1);let l=this._h0,f=this._h1,r=this._h2,o=this._h3,n=this._h4,i,s,a;for(let c=0;c<80;c++)c<20?(i=f&r|~f&o,s=1518500249):c<40?(i=f^r^o,s=1859775393):c<60?(i=f&r|f&o|r&o,s=2400959708):(i=f^r^o,s=3395469782),a=w(l,5)+i+n+s+g.getUint32(c*4,!1)&4294967295,n=o,o=r,r=w(f,30),f=l,l=a;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[24],ve([0,1,18,15]),function(oe,e,b,t){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(n,i,s){let a=n.get(i);return a===void 0&&(a=s,n.set(i,a)),a}e.getOrSet=E;function p(n){const i=[];return n.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=p;function S(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=S;class T{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=T;class R{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class w{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var v;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(y||(y={}));class d{constructor(i){this._iter=i}static forUris(i=()=>!1,s=()=>!1){return new d(new h(i,s))}static forPaths(i=!1){return new d(new w(void 0,!i))}static forStrings(){return new d(new T)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,b.shuffle)(a);for(const c of a)this.set(c,i)}else{const a=i.slice(0);(0,b.shuffle)(a);for(const c of a)this.set(c[0],c[1])}}set(i,s){const a=this._iter.reset(i);let c;this._root||(this._root=new I,this._root.segment=a.value());const m=[];for(c=this._root;;){const _=a.cmp(c.segment);if(_>0)c.left||(c.left=new I,c.left.segment=a.value()),m.push([-1,c]),c=c.left;else if(_<0)c.right||(c.right=new I,c.right.segment=a.value()),m.push([1,c]),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new I,c.mid.segment=a.value()),m.push([0,c]),c=c.mid;else break}const P=c.value;c.value=s,c.key=i;for(let _=m.length-1;_>=0;_--){const W=m[_][1];W.updateHeight();const K=W.balanceFactor();if(K<-1||K>1){const se=m[_][0],F=m[_+1][0];if(se===1&&F===1)m[_][1]=W.rotateLeft();else if(se===-1&&F===-1)m[_][1]=W.rotateRight();else if(se===1&&F===-1)W.right=m[_+1][1]=m[_+1][1].rotateRight(),m[_][1]=W.rotateLeft();else if(se===-1&&F===1)W.left=m[_+1][1]=m[_+1][1].rotateLeft(),m[_][1]=W.rotateRight();else throw new Error;if(_>0)switch(m[_-1][0]){case-1:m[_-1][1].left=m[_][1];break;case 1:m[_-1][1].right=m[_][1];break;case 0:m[_-1][1].mid=m[_][1];break}else this._root=m[0][1]}}return P}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const c=s.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),c=[];let m=this._root;for(;m;){const P=a.cmp(m.segment);if(P>0)c.push([-1,m]),m=m.left;else if(P<0)c.push([1,m]),m=m.right;else if(a.hasNext())a.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(s?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const P=this._min(m.right),{key:_,value:W,segment:K}=P;this._delete(P.key,!1),m.key=_,m.value=W,m.segment=K}else{const P=m.left??m.right;if(c.length>0){const[_,W]=c[c.length-1];switch(_){case-1:W.left=P;break;case 0:W.mid=P;break;case 1:W.right=P;break}}else this._root=P}for(let P=c.length-1;P>=0;P--){const _=c[P][1];_.updateHeight();const W=_.balanceFactor();if(W>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),c[P][1]=_.rotateLeft()):W<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),c[P][1]=_.rotateRight()),P>0)switch(c[P-1][0]){case-1:c[P-1][1].left=c[P][1];break;case 1:c[P-1][1].right=c[P][1];break;case 0:c[P-1][1].mid=c[P][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,c;for(;a;){const m=s.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(s.hasNext())s.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const c=s.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=d;class g{constructor(i,s){this.uri=i,this.value=s}}class u{constructor(i,s){this[D]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new g(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(const[a,c]of this.map)i(c.value,c.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=n=>n.toString();class l{constructor(i,s){this[C]="ResourceSet",!i||typeof i=="function"?this._map=new u(i):(this._map=new u(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((a,c)=>i.call(s,c,c,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var f;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class r{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let c=this._map.get(i);if(c)c.value=s,a!==0&&this.touch(c,a);else{switch(c={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let c=this._head;for(;c;){if(s?i.bind(s)(c.value,c.key,this):i(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.key,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return c}values(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.value,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return c}entries(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:[a.key,a.value],done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return c}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,c=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=r;class o extends r{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(pe[148],ve([0,1,24,15]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...$){return function(x,le){for(let ge=0,Pe=$.length;ge<Pe;ge++){const ke=$[ge](x,le);if(ke)return ke}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C($,x,le){if(!le||le.length<x.length)return null;let ge;return $?ge=t.startsWithIgnoreCase(le,x):ge=le.indexOf(x)===0,ge?x.length>0?[{start:0,end:x.length}]:[]:null}function k($,x){const le=x.toLowerCase().indexOf($.toLowerCase());return le===-1?null:[{start:le,end:le+$.length}]}e.matchesContiguousSubString=k;function E($,x){return p($.toLowerCase(),x.toLowerCase(),0,0)}e.matchesSubString=E;function p($,x,le,ge){if(le===$.length)return[];if(ge===x.length)return null;if($[le]===x[ge]){let Pe=null;return(Pe=p($,x,le+1,ge+1))?d({start:ge,end:ge+1},Pe):null}return p($,x,le,ge+1)}function S($){return 97<=$&&$<=122}function T($){return 65<=$&&$<=90}e.isUpper=T;function R($){return 48<=$&&$<=57}function w($){return $===32||$===9||$===10||$===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach($=>v.add($.charCodeAt(0)));function h($){return w($)||v.has($)}function I($,x){return $===x||h($)&&h(x)}function y($){return S($)||T($)||R($)}function d($,x){return x.length===0?x=[$]:$.end===x[0].start?x[0].start=$.start:x.unshift($),x}function g($,x){for(let le=x;le<$.length;le++){const ge=$.charCodeAt(le);if(T(ge)||R(ge)||le>0&&!y($.charCodeAt(le-1)))return le}return $.length}function u($,x,le,ge){if(le===$.length)return[];if(ge===x.length)return null;if($[le]!==x[ge].toLowerCase())return null;{let Pe=null,ke=ge+1;for(Pe=u($,x,le+1,ge+1);!Pe&&(ke=g(x,ke))<x.length;)Pe=u($,x,le+1,ke),ke++;return Pe===null?null:d({start:ge,end:ge+1},Pe)}}function l($){let x=0,le=0,ge=0,Pe=0,ke=0;for(let we=0;we<$.length;we++)ke=$.charCodeAt(we),T(ke)&&x++,S(ke)&&le++,y(ke)&&ge++,R(ke)&&Pe++;const Me=x/$.length,Be=le/$.length,me=ge/$.length,be=Pe/$.length;return{upperPercent:Me,lowerPercent:Be,alphaPercent:me,numericPercent:be}}function f($){const{upperPercent:x,lowerPercent:le}=$;return le===0&&x>.6}function r($){const{upperPercent:x,lowerPercent:le,alphaPercent:ge,numericPercent:Pe}=$;return le>.2&&x<.8&&ge>.6&&Pe<.2}function o($){let x=0,le=0,ge=0,Pe=0;for(let ke=0;ke<$.length;ke++)ge=$.charCodeAt(ke),T(ge)&&x++,S(ge)&&le++,w(ge)&&Pe++;return(x===0||le===0)&&Pe===0?$.length<=30:x<=5}function n($,x){if(!x||(x=x.trim(),x.length===0)||!o($)||x.length>60)return null;const le=l(x);if(!r(le)){if(!f(le))return null;x=x.toLowerCase()}let ge=null,Pe=0;for($=$.toLowerCase();Pe<x.length&&(ge=u($,x,0,Pe))===null;)Pe=g(x,Pe+1);return ge}e.matchesCamelCase=n;function i($,x,le=!1){if(!x||x.length===0)return null;let ge=null,Pe=0;for($=$.toLowerCase(),x=x.toLowerCase();Pe<x.length&&(ge=s($,x,0,Pe,le))===null;)Pe=a(x,Pe+1);return ge}e.matchesWords=i;function s($,x,le,ge,Pe){if(le===$.length)return[];if(ge===x.length)return null;if(I($.charCodeAt(le),x.charCodeAt(ge))){let ke=null,Me=ge+1;if(ke=s($,x,le+1,ge+1,Pe),!Pe)for(;!ke&&(Me=a(x,Me))<x.length;)ke=s($,x,le+1,Me,Pe),Me++;return ke?$.charCodeAt(le)!==x.charCodeAt(ge)?ke:d({start:ge,end:ge+1},ke):null}else return null}function a($,x){for(let le=x;le<$.length;le++)if(h($.charCodeAt(le))||le>0&&h($.charCodeAt(le-1)))return le;return $.length}const c=D(e.matchesPrefix,n,k),m=D(e.matchesPrefix,n,E),P=new b.LRUCache(1e4);function _($,x,le=!1){if(typeof $!="string"||typeof x!="string")return null;let ge=P.get($);ge||(ge=new RegExp(t.convertSimple2RegExpPattern($),"i"),P.set($,ge));const Pe=ge.exec(x);return Pe?[{start:Pe.index,end:Pe.index+Pe[0].length}]:le?m($,x):c($,x)}e.matchesFuzzy=_;function W($,x){const le=fe($,$.toLowerCase(),0,x,x.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?se(le):null}e.matchesFuzzy2=W;function K($,x,le,ge,Pe,ke){const Me=Math.min(13,$.length);for(;le<Me;le++){const Be=fe($,x,le,ge,Pe,ke,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Be)return Be}return[0,ke]}e.anyScore=K;function se($){if(typeof $=="undefined")return[];const x=[],le=$[1];for(let ge=$.length-1;ge>1;ge--){const Pe=$[ge]+le,ke=x[x.length-1];ke&&ke.end===Pe?ke.end=Pe+1:x.push({start:Pe,end:Pe+1})}return x}e.createMatches=se;const F=128;function Q(){const $=[],x=[];for(let le=0;le<=F;le++)x[le]=0;for(let le=0;le<=F;le++)$.push(x.slice(0));return $}function re($){const x=[];for(let le=0;le<=$;le++)x[le]=0;return x}const G=re(2*F),de=re(2*F),J=Q(),U=Q(),O=Q(),B=!1;function X($,x,le,ge,Pe){function ke(Be,me,be=" "){for(;Be.length<me;)Be=be+Be;return Be}let Me=` |   |${ge.split("").map(Be=>ke(Be,3)).join("|")}
`;for(let Be=0;Be<=le;Be++)Be===0?Me+=" |":Me+=`${x[Be-1]}|`,Me+=$[Be].slice(0,Pe+1).map(me=>ke(me.toString(),3)).join("|")+`
`;return Me}function ce($,x,le,ge){$=$.substr(x),le=le.substr(ge),console.log(X(U,$,$.length,le,le.length)),console.log(X(O,$,$.length,le,le.length)),console.log(X(J,$,$.length,le,le.length))}function ue($,x){if(x<0||x>=$.length)return!1;const le=$.codePointAt(x);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(le)}}function Y($,x){if(x<0||x>=$.length)return!1;switch($.charCodeAt(x)){case 32:case 9:return!0;default:return!1}}function ie($,x,le){return x[$]!==le[$]}function L($,x,le,ge,Pe,ke,Me=!1){for(;x<le&&Pe<ke;)$[x]===ge[Pe]&&(Me&&(G[x]=Pe),x+=1),Pe+=1;return x===le}e.isPatternInWord=L;var N;(function($){$[$.Diag=1]="Diag",$[$.Left=2]="Left",$[$.LeftLeft=3]="LeftLeft"})(N||(N={}));var q;(function($){$.Default=[-100,0];function x(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}$.isDefault=x})(q=e.FuzzyScore||(e.FuzzyScore={}));class te{constructor(x,le){this.firstMatchCanBeWeak=x,this.boostFullMatch=le}}e.FuzzyScoreOptions=te,te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function fe($,x,le,ge,Pe,ke,Me=te.default){const Be=$.length>F?F:$.length,me=ge.length>F?F:ge.length;if(le>=Be||ke>=me||Be-le>me-ke||!L(x,le,Be,Pe,ke,me,!0))return;ye(Be,me,le,ke,x,Pe);let be=1,we=1,Oe=le,Ne=ke;const Je=[!1];for(be=1,Oe=le;Oe<Be;be++,Oe++){const Ke=G[Oe],ae=de[Oe],Ce=Oe+1<Be?de[Oe+1]:me;for(we=Ke-ke+1,Ne=Ke;Ne<Ce;we++,Ne++){let Te=Number.MIN_SAFE_INTEGER,Ae=!1;Ne<=ae&&(Te=j($,x,Oe,le,ge,Pe,Ne,me,ke,J[be-1][we-1]===0,Je));let Fe=0;Te!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Fe=Te+U[be-1][we-1]);const Ue=Ne>Ke,xe=Ue?U[be][we-1]+(J[be][we-1]>0?-5:0):0,Qe=Ne>Ke+1&&J[be][we-1]>0,Ze=Qe?U[be][we-2]+(J[be][we-2]>0?-5:0):0;if(Qe&&(!Ue||Ze>=xe)&&(!Ae||Ze>=Fe))U[be][we]=Ze,O[be][we]=3,J[be][we]=0;else if(Ue&&(!Ae||xe>=Fe))U[be][we]=xe,O[be][we]=2,J[be][we]=0;else if(Ae)U[be][we]=Fe,O[be][we]=1,J[be][we]=J[be-1][we-1]+1;else throw new Error("not possible")}}if(B&&ce($,le,ge,ke),!Je[0]&&!Me.firstMatchCanBeWeak)return;be--,we--;const We=[U[be][we],ke];let qe=0,je=0;for(;be>=1;){let Ke=we;do{const ae=O[be][Ke];if(ae===3)Ke=Ke-2;else if(ae===2)Ke=Ke-1;else break}while(Ke>=1);qe>1&&x[le+be-1]===Pe[ke+we-1]&&!ie(Ke+ke-1,ge,Pe)&&qe+1>J[be][Ke]&&(Ke=we),Ke===we?qe++:qe=1,je||(je=Ke),be--,we=Ke-1,We.push(we)}me===Be&&Me.boostFullMatch&&(We[0]+=2);const He=je-Be;return We[0]-=He,We}e.fuzzyScore=fe;function ye($,x,le,ge,Pe,ke){let Me=$-1,Be=x-1;for(;Me>=le&&Be>=ge;)Pe[Me]===ke[Be]&&(de[Me]=Be,Me--),Be--}function j($,x,le,ge,Pe,ke,Me,Be,me,be,we){if(x[le]!==ke[Me])return Number.MIN_SAFE_INTEGER;let Oe=1,Ne=!1;return Me===le-ge?Oe=$[le]===Pe[Me]?7:5:ie(Me,Pe,ke)&&(Me===0||!ie(Me-1,Pe,ke))?(Oe=$[le]===Pe[Me]?7:5,Ne=!0):ue(ke,Me)&&(Me===0||!ue(ke,Me-1))?Oe=5:(ue(ke,Me-1)||Y(ke,Me-1))&&(Oe=5,Ne=!0),Oe>1&&le===ge&&(we[0]=!0),Ne||(Ne=ie(Me,Pe,ke)||ue(ke,Me-1)||Y(ke,Me-1)),le===ge?Me>me&&(Oe-=Ne?3:5):be?Oe+=Ne?2:0:Oe+=Ne?0:1,Me+1===Be&&(Oe-=Ne?3:5),Oe}function Z($,x,le,ge,Pe,ke,Me){return z($,x,le,ge,Pe,ke,!0,Me)}e.fuzzyScoreGracefulAggressive=Z;function ne($,x,le,ge,Pe,ke,Me){return z($,x,le,ge,Pe,ke,!1,Me)}e.fuzzyScoreGraceful=ne;function z($,x,le,ge,Pe,ke,Me,Be){let me=fe($,x,le,ge,Pe,ke,Be);if(me&&!Me)return me;if($.length>=3){const be=Math.min(7,$.length-1);for(let we=le+1;we<be;we++){const Oe=V($,we);if(Oe){const Ne=fe(Oe,Oe.toLowerCase(),le,ge,Pe,ke,Be);Ne&&(Ne[0]-=3,(!me||Ne[0]>me[0])&&(me=Ne))}}}return me}function V($,x){if(x+1>=$.length)return;const le=$[x],ge=$[x+1];if(le!==ge)return $.slice(0,x)+ge+le+$.slice(x+2)}}),define(pe[149],ve([0,1,40,148,15]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(b.CSSIcon.iconNameCharacter),E=new RegExp(`(\\\\)?${C.source}`,"g");function p(y){return y.replace(E,(d,g)=>g?d:`\\${d}`)}e.escapeIcons=p;const S=new RegExp(`\\\\${C.source}`,"g");function T(y){return y.replace(S,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function w(y){return y.indexOf(e.iconStartMarker)===-1?y:y.replace(R,(d,g,u,l)=>u?d:g||l||"")}e.stripIcons=w;function v(y){const d=y.indexOf(e.iconStartMarker);return d===-1?{text:y}:h(y,d)}e.parseLabelWithIcons=v;function h(y,d){const g=[];let u="";function l(c){if(c){u+=c;for(const m of c)g.push(o)}}let f=-1,r="",o=0,n,i,s=d;const a=y.length;for(l(y.substr(0,d));s<a;)n=y[s],i=y[s+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(f=s,l(r),r=e.iconStartMarker,s++):n===")"&&f!==-1?(o+=s-f+1,f=-1,r=""):f!==-1?k.test(n)?r+=n:(l(r),f=-1,r=""):l(n),s++;return l(r),{text:u,iconOffsets:g}}function I(y,d,g=!1){const{text:u,iconOffsets:l}=d;if(!l||l.length===0)return(0,t.matchesFuzzy)(y,u,g);const f=(0,D.ltrim)(u," "),r=u.length-f.length,o=(0,t.matchesFuzzy)(y,f,g);if(o)for(const n of o){const i=l[n.start+r]+r;n.start+=i,n.end+=i}return o}e.matchesFuzzyIconAware=I}),define(pe[89],ve([0,1,24]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new b.LRUCache(1e4);function D(S){return p(S,"NFC",t)}e.normalizeNFC=D;const C=new b.LRUCache(1e4);function k(S){return p(S,"NFD",C)}e.normalizeNFD=k;const E=/[^\u0000-\u0080]/;function p(S,T,R){if(!S)return S;const w=R.get(S);if(w)return w;let v;return E.test(S)?v=S.normalize(T):v=S,R.set(S,v),v}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(T){return k(T).replace(S,"")}}()}),define(pe[67],ve([0,1,15]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const C="error",k="warning",E="warn",p="info",S="ignore";function T(w){return w?b.equalsIgnoreCase(C,w)?D.Error:b.equalsIgnoreCase(k,w)||b.equalsIgnoreCase(E,w)?D.Warning:b.equalsIgnoreCase(p,w)?D.Info:D.Ignore:D.Ignore}D.fromValue=T;function R(w){switch(w){case D.Error:return C;case D.Warning:return k;case D.Info:return p;default:return S}}D.toString=R}(t||(t={})),e.default=t}),define(pe[4],ve([0,1,6,3]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function E(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(n,i){return!n&&!i?"file":n}function S(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==R&&(i=R+i):i=R;break}return i}const T="",R="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(i,s,a,c,m,P=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=p(i,P),this.authority=s||T,this.path=S(this.scheme,a||T),this.query=c||T,this.fragment=m||T,E(this,P))}static isUri(i){return i instanceof v?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:c,query:m,fragment:P}=i;return s===void 0?s=this.scheme:s===null&&(s=T),a===void 0?a=this.authority:a===null&&(a=T),c===void 0?c=this.path:c===null&&(c=T),m===void 0?m=this.query:m===null&&(m=T),P===void 0?P=this.fragment:P===null&&(P=T),s===this.scheme&&a===this.authority&&c===this.path&&m===this.query&&P===this.fragment?this:new I(s,a,c,m,P)}static parse(i,s=!1){const a=w.exec(i);return a?new I(a[2]||T,o(a[4]||T),o(a[5]||T),o(a[7]||T),o(a[9]||T),s):new I(T,T,T,T,T)}static file(i){let s=T;if(t.isWindows&&(i=i.replace(/\\/g,R)),i[0]===R&&i[1]===R){const a=i.indexOf(R,2);a===-1?(s=i.substring(2),i=R):(s=i.substring(2,a),i=i.substring(a)||R)}return new I("file",s,i,T,T)}static from(i){const s=new I(i.scheme,i.authority,i.path,i.query,i.fragment);return E(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&i.scheme==="file"?a=v.file(b.win32.join(u(i,!0),...s)).path:a=b.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof v)return i;{const s=new I(i);return s._formatted=i.external,s._fsPath=i._sep===h?i.fsPath:null,s}}else return i}}e.URI=v;const h=t.isWindows?1:void 0;class I extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(n,i){let s,a=-1;for(let c=0;c<n.length;c++){const m=n.charCodeAt(c);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||i&&m===47)a!==-1&&(s+=encodeURIComponent(n.substring(a,c)),a=-1),s!==void 0&&(s+=n.charAt(c));else{s===void 0&&(s=n.substr(0,c));const P=y[m];P!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,c)),a=-1),s+=P):a===-1&&(a=c)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function g(n){let i;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(i===void 0&&(i=n.substr(0,s)),i+=y[a]):i!==void 0&&(i+=n[s])}return i!==void 0?i:n}function u(n,i){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=u;function l(n,i){const s=i?g:d;let a="",{scheme:c,authority:m,path:P,query:_,fragment:W}=n;if(c&&(a+=c,a+=":"),(m||c==="file")&&(a+=R,a+=R),m){let K=m.indexOf("@");if(K!==-1){const se=m.substr(0,K);m=m.substr(K+1),K=se.indexOf(":"),K===-1?a+=s(se,!1):(a+=s(se.substr(0,K),!1),a+=":",a+=s(se.substr(K+1),!1)),a+="@"}m=m.toLowerCase(),K=m.indexOf(":"),K===-1?a+=s(m,!1):(a+=s(m.substr(0,K),!1),a+=m.substr(K))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const K=P.charCodeAt(1);K>=65&&K<=90&&(P=`/${String.fromCharCode(K+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const K=P.charCodeAt(0);K>=65&&K<=90&&(P=`${String.fromCharCode(K+32)}:${P.substr(2)}`)}a+=s(P,!0)}return _&&(a+="?",a+=s(_,!1)),W&&(a+="#",a+=i?W:d(W,!1)),a}function f(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+f(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,i=>f(i)):n}}),define(pe[150],ve([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(S){const T=S;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function D(S){const T=[];let R;try{const w=JSON.parse(S.arguments),v=w[w.length-1];v&&v.__$stack&&(w.pop(),R=v.__$stack),T.push(...w)}catch{T.push("Unable to log remote console arguments",S.arguments)}return{args:T,stack:R}}e.parse=D;function C(S){if(typeof S!="string")return C(D(S).stack);const T=S;if(T){const R=k(T),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(w&&w.length===4)return{uri:b.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=C;function k(S){if(!S)return S;const T=S.indexOf(`
`);return T===-1?S:S.substring(0,T)}function E(S,T){const{args:R,stack:w}=D(S),v=typeof R[0]=="string"&&R.length===1;let h=k(w);h&&(h=`(${h.trim()})`);let I=[];if(typeof R[0]=="string"?h&&v?I=[`%c[${T}] %c${R[0]} %c${h}`,p("blue"),p(""),p("grey")]:I=[`%c[${T}] %c${R[0]}`,p("blue"),p(""),...R.slice(1)]:I=[`%c[${T}]%`,p("blue"),...R],h&&!v&&I.push(h),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,I)}e.log=E;function p(S){return`color: ${S}`}}),define(pe[41],ve([0,1,16,15,4]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(S){return JSON.stringify(S,E)}e.stringify=C;function k(S){let T=JSON.parse(S);return T=p(T),T}e.parse=k;function E(S,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,t.regExpFlags)(T)}:T}function p(S,T=0){if(!S||T>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 14:return new Date(S.source)}if(S instanceof b.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let R=0;R<S.length;++R)S[R]=p(S[R],T+1);else for(const R in S)Object.hasOwnProperty.call(S,R)&&(S[R]=p(S[R],T+1))}return S}e.revive=p}),define(pe[10],ve([0,1,3,4]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${D.vscodeRemoteResource}`}set(p,S,T){this._hosts[p]=S,this._ports[p]=T}setConnectionToken(p,S){this._connectionTokens[p]=S}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)return this._delegate(p);const S=p.authority;let T=this._hosts[S];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const R=this._ports[S],w=this._connectionTokens[S];let v=`path=${encodeURIComponent(p.path)}`;return typeof w=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),t.URI.from({scheme:b.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${T}:${R}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new C;class k{asBrowserUri(p,S){const T=this.toUri(p,S);return T.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===D.file&&(b.isNative||b.isWebWorker&&b.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?T.with({scheme:D.vscodeFileResource,authority:T.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(p,S){const T=this.toUri(p,S);return T.scheme===D.vscodeFileResource?T.with({scheme:D.file,authority:T.authority!==k.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(p,S){return t.URI.isUri(p)?p:t.URI.parse(S.toUrl(p))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(pe[19],ve([0,1,35,10,6,3,15,4]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(v){return(0,E.uriToFsPath)(v,!0)}e.originalFSPath=p;class S{constructor(h){this._ignorePathCasing=h}compare(h,I,y=!1){return h===I?0:(0,k.compare)(this.getComparisonKey(h,y),this.getComparisonKey(I,y))}isEqual(h,I,y=!1){return h===I?!0:!h||!I?!1:this.getComparisonKey(h,y)===this.getComparisonKey(I,y)}getComparisonKey(h,I=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,I,y=!1){if(h.scheme===I.scheme){if(h.scheme===t.Schemas.file)return b.isEqualOrParent(p(h),p(I),this._ignorePathCasing(h))&&h.query===I.query&&(y||h.fragment===I.fragment);if((0,e.isEqualAuthority)(h.authority,I.authority))return b.isEqualOrParent(h.path,I.path,this._ignorePathCasing(h),"/")&&h.query===I.query&&(y||h.fragment===I.fragment)}return!1}joinPath(h,...I){return E.URI.joinPath(h,...I)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let I;return h.scheme===t.Schemas.file?I=E.URI.file(D.dirname(p(h))).path:(I=D.posix.dirname(h.path),h.authority&&I.length&&I.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),I="/")),h.with({path:I})}normalizePath(h){if(!h.path.length)return h;let I;return h.scheme===t.Schemas.file?I=E.URI.file(D.normalize(p(h))).path:I=D.posix.normalize(h.path),h.with({path:I})}relativePath(h,I){if(h.scheme!==I.scheme||!(0,e.isEqualAuthority)(h.authority,I.authority))return;if(h.scheme===t.Schemas.file){const g=D.relative(p(h),p(I));return C.isWindows?b.toSlashes(g):g}let y=h.path||"/";const d=I.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const u=Math.min(y.length,d.length);g<u&&!(y.charCodeAt(g)!==d.charCodeAt(g)&&y.charAt(g).toLowerCase()!==d.charAt(g).toLowerCase());g++);y=d.substr(0,g)+y.substr(g)}return D.posix.relative(y,d)}resolvePath(h,I){if(h.scheme===t.Schemas.file){const y=E.URI.file(D.resolve(p(h),I));return h.with({authority:y.authority,path:y.path})}return I=b.toPosixPath(I),h.with({path:D.posix.resolve(h.path,I)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,I){return h===I||h!==void 0&&I!==void 0&&(0,k.equalsIgnoreCase)(h,I)}hasTrailingPathSeparator(h,I=D.sep){if(h.scheme===t.Schemas.file){const y=p(h);return y.length>b.getRoot(y).length&&y[y.length-1]===I}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,I=D.sep){return(0,e.hasTrailingPathSeparator)(h,I)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,I=D.sep){let y=!1;if(h.scheme===t.Schemas.file){const d=p(h);y=d!==void 0&&d.length===b.getRoot(d).length&&d[d.length-1]===I}else{I="/";const d=h.path;y=d.length===1&&d.charCodeAt(d.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,I)?h.with({path:h.path+"/"}):h}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(v=>v.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new S(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(v,h){const I=[];for(let y=0;y<v.length;y++){const d=h(v[y]);v.some((g,u)=>u===y?!1:(0,e.isEqualOrParent)(d,h(g)))||I.push(v[y])}return I}e.distinctParents=T;var R;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(I){const y=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,f]=u.split(":");l&&f&&y.set(l,f)});const g=I.path.substring(0,I.path.indexOf(";"));return g&&y.set(v.META_DATA_MIME,g),y}v.parseMetaData=h})(R=e.DataUri||(e.DataUri={}));function w(v,h,I){if(h){let y=v.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),v.with({scheme:I,authority:h,path:y})}return v.with({scheme:I})}e.toLocalResource=w}),define(pe[14],ve([0,1,20,11,7,2,19,3]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(ie){return!!ie&&typeof ie.then=="function"}e.isThenable=p;function S(ie){const L=new b.CancellationTokenSource,N=ie(L.token),q=new Promise((te,fe)=>{const ye=L.token.onCancellationRequested(()=>{ye.dispose(),L.dispose(),fe(new t.CancellationError)});Promise.resolve(N).then(j=>{ye.dispose(),L.dispose(),te(j)},j=>{ye.dispose(),L.dispose(),fe(j)})});return new class{cancel(){L.cancel()}then(te,fe){return q.then(te,fe)}catch(te){return this.then(void 0,te)}finally(te){return q.finally(te)}}}e.createCancelablePromise=S;function T(ie,L,N){return new Promise((q,te)=>{const fe=L.onCancellationRequested(()=>{fe.dispose(),q(N)});ie.then(q,te).finally(()=>fe.dispose())})}e.raceCancellation=T;function R(ie,L){return new Promise((N,q)=>{const te=L.onCancellationRequested(()=>{te.dispose(),q(new t.CancellationError)});ie.then(N,q).finally(()=>te.dispose())})}e.raceCancellationError=R;async function w(ie){let L=-1;const N=ie.map((te,fe)=>te.then(ye=>(L=fe,ye))),q=await Promise.race(N);return ie.forEach((te,fe)=>{fe!==L&&te.cancel()}),q}e.raceCancellablePromises=w;function v(ie,L,N){let q;const te=setTimeout(()=>{q?.(void 0),N?.()},L);return Promise.race([ie.finally(()=>clearTimeout(te)),new Promise(fe=>q=fe)])}e.raceTimeout=v;function h(ie){return new Promise((L,N)=>{const q=ie();p(q)?q.then(L,N):L(q)})}e.asPromise=h;class I{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=L(),new Promise((N,q)=>{this.activePromise.then(te=>{this.activePromise=null,N(te)},te=>{this.activePromise=null,q(te)})})}}e.Throttler=I;class y{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=y;class d{constructor(){this.promiseMap=new Map}queue(L,N){const te=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(L)===te&&this.promiseMap.delete(L)});return this.promiseMap.set(L,te),te}}e.SequencerByKey=d;const g=(ie,L)=>{let N=!0;const q=setTimeout(()=>{N=!1,L()},ie);return{isTriggered:()=>N,dispose:()=>{clearTimeout(q),N=!1}}},u=ie=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,ie())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,N=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((te,fe)=>{this.doResolve=te,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const te=this.task;return this.task=null,te()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?u(q):g(N,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class f{constructor(L){this.delayer=new l(L),this.throttler=new I}trigger(L,N){return this.delayer.trigger(()=>this.throttler.queue(L),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class r{constructor(){this._isOpen=!1,this._promise=new Promise((L,N)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class o extends r{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n(ie,L){return L?new Promise((N,q)=>{const te=setTimeout(()=>{fe.dispose(),N()},ie),fe=L.onCancellationRequested(()=>{clearTimeout(te),fe.dispose(),q(new t.CancellationError)})}):S(N=>n(ie,N))}e.timeout=n;function i(ie,L=0){const N=setTimeout(ie,L);return(0,C.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=i;function s(ie){const L=[];let N=0;const q=ie.length;function te(){return N<q?ie[N++]():null}function fe(ye){ye!=null&&L.push(ye);const j=te();return j?j.then(fe):Promise.resolve(L)}return Promise.resolve(null).then(fe)}e.sequence=s;function a(ie,L=q=>!!q,N=null){let q=0;const te=ie.length,fe=()=>{if(q>=te)return Promise.resolve(N);const ye=ie[q++];return Promise.resolve(ye()).then(Z=>L(Z)?Promise.resolve(Z):fe())};return fe()}e.first=a;function c(ie,L=q=>!!q,N=null){if(ie.length===0)return Promise.resolve(N);let q=ie.length;const te=()=>{q=-1;for(const fe of ie)fe.cancel?.()};return new Promise((fe,ye)=>{for(const j of ie)j.then(Z=>{--q>=0&&L(Z)?(te(),fe(Z)):q===0&&fe(N)}).catch(Z=>{--q>=0&&(te(),ye(Z))})})}e.firstParallel=c;class m{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:L,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const N=L.factory();N.then(L.c,L.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class P extends m{constructor(){super(1)}}e.Queue=P;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new O;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,N=k.extUri){const q=N.getComparisonKey(L);let te=this.queues.get(q);return te||(te=new P,D.Event.once(te.onDrained)(()=>{te?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,te)),te}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class W{constructor(L,N){this._token=-1,typeof L=="function"&&typeof N=="number"&&this.setIfNotSet(L,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},N)}setIfNotSet(L,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},N))}}e.TimeoutTimer=W;class K{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,N){this.cancel(),this._token=setInterval(()=>{L()},N)}}e.IntervalTimer=K;class se{constructor(L,N){this.timeoutToken=-1,this.runner=L,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=se;class F{constructor(L,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class Q extends se{constructor(L,N){super(L,N);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class re extends C.Disposable{constructor(L,N){super();this.options=L,this.handler=N,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new se(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ie=>{(0,E.setTimeout0)(()=>{if(L)return;const N=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(ie,L)=>{const N=requestIdleCallback(ie,typeof L=="number"?{timeout:L}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class G{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=G;async function de(ie,L,N){let q;for(let te=0;te<N;te++)try{return await ie()}catch(fe){q=fe,await n(L)}throw q}e.retry=de;class J{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,N,q){return this._pending={taskId:L,cancel:()=>q?.(),promise:N},N.then(()=>this.donePending(L),()=>this.donePending(L)),N}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let N,q;const te=new Promise((fe,ye)=>{N=fe,q=ye});this._next={run:L,promise:te,promiseResolve:N,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=J;class U{constructor(L,N=()=>Date.now()){this.interval=L,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class O{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,N)=>{this.completeCallback=L,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(N=>{this.completeCallback(L),this.resolved=!0,N()})}error(L){return new Promise(N=>{this.errorCallback(L),this.rejected=!0,N()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=O;var B;(function(ie){async function L(q){let te;const fe=await Promise.all(q.map(ye=>ye.then(j=>j,j=>{te||(te=j)})));if(typeof te!="undefined")throw te;return fe}ie.settled=L;function N(q){return new Promise(async(te,fe)=>{try{await q(te,fe)}catch(ye){fe(ye)}})}ie.withAsyncBody=N})(B=e.Promises||(e.Promises={}));var X;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(X||(X={}));class ce{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const N={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(L(N)),this.resolve()}catch(q){this.reject(q)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(L){return new ce(N=>{N.emitMany(L)})}static fromPromise(L){return new ce(async N=>{N.emitMany(await L)})}static fromPromises(L){return new ce(async N=>{await Promise.all(L.map(async q=>N.emitOne(await q)))})}static merge(L){return new ce(async N=>{await Promise.all(L.map(async q=>{for await(const te of q)N.emitOne(te)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,N){return new ce(async q=>{for await(const te of L)q.emitOne(N(te))})}map(L){return ce.map(this,L)}static filter(L,N){return new ce(async q=>{for await(const te of L)N(te)&&q.emitOne(te)})}filter(L){return ce.filter(this,L)}static coalesce(L){return ce.filter(L,N=>!!N)}coalesce(){return ce.coalesce(this)}static async toPromise(L){const N=[];for await(const q of L)N.push(q);return N}toPromise(){return ce.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class ue extends ce{constructor(L,N){super(N);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ue;function Y(ie){const L=new b.CancellationTokenSource,N=ie(L.token);return new ue(L,async q=>{const te=L.token.onCancellationRequested(()=>{te.dispose(),L.dispose(),q.reject(new t.CancellationError)});try{for await(const fe of N){if(L.token.isCancellationRequested)return;q.emitOne(fe)}te.dispose(),L.dispose()}catch(fe){te.dispose(),L.dispose(),q.reject(fe)}})}e.createCancelableAsyncIterable=Y}),define(pe[68],ve([0,1,18,14,35,24,6,3,15]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",w=/\//g;function v(O,B){switch(O){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}${B?`|${T}${R}+`:""})*?`}}function h(O,B){if(!O)return[];const X=[];let ce=!1,ue=!1,Y="";for(const ie of O){switch(ie){case B:if(!ce&&!ue){X.push(Y),Y="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Y+=ie}return Y&&X.push(Y),X}e.splitGlobAware=h;function I(O){if(!O)return"";let B="";const X=h(O,e.GLOB_SPLIT);if(X.every(ce=>ce===e.GLOBSTAR))B=".*";else{let ce=!1;X.forEach((ue,Y)=>{if(ue===e.GLOBSTAR){if(ce)return;B+=v(2,Y===X.length-1)}else{let ie=!1,L="",N=!1,q="";for(const te of ue){if(te!=="}"&&ie){L+=te;continue}if(N&&(te!=="]"||!q)){let fe;te==="-"?fe=te:(te==="^"||te==="!")&&!q?fe="^":te===e.GLOB_SPLIT?fe="":fe=(0,p.escapeRegExpCharacters)(te),q+=fe;continue}switch(te){case"{":ie=!0;continue;case"[":N=!0;continue;case"}":{B+=`(?:${h(L,",").map(j=>I(j)).join("|")})`,ie=!1,L="";break}case"]":{B+="["+q+"]",N=!1,q="";break}case"?":B+=R;continue;case"*":B+=v(1);continue;default:B+=(0,p.escapeRegExpCharacters)(te)}}Y<X.length-1&&(X[Y+1]!==e.GLOBSTAR||Y+2<X.length)&&(B+=T)}ce=ue===e.GLOBSTAR})}return B}const y=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new C.LRUCache(1e4),o=function(){return!1},n=function(){return null};function i(O,B){if(!O)return n;let X;typeof O!="string"?X=O.pattern:X=O,X=X.trim();const ce=`${X}_${!!B.trimForExclusions}`;let ue=r.get(ce);if(ue)return s(ue,O);let Y;return y.test(X)?ue=c(X.substr(4),X):(Y=d.exec(a(X,B)))?ue=m(Y[1],X):(B.trimForExclusions?u:g).test(X)?ue=P(X,B):(Y=l.exec(a(X,B)))?ue=_(Y[1].substr(1),X,!0):(Y=f.exec(a(X,B)))?ue=_(Y[1],X,!1):ue=W(X),r.set(ce,ue),s(ue,O)}function s(O,B){if(typeof B=="string")return O;const X=function(ce,ue){return(0,D.isEqualOrParent)(ce,B.base,!E.isLinux)?O(ce.substr(B.base.length+1),ue):null};return X.allBasenames=O.allBasenames,X.allPaths=O.allPaths,X.basenames=O.basenames,X.patterns=O.patterns,X}function a(O,B){return B.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,B){return function(X,ce){return typeof X=="string"&&X.endsWith(O)?B:null}}function m(O,B){const X=`/${O}`,ce=`\\${O}`,ue=function(ie,L){return typeof ie!="string"?null:L?L===O?B:null:ie===O||ie.endsWith(X)||ie.endsWith(ce)?B:null},Y=[O];return ue.basenames=Y,ue.patterns=[B],ue.allBasenames=Y,ue}function P(O,B){const X=J(O.slice(1,-1).split(",").map(L=>i(L,B)).filter(L=>L!==n),O),ce=X.length;if(!ce)return n;if(ce===1)return X[0];const ue=function(L,N){for(let q=0,te=X.length;q<te;q++)if(X[q](L,N))return O;return null},Y=X.find(L=>!!L.allBasenames);Y&&(ue.allBasenames=Y.allBasenames);const ie=X.reduce((L,N)=>N.allPaths?L.concat(N.allPaths):L,[]);return ie.length&&(ue.allPaths=ie),ue}function _(O,B,X){const ce=k.sep===k.posix.sep,ue=ce?O:O.replace(w,k.sep),Y=k.sep+ue,ie=k.posix.sep+O;let L;return X?L=function(N,q){return typeof N=="string"&&(N===ue||N.endsWith(Y)||!ce&&(N===O||N.endsWith(ie)))?B:null}:L=function(N,q){return typeof N=="string"&&(N===ue||!ce&&N===O)?B:null},L.allPaths=[(X?"*/":"./")+O],L}function W(O){try{const B=new RegExp(`^${I(O)}$`);return function(X){return B.lastIndex=0,typeof X=="string"&&B.test(X)?O:null}}catch{return n}}function K(O,B,X){return!O||typeof B!="string"?!1:se(O)(B,void 0,X)}e.match=K;function se(O,B={}){if(!O)return o;if(typeof O=="string"||F(O)){const X=i(O,B);if(X===n)return o;const ce=function(ue,Y){return!!X(ue,Y)};return X.allBasenames&&(ce.allBasenames=X.allBasenames),X.allPaths&&(ce.allPaths=X.allPaths),ce}return G(O,B)}e.parse=se;function F(O){const B=O;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=F;function Q(O){return O.allBasenames||[]}e.getBasenameTerms=Q;function re(O){return O.allPaths||[]}e.getPathTerms=re;function G(O,B){const X=J(Object.getOwnPropertyNames(O).map(L=>de(L,O[L],B)).filter(L=>L!==n)),ce=X.length;if(!ce)return n;if(!X.some(L=>!!L.requiresSiblings)){if(ce===1)return X[0];const L=function(te,fe){let ye;for(let j=0,Z=X.length;j<Z;j++){const ne=X[j](te,fe);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(ye||(ye=[]),ye.push(ne))}return ye?(async()=>{for(const j of ye){const Z=await j;if(typeof Z=="string")return Z}return null})():null},N=X.find(te=>!!te.allBasenames);N&&(L.allBasenames=N.allBasenames);const q=X.reduce((te,fe)=>fe.allPaths?te.concat(fe.allPaths):te,[]);return q.length&&(L.allPaths=q),L}const ue=function(L,N,q){let te,fe;for(let ye=0,j=X.length;ye<j;ye++){const Z=X[ye];Z.requiresSiblings&&q&&(N||(N=(0,k.basename)(L)),te||(te=N.substr(0,N.length-(0,k.extname)(L).length)));const ne=Z(L,N,te,q);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(fe||(fe=[]),fe.push(ne))}return fe?(async()=>{for(const ye of fe){const j=await ye;if(typeof j=="string")return j}return null})():null},Y=X.find(L=>!!L.allBasenames);Y&&(ue.allBasenames=Y.allBasenames);const ie=X.reduce((L,N)=>N.allPaths?L.concat(N.allPaths):L,[]);return ie.length&&(ue.allPaths=ie),ue}function de(O,B,X){if(B===!1)return n;const ce=i(O,X);if(ce===n)return n;if(typeof B=="boolean")return ce;if(B){const ue=B.when;if(typeof ue=="string"){const Y=(ie,L,N,q)=>{if(!q||!ce(ie,L))return null;const te=ue.replace("$(basename)",N),fe=q(te);return(0,t.isThenable)(fe)?fe.then(ye=>ye?O:null):fe?O:null};return Y.requiresSiblings=!0,Y}}return ce}function J(O,B){const X=O.filter(L=>!!L.basenames);if(X.length<2)return O;const ce=X.reduce((L,N)=>{const q=N.basenames;return q?L.concat(q):L},[]);let ue;if(B){ue=[];for(let L=0,N=ce.length;L<N;L++)ue.push(B)}else ue=X.reduce((L,N)=>{const q=N.patterns;return q?L.concat(q):L},[]);const Y=function(L,N){if(typeof L!="string")return null;if(!N){let te;for(te=L.length;te>0;te--){const fe=L.charCodeAt(te-1);if(fe===47||fe===92)break}N=L.substr(te)}const q=ce.indexOf(N);return q!==-1?ue[q]:null};Y.basenames=ce,Y.patterns=ue,Y.allBasenames=ce;const ie=O.filter(L=>!L.basenames);return ie.push(Y),ie}function U(O,B){return(0,b.equals)(O,B,(X,ce)=>typeof X=="string"&&typeof ce=="string"?X===ce:typeof X!="string"&&typeof ce!="string"?X.base===ce.base&&X.pattern===ce.pattern:!1)}e.patternsEquals=U}),define(pe[90],ve([0,1,11,149,19,15,4]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(y){y[y.Paragraph=0]="Paragraph",y[y.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class p{constructor(d="",g=!1){if(this.value=d,typeof this.value!="string")throw(0,b.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(d,g=0){return this.value+=w(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,g){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(d,g,u){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(d),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(d,g){const u=new RegExp((0,C.escapeRegExpCharacters)(g),"g");return d.replace(u,(l,f)=>d.charAt(f-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=p;function S(y){return T(y)?!y.value:Array.isArray(y)?y.every(S):!0}e.isEmptyMarkdownString=S;function T(y){return y instanceof p?!0:y&&typeof y=="object"?typeof y.value=="string"&&(typeof y.isTrusted=="boolean"||y.isTrusted===void 0)&&(typeof y.supportThemeIcons=="boolean"||y.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function R(y,d){return y===d?!0:!y||!d?!1:y.value===d.value&&y.isTrusted===d.isTrusted&&y.supportThemeIcons===d.supportThemeIcons&&y.supportHtml===d.supportHtml&&(y.baseUri===d.baseUri||!!y.baseUri&&!!d.baseUri&&(0,D.isEqual)(k.URI.from(y.baseUri),k.URI.from(d.baseUri)))}e.markdownStringEqual=R;function w(y){return y.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function v(y){return y.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function h(y){return y&&y.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function I(y){const d=[],g=y.split("|").map(l=>l.trim());y=g[0];const u=g[1];if(u){const l=/height=(\d+)/.exec(u),f=/width=(\d+)/.exec(u),r=l?l[1]:"",o=f?f[1]:"",n=isFinite(parseInt(o)),i=isFinite(parseInt(r));n&&d.push(`width="${o}"`),i&&d.push(`height="${r}"`)}return{href:y,dimensions:d}}e.parseHrefAndDimensions=I}),define(pe[151],ve([0,1,18,35,6,3,19,15]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(n,i){const{os:s,tildify:a,relative:c}=i;if(c){const _=S(n,c,s);if(typeof _=="string")return _}let m=n.fsPath;if(s===1&&!C.isWindows?m=m.replace(/\//g,"\\"):s!==1&&C.isWindows&&(m=m.replace(/\\/g,"/")),s!==1&&a?.userHome){const _=a.userHome.fsPath;let W;n.scheme!==a.userHome.scheme&&n.path.startsWith(D.posix.sep)?W=a.userHome.with({path:n.path}).fsPath:W=n.fsPath,m=w(W,_,s)}return(s===1?D.win32:D.posix).normalize(T(m,s===1))}e.getPathLabel=p;function S(n,i,s){const a=s===1?D.win32:D.posix,c=s===3?k.extUri:k.extUriIgnorePathCase,m=i.getWorkspace(),P=(0,b.firstOrDefault)(m.folders);if(!P)return;n.scheme!==P.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=P.uri.with({path:n.path}));const _=i.getWorkspaceFolder(n);if(!_)return;let W;if(c.isEqual(_.uri,n)?W="":W=c.relativePath(_.uri,n)??"",W&&(W=a.normalize(W)),m.folders.length>1&&!i.noPrefix){const K=_.name?_.name:c.basenameOrAuthority(_.uri);W=W?`${K} \u2022 ${W}`:K}return W}function T(n,i=C.isWindows){return(0,t.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=T;let R=Object.create(null);function w(n,i,s=C.OS){if(s===1||!n||!i)return n;let a=R.original===i?R.normalized:void 0;a||(a=i,C.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,E.rtrim)(a,D.posix.sep)}${D.posix.sep}`,R={original:i,normalized:a});let c=n;return C.isWindows&&(c=(0,t.toSlashes)(c)),(s===3?c.startsWith(a):(0,E.startsWithIgnoreCase)(c,a))?`~/${c.substr(a.length)}`:n}e.tildify=w;function v(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=v;const h="\u2026",I="\\\\",y="~";function d(n,i=D.sep){const s=new Array(n.length);let a=!1;for(let c=0;c<n.length;c++){const m=n[c];if(m===""){s[c]=`.${i}`;continue}if(!m){s[c]=m;continue}a=!0;let P="",_=m;_.indexOf(I)===0?(P=_.substr(0,_.indexOf(I)+I.length),_=_.substr(_.indexOf(I)+I.length)):_.indexOf(i)===0?(P=_.substr(0,_.indexOf(i)+i.length),_=_.substr(_.indexOf(i)+i.length)):_.indexOf(y)===0&&(P=_.substr(0,_.indexOf(y)+y.length),_=_.substr(_.indexOf(y)+y.length));const W=_.split(i);for(let K=1;a&&K<=W.length;K++)for(let se=W.length-K;a&&se>=0;se--){a=!1;let F=W.slice(se,se+K).join(i);for(let Q=0;!a&&Q<n.length;Q++)if(Q!==c&&n[Q]&&n[Q].indexOf(F)>-1){const re=se+K===W.length,G=se>0&&n[Q].indexOf(i)>-1?i+F:F,de=n[Q].endsWith(G);a=!re||de}if(!a){let Q="";(W[0].endsWith(":")||P!=="")&&(se===1&&(se=0,K++,F=W[0]+i+F),se>0&&(Q=W[0]+i),Q=P+Q),se>0&&(Q=Q+h+i),Q=Q+F,se+K<W.length&&(Q=Q+i+h),s[c]=Q}}a&&(s[c]=m)}return s}e.shorten=d;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function u(n,i=Object.create(null)){const s=[];let a=!1,c="";for(const m of n)if(m==="$"||a&&m==="{")c&&s.push({value:c,type:g.TEXT}),c="",a=!0;else if(m==="}"&&a){const P=i[c];if(typeof P=="string")P.length&&s.push({value:P,type:g.VARIABLE});else if(P){const _=s[s.length-1];(!_||_.type!==g.SEPARATOR)&&s.push({value:P.label,type:g.SEPARATOR})}c="",a=!1}else c+=m;return c&&!a&&s.push({value:c,type:g.TEXT}),s.filter((m,P)=>{if(m.type===g.SEPARATOR){const _=s[P-1],W=s[P+1];return[_,W].every(K=>K&&(K.type===g.VARIABLE||K.type===g.TEXT)&&K.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=u;function l(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function f(n,i){return C.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=f;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(n){const i=n.indexOf("/")!==-1?D.posix:D.win32,s=i.basename(n),a=i.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(pe[69],ve([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class D{constructor(R){this._uriTransformer=R}transformIncoming(R){const w=this._uriTransformer.transformIncoming(R);return w===R?R:t(b.URI.from(w))}transformOutgoing(R){const w=this._uriTransformer.transformOutgoing(R);return w===R?R:t(b.URI.from(w))}transformOutgoingURI(R){const w=this._uriTransformer.transformOutgoing(R);return w===R?R:b.URI.from(w)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function C(T,R,w){if(!T||w>200)return null;if(typeof T=="object"){if(T instanceof b.URI)return R.transformOutgoing(T);for(const v in T)if(Object.hasOwnProperty.call(T,v)){const h=C(T[v],R,w+1);h!==null&&(T[v]=h)}}return null}function k(T,R){const w=C(T,R,0);return w===null?T:w}e.transformOutgoingURIs=k;function E(T,R,w,v){if(!T||v>200)return null;if(typeof T=="object"){if(T.$mid===1)return w?b.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(const h in T)if(Object.hasOwnProperty.call(T,h)){const I=E(T[h],R,w,v+1);I!==null&&(T[h]=I)}}return null}function p(T,R){const w=E(T,R,!1,0);return w===null?T:w}e.transformIncomingURIs=p;function S(T,R){const w=E(T,R,!0,0);return w===null?T:w}e.transformAndReviveIncomingURIs=S}),define(pe[91],ve([0,1,30,11,24,23,138]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const w=(0,b.networkInterfaces)();for(const v in w){const h=w[v];if(h)for(const{mac:I,internal:y}of h)y||(R+=1,this._isVirtualMachineMacAddress(I.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let E;async function p(){return E||(E=(async()=>await S()||C.generateUuid())()),E}e.getMachineId=p;async function S(){try{const T=await new Promise((w,v)=>{oe(["crypto"],w,v)}),R=(0,k.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(pe[21],ve([0,1,29,30,264,14,35,89,6,3,19,4]),function(oe,e,b,t,D,C,k,E,p,S,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function v(G,de=w.UNLINK){if((0,k.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");return de===w.UNLINK?I(G):h(G)}async function h(G){try{const de=(0,k.randomPath)((0,t.tmpdir)());try{await b.promises.rename(G,de)}catch{return I(G)}I(de).catch(J=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function I(G){return(0,D.promisify)(b.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function y(G){if((0,k.isRootOrDriveLetter)(G))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function d(G,de){return l(await(de?g(G):(0,D.promisify)(b.readdir)(G)))}async function g(G){try{return await(0,D.promisify)(b.readdir)(G,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const de=[],J=await d(G);for(const U of J){let O=!1,B=!1,X=!1;try{const ce=await e.Promises.lstat((0,p.join)(G,U));O=ce.isFile(),B=ce.isDirectory(),X=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}de.push({name:U,isFile:()=>O,isDirectory:()=>B,isSymbolicLink:()=>X})}return de}function u(G){return l(b.readdirSync(G))}e.readdirSync=u;function l(G){return G.map(de=>typeof de=="string"?S.isMacintosh?(0,E.normalizeNFC)(de):de:(de.name=S.isMacintosh?(0,E.normalizeNFC)(de.name):de.name,de))}async function f(G){const de=await d(G),J=[];for(const U of de)await o.existsDirectory((0,p.join)(G,U))&&J.push(U);return J}function r(G,de=1e3){return new Promise(J=>{let U=!1;const O=setInterval(()=>{U||(U=!0,b.access(G,B=>{U=!1,B&&(clearInterval(O),J(void 0))}))},de)})}e.whenDeleted=r;var o;(function(G){async function de(O){let B;try{if(B=await e.Promises.lstat(O),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(O),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(S.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ce}throw X}}G.stat=de;async function J(O){try{const{stat:B,symbolicLink:X}=await G.stat(O);return B.isFile()&&X?.dangling!==!0}catch{}return!1}G.existsFile=J;async function U(O){try{const{stat:B,symbolicLink:X}=await G.stat(O);return B.isDirectory()&&X?.dangling!==!0}catch{}return!1}G.existsDirectory=U})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new C.ResourceQueue;function i(G,de,J){return n.queueFor(R.URI.file(G),T.extUriBiasedIgnorePathCase).queue(()=>{const U=P(J);return new Promise((O,B)=>c(G,de,U,X=>X?B(X):O()))})}let s=!0;function a(G){s=G}e.configureFlushOnWrite=a;function c(G,de,J,U){if(!s)return b.writeFile(G,de,{mode:J.mode,flag:J.flag},U);b.open(G,J.flag,J.mode,(O,B)=>{if(O)return U(O);b.writeFile(B,de,X=>{if(X)return b.close(B,()=>U(X));b.fdatasync(B,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),a(!1)),b.close(B,ue=>U(ue))))})})}function m(G,de,J){const U=P(J);if(!s)return b.writeFileSync(G,de,{mode:U.mode,flag:U.flag});const O=b.openSync(G,U.flag,U.mode);try{b.writeFileSync(O,de);try{b.fdatasyncSync(O)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),a(!1)}}finally{b.closeSync(O)}}e.writeFileSync=m;function P(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function _(G,de){if(G!==de)try{await e.Promises.rename(G,de)}catch(J){if(G.toLowerCase()!==de.toLowerCase()&&J.code==="EXDEV"||G.endsWith("."))await W(G,de,{preserveSymlinks:!1}),await v(G,w.MOVE);else throw J}}async function W(G,de,J){return se(G,de,{root:{source:G,target:de},options:J,handledSourcePaths:new Set})}const K=511;async function se(G,de,J){if(J.handledSourcePaths.has(G))return;J.handledSourcePaths.add(G);const{stat:U,symbolicLink:O}=await o.stat(G);if(O){if(J.options.preserveSymlinks)try{return await re(G,de,J)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(O.dangling)return}return U.isDirectory()?F(G,de,U.mode&K,J):Q(G,de,U.mode&K)}async function F(G,de,J,U){await e.Promises.mkdir(de,{recursive:!0,mode:J});const O=await d(G);for(const B of O)await se((0,p.join)(G,B),(0,p.join)(de,B),U)}async function Q(G,de,J){await e.Promises.copyFile(G,de),await e.Promises.chmod(de,J)}async function re(G,de,J){let U=await e.Promises.readlink(G);(0,k.isEqualOrParent)(U,J.root.source,!S.isLinux)&&(U=(0,p.join)(J.root.target,U.substr(J.root.source.length+1))),await e.Promises.symlink(U,de)}e.Promises=new class{get access(){return(0,D.promisify)(b.access)}get stat(){return(0,D.promisify)(b.stat)}get lstat(){return(0,D.promisify)(b.lstat)}get utimes(){return(0,D.promisify)(b.utimes)}get read(){return(G,de,J,U,O)=>new Promise((B,X)=>{b.read(G,de,J,U,O,(ce,ue,Y)=>ce?X(ce):B({bytesRead:ue,buffer:Y}))})}get readFile(){return(0,D.promisify)(b.readFile)}get write(){return(G,de,J,U,O)=>new Promise((B,X)=>{b.write(G,de,J,U,O,(ce,ue,Y)=>ce?X(ce):B({bytesWritten:ue,buffer:Y}))})}get appendFile(){return(0,D.promisify)(b.appendFile)}get fdatasync(){return(0,D.promisify)(b.fdatasync)}get truncate(){return(0,D.promisify)(b.truncate)}get rename(){return(0,D.promisify)(b.rename)}get copyFile(){return(0,D.promisify)(b.copyFile)}get open(){return(0,D.promisify)(b.open)}get close(){return(0,D.promisify)(b.close)}get symlink(){return(0,D.promisify)(b.symlink)}get readlink(){return(0,D.promisify)(b.readlink)}get chmod(){return(0,D.promisify)(b.chmod)}get mkdir(){return(0,D.promisify)(b.mkdir)}get unlink(){return(0,D.promisify)(b.unlink)}get rmdir(){return(0,D.promisify)(b.rmdir)}get realpath(){return(0,D.promisify)(b.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return f}get writeFile(){return i}get rm(){return v}get move(){return _}get copy(){return W}}}),define(pe[152],ve([0,1,29,6,3,15,21]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(w){if(D.isLinux)return w;const v=(0,t.dirname)(w);if(w===v)return w;const h=((0,t.basename)(w)||w).toLowerCase();try{const y=(0,k.readdirSync)(v).filter(d=>d.toLowerCase()===h);if(y.length===1){const d=E(v);if(d)return(0,t.join)(d,y[0])}else if(y.length>1){const d=y.indexOf(h);if(d>=0){const g=E(v);if(g)return(0,t.join)(g,y[d])}}}catch{}return null}e.realcaseSync=E;async function p(w){if(D.isLinux)return w;const v=(0,t.dirname)(w);if(w===v)return w;const h=((0,t.basename)(w)||w).toLowerCase();try{const y=(await k.Promises.readdir(v)).filter(d=>d.toLowerCase()===h);if(y.length===1){const d=await p(v);if(d)return(0,t.join)(d,y[0])}else if(y.length>1){const d=y.indexOf(h);if(d>=0){const g=await p(v);if(g)return(0,t.join)(g,y[d])}}}catch{}return null}e.realcase=p;async function S(w){try{return await k.Promises.realpath(w)}catch{const h=R(w);return await k.Promises.access(h,b.constants.R_OK),h}}e.realpath=S;function T(w){try{return b.realpathSync(w)}catch{const h=R(w);return b.accessSync(h,b.constants.R_OK),h}}e.realpathSync=T;function R(w){return(0,C.rtrim)((0,t.normalize)(w),t.sep)}}),define(pe[92],ve([0,1,30,6,21]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var p;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(p||(p={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(f,r,o){this.exePath=f,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:l=!1}={}){return l?S===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:l=!1,findPreview:f=!1}={}){const r=w({useAlternateBitness:l});if(!r)return null;const o=t.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let n=-1,i=null;for(const c of await D.Promises.readdir(o)){let m=-1;if(f){const _=c.indexOf("-");if(_<0)continue;const W=c.substring(0,_);if(!C.test(W)||c.substring(_+1)!=="preview")continue;m=parseInt(W,10)}else{if(!C.test(c))continue;m=parseInt(c,10)}if(m<=n)continue;const P=t.join(o,c,"pwsh.exe");!await D.SymlinkSupport.existsFile(P)||(i=P,n=m)}if(!i)return null;const s=r.includes("x86")?" (x86)":"",a=f?" Preview":"";return new R(i,`PowerShell${a}${s}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const f=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=l?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(f))if(r.test(n)){const i=t.join(f,n,"pwsh.exe");return new R(i,o)}return null}function I(){const l=t.join(b.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function y(){const l=t.join(process.env.windir,S===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*d(){let l=await v();l&&(yield l),l=await v({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=I(),l&&(yield l),l=await v({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await v({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=y(),l&&(yield l)}async function*g(){for await(const l of d())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=g;async function u(){for await(const l of g())return l;return null}e.getFirstAvailablePowerShellInstallation=u}),define(pe[93],ve([0,1,6,3,28,56,12,21]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function p(R=D.env){return R.comspec||"cmd.exe"}e.getWindowsShell=p;function S(R){let w=[],v=!1;const h=function(I){if(v){w.push(I);return}(!R.send(I,d=>{if(d&&console.error(d),v=!1,w.length>0){const g=w.slice(0);w=[],g.forEach(u=>h(u))}})||t.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=S;var T;(function(R){async function w(v,h,I){if(b.isAbsolute(v))return v;if(h===void 0&&(h=D.cwd()),b.dirname(v)!=="."||(I===void 0&&k.isString(D.env.PATH)&&(I=D.env.PATH.split(b.delimiter)),I===void 0||I.length===0))return b.join(h,v);async function d(g){if(await E.Promises.exists(g)){let u;try{u=await E.Promises.stat(g)}catch(l){l.message.startsWith("EACCES")&&(u=await E.Promises.lstat(g))}return u?!u.isDirectory():!1}return!1}for(const g of I){let u;if(b.isAbsolute(g)?u=b.join(g,v):u=b.join(h,g,v),await d(u))return u;let l=u+".com";if(await d(l)||(l=u+".exe",await d(l)))return l}return b.join(h,v)}R.findExecutable=w})(T=e.win32||(e.win32={}))}),define(pe[94],ve([0,1,49,10]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((E,p)=>{let S;const T=new Map;function R(v,h,I,y,d){const g=T.get(h);if(v===k||g){const u={name:w(I),cmd:I,pid:v,ppid:h,load:y,mem:d};T.set(v,u),v===k&&(S=u),g&&(g.children||(g.children=[]),g.children.push(u),g.children.length>1&&(g.children=g.children.sort((l,f)=>l.pid-f.pid)))}}function w(v){const h=/--vscode-window-kind=shared-process/,I=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,l=/\\pipe\\winpty-control/,f=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(u.exec(v))return"electron-crash-reporter";if(l.exec(v))return"winpty-process";if(f.exec(v))return"console-window-host (Windows internal process)";let o=r.exec(v);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(v)?"shared-process":I.exec(v)?"issue-reporter":y.exec(v)?"process-explorer":"window";if(o[1]==="utility"){if(d.exec(v))return"utility-network-service";if(g.exec(v))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do o=n.exec(v),o&&(i+=o+" ");while(o);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,I)=>{oe(["windows-process-tree"],h,I)}).then(h=>{h.getProcessList(k,I=>{if(!I){p(new Error(`Root process ${k} not found`));return}h.getProcessCpuUsage(I,y=>{const d=new Map;y.forEach(g=>{const u=v(g.commandLine||"");d.set(g.pid,{name:w(u),cmd:u,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),S=d.get(k),S?(d.forEach(g=>{const u=d.get(g.ppid);u&&(u.children||(u.children=[]),u.children.push(g))}),d.forEach(g=>{g.children&&(g.children=g.children.sort((u,l)=>u.pid-l.pid))}),E(S)):p(new Error(`Root process ${k} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[S];const I=[];for(;h.length;){const d=h.shift();d&&(I.push(d.pid),d.children&&(h=h.concat(d.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",oe).fsPath);y+=" "+I.join(" "),(0,b.exec)(y,{},(d,g,u)=>{if(d||u)p(d||new Error(u.toString()));else{const l=g.toString().split(`
`);for(let f=0;f<I.length;f++){const r=T.get(I[f]);r.load=parseFloat(l[f])}if(!S){p(new Error(`Root process ${k} not found`));return}E(S)}})};(0,b.exec)("which ps",{},(h,I,y)=>{if(h||y)if(process.platform!=="linux")p(h||new Error(y.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",oe).fsPath);(0,b.exec)(d,{},(g,u,l)=>{g||l?p(g||new Error(l.toString())):(C(u,R),v())})}else{const d=I.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,b.exec)(`${d} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,f)=>{u||f&&!f.includes("screen size is bogus")?p(u||new Error(f.toString())):(C(l,R),process.platform==="linux"?v():S?E(S):p(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,E){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=k.toString().split(`
`);for(const T of S){const R=p.exec(T.trim());R&&R.length===6&&E(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}}),define(pe[153],ve([0,1,30,3,92,93]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(v,h){return v===1?t.isWindows?R():C.getWindowsShell(h):S(v,h)}e.getSystemShell=k;function E(v,h){return v===1?t.isWindows?w(h):C.getWindowsShell(h):S(v,h)}e.getSystemShellSync=E;let p=null;function S(v,h){if(t.isLinux&&v===2||t.isMacintosh&&v===3)return"/bin/bash";if(!p){let I;if(t.isWindows)I="/bin/bash";else{if(I=h.SHELL,!I)try{I=(0,b.userInfo)().shell}catch{}I||(I="sh"),I==="/bin/false"&&(I="/bin/bash")}p=I}return p}let T=null;async function R(){return T||(T=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),T}function w(v){if(T)return T;const h=t.isWindows&&parseFloat((0,b.release)())>=10,I=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${I?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?y:C.getWindowsShell(v)}});var Re=this&&this.__decorate||function(oe,e,b,t){var D=arguments.length,C=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,b):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(oe,e,b,t);else for(var E=oe.length-1;E>=0;E--)(k=oe[E])&&(C=(D<3?k(C):D>3?k(e,b,C):k(e,b))||C);return D>3&&C&&Object.defineProperty(e,b,C),C};define(pe[42],ve([0,1,18,14,16,20,83,11,7,2,41,15,12]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(I=e.ResponseType||(e.ResponseType={}));function y(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(d||(d={}));class g{constructor(B){this.buffer=B,this.pos=0}read(B){const X=this.buffer.slice(this.pos,this.pos+B);return this.pos+=X.byteLength,X}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var l;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(l||(l={}));function f(O){const B=D.VSBuffer.alloc(4);return B.writeUInt32BE(O,0),B}function r(O){return O.read(4).readUInt32BE(0)}function o(O){const B=D.VSBuffer.alloc(1);return B.writeUInt8(O,0),B}const n={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object)},i=typeof Buffer!="undefined";function s(O,B){if(typeof B=="undefined")O.write(n.Undefined);else if(typeof B=="string"){const X=D.VSBuffer.fromString(B);O.write(n.String),O.write(f(X.byteLength)),O.write(X)}else if(i&&Buffer.isBuffer(B)){const X=D.VSBuffer.wrap(B);O.write(n.Buffer),O.write(f(X.byteLength)),O.write(X)}else if(B instanceof D.VSBuffer)O.write(n.VSBuffer),O.write(f(B.byteLength)),O.write(B);else if(Array.isArray(B)){O.write(n.Array),O.write(f(B.length));for(const X of B)s(O,X)}else{const X=D.VSBuffer.fromString(JSON.stringify(B));O.write(n.Object),O.write(f(X.byteLength)),O.write(X)}}function a(O){switch(O.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return O.read(r(O)).toString();case l.Buffer:return O.read(r(O)).buffer;case l.VSBuffer:return O.read(r(O));case l.Array:{const X=r(O),ce=[];for(let ue=0;ue<X;ue++)ce.push(a(O));return ce}case l.Object:return JSON.parse(O.read(r(O)).toString())}}class c{constructor(B,X,ce=null,ue=1e3){this.protocol=B,this.ctx=X,this.logger=ce,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(B,X){this.channels.set(B,X),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const X=this.send([B.type]);this.logger?.logOutgoing(X,0,1,y(B.type));return}case 201:case 202:case 204:case 203:{const X=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(X,B.id,1,y(B.type),B.data);return}}}send(B,X=void 0){const ce=new u;return s(ce,B),s(ce,X),this.sendBuffer(ce.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const X=new g(B),ce=a(X),ue=a(X),Y=ce[0];switch(Y){case 100:return this.logger?.logIncoming(B.byteLength,ce[1],1,`${h(Y)}: ${ce[2]}.${ce[3]}`,ue),this.onPromise({type:Y,id:ce[1],channelName:ce[2],name:ce[3],arg:ue});case 102:return this.logger?.logIncoming(B.byteLength,ce[1],1,`${h(Y)}: ${ce[2]}.${ce[3]}`,ue),this.onEventListen({type:Y,id:ce[1],channelName:ce[2],name:ce[3],arg:ue});case 101:return this.logger?.logIncoming(B.byteLength,ce[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:ce[1]});case 103:return this.logger?.logIncoming(B.byteLength,ce[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:ce[1]})}}onPromise(B){const X=this.channels.get(B.channelName);if(!X){this.collectPendingRequest(B);return}const ce=new C.CancellationTokenSource;let ue;try{ue=X.call(this.ctx,B.name,B.arg,ce.token)}catch(L){ue=Promise.reject(L)}const Y=B.id;ue.then(L=>{this.sendResponse({id:Y,data:L,type:201}),this.activeRequests.delete(B.id)},L=>{L instanceof Error?this.sendResponse({id:Y,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:Y,data:L,type:203}),this.activeRequests.delete(B.id)});const ie=(0,S.toDisposable)(()=>ce.cancel());this.activeRequests.set(B.id,ie)}onEventListen(B){const X=this.channels.get(B.channelName);if(!X){this.collectPendingRequest(B);return}const ce=B.id,Y=X.listen(this.ctx,B.name,B.arg)(ie=>this.sendResponse({id:ce,data:ie,type:204}));this.activeRequests.set(B.id,Y)}disposeActiveRequest(B){const X=this.activeRequests.get(B.id);X&&(X.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let X=this.pendingRequests.get(B.channelName);X||(X=[],this.pendingRequests.set(B.channelName,X));const ce=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:B,timeoutTimer:ce})}flushPendingRequests(B){const X=this.pendingRequests.get(B);if(X){for(const ce of X)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.onPromise(ce.request);break;case 102:this.onEventListen(ce.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(B,X=null){this.protocol=B,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ce=>this.onBuffer(ce)),this.logger=X}getChannel(B){const X=this;return{call(ce,ue,Y){return X.isDisposed?Promise.reject(new E.CancellationError):X.requestPromise(B,ce,ue,Y)},listen(ce,ue){return X.isDisposed?p.Event.None:X.requestEvent(B,ce,ue)}}}requestPromise(B,X,ce,ue=C.CancellationToken.None){const Y=this.lastRequestId++,L={id:Y,type:100,channelName:B,name:X,arg:ce};if(ue.isCancellationRequested)return Promise.reject(new E.CancellationError);let N;return new Promise((te,fe)=>{if(ue.isCancellationRequested)return fe(new E.CancellationError);const ye=()=>{const z=V=>{switch(V.type){case 201:this.handlers.delete(Y),te(V.data);break;case 202:{this.handlers.delete(Y);const $=new Error(V.data.message);$.stack=V.data.stack,$.name=V.data.name,fe($);break}case 203:this.handlers.delete(Y),fe(V.data);break}};this.handlers.set(Y,z),this.sendRequest(L)};let j=null;this.state===d.Idle?ye():(j=(0,t.createCancelablePromise)(z=>this.whenInitialized()),j.then(()=>{j=null,ye()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:Y,type:101}),fe(new E.CancellationError)},ne=ue.onCancellationRequested(Z);N=(0,S.combinedDisposable)((0,S.toDisposable)(Z),ne),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(B,X,ce){const ue=this.lastRequestId++,ie={id:ue,type:102,channelName:B,name:X,arg:ce};let L=null;const N=new p.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(te=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(N),this.sendRequest(ie)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(N),this.sendRequest({id:ue,type:103}))}}),q=te=>N.fire(te.data);return this.handlers.set(ue,q),N.event}sendRequest(B){switch(B.type){case 100:case 102:{const X=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(X,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const X=this.send([B.type,B.id]);this.logger?.logOutgoing(X,B.id,0,h(B.type));return}}}send(B,X=void 0){const ce=new u;return s(ce,B),s(ce,X),this.sendBuffer(ce.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const X=new g(B),ce=a(X),ue=a(X),Y=ce[0];switch(Y){case 200:return this.logger?.logIncoming(B.byteLength,0,0,y(Y)),this.onResponse({type:ce[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,ce[1],0,y(Y),ue),this.onResponse({type:ce[0],id:ce[1],data:ue})}}onResponse(B){if(B.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Re([k.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class _{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:X,onDidClientDisconnect:ce})=>{p.Event.once(X.onMessage)(Y=>{const ie=new g(Y),L=a(ie),N=new c(X,L),q=new P(X);this.channels.forEach((fe,ye)=>N.registerChannel(ye,fe));const te={channelServer:N,channelClient:q,ctx:L};this._connections.add(te),this._onDidAddConnection.fire(te),ce(()=>{N.dispose(),q.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const B=[];return this._connections.forEach(X=>B.push(X)),B}getChannel(B,X){const ce=this;return{call(ue,Y,ie){let L;if((0,w.isFunction)(X)){const q=(0,b.getRandomElement)(ce.connections.filter(X));L=q?Promise.resolve(q):p.Event.toPromise(p.Event.filter(ce.onDidAddConnection,X))}else L=X.routeCall(ce,ue,Y);const N=L.then(q=>q.channelClient.getChannel(B));return K(N).call(ue,Y,ie)},listen(ue,Y){if((0,w.isFunction)(X))return ce.getMulticastEvent(B,X,ue,Y);const ie=X.routeEvent(ce,ue,Y).then(L=>L.channelClient.getChannel(B));return K(ie).listen(ue,Y)}}}getMulticastEvent(B,X,ce,ue){const Y=this;let ie=new S.DisposableStore;const L=new p.Emitter({onFirstListenerAdd:()=>{ie=new S.DisposableStore;const N=new p.EventMultiplexer,q=new Map,te=ye=>{const Z=ye.channelClient.getChannel(B).listen(ce,ue),ne=N.add(Z);q.set(ye,ne)},fe=ye=>{const j=q.get(ye);!j||(j.dispose(),q.delete(ye))};Y.connections.filter(X).forEach(te),p.Event.filter(Y.onDidAddConnection,X)(te,void 0,ie),Y.onDidRemoveConnection(fe,void 0,ie),N.event(L.fire,L,ie),ie.add(N)},onLastListenerRemove:()=>{ie.dispose()}});return L.event}registerChannel(B,X){this.channels.set(B,X),this._connections.forEach(ce=>{ce.channelServer.registerChannel(B,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class W{constructor(B,X,ce=null){const ue=new u;s(ue,X),B.send(ue.buffer),this.channelClient=new P(B,ce),this.channelServer=new c(B,X,ce)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,X){this.channelServer.registerChannel(B,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function K(O){return{call(B,X,ce){return O.then(ue=>ue.call(B,X,ce))},listen(B,X){const ce=new p.Relay;return O.then(ue=>ce.input=ue.listen(B,X)),ce.event}}}e.getDelayedChannel=K;function se(O){let B=!1;return{call(X,ce,ue){return B?O.call(X,ce,ue):(0,t.timeout)(0).then(()=>B=!0).then(()=>O.call(X,ce,ue))},listen(X,ce){if(B)return O.listen(X,ce);const ue=new p.Relay;return(0,t.timeout)(0).then(()=>B=!0).then(()=>ue.input=O.listen(X,ce)),ue.event}}}e.getNextTickChannel=se;class F{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const X of B.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await p.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=F;var Q;(function(O){function B(Y,ie){const L=Y,N=ie&&ie.disableMarshalling,q=new Map;for(const te in L)ce(te)&&q.set(te,p.Event.buffer(L[te],!0));return new class{listen(te,fe,ye){const j=q.get(fe);if(j)return j;if(ue(fe)){const Z=L[fe];if(typeof Z=="function")return Z.call(L,ye)}throw new Error(`Event not found: ${fe}`)}call(te,fe,ye){const j=L[fe];if(typeof j=="function"){if(!N&&Array.isArray(ye))for(let Z=0;Z<ye.length;Z++)ye[Z]=(0,T.revive)(ye[Z]);return j.apply(L,ye)}throw new Error(`Method not found: ${fe}`)}}}O.fromService=B;function X(Y,ie){const L=ie&&ie.disableMarshalling;return new Proxy({},{get(N,q){if(typeof q=="string")return ie?.properties?.has(q)?ie.properties.get(q):ue(q)?function(te){return Y.listen(q,te)}:ce(q)?Y.listen(q):async function(...te){let fe;ie&&!(0,w.isUndefinedOrNull)(ie.context)?fe=[ie.context,...te]:fe=te;const ye=await Y.call(q,fe);return L?ye:(0,T.revive)(ye)};throw new Error(`Property not found: ${String(q)}`)}})}O.toService=X;function ce(Y){return Y[0]==="o"&&Y[1]==="n"&&R.isUpperAsciiLetter(Y.charCodeAt(2))}function ue(Y){return/^onDynamic/.test(Y)&&R.isUpperAsciiLetter(Y.charCodeAt(9))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){const B=O.toString();if(B!=="[object Object]")return B}return O}function de(O){return Array.isArray(O)?O.map(G):G(O)}function J(O,B,X,ce,ue,Y,ie){ie=de(ie);const L=re[ue],N=L[ce%L.length];let q=[`%c[${O}]%c[${String(B).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(Y)?(q=q.concat(ie),q.push(")")):q.push(ie),console.log.apply(console,q)}e.logWithColors=J;class U{constructor(B,X){this._outgoingPrefix=B,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,X,ce,ue,Y){this._totalOutgoing+=B,J(this._outgoingPrefix,this._totalOutgoing,B,X,ce,ue,Y)}logIncoming(B,X,ce,ue,Y){this._totalIncoming+=B,J(this._incomingPrefix,this._totalIncoming,B,X,ce,ue,Y)}}e.IPCLogger=U}),define(pe[95],ve([0,1,16,7,2,42]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let a=0;function c(P,_){if(!s.has(P)){const W=String(++a);s.set(P,W)}return s.get(P)}function m(P,_,W,K){if(!i.enableDiagnostics)return;const se=c(P,_);if(K instanceof b.VSBuffer||K instanceof Uint8Array||K instanceof ArrayBuffer||ArrayBuffer.isView(K)){const F=b.VSBuffer.alloc(K.byteLength);F.set(K),i.records.push({timestamp:Date.now(),id:se,label:_,type:W,buff:F})}else i.records.push({timestamp:Date.now(),id:se,label:_,type:W,data:K})}i.traceSocketEvent=m})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function T(){return S||(S=b.VSBuffer.alloc(0)),S}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return T();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}const c=b.VSBuffer.alloc(s);let m=0,P=0;for(;s>0;){const _=this._chunks[P];if(_.byteLength>s){const W=_.slice(0,s);c.set(W,m),m+=s,a&&(this._chunks[P]=_.slice(s),this._totalLength-=s),s-=s}else c.set(_,m),m+=_.byteLength,a?(this._chunks.shift(),this._totalLength-=_.byteLength):P++,s-=_.byteLength}return c}}e.ChunkStream=R;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function v(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class I{constructor(s,a,c,m){this.type=s,this.id=a,this.ack=c,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends D.Disposable{constructor(s){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,m=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new I(c,m,P,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=b.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const c=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,c}_bufferTake(){const s=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class g extends D.Disposable{constructor(s){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new I(1,0,0,s))}}e.Protocol=g;class u extends C.IPCClient{constructor(s,a,c=null){super(s,a,c);this.protocol=s}static fromSocket(s,a){return new u(new g(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=u;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,c=this._first;for(;c;)s[a++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new f(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let c=0;for(let m=0;m<o._HISTORY_LENGTH;m++)s-this.lastRuns[m]<=a&&c++;return 1-c/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{constructor(s,a=null,c=o.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new I(5,0,0,T());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new I(7,0,0,T());this._socketWriter.write(s)}sendResume(){const s=new I(8,0,0,T());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new I(3,0,this._incomingAckId,T());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let c=0,m=a.length;c<m;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new I(6,0,0,T())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,m=a.length;c<m;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new I(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const a=new I(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:c});return}const P=Math.max(2e4-a,2e4-c,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new I(3,0,this._incomingAckId,T());this._socketWriter.write(s)}_sendKeepAlive(){const s=new I(9,0,0,T());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(pe[96],ve([0,1,49,14,16,20,150,11,7,2,22,93,56,42]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(d){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",g=>D.VSBuffer.wrap(Buffer.from(g,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=h;class I{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(u),this.child=null,this._client=null}getChannel(d){const g=this;return{call(u,l,f){return g.requestPromise(d,u,l,f)},listen(u,l){return g.requestEvent(d,u,l)}}}requestPromise(d,g,u,l=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(d),r=(0,t.createCancelablePromise)(i=>f.call(g,u,i)),o=l.onCancellationRequested(()=>r.cancel()),n=(0,S.toDisposable)(()=>r.cancel());return this.activeRequests.add(n),r.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(d,g,u){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let l;const f=new p.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(d).listen(g,u)(f.fire,f),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,w.removeDangerousEnvVariables)(g.env),this.child=(0,b.fork)(this.modulePath,d,g);const u=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,k.isRemoteConsoleLog)(s)){(0,k.log)(s,`IPC Library: ${this.options.serverName}`);return}u.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const f=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,r=s=>this.child&&this.child.connected&&f.send(s.buffer.toString("base64")),o=u.event,n={send:r,onMessage:o};this._client=new v.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(c=>(0,S.dispose)(c)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(pe[57],ve([0,1,16,11,7,2,6,3,23,42,95]),function(oe,e,b,t,D,C,k,E,p,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function R(){return{crypto:oe.__$__nodeRequire("crypto"),zlib:oe.__$__nodeRequire("zlib"),net:oe.__$__nodeRequire("net"),os:oe.__$__nodeRequire("os")}}class w{constructor(c,m=""){this.debugLabel=m,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}traceSocketEvent(c,m){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,m)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const m=P=>{this.traceSocketEvent("read",P),c(b.VSBuffer.wrap(P))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(c){const m=P=>{this.traceSocketEvent("close",{hadError:P}),c({type:0,hadError:P,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(c){const m=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=w;var v;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class I extends C.Disposable{constructor(c,m,P,_){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:P?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new y(this,m,P,_,this._onData,(W,K)=>this._write(W,K))),this._register(this._flowManager.onError(W=>{console.error(W),(0,t.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})})),this._incomingData=new T.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,m){this.socket.traceSocketEvent(c,m)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,m){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let P=2;c.byteLength<126?P+=0:c.byteLength<2**16?P+=2:P+=8;const _=b.VSBuffer.alloc(P);if(m?_.writeUInt8(194,0):_.writeUInt8(130,0),c.byteLength<126)_.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){_.writeUInt8(126,1);let W=1;_.writeUInt8(c.byteLength>>>8&255,++W),_.writeUInt8(c.byteLength>>>0&255,++W)}else{_.writeUInt8(127,1);let W=1;_.writeUInt8(0,++W),_.writeUInt8(0,++W),_.writeUInt8(0,++W),_.writeUInt8(0,++W),_.writeUInt8(c.byteLength>>>24&255,++W),_.writeUInt8(c.byteLength>>>16&255,++W),_.writeUInt8(c.byteLength>>>8&255,++W),_.writeUInt8(c.byteLength>>>0&255,++W)}this.socket.write(b.VSBuffer.concat([_,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),P=m.readUInt8(0),_=(P&128)>>>7,W=(P&64)>>>6,K=m.readUInt8(1),se=(K&128)>>>7,F=K&127;this._state.state=2,this._state.readLen=2+(se?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),P=m.readUInt8(1),_=(P&128)>>>7;let W=P&127,K=1;W===126?W=m.readUInt8(++K)*2**8+m.readUInt8(++K):W===127&&(W=m.readUInt8(++K)*0+m.readUInt8(++K)*0+m.readUInt8(++K)*0+m.readUInt8(++K)*0+m.readUInt8(++K)*2**24+m.readUInt8(++K)*2**16+m.readUInt8(++K)*2**8+m.readUInt8(++K));let se=0;_&&(se=m.readUInt8(++K)*2**24+m.readUInt8(++K)*2**16+m.readUInt8(++K)*2**8+m.readUInt8(++K)),this._state.state=3,this._state.readLen=W,this._state.mask=se,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),u(m,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(m,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=I;class y extends C.Disposable{constructor(c,m,P,_,W,K){super();this._tracer=c,this._onData=W,this._writeFn=K,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,m?(this._zlibInflateStream=this._register(new d(this._tracer,_,P,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(se=>this._onError.fire(se))),this._register(this._zlibDeflateStream.onError(se=>this._onError.fire(se)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:b.VSBuffer.alloc(0)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const m=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(m,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,m){return new Promise((P,_)=>{c.write(m),c.flush(W=>P(W))})}acceptFrame(c,m,P){this._readQueue.push({data:c,isCompressed:m,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const m=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(m)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,m,P){return new Promise((_,W)=>{c.write(m),P&&c.write(b.VSBuffer.fromByteArray([0,0,255,255])),c.flush(K=>_(K))})}}class d extends C.Disposable{constructor(c,m,P,_){super();this._tracer=c,this._recordInflateBytes=m,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=R().zlib.createInflateRaw(_),this._zlibInflate.on("error",W=>{this._tracer.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibInflate.on("data",W=>{this._tracer.traceSocketEvent("zlibInflateData",W),this._pendingInflateData.push(b.VSBuffer.wrap(W))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.concat(this._recordedInflateBytes):b.VSBuffer.alloc(0)}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const m=b.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(m)})}}class g extends C.Disposable{constructor(c,m){super();this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=R().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(b.VSBuffer.wrap(P))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let m=b.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.byteLength-4),c(m)})}}function u(a,c){if(c===0)return;const m=a.byteLength>>>2;for(let F=0;F<m;F++){const Q=a.readUInt32BE(F*4);a.writeUInt32BE(Q^c,F*4)}const P=m*4,_=a.byteLength-P,W=c>>>24&255,K=c>>>16&255,se=c>>>8&255;_>=1&&a.writeUInt8(a.readUInt8(P)^W,P),_>=2&&a.writeUInt8(a.readUInt8(P+1)^K,P+1),_>=3&&a.writeUInt8(a.readUInt8(P+2)^se,P+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const l={[2]:107,[1]:103};function f(){const a=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):c=(0,k.join)(R().os.tmpdir(),`vscode-ipc-${a}.sock`),o(c),c}e.createRandomIPCHandle=f;function r(a,c,m){const P=R().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${m}-${c}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${m}-${c}.sock`):_=(0,k.join)(a,`${m}-${c}.sock`),o(_),_}e.createStaticIPCHandle=r;function o(a){const c=l[E.platform];typeof c=="number"&&a.length>=c&&console.warn(`WARNING: IPC handle "${a}" is longer than ${c} chars, try a shorter --user-data-dir`)}class n extends S.IPCServer{constructor(c){super(n.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const m=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(m,P=>({protocol:new T.Protocol(new w(P,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(P,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(a){return new Promise((c,m)=>{const P=R().net.createServer();P.on("error",m),P.listen(a,()=>{P.removeListener("error",m),c(new n(P))})})}e.serve=i;function s(a,c){return new Promise((m,P)=>{const _=R().net.createConnection(a,()=>{_.removeListener("error",P),m(T.Client.fromSocket(new w(_,`ipc-client${c}`),c))});_.once("error",P)})}e.connect=s}),define(pe[154],ve([0,1,14,7,2,12]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function E(R){const w=R;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var p;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(w,v=Object.create(null)){super();this.database=w,this.options=v,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((v,h)=>this.accept(h,v)),w.deleted?.forEach(v=>this.accept(v,void 0))}accept(w,v){if(this.state===p.Closed)return;let h=!1;(0,C.isUndefinedOrNull)(v)?h=this.cache.delete(w):this.cache.get(w)!==v&&(this.cache.set(w,v),h=!0),h&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,v){const h=this.cache.get(w);return(0,C.isUndefinedOrNull)(h)?v:h}getBoolean(w,v){const h=this.get(w);return(0,C.isUndefinedOrNull)(h)?v:h==="true"}getNumber(w,v){const h=this.get(w);return(0,C.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(w,v){if(this.state===p.Closed)return;if((0,C.isUndefinedOrNull)(v))return this.delete(w);const h=String(v);if(this.cache.get(w)!==h)return this.cache.set(w,h),this.pendingInserts.set(w,h),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async delete(w){if(!(this.state===p.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(!!this.hasPending)return this.doFlush(w)}async doFlush(w){return this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert?.forEach((v,h)=>this.items.set(h,v)),w.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=T}),define(pe[155],ve([0,1,7,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,p){return this._map.set(E,p),this.fire([E]),(0,t.toDisposable)(()=>{this._map.get(E)===p&&(this._map.delete(E),this.fire([E]))})}registerFactory(E,p){this._factories.get(E)?.dispose();const S=new C(this,E,p);return this._factories.set(E,S),(0,t.toDisposable)(()=>{const T=this._factories.get(E);!T||T!==S||(this._factories.delete(E),T.dispose())})}async getOrCreate(E){const p=this.get(E);if(p)return p;const S=this._factories.get(E);return!S||S.isResolved?null:(await S.resolve(),this.get(E))}get(E){return this._map.get(E)||null}isResolved(E){if(this.get(E))return!0;const S=this._factories.get(E);return!!(!S||S.isResolved)}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class C extends t.Disposable{constructor(E,p,S){super();this._registry=E,this._languageId=p,this._factory=S,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const E=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,E&&!this._isDisposed&&this._register(this._registry.register(this._languageId,E))}}}),define(pe[156],ve([0,1,40,4,48,155]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(P,_,W){this._tokenBrand=void 0,this.offset=P,this.type=_,this.language=W}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class E{constructor(P,_){this._tokenizationResultBrand=void 0,this.tokens=P,this.endState=_}}e.TokenizationResult=E;class p{constructor(P,_){this._encodedTokenizationResultBrand=void 0,this.tokens=P,this.endState=_}}e.EncodedTokenizationResult=p;var S;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(S=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(m){const P=new Map;P.set(0,b.Codicon.symbolMethod),P.set(1,b.Codicon.symbolFunction),P.set(2,b.Codicon.symbolConstructor),P.set(3,b.Codicon.symbolField),P.set(4,b.Codicon.symbolVariable),P.set(5,b.Codicon.symbolClass),P.set(6,b.Codicon.symbolStruct),P.set(7,b.Codicon.symbolInterface),P.set(8,b.Codicon.symbolModule),P.set(9,b.Codicon.symbolProperty),P.set(10,b.Codicon.symbolEvent),P.set(11,b.Codicon.symbolOperator),P.set(12,b.Codicon.symbolUnit),P.set(13,b.Codicon.symbolValue),P.set(15,b.Codicon.symbolEnum),P.set(14,b.Codicon.symbolConstant),P.set(15,b.Codicon.symbolEnum),P.set(16,b.Codicon.symbolEnumMember),P.set(17,b.Codicon.symbolKeyword),P.set(27,b.Codicon.symbolSnippet),P.set(18,b.Codicon.symbolText),P.set(19,b.Codicon.symbolColor),P.set(20,b.Codicon.symbolFile),P.set(21,b.Codicon.symbolReference),P.set(22,b.Codicon.symbolCustomColor),P.set(23,b.Codicon.symbolFolder),P.set(24,b.Codicon.symbolTypeParameter),P.set(25,b.Codicon.account),P.set(26,b.Codicon.issues);function _(se){let F=P.get(se);return F||(console.info("No codicon found for CompletionItemKind "+se),F=b.Codicon.symbolProperty),F}m.toIcon=_;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function K(se,F){let Q=W.get(se);return typeof Q=="undefined"&&!F&&(Q=9),Q}m.fromString=K})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(m){m[m.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var h;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(h=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var I;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(I=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var y;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(m){return m&&t.URI.isUri(m.uri)&&D.Range.isIRange(m.range)&&(D.Range.isIRange(m.originSelectionRange)||D.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=g;var u;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var l;(function(m){m[m.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var f;(function(m){const P=new Map;P.set(0,b.Codicon.symbolFile),P.set(1,b.Codicon.symbolModule),P.set(2,b.Codicon.symbolNamespace),P.set(3,b.Codicon.symbolPackage),P.set(4,b.Codicon.symbolClass),P.set(5,b.Codicon.symbolMethod),P.set(6,b.Codicon.symbolProperty),P.set(7,b.Codicon.symbolField),P.set(8,b.Codicon.symbolConstructor),P.set(9,b.Codicon.symbolEnum),P.set(10,b.Codicon.symbolInterface),P.set(11,b.Codicon.symbolFunction),P.set(12,b.Codicon.symbolVariable),P.set(13,b.Codicon.symbolConstant),P.set(14,b.Codicon.symbolString),P.set(15,b.Codicon.symbolNumber),P.set(16,b.Codicon.symbolBoolean),P.set(17,b.Codicon.symbolArray),P.set(18,b.Codicon.symbolObject),P.set(19,b.Codicon.symbolKey),P.set(20,b.Codicon.symbolNull),P.set(21,b.Codicon.symbolEnumMember),P.set(22,b.Codicon.symbolStruct),P.set(23,b.Codicon.symbolEvent),P.set(24,b.Codicon.symbolOperator),P.set(25,b.Codicon.symbolTypeParameter);function _(W){let K=P.get(W);return K||(console.info("No codicon found for SymbolKind "+W),K=b.Codicon.symbolProperty),K}m.toIcon=_})(f=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(P){this.value=P}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(m){function P(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}m.is=P})(o=e.Command||(e.Command={}));var n;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(m){m[m.Unresolved=0]="Unresolved",m[m.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var a;(function(m){m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new C.TokenizationRegistry;var c;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[157],ve([8,9]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(pe[158],ve([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[159],ve([8,9]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(pe[160],ve([8,9]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(pe[161],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[162],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[163],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(pe[164],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[165],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[166],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[167],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[168],ve([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[169],ve([8,9]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(pe[170],ve([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(pe[171],ve([8,9]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(pe[172],ve([8,9]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[173],ve([8,9]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[174],ve([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(pe[175],ve([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(pe[176],ve([8,9]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(pe[177],ve([8,9]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[178],ve([8,9]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[179],ve([8,9]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[180],ve([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[181],ve([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(pe[182],ve([8,9]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(pe[183],ve([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(pe[184],ve([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[185],ve([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[186],ve([0,1,7,2]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new b.Emitter,this._onReloadEmitter=new b.Emitter,this._onTerminateEmitter=new b.Emitter,this._onAttachEmitter=new b.Emitter}call(E,p,S){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:S[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:S[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:S[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:S[0],port:S[1],subId:S[2]}))}throw new Error("Method not implemented.")}listen(E,p,S){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends t.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,p,S){this.channel.call("attach",[E,p,S])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,p){this.channel.call("terminate",[E,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,p){return this.channel.call("openExtensionDevelopmentHostWindow",[E,p])}}e.ExtensionHostDebugChannelClient=C}),define(pe[187],ve([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,E,p){throw new Error("Invalid listen")}call(k,E,p){switch(E){case"download":return this.service.download(b.URI.revive(p[0]),b.URI.revive(p[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class D{constructor(k,E){this.channel=k,this.getUriTransformer=E}async download(k,E){const p=this.getUriTransformer();p&&(k=p.transformOutgoingURI(k),E=p.transformOutgoingURI(E)),await this.channel.call("download",[k,E])}}e.DownloadServiceChannelClient=D}),define(pe[188],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class b{constructor(D){this.machineId=D}encryption(){return new Promise((D,C)=>oe(["vscode-encrypt"],D,C))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=b}),define(pe[97],ve([0,1,141,83,10,6,28,19,4]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(I,y,d){this._args=I,this.paths=y,this.productService=d,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",oe).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const I=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",I)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(p.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const I=k.env.VSCODE_PORTABLE;return I?p.URI.file((0,C.join)(I,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const I=this.args["builtin-extensions-dir"];return I?(0,C.resolve)(I):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",oe).fsPath,"..","extensions"))}get extensionsDownloadPath(){const I=this.args["extensions-download-dir"];return I?(0,C.resolve)(I):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const I=this.args["extensions-dir"];if(I)return(0,C.resolve)(I);const y=k.env.VSCODE_EXTENSIONS;if(y)return y;const d=k.env.VSCODE_PORTABLE;return d?(0,C.join)(d,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const I=this.args.extensionDevelopmentPath;if(Array.isArray(I))return I.map(y=>/^[^:/?#]+?:\/\//.test(y)?p.URI.parse(y):p.URI.file((0,C.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(I=>I==="ui"||I==="workspace"||I==="web"?I:"workspace")}get extensionTestsLocationURI(){const I=this.args.extensionTestsPath;if(I)return/^[^:/?#]+?:\/\//.test(I)?p.URI.parse(I):p.URI.file((0,C.normalize)(I))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const I=this.args["disable-extension"];if(I){if(typeof I=="string")return[I];if(Array.isArray(I)&&I.length>0)return I}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return p.URI.file((0,C.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const I=k.env.VSCODE_PORTABLE;return I?p.URI.file((0,C.join)(I,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}Re([t.memoize],S.prototype,"appRoot",null),Re([t.memoize],S.prototype,"userHome",null),Re([t.memoize],S.prototype,"userDataPath",null),Re([t.memoize],S.prototype,"appSettingsHome",null),Re([t.memoize],S.prototype,"tmpDir",null),Re([t.memoize],S.prototype,"cacheHome",null),Re([t.memoize],S.prototype,"stateResource",null),Re([t.memoize],S.prototype,"userRoamingDataHome",null),Re([t.memoize],S.prototype,"userDataSyncHome",null),Re([t.memoize],S.prototype,"userDataSyncLogResource",null),Re([t.memoize],S.prototype,"editSessionsLogResource",null),Re([t.memoize],S.prototype,"sync",null),Re([t.memoize],S.prototype,"machineSettingsResource",null),Re([t.memoize],S.prototype,"workspaceStorageHome",null),Re([t.memoize],S.prototype,"localHistoryHome",null),Re([t.memoize],S.prototype,"keyboardLayoutResource",null),Re([t.memoize],S.prototype,"argvResource",null),Re([t.memoize],S.prototype,"isExtensionDevelopment",null),Re([t.memoize],S.prototype,"untitledWorkspacesHome",null),Re([t.memoize],S.prototype,"installSourcePath",null),Re([t.memoize],S.prototype,"builtinExtensionsPath",null),Re([t.memoize],S.prototype,"extensionsPath",null),Re([t.memoize],S.prototype,"extensionDevelopmentLocationURI",null),Re([t.memoize],S.prototype,"extensionDevelopmentKind",null),Re([t.memoize],S.prototype,"extensionTestsLocationURI",null),Re([t.memoize],S.prototype,"debugExtensionHost",null),Re([t.memoize],S.prototype,"serviceMachineIdResource",null),Re([t.memoize],S.prototype,"telemetryLogResource",null),Re([t.memoize],S.prototype,"disableWorkspaceTrust",null),Re([t.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function T(h,I){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,I,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=T;function R(h,I){return v(h["inspect-search"],h["inspect-brk-search"],5876,I,h.extensionEnvironment)}e.parseSearchPort=R;function w(h,I){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,I,h.extensionEnvironment)}e.parsePtyHostPort=w;function v(h,I,y,d,g,u){const f=Number(I||h)||(d?null:y),r=f?Boolean(!!I):!1;let o;if(u)try{o=JSON.parse(u)}catch{}return{port:f,break:r,debugId:g,env:o}}}),define(pe[58],ve([0,1,265,3,159]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(h,I,y=k){const d={},g=["_"],u=[];for(const o in I){const n=I[o];n.alias&&(d[o]=n.alias),n.type==="string"||n.type==="string[]"?(g.push(o),n.deprecates&&g.push(...n.deprecates)):n.type==="boolean"&&(u.push(o),n.deprecates&&u.push(...n.deprecates))}const l=b(h,{string:g,boolean:u,alias:d}),f={},r=l;f._=l._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in I){const n=I[o];n.alias&&delete r[n.alias];let i=r[o];if(n.deprecates)for(const s of n.deprecates)r.hasOwnProperty(s)&&(i||(i=r[s],i&&y.onDeprecatedOption(s,n.deprecationMessage||(0,D.localize)(35,null,o))),delete r[s]);if(typeof i!="undefined"){if(n.type==="string[]"){if(Array.isArray(i)||(i=[i]),!n.allowEmptyValue){const s=i.filter(a=>a.length>0);s.length!==i.length&&(y.onEmptyValue(o),i=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(i)?(i=i.pop(),y.onMultipleValues(o,i)):!i&&!n.allowEmptyValue&&(y.onEmptyValue(o),i=void 0));f[o]=i,n.deprecationMessage&&y.onDeprecatedOption(o,n.deprecationMessage)}delete r[o]}for(const o in r)y.onUnknownOption(o);return f}e.parseArgs=E;function p(h,I){let y="";return I.args&&(Array.isArray(I.args)?y=` <${I.args.join("> <")}>`:y=` <${I.args}>`),I.alias?`-${I.alias} --${h}${y}`:`--${h}${y}`}function S(h,I){let y=0;const d=[];for(const f in h){const r=h[f],o=p(f,r);y=Math.max(y,o.length),d.push([o,r.description])}const g=y+2+1;if(I-g<25)return d.reduce((f,r)=>f.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const u=I-g-1,l=[];for(const f of d){const r=f[0],o=R(f[1],u),n=T(g-r.length-2);l.push("  "+r+n+o[0]);for(let i=1;i<o.length;i++)l.push(T(g)+o[i])}return l}e.formatOptions=S;function T(h){return" ".repeat(h)}function R(h,I){const y=[];for(;h.length;){const d=h.length<I?h.length:h.lastIndexOf(" ",I),g=h.slice(0,d).trim();h=h.slice(d),y.push(g)}return y}function w(h,I,y,d,g){const u=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",f=[`${h} ${y}`];f.push(""),f.push(`${(0,D.localize)(37,null)}: ${I} [${(0,D.localize)(38,null)}]${l}`),f.push(""),g?.noPipe!==!0&&(t.isWindows?f.push((0,D.localize)(39,null,I)):f.push((0,D.localize)(40,null,I)),f.push(""));const r={};for(const o in d){const n=d[o];if(n.description&&n.cat){let i=r[n.cat];i||(r[n.cat]=i={}),i[o]=n}}for(const o in r){const n=o,i=r[n];i&&(f.push(C[n]),f.push(...S(i,u)),f.push(""))}return f.join(`
`)}e.buildHelpMessage=w;function v(h,I){return`${h||(0,D.localize)(41,null)}
${I||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(pe[189],ve([0,1,266,160,58]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function k(w,v){const h={onUnknownOption:y=>{console.warn((0,t.localize)(0,null,y))},onMultipleValues:(y,d)=>{console.warn((0,t.localize)(1,null,y,d))},onEmptyValue:y=>{console.warn((0,t.localize)(2,null,y))},onDeprecatedOption:(y,d)=>{console.warn((0,t.localize)(3,null,y,d))}},I=(0,D.parseArgs)(w,D.OPTIONS,v?h:void 0);return I.goto&&I._.forEach(y=>b(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,t.localize)(4,null))),I["max-memory"]&&b(parseInt(I["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),I}function E(w){const v=w.findIndex(h=>!/^-/.test(h));if(v>-1)return[...w.slice(0,v),...w.slice(v+1)]}function p(w){let[,...v]=w;process.env.VSCODE_DEV&&(v=E(v)||[]);const h=!R(process.env);return k(v,h)}e.parseMainProcessArgv=p;function S(w){const[,,...v]=w;return k(v,!0)}e.parseCLIProcessArgv=S;function T(w,...v){const h=w.indexOf("--");return h===-1?w.push(...v):w.splice(h,0,...v),w}e.addArg=T;function R(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function oe(e,b,t,D){function C(E){const p=k(E),S=[p];return e.isAbsolute(p)||S.unshift(D),e.resolve(...S)}function k(E){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,t);const T=E["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(R,"AppData","Roaming")}break;case"darwin":S=e.join(b.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,t)}return{getUserDataPath:C}}if(typeof define=="function")define(pe[190],ve([0,84,30,10,19,28]),function(e,b,t,D,C,k){const E=C.dirname(D.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(C.joinPath(E,"package.json").fsPath);return oe(b,t,p.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),b=require("path"),t=require("os");module.exports=oe(b,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[191],ve([0,1,30,97,190]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends t.AbstractNativeEnvironmentService{constructor(E,p){super(E,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E)},p)}}e.NativeEnvironmentService=C}),define(pe[192],ve([0,1,12,164]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(k,E,p){try{C(k,E,p)}catch{}return k}e.localizeManifest=D;function C(k,E,p){const S=(T,R,w)=>{const v=T[R];if((0,b.isString)(v)){const h=v,I=h.length;if(I>1&&h[0]==="%"&&h[I-1]==="%"){const y=h.substr(1,I-2);let d=E[y];d===void 0&&p&&(d=p[y]);const g=typeof d=="string"?d:d.message;if(g!==void 0){const u=p?.[y],l=typeof u=="string"?u:u?.message;if(w&&(R==="title"||R==="category")&&l&&l!==g){const f={value:g,original:l};T[R]=f}else T[R]=g}else console.warn(`[${k.name}]: ${(0,t.localize)(0,null,y)}`)}}else if((0,b.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?S(v,h,!0):S(v,h,w));else if(Array.isArray(v))for(let h=0;h<v.length;h++)S(v,h,w)};for(const T in k)k.hasOwnProperty(T)&&S(k,T)}}),define(pe[70],ve([0,1,19,67,168,50]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function p(d){return d=d.trim(),d==="*"||k.test(d)}e.isValidVersionStr=p;function S(d){if(!p(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=d.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=S;function T(d){if(!d)return null;const g=d.majorBase,u=d.majorMustEqual,l=d.minorBase;let f=d.minorMustEqual;const r=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(g===0||(f=!1),o=!1);let n=0;if(d.preRelease){const i=E.exec(d.preRelease);if(i){const[,s,a,c]=i;n=Date.UTC(Number(s),Number(a)-1,Number(c))}}return{majorBase:g,majorMustEqual:u,minorBase:l,minorMustEqual:f,patchBase:r,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=T;function R(d,g,u){let l;typeof d=="string"?l=T(S(d)):l=d;let f;g instanceof Date?f=g.getTime():typeof g=="string"&&(f=new Date(g).getTime());let r;if(typeof u=="string"?r=T(S(u)):r=u,!l||!r)return!1;const o=l.majorBase,n=l.minorBase,i=l.patchBase;let s=r.majorBase,a=r.minorBase,c=r.patchBase;const m=r.notBefore;let P=r.majorMustEqual,_=r.minorMustEqual,W=r.patchMustEqual;return r.isMinimum?o>s?!0:o<s?!1:n>a?!0:n<a||f&&f<m?!1:i>=c:(o===1&&s===0&&(!P||!_||!W)&&(s=1,a=0,c=0,P=!0,_=!1,W=!1),o<s?!1:o>s?!P:n<a?!1:n>a?!_:i<c?!1:i>c?!W:!(f&&f<m))}e.isValidVersion=R;function w(d,g,u,l,f){const r=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return r.push([t.default.Error,D.localize(0,null)]),r;if(typeof l.name!="string")return r.push([t.default.Error,D.localize(1,null,"name")]),r;if(typeof l.version!="string")return r.push([t.default.Error,D.localize(2,null,"version")]),r;if(!l.engines)return r.push([t.default.Error,D.localize(3,null,"engines")]),r;if(typeof l.engines.vscode!="string")return r.push([t.default.Error,D.localize(4,null,"engines.vscode")]),r;if(typeof l.extensionDependencies!="undefined"&&!y(l.extensionDependencies))return r.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),r;if(typeof l.activationEvents!="undefined"){if(!y(l.activationEvents))return r.push([t.default.Error,D.localize(6,null,"activationEvents")]),r;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return r.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),r}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&r.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return r.push([t.default.Error,D.localize(9,null,"main")]),r;{const i=(0,b.joinPath)(u,l.main);(0,b.isEqualOrParent)(i,u)||r.push([t.default.Warning,D.localize(10,null,i.path,u.path)])}if(typeof l.activationEvents=="undefined")return r.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),r}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return r.push([t.default.Error,D.localize(12,null,"browser")]),r;{const i=(0,b.joinPath)(u,l.browser);(0,b.isEqualOrParent)(i,u)||r.push([t.default.Warning,D.localize(13,null,i.path,u.path)])}if(typeof l.activationEvents=="undefined")return r.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),r}if(!C.valid(l.version))return r.push([t.default.Error,D.localize(15,null)]),r;const o=[];if(!v(d,g,l,f,o))for(const i of o)r.push([t.default.Error,i]);return r}e.validateExtensionManifest=w;function v(d,g,u,l,f){return l||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:I(d,g,u.engines.vscode,f)}e.isValidExtensionVersion=v;function h(d,g,u){return d==="*"||I(g,u,d)}e.isEngineValid=h;function I(d,g,u,l=[]){const f=T(S(u));if(!f)return l.push(D.localize(16,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return l.push(D.localize(17,null,u)),!1}else if(!f.majorMustEqual)return l.push(D.localize(18,null,u)),!1;return R(d,g,f)?!0:(l.push(D.localize(19,null,d,u)),!1)}function y(d){if(!Array.isArray(d))return!1;for(let g=0,u=d.length;g<u;g++)if(typeof d[g]!="string")return!1;return!0}}),define(pe[193],ve([0,1,16,23]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,E){let p=E&&E.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const T=(await k.readFile(C.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(T)?T:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,b.VSBuffer.fromString(p))}catch{}}return E?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=D}),define(pe[59],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class b{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b}),define(pe[194],ve([0,1,59]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(k,E,p){E instanceof b.SyncDescriptor||(E=new b.SyncDescriptor(E,[],p)),t.push([k,E])}e.registerSingleton=D;function C(){return t}e.getSingletonServiceDescriptors=C}),define(pe[195],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=b;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const E=this.lookupOrInsertNode(C),p=this.lookupOrInsertNode(k);E.outgoing.set(this._hashFn(k),p),p.incoming.set(this._hashFn(C),E)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(const E of this._nodes.values())E.outgoing.delete(k),E.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let E=this._nodes.get(k);return E||(E=new b(C),this._nodes.set(k,E)),E}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[k,E]of this._nodes)C.push(`${k}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(const[C,k]of this._nodes){const E=new Set([C]),p=this._findCycle(k,E);if(p)return p}}_findCycle(C,k){for(const[E,p]of C.outgoing){if(k.has(E))return[...k,E].join(" -> ");k.add(E);const S=this._findCycle(p,k);if(S)return S;k.delete(E)}}}e.Graph=t}),define(pe[5],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function E(p){return p[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=E})(b=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(k,E,p){E[b.DI_TARGET]===E?E[b.DI_DEPENDENCIES].push({id:k,index:p}):(E[b.DI_DEPENDENCIES]=[{id:k,index:p}],E[b.DI_TARGET]=E)}function D(k){if(b.serviceIds.has(k))return b.serviceIds.get(k);const E=function(p,S,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,p,T)};return E.toString=()=>k,b.serviceIds.set(k,E),E}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(pe[25],ve([0,1,12,4,5]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=C;function k(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var E;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function S(d,g){const u=Object.create(null);for(const l in d)T(u,l,d[l],g);return u}e.toValuesTree=S;function T(d,g,u,l){const f=g.split("."),r=f.pop();let o=d;for(let n=0;n<f.length;n++){const i=f[n];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${f.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[r]=u}catch{l(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=T;function R(d,g){const u=g.split(".");w(d,u)}e.removeFromValueTree=R;function w(d,g){const u=g.shift();if(g.length===0){delete d[u];return}if(Object.keys(d).indexOf(u)!==-1){const l=d[u];typeof l=="object"&&!Array.isArray(l)&&(w(l,g),Object.keys(l).length===0&&delete d[u])}}function v(d,g,u){function l(o,n){let i=o;for(const s of n){if(typeof i!="object"||i===null)return;i=i[s]}return i}const f=g.split("."),r=l(d,f);return typeof r=="undefined"?u:r}e.getConfigurationValue=v;function h(d,g,u){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in d?b.isObject(d[l])&&b.isObject(g[l])?h(d[l],g[l],u):u&&(d[l]=g[l]):d[l]=g[l])})}e.merge=h;function I(d,g,u){const l=d.inspect(g),f=d.inspect(u);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=I;function y(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(pe[98],ve([0,1,3,15,5]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",b.isMacintosh),C.set("isLinux",b.isLinux),C.set("isWindows",b.isWindows),C.set("isWeb",b.isWeb),C.set("isMacNative",b.isMacintosh&&!b.isWeb),C.set("isEdge",b.isEdge),C.set("isFirefox",b.isFirefox),C.set("isChrome",b.isChrome),C.set("isSafari",b.isSafari);const k=Object.prototype.hasOwnProperty;var E;(function(se){se[se.False=0]="False",se[se.True=1]="True",se[se.Defined=2]="Defined",se[se.Not=3]="Not",se[se.Equals=4]="Equals",se[se.NotEquals=5]="NotEquals",se[se.And=6]="And",se[se.Regex=7]="Regex",se[se.NotRegex=8]="NotRegex",se[se.Or=9]="Or",se[se.In=10]="In",se[se.NotIn=11]="NotIn",se[se.Greater=12]="Greater",se[se.GreaterEquals=13]="GreaterEquals",se[se.Smaller=14]="Smaller",se[se.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return R.INSTANCE}static true(){return w.INSTANCE}static has(F){return v.create(F)}static equals(F,Q){return h.create(F,Q)}static notEquals(F,Q){return d.create(F,Q)}static regex(F,Q){return n.create(F,Q)}static in(F,Q){return I.create(F,Q)}static notIn(F,Q){return y.create(F,Q)}static not(F){return g.create(F)}static and(...F){return a.create(F,null)}static or(...F){return c.create(F,null,!0)}static greater(F,Q){return l.create(F,Q)}static greaterEquals(F,Q){return f.create(F,Q)}static smaller(F,Q){return r.create(F,Q)}static smallerEquals(F,Q){return o.create(F,Q)}static deserialize(F,Q=!1){if(!!F)return this._deserializeOrExpression(F,Q)}static _deserializeOrExpression(F,Q){const re=F.split("||");return c.create(re.map(G=>this._deserializeAndExpression(G,Q)),null,!0)}static _deserializeAndExpression(F,Q){const re=F.split("&&");return a.create(re.map(G=>this._deserializeOne(G,Q)),null)}static _deserializeOne(F,Q){if(F=F.trim(),F.indexOf("!=")>=0){const re=F.split("!=");return d.create(re[0].trim(),this._deserializeValue(re[1],Q))}if(F.indexOf("==")>=0){const re=F.split("==");return h.create(re[0].trim(),this._deserializeValue(re[1],Q))}if(F.indexOf("=~")>=0){const re=F.split("=~");return n.create(re[0].trim(),this._deserializeRegexValue(re[1],Q))}if(F.indexOf(" not in ")>=0){const re=F.split(" not in ");return y.create(re[0].trim(),re[1].trim())}if(F.indexOf(" in ")>=0){const re=F.split(" in ");return I.create(re[0].trim(),re[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const re=F.split(">=");return f.create(re[0].trim(),re[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const re=F.split(">");return l.create(re[0].trim(),re[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const re=F.split("<=");return o.create(re[0].trim(),re[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const re=F.split("<");return r.create(re[0].trim(),re[1].trim())}return/^\!\s*/.test(F)?g.create(F.substr(1).trim()):v.create(F)}static _deserializeValue(F,Q){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const re=/^'([^']*)'$/.exec(F);return re?re[1].trim():F}static _deserializeRegexValue(F,Q){if((0,t.isFalsyOrWhitespace)(F)){if(Q)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const re=F.indexOf("/"),G=F.lastIndexOf("/");if(re===G||re<0){if(Q)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const de=F.slice(re+1,G),J=F[G+1]==="i"?"i":"";try{return new RegExp(de,J)}catch(U){if(Q)throw new Error(`bad regexp-value '${F}', parse error: ${U}`);return console.warn(`bad regexp-value '${F}', parse error: ${U}`),null}}}e.ContextKeyExpr=p;function S(se,F){const Q=se?se.substituteConstants():void 0,re=F?F.substituteConstants():void 0;return!Q&&!re?!0:!Q||!re?!1:Q.equals(re)}e.expressionsAreEqualWithConstantSubstitution=S;function T(se,F){return se.cmp(F)}class R{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class w{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class v{constructor(F,Q){this.key=F,this.negated=Q,this.type=2}static create(F,Q=null){const re=C.get(F);return typeof re=="boolean"?re?w.INSTANCE:R.INSTANCE:new v(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:P(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=C.get(this.key);return typeof F=="boolean"?F?w.INSTANCE:R.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{constructor(F,Q,re){this.key=F,this.value=Q,this.negated=re,this.type=4}static create(F,Q,re=null){if(typeof Q=="boolean")return Q?v.create(F,re):g.create(F,re);const G=C.get(F);return typeof G=="boolean"?Q===(G?"true":"false")?w.INSTANCE:R.INSTANCE:new h(F,Q,re)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=C.get(this.key);if(typeof F=="boolean"){const Q=F?"true":"false";return this.value===Q?w.INSTANCE:R.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class I{constructor(F,Q){this.key=F,this.valueKey=Q,this.type=10,this.negated=null}static create(F,Q){return new I(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.valueKey),re=F.getValue(this.key);return Array.isArray(Q)?Q.includes(re):typeof re=="string"&&typeof Q=="object"&&Q!==null?k.call(Q,re):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=I;class y{constructor(F,Q){this.key=F,this.valueKey=Q,this.type=11,this._negated=I.create(F,Q)}static create(F,Q){return new y(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:this._negated.cmp(F._negated)}equals(F){return F.type===this.type?this._negated.equals(F._negated):!1}substituteConstants(){return this}evaluate(F){return!this._negated.evaluate(F)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(F){return F.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class d{constructor(F,Q,re){this.key=F,this.value=Q,this.negated=re,this.type=5}static create(F,Q,re=null){if(typeof Q=="boolean")return Q?g.create(F,re):v.create(F,re);const G=C.get(F);return typeof G=="boolean"?Q===(G?"true":"false")?R.INSTANCE:w.INSTANCE:new d(F,Q,re)}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=C.get(this.key);if(typeof F=="boolean"){const Q=F?"true":"false";return this.value===Q?R.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class g{constructor(F,Q){this.key=F,this.negated=Q,this.type=3}static create(F,Q=null){const re=C.get(F);return typeof re=="boolean"?re?R.INSTANCE:w.INSTANCE:new g(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:P(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=C.get(this.key);return typeof F=="boolean"?F?R.INSTANCE:w.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function u(se,F){if(typeof se=="string"){const Q=parseFloat(se);isNaN(Q)||(se=Q)}return typeof se=="string"||typeof se=="number"?F(se):R.INSTANCE}class l{constructor(F,Q,re){this.key=F,this.value=Q,this.negated=re,this.type=12}static create(F,Q,re=null){return u(Q,G=>new l(F,G,re))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class f{constructor(F,Q,re){this.key=F,this.value=Q,this.negated=re,this.type=13}static create(F,Q,re=null){return u(Q,G=>new f(F,G,re))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class r{constructor(F,Q,re){this.key=F,this.value=Q,this.negated=re,this.type=14}static create(F,Q,re=null){return u(Q,G=>new r(F,G,re))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class o{constructor(F,Q,re){this.key=F,this.value=Q,this.negated=re,this.type=15}static create(F,Q,re=null){return u(Q,G=>new o(F,G,re))}cmp(F){return F.type!==this.type?this.type-F.type:_(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class n{constructor(F,Q){this.key=F,this.regexp=Q,this.type=7,this.negated=null}static create(F,Q){return new n(F,Q)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const Q=this.regexp?this.regexp.source:"",re=F.regexp?F.regexp.source:"";return Q<re?-1:Q>re?1:0}equals(F){if(F.type===this.type){const Q=this.regexp?this.regexp.source:"",re=F.regexp?F.regexp.source:"";return this.key===F.key&&Q===re}return!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.key);return this.regexp?this.regexp.test(Q):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{constructor(F){this._actual=F,this.type=8}static create(F){return new i(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new i(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(se){let F=null;for(let Q=0,re=se.length;Q<re;Q++){const G=se[Q].substituteConstants();if(se[Q]!==G&&F===null){F=[];for(let de=0;de<Q;de++)F[de]=se[de]}F!==null&&(F[Q]=G)}return F===null?se:F}class a{constructor(F,Q){this.expr=F,this.negated=Q,this.type=6}static create(F,Q){return a._normalizeArr(F,Q)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,re=this.expr.length;Q<re;Q++){const G=T(this.expr[Q],F.expr[Q]);if(G!==0)return G}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,re=this.expr.length;Q<re;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=s(this.expr);return F===this.expr?this:a.create(F,this.negated)}evaluate(F){for(let Q=0,re=this.expr.length;Q<re;Q++)if(!this.expr[Q].evaluate(F))return!1;return!0}static _normalizeArr(F,Q){const re=[];let G=!1;for(const de of F)if(!!de){if(de.type===1){G=!0;continue}if(de.type===0)return R.INSTANCE;if(de.type===6){re.push(...de.expr);continue}re.push(de)}if(re.length===0&&G)return w.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(T);for(let de=1;de<re.length;de++)re[de-1].equals(re[de])&&(re.splice(de,1),de--);if(re.length===1)return re[0];for(;re.length>1;){const de=re[re.length-1];if(de.type!==9)break;re.pop();const J=re.pop(),U=re.length===0,O=c.create(de.expr.map(B=>a.create([B,J],null)),null,U);O&&(re.push(O),re.sort(T))}return re.length===1?re[0]:new a(re,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new a(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.negated){const F=[];for(const Q of this.expr)F.push(Q.negate());this.negated=c.create(F,this,!0)}return this.negated}}class c{constructor(F,Q){this.expr=F,this.negated=Q,this.type=9}static create(F,Q,re){return c._normalizeArr(F,Q,re)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,re=this.expr.length;Q<re;Q++){const G=T(this.expr[Q],F.expr[Q]);if(G!==0)return G}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,re=this.expr.length;Q<re;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=s(this.expr);return F===this.expr?this:c.create(F,this.negated,!1)}evaluate(F){for(let Q=0,re=this.expr.length;Q<re;Q++)if(this.expr[Q].evaluate(F))return!0;return!1}static _normalizeArr(F,Q,re){let G=[],de=!1;if(F){for(let J=0,U=F.length;J<U;J++){const O=F[J];if(!!O){if(O.type===0){de=!0;continue}if(O.type===1)return w.INSTANCE;if(O.type===9){G=G.concat(O.expr);continue}G.push(O)}}if(G.length===0&&de)return R.INSTANCE;G.sort(T)}if(G.length!==0){if(G.length===1)return G[0];for(let J=1;J<G.length;J++)G[J-1].equals(G[J])&&(G.splice(J,1),J--);if(G.length===1)return G[0];if(re){for(let J=0;J<G.length;J++)for(let U=J+1;U<G.length;U++)W(G[J],G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0]}return new c(G,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new c(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.negated){const F=[];for(const Q of this.expr)F.push(Q.negate());for(;F.length>1;){const Q=F.shift(),re=F.shift(),G=[];for(const J of K(Q))for(const U of K(re))G.push(a.create([J,U],null));const de=F.length===0;F.unshift(c.create(G,null,de))}this.negated=F[0]}return this.negated}}class m extends v{constructor(F,Q,re){super(F,null);this._defaultValue=Q,typeof re=="object"?m._info.push({...re,key:F}):re!==!0&&m._info.push({key:F,description:re,type:Q!=null?typeof Q:void 0})}static all(){return m._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return h.create(this.key,F)}notEqualsTo(F){return d.create(this.key,F)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(se,F){return se<F?-1:se>F?1:0}function _(se,F,Q,re){return se<Q?-1:se>Q?1:F<re?-1:F>re?1:0}function W(se,F){if(F.type===6&&se.type!==9&&se.type!==6){for(const G of F.expr)if(se.equals(G))return!0}const Q=se.negate(),re=K(Q).concat(K(F));re.sort(T);for(let G=0;G<re.length;G++){const J=re[G].negate();for(let U=G+1;U<re.length;U++){const O=re[U];if(J.equals(O))return!0}}return!1}e.implies=W;function K(se){return se.type===9?se.expr:[se]}}),define(pe[71],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,b.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,b.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(C,k){return this.secretVault[C]?.[k]??null}async setPassword(C,k,E){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][k]=E}async deletePassword(C,k){return this.secretVault[C]?.[k]?(delete this.secretVault[C][k],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const k=[];for(const E of Object.keys(this.secretVault[C]||{}))k.push({account:E,password:this.secretVault[C][E]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(pe[196],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,b.createDecorator)(e.ID);function t(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(k,E){return{}}async getSystemInfo(k,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,E){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=D}),define(pe[72],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,b.createDecorator)("downloadService")}),define(pe[197],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,b.createDecorator)("encryptionMainService")}),define(pe[26],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[31],ve([0,1,162,5]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function k(d,g){switch(d){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function E(d,g){return g==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function p(d,g,u){return E(g,u)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===u?!0:S(u).includes(d)}e.isTargetPlatformCompatible=p;function S(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function T(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=T;var R;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var w;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var v;(function(d){d.Install="install",d.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var I;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(I=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(g,u){super(g);this.code=u,this.name=u}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(pe[198],ve([0,1,7,2,41,22,4,69,31]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(y,d){return k.URI.revive(d?d.transformIncoming(y):y)}function T(y,d){return d?d.transformOutgoingURI(y):y}function R(y,d){d=d||E.DefaultURITransformer;const g=y.manifest;return{...(0,E.transformAndReviveIncomingURIs)({...y,manifest:void 0},d),manifest:g}}function w(y,d){return d?(0,C.cloneAndChange)(y,g=>g instanceof k.URI?d.transformOutgoingURI(g):void 0):y}class v{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=b.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=b.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=b.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=b.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const u=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return b.Event.map(this.onDidInstallExtensions,l=>l.map(f=>({...f,local:f.local?w(f.local,u):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,u){const l=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(R(u[0],l)).then(f=>T(f,l));case"unzip":return this.service.unzip(S(u[0],l));case"install":return this.service.install(S(u[0],l),(0,D.revive)(u[1]));case"getManifest":return this.service.getManifest(S(u[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,D.revive)(u[1]));case"uninstall":return this.service.uninstall(R(u[0],l),(0,D.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(R(u[0],l));case"getInstalled":return this.service.getInstalled(u[0],k.URI.revive(u[1])).then(f=>f.map(r=>w(r,l)));case"getMetadata":return this.service.getMetadata(R(u[0],l));case"updateMetadata":return this.service.updateMetadata(R(u[0],l),u[1]).then(f=>w(f,l));case"updateExtensionScope":return this.service.updateExtensionScope(R(u[0],l),u[1]).then(f=>w(f,l));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends t.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new b.Emitter),this._onDidInstallExtensions=this._register(new b.Emitter),this._onUninstallExtension=this._register(new b.Emitter),this._onDidUninstallExtension=this._register(new b.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?k.URI.revive(g.source):g.source,profileLocation:k.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(u=>({...u,local:u.local?R(u.local,null):u.local,source:this.isUriComponents(u.source)?k.URI.revive(u.source):u.source,profileLocation:k.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:k.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:k.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(u=>(0,p.isTargetPlatformCompatible)(u,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>k.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(u=>R(u,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(u=>R(u,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null,g){return Promise.resolve(this.channel.call("getInstalled",[d,g])).then(u=>u.map(l=>R(l,null)))}getMetadata(d){return Promise.resolve(this.channel.call("getMetadata",[d]))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(u=>R(u,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(u=>R(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class I{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,u){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=I}),define(pe[17],ve([0,1,24,6,15,12,4,170,5]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function S(J){return J.create===!0}e.isFileOpenForWriteOptions=S;var T;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var R;(function(J){J[J.Readonly=1]="Readonly"})(R=e.FilePermission||(e.FilePermission={}));var w;(function(J){J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(J){return!!(J.capabilities&2)}e.hasReadWriteCapability=v;function h(J){return!!(J.capabilities&8)}e.hasFileFolderCopyCapability=h;function I(J){return!!(J.capabilities&32768)}e.hasFileCloneCapability=I;function y(J){return!!(J.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function d(J){return!!(J.capabilities&16)}e.hasFileReadStreamCapability=d;function g(J){return v(J)?!!(J.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var u;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(U,O){super(U);this.code=O}}e.FileSystemProviderError=l;function f(J,U){const O=new l(J.toString(),U);return o(O,U),O}e.createFileSystemProviderError=f;function r(J){return J||f((0,E.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function o(J,U){return J.name=U?`${U} (FileSystemError)`:"FileSystemError",J}e.markAsFileSystemProviderError=o;function n(J){if(!J)return u.Unknown;if(J instanceof l)return J.code;const U=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!U)return u.Unknown;switch(U[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function i(J){if(J instanceof _)return J.fileOperationResult;switch(n(J)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(U,O,B){this.resource=U,this.operation=O,this.target=B}isOperation(U){return this.operation===U}}e.FileOperationEvent=a;var c;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class m{constructor(U,O){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const B=new Map;for(const X of U){const ce=B.get(X.type);switch(ce?ce.push([X.resource,X]):B.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,ce]of B)switch(X){case 1:this.added=b.TernarySearchTree.forUris(()=>O),this.added.fill(ce);break;case 0:this.updated=b.TernarySearchTree.forUris(()=>O),this.updated.fill(ce);break;case 2:this.deleted=b.TernarySearchTree.forUris(()=>O),this.deleted.fill(ce);break}}contains(U,...O){return this.doContains(U,{includeChildren:!1},...O)}affects(U,...O){return this.doContains(U,{includeChildren:!0},...O)}doContains(U,O,...B){if(!U)return!1;const X=B.length>0;return!!((!X||B.includes(1))&&(this.added?.get(U)||O.includeChildren&&this.added?.findSuperstr(U))||(!X||B.includes(0))&&(this.updated?.get(U)||O.includeChildren&&this.updated?.findSuperstr(U))||(!X||B.includes(2))&&(this.deleted?.findSubstr(U)||O.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function P(J,U,O){return!J||!U||J===U||U.length>J.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),O?(0,D.startsWithIgnoreCase)(J,U):J.indexOf(U)===0)}e.isParent=P;class _ extends Error{constructor(U,O,B){super(U);this.fileOperationResult=O,this.options=B}}e.FileOperationError=_;class W extends _{constructor(U,O,B){super(U,2,B);this.stat=O}}e.NotModifiedSinceFileOperationError=W;var K;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",J[J.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var se;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(se=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}e.etag=F;async function Q(J,U){if(!U.hasProvider(k.URI.from({scheme:J.scheme})))return new Promise(O=>{const B=U.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===J.scheme&&X.added&&(B.dispose(),O())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(U){return(0,C.isNumber)(U)||(U=0),U<re.KB?(0,E.localize)(1,null,U.toFixed(0)):U<re.MB?(0,E.localize)(2,null,(U/re.KB).toFixed(2)):U<re.GB?(0,E.localize)(3,null,(U/re.MB).toFixed(2)):U<re.TB?(0,E.localize)(4,null,(U/re.GB).toFixed(2)):(0,E.localize)(5,null,(U/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var G;(function(J){J[J.IA32=0]="IA32",J[J.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function de(J){return{maxFileSize:J===0?300*re.MB:16*re.GB,maxHeapSize:J===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=de}),define(pe[199],ve([0,1,16,38,11,7,2,46,4,23,17]),function(oe,e,b,t,D,C,k,E,p,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(v,h){super();this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:I}=await this.channel.call("readFile",[v,h]);return I}readFileStream(v,h,I){const y=(0,E.newWriteableStream)(g=>b.VSBuffer.concat(g.map(u=>b.VSBuffer.wrap(u))).buffer),d=this.channel.listen("readFileStream",[v,h])(g=>{if(g instanceof b.VSBuffer)y.write(g.buffer);else{if(g==="end")y.end();else{let u=g;u instanceof Error||(u=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(u),T.FileSystemProviderErrorCode.Unknown)),y.error(u),y.end()}d.dispose()}});return I.onCancellationRequested(()=>{y.error((0,D.canceled)()),y.end(),d.dispose()}),y}writeFile(v,h,I){return this.channel.call("writeFile",[v,b.VSBuffer.wrap(h),I])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,I,y,d){const[g,u]=await this.channel.call("read",[v,h,d]);return I.set(g.buffer.slice(0,u),y),u}write(v,h,I,y,d){return this.channel.call("write",[v,h,b.VSBuffer.wrap(I),y,d])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,I){return this.channel.call("rename",[v,h,I])}copy(v,h,I){return this.channel.call("copy",[v,h,I])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(I=>({resource:p.URI.revive(I.resource),type:I.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const I=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,I,v,h]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,I]))}}e.DiskFileSystemProviderClient=R}),define(pe[99],ve([0,1,16,11,171,17]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,R,w,v,h,I){let y;try{await E(T,R,w,v,h,I)}catch(d){y=d}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y!="undefined"&&w.error(y),w.end()}}e.readFileIntoStream=k;async function E(T,R,w,v,h,I){p(I);const y=await T.open(R,{create:!1});try{p(I);let d=0,g=0,u=h&&typeof h.length=="number"?h.length:void 0,l=b.VSBuffer.alloc(Math.min(h.bufferSize,typeof u=="number"?u:h.bufferSize)),f=h&&typeof h.position=="number"?h.position:0,r=0;do g=await T.read(y,f,l.buffer,r,l.byteLength-r),f+=g,r+=g,d+=g,typeof u=="number"&&(u-=g),r===l.byteLength&&(await w.write(v(l)),l=b.VSBuffer.alloc(Math.min(h.bufferSize,typeof u=="number"?u:h.bufferSize)),r=0);while(g>0&&(typeof u!="number"||u>0)&&p(I)&&S(d,h));if(r>0){let o=r;typeof u=="number"&&(o=Math.min(r,u)),w.write(v(l.slice(0,o)))}}catch(d){throw(0,C.ensureFileSystemProviderError)(d)}finally{await T.close(y)}}function p(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function S(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(pe[60],ve([0,1,68,2,6,3,4,17]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(d){return d.recursive===!0}e.isRecursiveWatchRequest=p;class S extends t.Disposable{constructor(g,u,l,f){super();this.onFileChanges=g,this.onLogMessage=u,this.verboseLogging=l,this.options=f,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new t.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),g.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),g.add(this.watcher.onDidError(u=>this.onError(u)))}onError(g){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class T extends S{constructor(g,u,l){super(g,u,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class R extends S{constructor(g,u,l){super(g,u,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function w(d){return d.map(g=>({type:g.type,resource:k.URI.file(g.path)}))}e.toFileChanges=w;function v(d){const g=new y;for(const u of d)g.processEvent(u);return g.coalesce()}e.coalesceEvents=v;function h(d,g){return typeof g=="string"&&!g.startsWith(b.GLOBSTAR)&&!(0,D.isAbsolute)(g)?{base:d,pattern:g}:g}e.normalizeWatcherPattern=h;function I(d,g){const u=[];for(const l of g)u.push((0,b.parse)(h(d,l)));return u}e.parseWatcherPatterns=I;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return C.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const u=this.mapPathToChange.get(this.toKey(g));let l=!1;if(u){const f=u.type,r=g.type;u.path!==g.path&&(g.type===2||g.type===1)?l=!0:f===1&&r===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(u)):f===2&&r===1?u.type=0:f===1&&r===0||(u.type=r)}else l=!0;l&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],u=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(g.push(l),!1):!0).sort((l,f)=>l.path.length-f.path.length).filter(l=>u.some(f=>(0,E.isParent)(l.path,f,!C.isLinux))?!1:(u.push(l.path),!0)).concat(g)}}}),define(pe[200],ve([0,1,29,14,20,35,2,89,6,3,152,21,60]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends k.Disposable{constructor(y,d,g,u){super();this.request=y,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=u,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,w.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,w.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await R.Promises.stat(y);this._register(await this.doWatch(y,d.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let d=y.path;try{d=await R.Promises.realpath(y.path),y.path===d&&(d=await(0,T.realcase)(y.path)??y.path),y.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${d})`)}catch{}return d}async doWatch(y,d){if(S.isMacintosh&&(0,C.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=new D.CancellationTokenSource(this.cts.token),u=new k.DisposableStore;try{const l=(0,p.basename)(y),f=(0,b.watch)(y);u.add((0,k.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.trace(`Started watching: '${y}'`);const r=new Set;if(d)try{for(const n of await R.Promises.readdir(y))r.add(n)}catch(n){this.error(n)}const o=new Map;u.add((0,k.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),f.on("error",(n,i)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),f.on("change",(n,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let s="";if(i&&(s=i.toString(),S.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(d)if(n==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===l&&!await R.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,p.join)(y,s));if(g.token.isCancellationRequested)return;let m;c?r.has(s)?m=0:(m=1,r.add(s)):(r.delete(s),m=2),this.onFileChange({path:(0,p.join)(this.request.path,s),type:m})},v.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,k.toDisposable)(()=>clearTimeout(a)))}else{let a;r.has(s)?a=0:(a=1,r.add(s)),this.onFileChange({path:(0,p.join)(this.request.path,s),type:a})}else if(n==="rename"||s!==l){const a=setTimeout(async()=>{const c=await R.Promises.exists(y);g.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,k.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(y)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${l.toString()})`)}return(0,k.toDisposable)(()=>{g.dispose(!0),u.dispose()})}async onFileChange(y,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!d&&this.excludes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,w.coalesceEvents)(g);if(u.length>0){if(this.verboseLogging)for(const f of u)this.trace(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(S.isLinux)return R.Promises.exists(y);try{const d=(0,p.basename)(y);return(await R.Promises.readdir((0,p.dirname)(y))).some(u=>u===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(I,y,d,g,u=512){const l=await R.Promises.open(I,"r"),f=Buffer.allocUnsafe(u),r=new D.CancellationTokenSource(g);let o,n=!1;const i={path:I,excludes:[],recursive:!1},s=new v(i,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:m}=await R.Promises.read(l,f,0,u,null);if(!m||r.token.isCancellationRequested)break;y(f.slice(0,m))}}catch(m){o=new Error(m),r.dispose(!0)}finally{n=!1}}})()});return await s.ready,d(),new Promise((a,c)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await R.Promises.close(l)}catch(m){o=new Error(m)}o?c(o):a()})})}e.watchFileContents=h}),define(pe[201],ve([0,1,7,68,2,3,200]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new b.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new b.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=b.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const T=this.normalizeRequests(S),R=T.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,t.patternsEquals)(h.request.excludes,v.excludes)||!(0,t.patternsEquals)(h.request.includes,v.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:v})=>!T.find(h=>h.path===v.path&&(0,t.patternsEquals)(h.excludes,v.excludes)&&(0,t.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);R.length&&this.trace(`Request to start watching: ${R.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const v of w)this.stopWatching(v);for(const v of R)this.startWatching(v)}startWatching(S){const T=new k.NodeJSFileWatcherLibrary(S,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),R={request:S,instance:T};this.watchers.set(S.path,R)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const T=this.watchers.get(S);T&&(this.watchers.delete(S),T.instance.dispose())}normalizeRequests(S){const T=new Map;for(const R of S){const w=C.isLinux?R.path:R.path.toLowerCase();T.set(w,R)}return Array.from(T.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,T]of this.watchers)T.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,T){return T?`[File Watcher (node.js)] ${S} (path: ${T.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=E}),define(pe[202],ve([0,1,60,201]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends b.AbstractNonRecursiveWatcherClient{constructor(k,E,p){super(k,E,p);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(pe[203],ve([0,1,10,42,96,60]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends C.AbstractUniversalWatcherClient{constructor(p,S,T){super(p,S,T);this.init()}createWatcher(p){const S=p.add(new D.Client(b.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(S.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(pe[73],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...D){this._entries=new Map;for(const[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=b}),define(pe[100],ve([0,1,14,11,59,195,5,73]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class S extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class T{constructor(h=new E.ServiceCollection,I=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=I,this._parent=y,this._services.set(k.IInstantiationService,this)}createChild(h){return new T(h,this._strict,this)}invokeFunction(h,...I){const y=w.traceInvocation(h);let d=!1;try{return h({get:u=>{if(d)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(u,y);if(!l)throw new Error(`[invokeFunction] unknown service '${u}'`);return l}},...I)}finally{d=!0,y.stop()}}createInstance(h,...I){let y,d;return h instanceof D.SyncDescriptor?(y=w.traceCreation(h.ctor),d=this._createInstance(h.ctor,h.staticArguments.concat(I),y)):(y=w.traceCreation(h),d=this._createInstance(h,I,y)),y.stop(),d}_createInstance(h,I=[],y){const d=k._util.getServiceDependencies(h).sort((l,f)=>l.index-f.index),g=[];for(const l of d){const f=this._getOrCreateServiceInstance(l.id,y);f||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(f)}const u=d.length>0?d[0].index:I.length;if(I.length!==u){console.trace(`[createInstance] First service dependency of ${h.name} at position ${u+1} conflicts with ${I.length} static arguments`);const l=u-I.length;l>0?I=I.concat(new Array(l)):I=I.slice(0,u)}return new h(...[...I,...g])}_setServiceInstance(h,I){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,I);else if(this._parent)this._parent._setServiceInstance(h,I);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const I=this._services.get(h);return!I&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):I}_getOrCreateServiceInstance(h,I){const y=this._getServiceInstanceOrDescriptor(h);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,I.branch(h,!0)):(I.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,I,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,I,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,I,y){const d=new C.Graph(l=>l.id.toString());let g=0;const u=[{id:h,desc:I,_trace:y}];for(;u.length;){const l=u.pop();if(d.lookupOrInsertNode(l),g++>1e3)throw new S(d);for(const f of k._util.getServiceDependencies(l.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(f.id);if(r||this._throwIfStrict(`[createInstance] ${h} depends on ${f.id} which is NOT registered.`,!0),r instanceof D.SyncDescriptor){const o={id:f.id,desc:r,_trace:l._trace.branch(f.id,!0)};d.insertEdge(l,o),u.push(o)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,o)}d.removeNode(f)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,I,y=[],d,g){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(I,y,d,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,I,y,d,g);throw new Error(`illegalState - creating UNKNOWN service instance ${I.name}`)}_createServiceInstance(h,I=[],y,d){if(y){const g=new b.IdleValue(()=>this._createInstance(h,I,d));return new Proxy(Object.create(null),{get(u,l){if(l in u)return u[l];const f=g.value;let r=f[l];return typeof r!="function"||(r=r.bind(f),u[l]=r),r},set(u,l,f){return g.value[l]=f,!0}})}else return this._createInstance(h,I,d)}_throwIfStrict(h,I){if(I&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=T;var R;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(R||(R={}));class w{constructor(h,I){this.type=h,this.name=I,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return p?new w(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(h){return p?new w(0,h.name):w._None}branch(h,I){const y=new w(2,h.toString());return this._dep.push([h,I,y]),y}stop(){const h=Date.now()-this._start;w._totals+=h;let I=!1;function y(g,u){const l=[],f=new Array(g+1).join("	");for(const[r,o,n]of u._dep)if(o&&n){I=!0,l.push(`${f}CREATES -> ${r}`);const i=y(g+1,n);i&&l.push(i)}else l.push(`${f}uses -> ${r}`);return l.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(h>2||I)&&console.log(d.join(`
`))}}e.Trace=w,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(pe[204],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,b.createDecorator)("labelService")});var _e=this&&this.__param||function(oe,e){return function(b,t){e(b,t,oe)}};define(pe[74],ve([0,1,20,2,3,173,31,5]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,E.createDecorator)("languagePackService");let p=class extends t.Disposable{constructor(T){super();this.extensionGalleryService=T}async getAvailableLanguages(){const T=new b.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const v=R.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(I=>I.startsWith("lp-"))).map(h=>{const I=h.properties.localizedLanguages?.[0],y=this.getLocale(h);return{...this.createQuickPickItem(y,I,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(T){return T.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(T,R,w){const v=R??T;let h;if(v!==T&&(h=`(${T})`),T.toLowerCase()===D.language.toLowerCase()&&(h??(h=""),h+=(0,C.localize)(0,null)),w?.installCount){h??(h="");const I=w.installCount;let y;I>1e6?y=`${Math.floor(I/1e5)/10}M`:I>1e3?y=`${Math.floor(I/1e3)}K`:y=String(I),h+=` $(cloud-download) ${y}`}return{id:T,label:v,description:h}}};p=Re([_e(0,k.IExtensionGalleryService)],p),e.LanguagePackBaseService=p}),define(pe[13],ve([0,1,38,7,2,3,5]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function E(){return new Date().toISOString()}var p;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function S(o,n,i){switch(n){case p.Trace:o.trace(i);break;case p.Debug:o.debug(i);break;case p.Info:o.info(i);break;case p.Warning:o.warn(i);break;case p.Error:o.error(i);break;case p.Critical:o.critical(i);break;default:throw new Error("Invalid log level")}}e.log=S;function T(o){let n="";for(let i=0;i<o.length;i++){let s=o[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(i>0?" ":"")+s}return n}e.format=T;class R extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class w extends R{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(p.Trace)&&this.log(p.Trace,T([n,...i]))}debug(n,...i){this.checkLogLevel(p.Debug)&&this.log(p.Debug,T([n,...i]))}info(n,...i){this.checkLogLevel(p.Info)&&this.log(p.Info,T([n,...i]))}warn(n,...i){this.checkLogLevel(p.Warning)&&this.log(p.Warning,T([n,...i]))}error(n,...i){if(this.checkLogLevel(p.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(p.Error,T(s))}else this.log(p.Error,T([n,...i]))}critical(n,...i){this.checkLogLevel(p.Critical)&&this.log(p.Critical,T([n,...i]))}flush(){}}e.AbstractMessageLogger=w;class v extends R{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...i):console.log(`[main ${E()}]`,n,...i))}debug(n,...i){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...i):console.log(`[main ${E()}]`,n,...i))}info(n,...i){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...i):console.log(`[main ${E()}]`,n,...i))}warn(n,...i){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,n,...i):console.warn(`[main ${E()}]`,n,...i))}error(n,...i){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,n,...i):console.error(`[main ${E()}]`,n,...i))}critical(n,...i){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,n,...i):console.error(`[main ${E()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends R{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=h;class I extends R{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,b.toErrorMessage)(n,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class y extends R{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const s of this.logServices)s.trace(n,...i)}debug(n,...i){for(const s of this.logServices)s.debug(n,...i)}info(n,...i){for(const s of this.logServices)s.info(n,...i)}warn(n,...i){for(const s of this.logServices)s.warn(n,...i)}error(n,...i){for(const s of this.logServices)s.error(n,...i)}critical(n,...i){for(const s of this.logServices)s.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class d extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=d;class g extends D.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,i?.always?p.Trace:this.logLevel,i),this.loggers.set(n.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class u{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return p.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=u;function l(o){if(o.verbose)return p.Trace;if(typeof o.logLevel=="string"){const n=f(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function f(o){switch(o){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function r(o){switch(o){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=r}),define(pe[205],ve([0,1,71,7,2,13,3]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class zt extends D.Disposable{constructor(S){super();this.logService=S,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(S,T){let R;try{R=await this.withKeytar()}catch{return null}const w=await R.getPassword(S,T);if(w)try{let{content:v,hasNextChunk:h}=JSON.parse(w);if(!v||!h)return w;let I=1;for(;h;){const y=await R.getPassword(S,`${T}-${I}`),d=JSON.parse(y);v+=d.content,h=d.hasNextChunk,I++}return v}catch{return w}return w}async setPassword(S,T,R){let w;try{w=await this.withKeytar()}catch(I){throw this.surfaceKeytarLoadError?.(I),I}const v=3,h=async(I,y,d)=>{let g=0,u;for(;g<v;)try{await w.setPassword(I,y,d);return}catch(l){u=l,this.logService.warn("Error attempting to set a password: ",l?.message??l),g++,await new Promise(f=>setTimeout(f,200))}throw u};if(k.isWindows&&R.length>zt.MAX_PASSWORD_LENGTH){let I=0,y=0,d=!0;for(;d;){const g=R.substring(I,I+zt.PASSWORD_CHUNK_SIZE);I+=zt.PASSWORD_CHUNK_SIZE,d=R.length-I>0;const u={content:g,hasNextChunk:d};await h(S,y?`${T}-${y}`:T,JSON.stringify(u)),y++}}else await h(S,T,R);this._onDidChangePassword.fire({service:S,account:T})}async deletePassword(S,T){let R;try{R=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}const w=await R.getPassword(S,T);if(!w)return!1;const v=await R.deletePassword(S,T);try{let{content:h,hasNextChunk:I}=JSON.parse(w);if(h&&I){let y=1;for(;I;){const d=`${T}-${y}`,g=await R.getPassword(S,d);await R.deletePassword(S,d),I=JSON.parse(g).hasNextChunk,y++}}}catch{}return v&&this._onDidChangePassword.fire({service:S,account:T}),v}async findPassword(S){let T;try{T=await this.withKeytar()}catch{return null}return T.findPassword(S)}async findCredentials(S){let T;try{T=await this.withKeytar()}catch{return[]}return T.findCredentials(S)}clear(){return this._keytarCache instanceof b.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=Re([_e(0,C.ILogService)],E),e.BaseCredentialsMainService=E}),define(pe[206],ve([0,1,18,14,11,7,2,6,60,13]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(w,v){super();this.logService=w,this.options=v,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(w,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,v):this.watchNonRecursive(w,v)}watchUniversal(w,v){const h={path:this.toFilePath(w),excludes:v.excludes,includes:v.includes,recursive:v.recursive},I=(0,b.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{I(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,D.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,p.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const v of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const v of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(v)&&w.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,v){const h={path:this.toFilePath(w),excludes:v.excludes,includes:v.includes,recursive:!1},I=(0,b.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{I(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,D.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,p.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,E.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(pe[101],ve([0,1,18,14,16,20,7,88,45,2,24,10,47,19,46,169,17,99,13]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends S.Disposable{constructor(f){super();this.logService=f,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(f,r){if(this.provider.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${f}`);const o=new S.DisposableStore;return this.provider.set(f,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:f,provider:r}),o.add(r.onDidChangeFile(n=>this._onDidFilesChange.fire(new y.FileChangesEvent(n,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&o.add(r.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:f}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:f,provider:r}),this.provider.delete(f),(0,S.dispose)(o)})}getProvider(f){return this.provider.get(f)}async activateProvider(f){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:f,join(o){r.push(o)}}),!this.provider.has(f)&&await t.Promises.settled(r)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.provider.has(f.scheme)}hasCapability(f,r){const o=this.provider.get(f.scheme);return!!(o&&o.capabilities&r)}listCapabilities(){return p.Iterable.map(this.provider,([f,r])=>({scheme:f,capabilities:r.capabilities}))}async withProvider(f){if(!(0,v.isAbsolutePath)(f))throw new y.FileOperationError((0,I.localize)(0,null,this.resourceForError(f)),8);await this.activateProvider(f.scheme);const r=this.provider.get(f.scheme);if(!r){const o=new Error;throw o.name="ENOPRO",o.message=(0,I.localize)(1,null,f.toString()),o}return r}async withReadProvider(f){const r=await this.withProvider(f);if((0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)||(0,y.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(f){const r=await this.withProvider(f);if((0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,r){try{return await this.doResolveFile(f,r)}catch(o){throw(0,y.toFileSystemProviderErrorCode)(o)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,I.localize)(2,null,this.resourceForError(f)),1):(0,y.ensureFileSystemProviderError)(o)}}async doResolveFile(f,r){const o=await this.withProvider(f),n=this.isPathCaseSensitive(o),i=r?.resolveTo,s=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,c=await o.stat(f);let m;return this.toFileStat(o,f,c,void 0,!!a,(P,_)=>(m||(m=T.TernarySearchTree.forUris(()=>!n),m.set(f,!0),i&&m.fill(!0,i)),m.get(P.resource)||m.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&s?_===1:!1))}async toFileStat(f,r,o,n,i,s){const{providerExtUri:a}=this.getExtUri(f),c={resource:r,name:a.basename(r),isFile:(o.type&y.FileType.File)!=0,isDirectory:(o.type&y.FileType.Directory)!=0,isSymbolicLink:(o.type&y.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&y.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,y.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(c.isDirectory&&s(c,n)){try{const m=await f.readdir(r),P=await t.Promises.settled(m.map(async([_,W])=>{try{const K=a.joinPath(r,_),se=i?await f.stat(K):{type:W};return await this.toFileStat(f,K,se,m.length,i,s)}catch(K){return this.logService.trace(K),null}}));c.children=(0,b.coalesce)(P)}catch(m){this.logService.trace(m),c.children=[]}return c}return c}async resolveAll(f){return t.Promises.settled(f.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(f){const r=await this.withProvider(f),o=await r.stat(f);return this.toFileStat(r,f,o,void 0,!0,()=>!1)}async exists(f){const r=await this.withProvider(f);try{return!!await r.stat(f)}catch{return!1}}async canCreateFile(f,r){try{await this.doValidateCreateFile(f,r)}catch(o){return o}return!0}async doValidateCreateFile(f,r){if(!r?.overwrite&&await this.exists(f))throw new y.FileOperationError((0,I.localize)(3,null,this.resourceForError(f)),3,r)}async createFile(f,r=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(f,o);const n=await this.writeFile(f,r);return this._onDidRunOperation.fire(new y.FileOperationEvent(f,0,n)),n}async writeFile(f,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,f,o)||await this.mkdirp(n,i.dirname(f));let a;if((0,y.hasReadWriteCapability)(n)&&!(r instanceof D.VSBuffer))if((0,h.isReadableStream)(r)){const c=await(0,h.peekStream)(r,3);c.ended?a=D.VSBuffer.concat(c.buffer):a=c}else a=(0,h.peekReadable)(r,c=>D.VSBuffer.concat(c),3);else a=r;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(n,f,o,a):await this.doWriteBuffered(n,f,o,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new y.FileOperationEvent(f,4))}catch(s){throw new y.FileOperationError((0,I.localize)(4,null,this.resourceForError(f),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),o)}return this.resolve(f,{resolveMetadata:!0})}async validateWriteFile(f,r,o){if(!!o?.unlock&&!(f.capabilities&8192))throw new Error((0,I.localize)(5,null,this.resourceForError(r)));let i;try{i=await f.stat(r)}catch{return}if((i.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,I.localize)(6,null,this.resourceForError(r)),0,o);if(this.throwIfFileIsReadonly(r,i),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==y.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&o.mtime<i.mtime&&o.etag!==(0,y.etag)({mtime:o.mtime,size:i.size}))throw new y.FileOperationError((0,I.localize)(7,null),3,o);return i}async readFile(f,r,o){const n=await this.withReadProvider(f);return r?.atomic?this.doReadFileAtomic(n,f,r,o):this.doReadFile(n,f,r,o)}async doReadFileAtomic(f,r,o,n){return new Promise((i,s)=>{this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(f,r,o,n);i(a)}catch(a){s(a)}})})}async doReadFile(f,r,o,n){const i=await this.doReadFileStream(f,r,{...o,preferUnbuffered:!0},n);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(f,r,o){const n=await this.withReadProvider(f);return this.doReadFileStream(n,f,r,o)}async doReadFileStream(f,r,o,n){const i=new C.CancellationTokenSource(n),s=this.validateReadFile(r,o).then(c=>c,c=>{throw i.cancel(),c});let a;try{return typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&await s,o?.atomic&&(0,y.hasFileAtomicReadCapability)(f)||!((0,y.hasOpenReadWriteCloseCapability)(f)||(0,y.hasFileReadStreamCapability)(f))||(0,y.hasReadWriteCapability)(f)&&o?.preferUnbuffered?a=this.readFileUnbuffered(f,r,o):(0,y.hasFileReadStreamCapability)(f)?a=this.readFileStreamed(f,r,i.token,o):a=this.readFileBuffered(f,r,i.token,o),{...await s,value:a}}catch(c){a&&await(0,h.consumeStream)(a);const m=(0,I.localize)(8,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(c).toString());throw c instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(m,c.stat,o):new y.FileOperationError(m,(0,y.toFileOperationResult)(c),o)}}readFileStreamed(f,r,o,n=Object.create(null)){const i=f.readFileStream(r,n,o);return(0,h.transform)(i,{data:s=>s instanceof D.VSBuffer?s:D.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,I.localize)(9,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),n)},s=>D.VSBuffer.concat(s))}readFileBuffered(f,r,o,n=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,d.readFileIntoStream)(f,r,i,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,I.localize)(10,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),n)},o),i}readFileUnbuffered(f,r,o){const n=(0,h.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;o?.atomic&&(0,y.hasFileAtomicReadCapability)(f)?i=await f.readFile(r,{atomic:!0}):i=await f.readFile(r),typeof o?.position=="number"&&(i=i.slice(o.position)),typeof o?.length=="number"&&(i=i.slice(0,o.length)),this.validateReadFileLimits(r,i.byteLength,o),n.end(D.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(f,r){const o=await this.resolve(f,{resolveMetadata:!0});if(o.isDirectory)throw new y.FileOperationError((0,I.localize)(11,null,this.resourceForError(f)),0,r);if(typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&r.etag===o.etag)throw new y.NotModifiedSinceFileOperationError((0,I.localize)(12,null),o,r);return this.validateReadFileLimits(f,o.size,r),o}validateReadFileLimits(f,r,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&r>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&r>o.limits.size&&(n=7),typeof n=="number")throw new y.FileOperationError((0,I.localize)(13,null,this.resourceForError(f)),n)}}async canMove(f,r,o){return this.doCanMoveCopy(f,r,"move",o)}async canCopy(f,r,o){return this.doCanMoveCopy(f,r,"copy",o)}async doCanMoveCopy(f,r,o,n){if(f.toString()!==r.toString())try{const i=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f):await this.withReadProvider(f),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(i,f,s,r,o,n)}catch(i){return i}return!0}async move(f,r,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,f,i,r,"move",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,s==="move"?2:3,a)),a}async copy(f,r,o){const n=await this.withReadProvider(f),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,f,i,r,"copy",!!o),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,s==="copy"?3:2,a)),a}async doMoveCopy(f,r,o,n,i,s){if(r.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(f,r,o,n,i,s);if(a&&!c&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),i==="copy"){if(f===o&&(0,y.hasFileFolderCopyCapability)(f))await f.copy(r,n,{overwrite:s});else{const m=await this.resolve(r);m.isDirectory?await this.doCopyFolder(f,m,o,n):await this.doCopyFile(f,r,o,n)}return i}else return f===o?(await f.rename(r,n,{overwrite:s}),i):(await this.doMoveCopy(f,r,o,n,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(f,r,o,n){if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(f,r,o,n);if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(f,r,o,n);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(f,r,o,n);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasReadWriteCapability)(o))return this.doPipeUnbuffered(f,r,o,n)}async doCopyFolder(f,r,o,n){await o.mkdir(n),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async i=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(f,await this.resolve(i.resource),o,s):this.doCopyFile(f,i.resource,o,s)}))}async doValidateMoveCopy(f,r,o,n,i,s){let a=!1;if(f===o){const{providerExtUri:m,isPathCaseSensitive:P}=this.getExtUri(f);if(P||(a=m.isEqual(r,n)),a&&i==="copy")throw new Error((0,I.localize)(14,null,this.resourceForError(r),this.resourceForError(n)));if(!a&&m.isEqualOrParent(n,r))throw new Error((0,I.localize)(15,null,this.resourceForError(r),this.resourceForError(n)))}const c=await this.exists(n);if(c&&!a){if(!s)throw new y.FileOperationError((0,I.localize)(16,null,this.resourceForError(r),this.resourceForError(n)),4);if(f===o){const{providerExtUri:m}=this.getExtUri(f);if(m.isEqualOrParent(r,n))throw new Error((0,I.localize)(17,null,this.resourceForError(r),this.resourceForError(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(f){const r=this.isPathCaseSensitive(f);return{providerExtUri:r?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(f){return!!(f.capabilities&1024)}async createFolder(f){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);await this.mkdirp(r,f);const o=await this.resolve(f,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,0,o)),o}async mkdirp(f,r){const o=[],{providerExtUri:n}=this.getExtUri(f);for(;!n.isEqual(r,n.dirname(r));)try{if(((await f.stat(r)).type&y.FileType.Directory)==0)throw new Error((0,I.localize)(18,null,this.resourceForError(r)));break}catch(i){if((0,y.toFileSystemProviderErrorCode)(i)!==y.FileSystemProviderErrorCode.FileNotFound)throw i;o.push(n.basename(r)),r=n.dirname(r)}for(let i=o.length-1;i>=0;i--){r=n.joinPath(r,o[i]);try{await f.mkdir(r)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(f,r){try{await this.doValidateDelete(f,r)}catch(o){return o}return!0}async doValidateDelete(f,r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);if(!!r?.useTrash&&!(o.capabilities&4096))throw new Error((0,I.localize)(19,null,this.resourceForError(f)));let i;try{i=await o.stat(f)}catch{}if(i)this.throwIfFileIsReadonly(f,i);else throw new y.FileOperationError((0,I.localize)(20,null,this.resourceForError(f)),1);if(!!!r?.recursive){const a=await this.resolve(f);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,I.localize)(21,null,this.resourceForError(f)))}return o}async del(f,r){const o=await this.doValidateDelete(f,r),n=!!r?.useTrash,i=!!r?.recursive;await o.delete(f,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new y.FileOperationEvent(f,1))}async cloneFile(f,r){const o=await this.withProvider(f),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(f,r))return;if(o===n&&(0,y.hasFileCloneCapability)(o))return o.cloneFile(f,r);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r));const i=this.writeQueue.queueFor(f,this.getExtUri(o).providerExtUri);return o===n&&(0,y.hasFileFolderCopyCapability)(o)?i.queue(()=>o.copy(f,r,{overwrite:!0})):i.queue(()=>this.doCopyFile(o,f,n,r))}watch(f,r={recursive:!1,excludes:[]}){const o=new S.DisposableStore;let n=!1,i=()=>{n=!0};return o.add((0,S.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(f,r);n?(0,S.dispose)(s):i=()=>(0,S.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(f,r){const o=await this.withProvider(f),n=(0,E.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(f),r]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:o.watch(f,r)},this.activeWatchers.set(n,i)),i.count+=1,(0,S.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,S.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,f]of this.activeWatchers)(0,S.dispose)(f.disposable);this.activeWatchers.clear()}async doWriteBuffered(f,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(async()=>{const i=await f.open(r,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(f,i,n):await this.doWriteReadableBufferedQueued(f,i,n)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await f.close(i)}})}async doWriteStreamBufferedQueued(f,r,o){let n=0,i;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(f,r,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;i=o.stream}else i=o;return new Promise((s,a)=>{(0,h.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(f,r,c,c.byteLength,n,0)}catch(m){return a(m)}n+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>a(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(f,r,o){let n=0,i;for(;(i=o.read())!==null;)await this.doWriteBuffer(f,r,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(f,r,o,n,i,s){let a=0;for(;a<n;)a+=await f.write(r,i+a,o.buffer,s+a,n-a)}async doWriteUnbuffered(f,r,o,n){return this.writeQueue.queueFor(r,this.getExtUri(f).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(f,r,o,n))}async doWriteUnbufferedQueued(f,r,o,n){let i;n instanceof D.VSBuffer?i=n:(0,h.isReadableStream)(n)?i=await(0,D.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?i=await(0,D.bufferedStreamToBuffer)(n):i=(0,D.readableToBuffer)(n),await f.writeFile(r,i.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(f,r,o,n))}async doPipeBufferedQueued(f,r,o,n){let i,s;try{i=await f.open(r,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,m=0,P=0;do P=await f.read(i,c,a.buffer,m,a.byteLength-m),await this.doWriteBuffer(o,s,a,P,c,m),c+=P,m+=P,m===a.byteLength&&(m=0);while(P>0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof i=="number"?f.close(i):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(f,r,o,n))}async doPipeUnbufferedQueued(f,r,o,n){return o.writeFile(n,await f.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(f,r,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(f,r,o,n))}async doPipeUnbufferedToBufferedQueued(f,r,o,n){const i=await o.open(n,{create:!0,unlock:!1});try{const s=await f.readFile(r);await this.doWriteBuffer(o,i,D.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await o.close(i)}}async doPipeBufferedToUnbuffered(f,r,o,n){const i=await(0,D.streamToBuffer)(this.readFileBuffered(f,r,C.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,i)}throwIfFileSystemIsReadonly(f,r){if(f.capabilities&2048)throw new y.FileOperationError((0,I.localize)(22,null,this.resourceForError(r)),6);return f}throwIfFileIsReadonly(f,r){if((r.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,I.localize)(23,null,this.resourceForError(f)),6)}resourceForError(f){return f.scheme===R.Schemas.file?f.fsPath:f.toString(!0)}};u=Re([_e(0,g.ILogService)],u),e.FileService=u}),define(pe[61],ve([0,1,29,267,14,24,16,7,35,2,6,3,19,46,21,172,17,99,206,38,203,202]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(b)}catch(o){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(o)}`)}})();class r extends g.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i);this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new C.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,w.joinPath)(n,a.name))).type:c=this.toType(a),s.push([a.name,c])}catch(c){this.logService.trace(c)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let s;return i?.dangling?s=y.FileType.Unknown:n.isFile()?s=y.FileType.File:n.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,i&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(n){const i=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new D.Barrier;return this.resourceLocks.set(n,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,S.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const a=this.toFilePath(n);return await h.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(n,i,s){const a=(0,v.newWriteableStream)(c=>k.VSBuffer.concat(c.map(m=>k.VSBuffer.wrap(m))).buffer);return(0,d.readFileIntoStream)(this,n,a,c=>c.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(n,i,s){let a;try{const c=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(c)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,I.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,I.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(n,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){r.canFlush=n}async open(n,i){const s=this.toFilePath(n);let a;(0,y.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let c;try{if((0,y.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await h.SymlinkSupport.stat(s);P.mode&128||await h.Promises.chmod(s,P.mode|128)}catch(P){this.logService.trace(P)}let m;if((0,y.isFileOpenForWriteOptions)(i)){if(R.isWindows)try{await h.Promises.truncate(s,0),m="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}m||(m="w")}else m="r";c=await h.Promises.open(s,m)}catch(m){throw a?.dispose(),(0,y.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,m):this.toFileSystemProviderError(m)}if(this.mapHandleToPos.set(c,0),(0,y.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,n),a){const m=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.mapHandleToLock.set(c,a),m&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),m.dispose())}return c}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&r.canFlush)try{await h.Promises.fdatasync(n)}catch(s){r.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,s,a,c){const m=this.normalizePos(n,i);let P=null;try{P=(await h.Promises.read(n,s,a,c,m)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(n,m,P)}return P}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,s){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,a+s):this.mapHandleToPos.delete(n)))}async write(n,i,s,a,c){return(0,D.retry)(()=>this.doWrite(n,i,s,a,c),100,3)}async doWrite(n,i,s,a,c){const m=this.normalizePos(n,i);let P=null;try{P=(await h.Promises.write(n,s,a,c,m)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),_)}finally{this.updatePos(n,m,P)}return P}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const s=this.toFilePath(n);i.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,i,s){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(n,i,"move",s.overwrite),await h.Promises.move(a,c)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,I.localize)(2,null,(0,T.basename)(a),(0,T.basename)((0,T.dirname)(c)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(n,i,s){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(n,i,"copy",s.overwrite),await h.Promises.copy(a,c,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,I.localize)(3,null,(0,T.basename)(a),(0,T.basename)((0,T.dirname)(c)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(n,i,s,a){const c=this.toFilePath(n),m=this.toFilePath(i);let P=!1;if(!!(this.capabilities&1024)||(P=(0,p.isEqual)(c,m,!0)),P&&s==="copy")throw(0,y.createFileSystemProviderError)((0,I.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!P&&await h.Promises.exists(m)){if(!a)throw(0,y.createFileSystemProviderError)((0,I.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,s){const a=this.toFilePath(n),c=this.toFilePath(i),m=!!(this.capabilities&1024);if((0,p.isEqual)(a,c,!m))return;const P=new S.DisposableStore;try{const[_,W]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);P.add(_),P.add(W),s&&await h.Promises.mkdir((0,T.dirname)(c),{recursive:!0}),await h.Promises.copyFile(a,c)}catch(_){if(_.code==="ENOENT"&&!s)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(_)}finally{P.dispose()}}createUniversalWatcher(n,i,s){return new l.UniversalWatcherClient(a=>n(a),a=>i(a),s)}createNonRecursiveWatcher(n,i,s){return new f.NodeJSWatcherClient(a=>n(a),a=>i(a),s)}toFileSystemProviderError(n){if(n instanceof y.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=y.FileSystemProviderErrorCode.NoPermissions;break;default:i=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let s=this.toFileSystemProviderError(i);if(n&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(s=(0,y.createFileSystemProviderError)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=r,r.canFlush=!0}),define(pe[207],ve([0,1,7,61,2,16,46,20]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends D.Disposable{constructor(R,w){super();this.provider=R,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,w,v){const h=this.getUriTransformer(R);switch(w){case"stat":return this.stat(h,v[0]);case"readdir":return this.readdir(h,v[0]);case"open":return this.open(h,v[0],v[1]);case"close":return this.close(v[0]);case"read":return this.read(v[0],v[1],v[2]);case"readFile":return this.readFile(h,v[0],v[1]);case"write":return this.write(v[0],v[1],v[2],v[3],v[4]);case"writeFile":return this.writeFile(h,v[0],v[1],v[2]);case"rename":return this.rename(h,v[0],v[1],v[2]);case"copy":return this.copy(h,v[0],v[1],v[2]);case"cloneFile":return this.cloneFile(h,v[0],v[1]);case"mkdir":return this.mkdir(h,v[0]);case"delete":return this.delete(h,v[0],v[1]);case"watch":return this.watch(h,v[0],v[1],v[2],v[3]);case"unwatch":return this.unwatch(v[0],v[1])}throw new Error(`IPC Command ${w} not found`)}listen(R,w,v){const h=this.getUriTransformer(R);switch(w){case"fileChange":return this.onFileChange(h,v[0]);case"readFileStream":return this.onReadFileStream(h,v[0],v[1])}throw new Error(`Unknown event ${w}`)}stat(R,w){const v=this.transformIncoming(R,w,!0);return this.provider.stat(v)}readdir(R,w){const v=this.transformIncoming(R,w);return this.provider.readdir(v)}async readFile(R,w,v){const h=this.transformIncoming(R,w,!0),I=await this.provider.readFile(h,v);return C.VSBuffer.wrap(I)}onReadFileStream(R,w,v){const h=this.transformIncoming(R,w,!0),I=new E.CancellationTokenSource,y=new b.Emitter({onLastListenerRemove:()=>{I.cancel()}}),d=this.provider.readFileStream(h,v,I.token);return(0,k.listenStream)(d,{onData:g=>y.fire(C.VSBuffer.wrap(g)),onError:g=>y.fire(g),onEnd:()=>{y.fire("end"),y.dispose(),I.dispose()}}),y.event}writeFile(R,w,v,h){const I=this.transformIncoming(R,w);return this.provider.writeFile(I,v.buffer,h)}open(R,w,v){const h=this.transformIncoming(R,w,!0);return this.provider.open(h,v)}close(R){return this.provider.close(R)}async read(R,w,v){const h=C.VSBuffer.alloc(v),I=0,y=await this.provider.read(R,w,h.buffer,I,v);return[h,y]}write(R,w,v,h,I){return this.provider.write(R,w,v.buffer,h,I)}mkdir(R,w){const v=this.transformIncoming(R,w);return this.provider.mkdir(v)}delete(R,w,v){const h=this.transformIncoming(R,w);return this.provider.delete(h,v)}rename(R,w,v,h){const I=this.transformIncoming(R,w),y=this.transformIncoming(R,v);return this.provider.rename(I,y,h)}copy(R,w,v,h){const I=this.transformIncoming(R,w),y=this.transformIncoming(R,v);return this.provider.copy(I,y,h)}cloneFile(R,w,v){const h=this.transformIncoming(R,w),I=this.transformIncoming(R,v);return this.provider.cloneFile(h,I)}onFileChange(R,w){const v=new b.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(R,v))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return v.event}async watch(R,w,v,h,I){const y=this.sessionToWatcher.get(w);if(y){const d=this.transformIncoming(R,h),g=y.watch(v,d,I);this.watchRequests.set(w+v,g)}}async unwatch(R,w){const v=R+w,h=this.watchRequests.get(v);h&&((0,D.dispose)(h),this.watchRequests.delete(v))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class S extends D.Disposable{constructor(R,w,v,h){super();this.uriTransformer=R,this.logService=v,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(R){const w=this._register(new b.Emitter);this._register(w.event(v=>{R.fire(v.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(v=>w.fire(v))),this._register(this.fileWatcher.onDidWatchError(v=>R.fire(v)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,w,v){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(v.excludes=[...v.excludes,...h]),this.watcherRequests.set(R,this.fileWatcher.watch(w,v)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=S}),define(pe[102],ve([0,1,7,4,13]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(w){this.service=w,this.onDidChangeLogLevel=b.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(w,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=C;class k{constructor(w){this.channel=w}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(w){k.setLevel(this.channel,w)}static setLevel(w,v){return w.call("setLevel",v)}}e.LogLevelChannelClient=k;class E{constructor(w){this.loggerService=w,this.loggers=new Map}listen(w,v){throw new Error(`Event not found: ${v}`)}async call(w,v,h){switch(v){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(w,v){this.loggers.set(w.toString(),this.loggerService.createLogger(w,v))}consoleLog(w,v){let h=console.log;switch(w){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(w,v){const h=this.loggers.get(w.toString());if(!h)throw new Error("Create the logger before logging");for(const[I,y]of v)(0,D.log)(h,I,y)}}e.LoggerChannel=E;class p extends D.AbstractLoggerService{constructor(w,v,h){super(w,v);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,v)=>{this.channel.call("consoleLog",[w,v])}})}doCreateLogger(w,v,h){return new S(this.channel,w,v,h)}}e.LoggerChannelClient=p;class S extends D.AbstractMessageLogger{constructor(w,v,h,I){super(I?.always);this.channel=w,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,I]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,v){const h=[[w,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(w){this.channel.call("log",[this.file,w])}}class T extends D.LogService{constructor(w,v){super(v);this.parent=w,this._register(w.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(w){super.setLevel(w),this.parent.setLevel(w)}}e.FollowerLogService=T}),define(pe[103],ve([0,1,17,13]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(E,p,S,T,R){try{const w=await new Promise((h,I)=>{oe(["spdlog"],h,I)});w.setFlushOn(t.LogLevel.Trace);const v=await w.createAsyncRotatingLogger(E,p,S,T);return R&&v.clearFormatters(),v}catch(w){console.error(w)}return null}function C(E,p,S){switch(p){case t.LogLevel.Trace:E.trace(S);break;case t.LogLevel.Debug:E.debug(S);break;case t.LogLevel.Info:E.info(S);break;case t.LogLevel.Warning:E.warn(S);break;case t.LogLevel.Error:E.error(S);break;case t.LogLevel.Critical:E.critical(S);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(p,S,T,R,w){super();this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(p,S,T,R),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(p,S,T,R){const w=T?6:1,v=30/w*b.ByteSize.MB,h=await D(p,S,v,w,R);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:I,message:y}of this.buffer)C(this._logger,I,y);this.buffer=[]}}log(p,S){this._logger?C(this._logger,p,S):this.getLevel()<=p&&this.buffer.push({level:p,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(pe[208],ve([0,1,67,174,5]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var k;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(p){function S(h,I){return I-h}p.compare=S;const T=Object.create(null);T[p.Error]=(0,t.localize)(0,null),T[p.Warning]=(0,t.localize)(1,null),T[p.Info]=(0,t.localize)(2,null);function R(h){return T[h]||""}p.toString=R;function w(h){switch(h){case b.default.Error:return p.Error;case b.default.Warning:return p.Warning;case b.default.Info:return p.Info;case b.default.Ignore:return p.Hint}}p.fromSeverity=w;function v(h){switch(h){case p.Error:return b.default.Error;case p.Warning:return b.default.Warning;case p.Info:return b.default.Info;case p.Hint:return b.default.Ignore}}p.toSeverity=v}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(p){const S="";function T(w){return R(w,!0)}p.makeKey=T;function R(w,v){const h=[S];return w.source?h.push(w.source.replace("\xA6","\\\xA6")):h.push(S),w.code?typeof w.code=="string"?h.push(w.code.replace("\xA6","\\\xA6")):h.push(w.code.value.replace("\xA6","\\\xA6")):h.push(S),w.severity!==void 0&&w.severity!==null?h.push(k.toString(w.severity)):h.push(S),w.message&&v?h.push(w.message.replace("\xA6","\\\xA6")):h.push(S),w.startLineNumber!==void 0&&w.startLineNumber!==null?h.push(w.startLineNumber.toString()):h.push(S),w.startColumn!==void 0&&w.startColumn!==null?h.push(w.startColumn.toString()):h.push(S),w.endLineNumber!==void 0&&w.endLineNumber!==null?h.push(w.endLineNumber.toString()):h.push(S),w.endColumn!==void 0&&w.endColumn!==null?h.push(w.endColumn.toString()):h.push(S),h.push(S),h.join("\xA6")}p.makeKeyOptionalMessage=R})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(pe[62],ve([0,1,7,45,2,5]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class k extends D.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(S){const T=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},T!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(S),t.Iterable.reduce(this.policies.entries(),(R,[w,v])=>({...R,[w]:v}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[T,R])=>({...S,[T]:{definition:R,value:this.policies.get(T)}}),{})}}e.AbstractPolicyService=k;class E{constructor(){this.onDidChange=b.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(pe[51],ve([0,1,10,3,28,19]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const E=t.globals.vscode.context.configuration();if(E)k=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof oe?.__$__nodeRequire=="function"){const E=(0,C.dirname)(b.FileAccess.asFileUri("",oe));k=oe.__$__nodeRequire((0,C.joinPath)(E,"product.json").fsPath);const p=oe.__$__nodeRequire((0,C.joinPath)(E,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:p.version})}else k={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"vscjava.vscode-gradle":{name:"Gradle for Java",pattern:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsNew","inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookEditorEdit","notebookLiveShare","notebookWorkspaceEdit","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging","notebookWorkspaceEdit"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribViewsRemote"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentsResolvedState","badges","contribViewSize"],"GitHub.copilot":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookWorkspaceEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow"],"ms-toolsai.vscode-jupyter-powertoys":["notebookWorkspaceEdit"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["resolvers","tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com","https://github.com/login/oauth/authorize","https://vscode.dev/+ms-vscode.remote-server/*","https://insiders.vscode.dev/+ms-vscode.remote-server/*"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.71.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.16",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.71.0",commit:"784b0177c56c607789f9638da7b6bf3230d47a8c",date:"2022-09-01T07:08:23.688Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(pe[27],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,b.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(pe[209],ve([0,1,71,13,26,27,205]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let E=class extends k.BaseCredentialsMainService{constructor(S,T,R){super(S);this.environmentMainService=T,this.productService=R}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new b.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((S,T)=>{oe(["keytar"],S,T)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(S){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${S.message??S}`),this._keytarCache=new b.InMemoryCredentialsProvider}return this._keytarCache}};E=Re([_e(0,t.ILogService),_e(1,D.INativeEnvironmentService),_e(2,C.IProductService)],E),e.CredentialsWebMainService=E}),define(pe[33],ve([0,1,82,12]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,E){b.ok(t.isString(k)),b.ok(t.isObject(E)),b.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,E)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(pe[210],ve([0,1,7,33]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class C{constructor(){this._onDidChangeSchema=new b.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,S){this.schemasById[D(p)]=S,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;t.Registry.add(e.Extensions.JSONContribution,k)}),define(pe[52],ve([0,1,18,7,12,158,25,210,33]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=p.Registry.as(E.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const n=this.doRegisterConfigurations(r,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const o=this.doDeregisterConfigurations(r);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(r,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,b.distinct)(n)})}registerDefaultConfigurations(r){const o=[],n=[];for(const{overrides:i,source:s}of r)for(const a in i)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),m=c?.valuesSources??new Map;if(s)for(const K of Object.keys(i[a]))m.set(K,s);const P={...c?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:P,valuesSources:m});const _=(0,k.getLanguageTagSettingPlainKey)(a),W={type:"object",default:P,description:C.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:D.isString(s)?void 0:s,defaultValueSource:s};n.push(...I(a)),this.configurationProperties[a]=W,this.defaultLanguageConfigurationOverridesNode.properties[a]=W}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:s});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const o=[];for(const{overrides:n,source:i}of r)for(const s in n){const a=this.configurationDefaultsOverrides.get(s),c=D.isString(i)?i:i?.id,m=D.isString(a?.source)?a?.source:a?.source?.id;if(c===m)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const P=this.configurationProperties[s];P&&(this.updatePropertyDefaultValue(s,P),this.updateSchema(s,P))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o){const n=[];return r.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(r){const o=[],n=i=>{if(i.properties)for(const s in i.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>n(s))};for(const i of r){n(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(r,o=!0,n,i,s=3){s=D.isUndefinedOrNull(r.scope)?s:r.scope;const a=[],c=r.properties;if(c)for(const P in c){const _=c[P];if(o&&u(P,_)){delete c[P];continue}if(_.source=n,_.defaultDefaultValue=c[P].default,this.updatePropertyDefaultValue(P,_),e.OVERRIDE_PROPERTY_REGEX.test(P)?_.scope=void 0:(_.scope=D.isUndefinedOrNull(_.scope)?s:_.scope,_.restricted=D.isUndefinedOrNull(_.restricted)?!!i?.includes(P):_.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.excludedConfigurationProperties[P]=c[P],delete c[P];continue}else this.configurationProperties[P]=c[P],c[P].policy?.name&&this.policyConfigurations.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),a.push(P)}const m=r.allOf;if(m)for(const P of m)a.push(...this.validateAndRegisterProperties(P,o,n,i,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,n={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const n=this.configurationDefaultsOverrides.get(r);let i=n?.value,s=n?.source;D.isUndefined(i)&&(i=o.defaultDefaultValue,s=void 0),D.isUndefined(i)&&(i=d(o.type)),o.default=i,o.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function I(f){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let o=h.exec(f);for(;o?.length;){const n=o[1].trim();n&&r.push(n),o=h.exec(f)}}return(0,b.distinct)(r)}e.overrideIdentifiersFromKey=I;function y(f){return f.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=y;function d(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new w;p.Registry.add(e.Extensions.Configuration,g);function u(f,r){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?C.localize(7,null,f):g.getConfigurationProperties()[f]!==void 0?C.localize(8,null,f):r.policy?.name&&g.getPolicyConfigurations().get(r.policy?.name)!==void 0?C.localize(9,null,f,r.policy?.name,g.getPolicyConfigurations().get(r.policy?.name)):null:C.localize(6,null)}e.validateProperty=u;function l(){const f=[],r=g.getConfigurationProperties();for(const o of Object.keys(r))f.push([o,r[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=l}),define(pe[104],ve([0,1,18,7,65,2,24,22,12,4,25,52,33]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(o={},n=[],i=[]){this._contents=o,this._keys=n,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,T.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,n){const i=this.getContentsForOverrideIdentifer(n);return i?o?(0,T.getConfigurationValue)(i,o):i:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const i of this.overrides)i.identifiers.includes(o)&&n.push(...i.keys);return b.distinct(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return b.distinct(o)}override(o){let n=this.overrideConfigurations.get(o);return n||(n=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,n)),n}merge(...o){const n=E.deepClone(this.contents),i=E.deepClone(this.overrides),s=[...this.keys];for(const a of o)if(!a.isEmpty()){this.mergeContents(n,a.contents);for(const c of a.overrides){const[m]=i.filter(P=>b.equals(P.identifiers,c.identifiers));m?(this.mergeContents(m.contents,c.contents),m.keys.push(...c.keys),m.keys=b.distinct(m.keys)):i.push(E.deepClone(c))}for(const c of a.keys)s.indexOf(c)===-1&&s.push(c)}return new v(n,s,i)}freeze(){return this.frozen=!0,this}clone(){return new v(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(o){const n=this.getContentsForOverrideIdentifer(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const s of b.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s];const c=n[s];c&&(typeof a=="object"&&typeof c=="object"?(a=E.deepClone(a),this.mergeContents(a,c)):a=c),i[s]=a}return new v(i,this.keys,this.overrides)}mergeContents(o,n){for(const i of Object.keys(n)){if(i in o&&p.isObject(o[i])&&p.isObject(n[i])){this.mergeContents(o[i],n[i]);continue}o[i]=E.deepClone(n[i])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?E.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let n=null,i=null;const s=a=>{a&&(i?this.mergeContents(i,a):i=E.deepClone(a))};for(const a of this.overrides)b.equals(a.identifiers,[o])?n=a.contents:a.identifiers.includes(o)&&s(a.contents);return s(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,n){this.addKey(o),(0,T.addToValueTree)(this.contents,o,n,i=>{throw new Error(i)})}removeValue(o){this.removeKey(o)&&(0,T.removeFromValueTree)(this.contents,o)}addKey(o){let n=this.keys.length;for(let i=0;i<n;i++)o.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,o)}removeKey(o){const n=this.keys.indexOf(o);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,n){if(!p.isUndefinedOrNull(o)){const i=this.doParseContent(o);this.parseRaw(i,n)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,n){this._raw=o;const{contents:i,keys:s,overrides:a,restricted:c}=this.doParseRaw(o,n);this._configurationModel=new v(i,s,a),this._restrictedConfigurations=c||[]}doParseContent(o){let n={},i=null,s=[];const a=[],c=[];function m(_){Array.isArray(s)?s.push(_):i!==null&&(s[i]=_)}const P={onObjectBegin:()=>{const _={};m(_),a.push(s),s=_,i=null},onObjectProperty:_=>{i=_},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const _=[];m(_),a.push(s),s=_,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:m,onError:(_,W,K)=>{c.push({error:_,offset:W,length:K})}};if(o)try{D.visit(o,P),n=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return n}doParseRaw(o,n){const i=w.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),s=this.filter(o,i,!0,n);o=s.raw;const a=(0,T.toValuesTree)(o,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(o),m=this.toOverrides(o,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:c,overrides:m,restricted:s.restricted}}filter(o,n,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:o,restricted:[]};const a={},c=[];for(const m in o)if(R.OVERRIDE_PROPERTY_REGEX.test(m)&&i){const P=this.filter(o[m],n,!1,s);a[m]=P.raw,c.push(...P.restricted)}else{const P=n[m],_=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&c.push(m),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&P?.restricted||(a[m]=o[m]))}return{raw:a,restricted:c}}toOverrides(o,n){const i=[];for(const s of Object.keys(o))if(R.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const c in o[s])a[c]=o[s][c];i.push({identifiers:(0,R.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,T.toValuesTree)(a,n)})}return i}}e.ConfigurationModelParser=h;class I extends C.Disposable{constructor(o,n,i,s){super();this.userSettingsResource=o,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class y{constructor(o,n,i,s,a=new v,c=new v,m=new k.ResourceMap,P=new v,_=new k.ResourceMap,W=!0){this._defaultConfiguration=o,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=a,this._workspaceConfiguration=c,this._folderConfigurations=m,this._memoryConfiguration=P,this._memoryConfigurationByResource=_,this._freeze=W,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(o,n,i){return this.getConsolidatedConfigurationModel(o,n,i).getValue(o)}updateValue(o,n,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new v,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(o):s.setValue(o,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,n,i){const s=this.getConsolidatedConfigurationModel(o,n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(o),_=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(o),W=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),K=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),se=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),F=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,Q=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(o):a.freeze().getValue(o):void 0,re=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(o):c.getValue(o),G=s.getValue(o),de=b.distinct(s.overrides.map(J=>J.identifiers).flat()).filter(J=>s.getOverrideValue(o,J)!==void 0);return{defaultValue:m,policyValue:P,applicationValue:_,userValue:W,userLocalValue:K,userRemoteValue:se,workspaceValue:F,workspaceFolderValue:Q,memoryValue:re,value:G,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:_!==void 0?{value:_,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,user:W!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userLocal:K!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userRemote:se!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:a?.freeze().getValue(o),override:n.overrideIdentifier?a?.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:c.getValue(o),override:n.overrideIdentifier?c.getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:de.length?de:void 0}}keys(o){const n=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,n){this._folderConfigurations.set(o,n),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const i=[];if(!n){const{added:s,updated:a,removed:c}=l(this._defaultConfiguration,o);n=[...s,...a,...c]}for(const s of n)for(const a of(0,R.overrideIdentifiersFromKey)(s)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=o.getKeysForOverrideIdentifier(a),P=[...m.filter(_=>c.indexOf(_)===-1),...c.filter(_=>m.indexOf(_)===-1),...c.filter(_=>!E.equals(this._defaultConfiguration.override(a).getValue(_),o.override(a).getValue(_)))];i.push([a,P])}return this.updateDefaultConfiguration(o),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(o){const{added:n,updated:i,removed:s}=l(this._policyConfiguration,o),a=[...n,...i,...s];return a.length&&this.updatePolicyConfiguration(o),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.applicationConfiguration,o),c=[...n,...i,...s];return c.length&&this.updateApplicationConfiguration(o),{keys:c,overrides:a}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.localUserConfiguration,o),c=[...n,...i,...s];return c.length&&this.updateLocalUserConfiguration(o),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.remoteUserConfiguration,o),c=[...n,...i,...s];return c.length&&this.updateRemoteUserConfiguration(o),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:i,removed:s,overrides:a}=l(this.workspaceConfiguration,o),c=[...n,...i,...s];return c.length&&this.updateWorkspaceConfiguration(o),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(o,n){const i=this.folderConfigurations.get(o),{added:s,updated:a,removed:c,overrides:m}=l(i,n),P=[...s,...a,...c];return(P.length||!i)&&this.updateFolderConfiguration(o,n),{keys:P,overrides:m}}compareAndDeleteFolderConfiguration(o){const n=this.folderConfigurations.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:i,updated:s,removed:a,overrides:c}=l(n,void 0);return{keys:[...i,...s,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,n,i){let s=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(s=s.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:o},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&o){const s=n.getFolder(o);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const a=this._memoryConfigurationByResource.get(o);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let n=this._foldersConsolidatedConfigurations.get(o);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(o);s?(n=i.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(o,n)):n=i}return n}getFolderConfigurationModelForResource(o,n){if(n&&o){const i=n.getFolder(o);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,n)=>{const{contents:i,overrides:s,keys:a}=this._folderConfigurations.get(n);return o.push([n,{contents:i,overrides:s,keys:a}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>o.add(n)),this.userConfiguration.freeze().keys.forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>o.add(i))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(o).forEach(s=>n.add(s))),[...n.values()]}static parse(o){const n=this.parseConfigurationModel(o.defaults),i=this.parseConfigurationModel(o.policy),s=this.parseConfigurationModel(o.application),a=this.parseConfigurationModel(o.user),c=this.parseConfigurationModel(o.workspace),m=o.folders.reduce((P,_)=>(P.set(S.URI.revive(_[0]),this.parseConfigurationModel(_[1])),P),new k.ResourceMap);return new y(n,i,s,a,new v,c,m,new v,new k.ResourceMap,!1)}static parseConfigurationModel(o){return new v(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=y;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const o=new Set,n=new Map;for(const s of r)s.keys.forEach(a=>o.add(a)),s.overrides.forEach(([a,c])=>{const m=(0,k.getOrSet)(n,a,new Set);c.forEach(P=>m.add(P))});const i=[];return n.forEach((s,a)=>i.push([a,[...s.values()]])),{keys:[...o.values()],overrides:i}}e.mergeChanges=d;class g{constructor(o,n,i,s){this.change=o,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;o.keys.forEach(m=>a.add(m)),o.overrides.forEach(([,m])=>m.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const c=new v;this.affectedKeys.forEach(m=>c.setValue(m,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(o,n,this.currentWorkspace);return!E.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(o,n){let i=(0,T.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(o=o[s],!o)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=g;class u extends g{constructor(o,n,i,s){super({keys:o.allKeys(),overrides:[]},void 0,o,n);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=u;function l(r,o){const{added:n,removed:i,updated:s}=f(o,r),a=[],c=r?.getAllOverrideIdentifiers()||[],m=o?.getAllOverrideIdentifiers()||[];if(o){const P=m.filter(_=>!c.includes(_));for(const _ of P)a.push([_,o.getKeysForOverrideIdentifier(_)])}if(r){const P=c.filter(_=>!m.includes(_));for(const _ of P)a.push([_,r.getKeysForOverrideIdentifier(_)])}if(o&&r){for(const P of c)if(m.includes(P)){const _=f({contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)},{contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)});a.push([P,[..._.added,..._.removed,..._.updated]])}}return{added:n,removed:i,updated:s,overrides:a}}function f(r,o){const n=r?o?r.keys.filter(a=>o.keys.indexOf(a)===-1):[...r.keys]:[],i=o?r?o.keys.filter(a=>r.keys.indexOf(a)===-1):[...o.keys]:[],s=[];if(r&&o){for(const a of o.keys)if(r.keys.indexOf(a)!==-1){const c=(0,T.getConfigurationValue)(o.contents,a),m=(0,T.getConfigurationValue)(r.contents,a);E.equals(c,m)||s.push(a)}}return{added:n,removed:i,updated:s}}}),define(pe[211],ve([0,1,18,7,2,22,12,25,104,52,13,62,33]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(w.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:u})=>this.onDidUpdateConfiguration(g,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends p.ConfigurationModel{constructor(g={}){const u=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(u),f=Object.create(null),r=[];for(const o in u){const n=g[o],i=n!==void 0?n:u[o].default;(0,E.addToValueTree)(f,o,i,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(f))S.OVERRIDE_PROPERTY_REGEX.test(o)&&r.push({identifiers:(0,S.overrideIdentifiersFromKey)(o),keys:Object.keys(f[o]),contents:(0,E.toValuesTree)(f[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(f,l,r)}}e.DefaultConfigurationModel=h;class I{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=I;let y=class extends D.Disposable{constructor(g,u,l){super();this.defaultConfiguration=g,this.policyService=u,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const u={},l=[],f=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const r of g){const o=f[r];if(!o){l.push(r);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}l.push(r),u[o.policy.name]={type:o.type}}}return(0,k.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),l}onDidChangePolicies(g){const u=w.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),l=(0,b.coalesce)(g.map(f=>u.get(f)));this.update(l,!0)}update(g,u){const l=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=[],r=this._configurationModel.isEmpty();for(const o of g){const n=l[o]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(r?i!==void 0:!(0,C.equals)(this._configurationModel.getValue(o),i))&&f.push([o,i])}else this._configurationModel.getValue(o)!==void 0&&f.push([o,void 0])}if(f.length){const o=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,i]of f)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=Re([_e(1,R.IPolicyService),_e(2,T.ILogService)],y),e.PolicyConfiguration=y}),define(pe[105],ve([0,1,14,7,2,19,25,104,211,62]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends D.Disposable{constructor(w,v,h,I){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=h instanceof S.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,h,I)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,v)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new b.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:d})=>this.onDidDefaultConfigurationChange(y,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[w,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(w,v,new E.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(w,v){const h=typeof w=="string"?w:void 0,I=(0,k.isConfigurationOverrides)(w)?w:(0,k.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,I,void 0)}updateValue(w,v,h,I){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(h,v,2)}onDidDefaultConfigurationChange(w,v){const h=this.configuration.toData(),I=this.configuration.compareAndUpdateDefaultConfiguration(w,v);this.trigger(I,h,7)}onDidPolicyConfigurationChange(w){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(w);this.trigger(h,v,7)}trigger(w,v,h){const I=new E.ConfigurationChangeEvent(w,{data:v},this.configuration);I.source=h,I.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(I)}getTargetConfiguration(w){switch(w){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(pe[106],ve([0,1,11,5]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends b.ErrorNoTelemetry{constructor(E,p=D.Unknown,S){super(E);this._message=E,this._code=p,this._detail=S,this.isHandled=p===D.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(E){return E instanceof C&&E._code===D.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof C&&E._code===D.NoResolverFound}static isHandled(E){return E instanceof C&&E.isHandled}}e.RemoteAuthorityResolverError=C}),define(pe[75],ve([0,1,10]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(S){return S.scheme===b.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=t;function D(S){if(!S)return;const T=S.indexOf("+");return T<0?S:S.substr(0,T)}e.getRemoteName=D;function C(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=C;function k(S){const{host:T,port:R}=p(S);if(typeof R=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:R}}e.parseAuthorityWithPort=k;function E(S,T){let{host:R,port:w}=p(S);return typeof w=="undefined"&&(w=T),{host:R,port:w}}e.parseAuthorityWithOptionalPort=E;function p(S){const T=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const R=S.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const w=S.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:S,port:void 0}}}),define(pe[36],ve([0,1,15,5,75]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=C;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var p;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,y){if(typeof I=="undefined"||I===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof I=="string"||typeof y=="string"){const d=typeof I=="string"?I:I.value,g=typeof y=="string"?y:y.value;return b.equalsIgnoreCase(d,g)}return I._lower===y._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=S;function T(h){return R(h)}e.isApplicationScopedExtension=T;function R(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function w(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function v(h,I){if(I){const y=`onResolveRemoteAuthority:${(0,D.getRemoteName)(I)}`;return h.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[34],ve([0,1,15,31,36,3,4,11,28]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,b.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=S;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(n,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=n.id}static create(n){const i=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new R(n.identifier,i,s)}static parse(n){const i=T.exec(n);return i&&i[1]&&i[2]?new R({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof R?S(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=R;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const n=w.exec(o);return n&&n[1]?[I(n[1]),n[2]]:[I(o),void 0]}e.getIdAndVersion=v;function h(o,n){return`${o}.${n}`}e.getExtensionId=h;function I(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(o,n){return I(h(o,n))}e.getGalleryExtensionId=y;function d(o,n){const i=[],s=a=>{for(const c of i)if(c.some(m=>S(n(m),n(a))))return c;return null};for(const a of o){const c=s(a);c?c.push(a):i.push([a])}return i}e.groupByExtension=d;function g(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function u(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function l(o,n){const i=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&i.every(c=>!S(c.identifier,{id:a}))){const c=o.filter(m=>S(m.identifier,{id:a}));c.length===1&&(i.push(c[0]),s.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=l;async function f(o,n){if(!C.isLinux)return!1;let i;try{i=(await o.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await o.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function r(o,n){const i=await f(o,n),s=(0,t.getTargetPlatform)(i?"alpine":C.platform,p.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(pe[107],ve([0,1,20,11,10,19,50,4,163,31,34,36]),function(oe,e,b,t,D,C,k,E,p,S,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const w=y=>(0,p.localize)(0,null,y),v=(0,p.localize)(1,null,"ms-dotnettools.csharp");function h(y,d){return d?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let I=class{constructor(d,g){this.extensionManagementService=d,this.extensionGalleryService=g}get location(){}async listExtensions(d,g,u=console){let l=await this.extensionManagementService.getInstalled(1);const f=R.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(g&&g!==""){if(f.indexOf(g.toLowerCase())<0){u.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}l=l.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){u.log("Possible Categories: "),f.forEach(o=>{u.log(o)});return}this.location&&u.log((0,p.localize)(2,null,this.location)),l=l.sort((o,n)=>o.identifier.id.localeCompare(n.identifier.id));let r;for(const o of l)r!==o.identifier.id&&(r=o.identifier.id,u.log(h(o.manifest,d)))}async installExtensions(d,g,u,l,f=console){const r=[],o=[];d.length&&f.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1),i=(m,P)=>{const _=n.find(W=>(0,T.areSameExtensions)(W.identifier,{id:m}));if(_){if(!l&&(!P||P==="prerelease"&&_.preRelease))return f.log((0,p.localize)(5,null,m,_.manifest.version,m)),!1;if(P&&_.manifest.version===P)return f.log((0,p.localize)(6,null,`${m}@${P}`)),!1}return!0},s=(m,P,_)=>{c.push({id:m,version:P!=="prerelease"?P:void 0,installOptions:{...u,isBuiltin:_,installPreReleaseVersion:P==="prerelease"||u.installPreReleaseVersion}})},a=[],c=[];for(const m of d)if(m instanceof E.URI)a.push(m);else{const[P,_]=(0,T.getIdAndVersion)(m);i(P,_)&&s(P,_,!1)}for(const m of g){const[P,_]=(0,T.getIdAndVersion)(m);i(P,_)&&s(P,_,!0)}if(a.length&&await Promise.all(a.map(async m=>{try{const P=await this.installVSIX(m,{...u,isBuiltin:!1},l,f);P&&o.push(P)}catch(P){f.error(P.message||P.stack||P),r.push(m.toString())}})),c.length){const m=await this.getGalleryExtensions(c);await Promise.all(c.map(async P=>{const _=m.get(P.id.toLowerCase());if(_)try{const W=await this.installFromGallery(P,_,n,l,f);W&&o.push(W)}catch(W){f.error(W.message||W.stack||W),r.push(P.id)}else f.error(`${w(P.version?`${P.id}@${P.version}`:P.id)}
${v}`),r.push(P.id)}))}if(r.length)throw new Error((0,p.localize)(7,null,r.join(", ")))}async installVSIX(d,g,u,l){const f=await this.extensionManagementService.getManifest(d);if(!f)throw new Error("Invalid vsix");if(await this.validateVSIX(f,u,l))try{return await this.extensionManagementService.install(d,g),l.log((0,p.localize)(8,null,(0,C.basename)(d))),f}catch(o){if((0,t.isCancellationError)(o))return l.log((0,p.localize)(9,null,(0,C.basename)(d))),null;throw o}return null}async getGalleryExtensions(d){const g=new Map,u=d.some(f=>f.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(d.map(f=>({...f,preRelease:u})),b.CancellationToken.None);for(const f of l)g.set(f.identifier.id.toLowerCase(),f);return g}async installFromGallery({id:d,version:g,installOptions:u},l,f,r,o){const n=await this.extensionGalleryService.getManifest(l,b.CancellationToken.None);if(n&&!this.validateExtensionKind(n,o))return null;const i=f.find(s=>(0,T.areSameExtensions)(s.identifier,l.identifier));if(i){if(l.version===i.manifest.version)return o.log((0,p.localize)(10,null,g?`${d}@${g}`:d)),null;o.log((0,p.localize)(11,null,d,l.version))}try{u.isBuiltin?o.log(g?(0,p.localize)(12,null,d,g):(0,p.localize)(13,null,d)):o.log(g?(0,p.localize)(14,null,d,g):(0,p.localize)(15,null,d));const s=await this.extensionManagementService.installFromGallery(l,{...u,installGivenVersion:!!g});return o.log((0,p.localize)(16,null,d,s.manifest.version)),n}catch(s){if((0,t.isCancellationError)(s))return o.log((0,p.localize)(17,null,d)),null;throw s}}validateExtensionKind(d,g){return!0}async validateVSIX(d,g,u){const l={id:(0,T.getGalleryExtensionId)(d.publisher,d.name)},r=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,T.areSameExtensions)(l,o.identifier)&&(0,k.gt)(o.manifest.version,d.version));return r&&!g?(u.log((0,p.localize)(18,null,r.identifier.id,r.manifest.version,d.version)),!1):this.validateExtensionKind(d,u)}async uninstallExtensions(d,g,u=console){const l=async r=>{if(r instanceof E.URI){const o=await this.extensionManagementService.getManifest(r);return h(o)}return r},f=[];for(const r of d){const o=await l(r),i=(await this.extensionManagementService.getInstalled()).filter(s=>(0,T.areSameExtensions)(s.identifier,{id:o}));if(!i.length)throw new Error(`${this.notInstalled(o)}
${v}`);if(i.some(s=>s.type===0)){u.log((0,p.localize)(19,null,o));return}if(!g&&i.some(s=>s.isBuiltin)){u.log((0,p.localize)(20,null,o));return}u.log((0,p.localize)(21,null,o));for(const s of i)await this.extensionManagementService.uninstall(s),f.push(s);this.location?u.log((0,p.localize)(22,null,o,this.location)):u.log((0,p.localize)(23,null,o))}}async locateExtension(d,g=console){const u=await this.extensionManagementService.getInstalled();d.forEach(l=>{u.forEach(f=>{if(f.identifier.id===l&&f.location.scheme===D.Schemas.file){g.log(f.location.fsPath);return}})})}notInstalled(d){return this.location?(0,p.localize)(24,null,d,this.location):(0,p.localize)(25,null,d)}};I=Re([_e(0,S.IExtensionManagementService),_e(1,S.IExtensionGalleryService)],I),e.ExtensionManagementCLIService=I}),define(pe[53],ve([0,1,14,16,2,24,4,34,17,5,13]),function(oe,e,b,t,D,C,k,E,p,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let R=class extends D.Disposable{constructor(v,h){super();this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new C.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,I=>(I=I.filter(y=>v.some(([d])=>!(0,E.areSameExtensions)(y.identifier,d.identifier))),I.push(...v.map(([y,d])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:d}))),I))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,I=>I.filter(y=>!(0,E.areSameExtensions)(y.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let I=[];try{const y=await this.fileService.readFile(v),d=JSON.parse(y.value.toString());for(const g of d){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}I.push({identifier:g.identifier,location:k.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(h){I=h(I);const y=I.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),metadata:d.metadata}));await this.fileService.writeFile(v,t.VSBuffer.fromString(JSON.stringify(y)))}return I})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new b.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};R=Re([_e(0,p.IFileService),_e(1,T.ILogService)],R),e.ExtensionsProfileScannerService=R}),define(pe[212],ve([0,1,14,11,2,3,19,50,4,23,21,26,31,34,17,13]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class extends D.Disposable{constructor(g,u,l,f){super();this.fileService=u,this.extensionGalleryService=l,this.logService=f,this.extensionsDownloadDir=p.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,u){await this.cleanUpPromise;const l=this.getName(g),f=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(f)){const r=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,S.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(g,r,u);try{await this.rename(r,f,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(r)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,r.path),o}}return f}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,u,l){try{await T.Promises.rename(g.fsPath,u.fsPath)}catch(f){if(C.isWindows&&f&&f.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${u} with 'EPERM' error. Trying again...`),this.rename(g,u,l);throw f}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const u=[],l=[];for(const o of g.children){const n=v.ExtensionKey.parse(o.name);n&&l.push([n,o])}const f=(0,v.groupByExtension)(l,([o])=>o),r=[];for(const o of f)o.sort((n,i)=>E.rcompare(n[0].version,i[0].version)),u.push(...o.slice(1).map(n=>n[1].resource)),r.push(o[0][1]);r.sort((o,n)=>o.mtime-n.mtime),u.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),await b.Promises.settled(u.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?v.ExtensionKey.create(g).toString().toLowerCase():(0,S.generateUuid)()}};y=Re([_e(0,R.INativeEnvironmentService),_e(1,h.IFileService),_e(2,w.IExtensionGalleryService),_e(3,I.ILogService)],y),e.ExtensionsDownloader=y}),define(pe[213],ve([0,1,2,6,21,36]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends b.Disposable{constructor(p,S){super();this.environmentService=p,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(S.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(S.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(p){p.some(S=>!!S.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(pe[108],ve([0,1,109,18,14,2,10,6,21,26,31,34,13,74]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(g,u,l,f){super(l);this.extensionManagementService=g,this.logService=f,this.cache=this._register(new I(u,f)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),u=Object.keys(g).map(l=>{const f=g[l];return{...this.createQuickPickItem(l,f.label),extensionId:f.extensions[0].extensionIdentifier.id}});return u.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),u.sort((l,f)=>l.label.localeCompare(f.label)),u}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const u=await this.cache.getLanguagePacks();Object.keys(u).some(l=>u[l]&&u[l].extensions.some(f=>(0,R.areSameExtensions)(f.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(u);return!(0,t.equals)(Object.keys(g),Object.keys(l))}};h=Re([_e(0,T.IExtensionManagementService),_e(1,S.INativeEnvironmentService),_e(2,T.IExtensionGalleryService),_e(3,w.ILogService)],h),e.NativeLanguagePackService=h;let I=class extends C.Disposable{constructor(g,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(u=>{Object.keys(u).forEach(l=>delete u[l]),this.createLanguagePacksFromExtensions(u,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...u){for(const l of u)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,l);Object.keys(g).forEach(l=>this.updateHash(g[l]))}createLanguagePacksFromExtension(g,u){const l=u.identifier,f=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of f)if(u.location.scheme===k.Schemas.file&&y(r)){let o=g[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},g[r.languageId]=o);const n=o.extensions.filter(i=>(0,R.areSameExtensions)(i.extensionIdentifier,l))[0];n?n.version=u.manifest.version:o.extensions.push({extensionIdentifier:l,version:u.manifest.version});for(const i of r.translations)o.translations[i.id]=(0,E.join)(u.location.fsPath,i.path)}}updateHash(g){if(g){const u=(0,b.createHash)("md5");for(const l of g.extensions)u.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);g.hash=u.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(u=g(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.languagePacks=l,this.initializedCache=!0;const f=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",f),p.Promises.writeFile(this.languagePacksFilePath,f)}).then(()=>u,l=>this.logService.error(l))})}};I=Re([_e(0,S.INativeEnvironmentService),_e(1,w.ILogService)],I);function y(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const g of d.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(pe[54],ve([0,1,16,175,52,5,33]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function E(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}e.isSuccess=E;function p(I){return I.res.statusCode===204}async function S(I){return p(I)?null:(await(0,b.streamToBuffer)(I.stream)).toString()}e.asText=S;async function T(I){if(!E(I))throw new Error("Server returned "+I.res.statusCode);return S(I)}e.asTextOrError=T;async function R(I){if(!E(I))throw new Error("Server returned "+I.res.statusCode);if(p(I))return null;const d=(await(0,b.streamToBuffer)(I.stream)).toString();try{return JSON.parse(d)}catch(g){throw g.message+=`:
`+d,g}}e.asJson=R;function w(I){h(I)}e.updateProxyConfigurationsScope=w;let v;function h(I){const y=k.Registry.as(D.Extensions.Configuration),d=v;v={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:d?[d]:[]})}h(2)}),define(pe[214],ve([0,1,20,10,17,54]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(p,S){this.requestService=p,this.fileService=S}async download(p,S,T=b.CancellationToken.None){if(p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(p,S);return}const R={type:"GET",url:p.toString(!0)},w=await this.requestService.request(R,T);if(w.res.statusCode===200)await this.fileService.writeFile(S,w.stream);else{const v=await(0,C.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${v}`)}}};k=Re([_e(0,C.IRequestService),_e(1,D.IFileService)],k),e.DownloadService=k}),define(pe[215],ve([0,1,16,20]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(E){this.service=E}listen(E,p){throw new Error("Invalid listen")}call(E,p,S,T=t.CancellationToken.None){switch(p){case"request":return this.service.request(S[0],T).then(async({res:R,stream:w})=>{const v=await(0,b.streamToBuffer)(w);return[{statusCode:R.statusCode,headers:R.headers},v]});case"resolveProxy":return this.service.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class C{constructor(E){this.channel=E}async request(E,p){const[S,T]=await this.channel.call("request",[E],p);return{res:S,stream:(0,b.bufferToStream)(T)}}async resolveProxy(E){return this.channel.call("resolveProxy",[E])}}e.RequestChannelClient=C}),define(pe[216],ve([0,1,76,12]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,E){return k.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:k.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function C(k,E,p={}){const S=(0,b.parse)(k),T=p.proxyUrl||D(S,E);if(!T)return null;const R=(0,b.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const w={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((v,h)=>{oe(["http-proxy-agent"],v,h)}))(w):new(await new Promise((v,h)=>{oe(["https-proxy-agent"],v,h)}))(w)}e.getProxyAgent=C}),define(pe[77],ve([0,1,49,6,176,20,38,11,3,23,153,189,14]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function I(d,g,u){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(u)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(u)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=w.Promises.withAsyncBody(async(l,f)=>{const r=new C.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),f(new Error((0,D.localize)(0,null)))},v);try{l(await y(d,r.token))}catch(n){!(0,E.isCancellationError)(n)&&!r.token.isCancellationRequested?f(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(n)))):l({})}finally{clearTimeout(o),r.dispose()}})),h)}e.getResolvedShellEnv=I;async function y(d,g){const u=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",u);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",l);const f=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(f+"(.*)"+f),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",o);const n=await(0,T.getSystemShell)(p.OS,o);return d.trace("getUnixShellEnvironment#shell",n),new Promise((i,s)=>{if(g.isCancellationRequested)return s((0,E.canceled)());const a=(0,t.basename)(n);let c,m;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${P} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,m=["-Login","-Command"]):(c=`'${process.execPath}' ${P} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,a==="tcsh"?m=["-ic"]:m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),c);const _=(0,b.spawn)(n,[...m,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(_.kill(),s((0,E.canceled)()))),_.on("error",se=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(se)),s(se)});const W=[];_.stdout.on("data",se=>W.push(se));const K=[];_.stderr.on("data",se=>K.push(se)),_.on("close",(se,F)=>{const Q=Buffer.concat(W).toString("utf8");d.trace("getUnixShellEnvironment#raw",Q);const re=Buffer.concat(K).toString("utf8");if(re.trim()&&d.trace("getUnixShellEnvironment#stderr",re),se||F)return s(new Error((0,D.localize)(2,null,se,F)));const G=r.exec(Q),de=G?G[1]:"{}";try{const J=JSON.parse(de);u?J.ELECTRON_RUN_AS_NODE=u:delete J.ELECTRON_RUN_AS_NODE,l?J.ELECTRON_NO_ATTACH_CONSOLE=l:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",J),i(J)}catch(J){d.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(J)),s(J)}})})}}),define(pe[110],ve([0,1,3,28,4,23]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(S){if(b.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function E(S,T,R,w,v,h,I,y,d,g){const u=Object.create(null);u["common.machineId"]=I,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=v,u.version=h,u["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,b.PlatformToString)(b.platform),u["common.nodePlatform"]=t.platform,u["common.nodeArch"]=w,u["common.product"]=g||"desktop",y&&(u["common.msftInternal"]=y);let l=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),b.isLinuxSnap&&(u["common.snap"]="true");const r=k(R);r&&(u["common.platformDetail"]=r);try{const o=await S.readFile(D.URI.file(d));u["common.source"]=o.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=E;function p(S){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return S.some(w=>R===w)}e.verifyMicrosoftInternalDomain=p}),define(pe[217],ve([0,1,18,11,2,22,17]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var E;(function(S){function T(R,w){return R.callstack<w.callstack?-1:R.callstack>w.callstack?1:0}S.compare=T})(E=e.ErrorEvent||(e.ErrorEvent={}));class p{constructor(T,R=p.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new D.DisposableStore,this._telemetryService=T,this._flushDelay=R;const w=t.errorHandler.addListener(v=>this._onErrorEvent(v));this._disposables.add((0,D.toDisposable)(w)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof k.FileOperationError))return;const R=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,w=T.message?T.message:(0,C.safeStringify)(T);!R||this._enqueue({msg:w,callstack:R})}_enqueue(T){const R=(0,b.binarySearch)(this._buffer,T,E.compare);R<0?(T.count=1,this._buffer.splice(~R,0,T)):(this._buffer[R].count||(this._buffer[R].count=0),this._buffer[R].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const T of this._buffer)this._telemetryService.publicLogError2("UnhandledError",T);this._buffer.length=0}}e.default=p,p.ERROR_FLUSH_TIMEOUT=5*1e3}),define(pe[218],ve([0,1,2]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends b.Disposable{constructor(C,k){super();this.telemetryService=C,this.telemetryAppender=k}async call(C,k,E){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:p}=E;return this.telemetryService.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:S}=E;return this.telemetryAppender?this.telemetryAppender.log(p,S):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(C,k,E){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(pe[32],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,b.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(pe[219],ve([0,1,30,45,14,65,10,6,3,4,91,21,94,196,17,27,32]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function g(o,n){const i=`${o}::${n.join(":")}`,s=d.get(i);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,m=new Map,P=2e4;function _(K,se,F,Q){const re=se.substring(K.length+1);return D.Promises.withAsyncBody(async G=>{let de;try{de=await R.Promises.readdir(se,{withFileTypes:!0})}catch{G();return}if(Q.count>=P){Q.count+=de.length,Q.maxReached=!0,G();return}let J=de.length;if(J===0){G();return}let U=de;Q.count+de.length>P&&(Q.maxReached=!0,J=P-Q.count,U=de.slice(0,J)),Q.count+=de.length;for(const O of U)if(O.isDirectory()){if(F.includes(O.name)||await _(K,(0,E.join)(se,O.name),F,Q),--J==0){G();return}}else{const B=O.name.lastIndexOf(".");if(B>=0){const X=O.name.substring(B+1);X&&c.set(X,(c.get(X)??0)+1)}for(const X of a)X.relativePathPattern?.test(re)!==!1&&X.filePattern.test(O.name)&&m.set(X.tag,(m.get(X.tag)??0)+1);if(--J==0){G();return}}})}const W=D.Promises.withAsyncBody(async K=>{const se={count:0,maxReached:!1};await _(o,o,n,se);const F=await f(o);K({configFiles:u(m),fileTypes:u(c),fileCount:se.count,maxFilesReached:se.maxReached,launchConfigFiles:F})});return d.set(i,W),W}e.collectWorkspaceStats=g;function u(o){return[...t.Iterable.map(o.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function l(){const o={os:`${b.type()} ${b.arch()} ${b.release()}`,memory:`${(b.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},n=b.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=l;async function f(o){try{const n=new Map,i=(0,E.join)(o,".vscode","launch.json"),s=await R.Promises.readFile(i),a=[],c=(0,C.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(c)==="object"&&c.configurations)for(const m of c.configurations){const P=m.type;P&&(n.has(P)?n.set(P,n.get(P)+1):n.set(P,1))}return u(n)}catch{return[]}}e.collectLaunchConfigs=f;let r=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${b.type()} ${b.arch()} ${b.release()}`);const s=b.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(b.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||i.push(`Load (avg):       ${b.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,w.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[a,c]=s,m=this.formatProcessList(n,a);return i.forEach(P=>{if((0,v.isRemoteDiagnosticError)(P))m+=`
${P.errorMessage}`,c+=`
${P.errorMessage}`;else if(m+=`

Remote: ${P.hostName}`,P.processes&&(m+=`
${this.formatProcessList(n,P.processes)}`),P.workspaceMetadata){c+=`
|  Remote: ${P.hostName}`;for(const _ of Object.keys(P.workspaceMetadata)){const W=P.workspaceMetadata[_];let K=`${W.fileCount} files`;W.maxFilesReached&&(K=`more than ${K}`),c+=`|    Folder (${_}): ${K}`,c+=this.formatWorkspaceStats(W)}}}),{processInfo:m,workspaceInfo:c}})}async getSystemInfo(n,i){const{memory:s,vmHint:a,os:c,cpus:m}=l(),P={os:c,memory:s,cpus:m,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return p.isWindows||(P.load=`${b.loadavg().map(_=>Math.round(_)).join(", ")}`),p.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(n,i){const s=[];return(0,w.listProcesses)(n.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,a)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),i.forEach(c=>{if((0,v.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.formatMachineInfo(c.machineInfo)),c.processes&&s.push(this.formatProcessList(n,c.processes)),c.workspaceMetadata)for(const m of Object.keys(c.workspaceMetadata)){const P=c.workspaceMetadata[m];let _=`${P.fileCount} files`;P.maxFilesReached&&(_=`more than ${_}`),s.push(`Folder (${m}): ${_}`),s.push(this.formatWorkspaceStats(P))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const i=[],s=60;let a=0;const c=(W,K)=>{const se=` ${W}(${K})`;a+se.length>s?(i.push(m),m="|                 ",a=m.length):a+=se.length,m+=se};let m="|      File types:";const P=10,_=n.fileTypes.length>P?P:n.fileTypes.length;for(let W=0;W<_;W++){const K=n.fileTypes[W];c(K.name,K.count)}if(i.push(m),n.configFiles.length>=0&&(m="|      Conf files:",a=0,n.configFiles.forEach(W=>{c(W.name,W.count)}),i.push(m)),n.launchConfigFiles.length>0){let W="|      Launch Configs:";n.launchConfigFiles.forEach(K=>{W+=K.count>1?` ${K.name}(${K.count})`:` ${K.name}`}),i.push(W)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],s=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const m=S.URI.revive(c);if(m.scheme===k.Schemas.file){const P=m.fsPath;s.push(g(P,["node_modules",".git"]).then(_=>{let W=`${_.fileCount} files`;_.maxFilesReached&&(W=`more than ${W}`),i.push(`|    Folder (${(0,E.basename)(P)}): ${W}`),i.push(this.formatWorkspaceStats(_))}).catch(_=>{i.push(`|      Error: Unable to collect workspace stats for folder ${P} (${_.toString()})`)}))}else i.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,i){const s=new Map;n.windows.forEach(c=>s.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,s,a,i,0),a.join(`
`)}formatProcessItem(n,i,s,a,c){const m=c===0;let P;m?P=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(P=`${P} (${i.get(a.pid)})`));const _=process.platform==="win32"?a.mem:b.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(_/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(a.children)&&a.children.forEach(W=>this.formatProcessItem(n,i,s,W,c+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:s}of n.folders){const a=S.URI.revive(s);if(a.scheme!==k.Schemas.file)continue;const c=a.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(P=>i.add(P.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const s=S.URI.revive(i);if(s.scheme!==k.Schemas.file)continue;const a=s.fsPath;try{const c=await g(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:m.name,count:m.count})}),c.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:m.name,count:m.count})}),c.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};r=Re([_e(0,y.ITelemetryService),_e(1,I.IProductService)],r),e.DiagnosticsService=r}),define(pe[43],ve([0,1,22,87,12,25,110,32]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class S{async publicLog(r,o,n){}async publicLogError(r,o,n){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(f,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&f.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:d(o.sourceConfig)})})}e.configurationTelemetry=T;function R(f,r){return!(r.disableTelemetry||!f.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=R;function w(f){const r=f.getValue(E.TELEMETRY_SETTING_ID),o=f.getValue("telemetry.enableCrashReporter");if(f.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function v(f){const r={},o={},n={};y(f,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const s=n[i];typeof s=="number"?o[i]=s:typeof s=="boolean"?o[i]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${s.length}`),r[i]=s.substring(0,8191)):typeof s!="undefined"&&s!==null&&(r[i]=s)}return{properties:r,measurements:o}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function I(f){if(!f)return"none";for(const r of h)if(f.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=I;function y(f,r,o=0,n){if(!!f)for(const i of Object.getOwnPropertyNames(f)){const s=f[i],a=n?n+i:i;Array.isArray(s)?r[a]=(0,b.safeStringify)(s):s instanceof Date?r[a]=s.toISOString():(0,D.isObject)(s)?o<2?y(s,r,o+1,a+"."):r[a]=(0,b.safeStringify)(s):r[a]=s}}function d(f){if(!f)return[];const r=[];return g(r,"",f),r}function g(f,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>g(f,r?`${r}.${n}`:n,o[n])):f.push(r)}function u(f,r){const o=f.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=u;function l(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}e.getPiiPathsFromEnvironment=l}),define(pe[220],ve([0,1,193,43]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(C,k,E,p,S,T,R){const w={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${k.nameShort})`},v=await(0,b.getServiceMachineId)(E,S,T),{sessionId:h}=await R.getTelemetryInfo();return(0,t.supportsTelemetry)(k,E)&&(0,t.getTelemetryLevel)(p)===3&&(w["X-Market-User-Id"]=v,w["VSCode-SessionId"]=h),w}e.resolveMarketplaceHeaders=D}),define(pe[221],ve([0,1,11,22,43]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function k(p,S,T){const R=await new Promise((y,d)=>{oe(["@microsoft/1ds-core-js"],y,d)}),w=await new Promise((y,d)=>{oe(["@microsoft/1ds-post-js"],y,d)}),v=new R.AppInsightsCore,h=new w.PostChannel,I={instrumentationKey:p,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(T){I.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:T};I.extensionConfig[h.identifier]=y}return v.initialize(I,[]),v.addTelemetryInitializer(y=>{S&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class E{constructor(S,T,R,w,v){this._isInternalTelemetry=S,this._eventPrefix=T,this._defaultData=R,this._xhrOverride=v,this.endPointUrl=C,this._defaultData||(this._defaultData={}),typeof w=="function"?this._aiCoreOrKey=w():this._aiCoreOrKey=w,this._asyncAiCore=null}_withAIClient(S){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){S(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(T=>{S(T)},T=>{(0,b.onUnexpectedError)(T),console.error(T)})}}log(S,T){if(!this._aiCoreOrKey)return;T=(0,t.mixin)(T,this._defaultData),T=(0,D.validateTelemetryData)(T);const R=this._eventPrefix+"/"+S;try{this._withAIClient(w=>{w.pluginVersionString=T?.properties.version??"Unknown",w.track({name:R,baseData:{name:R,properties:T?.properties,measurements:T?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(S=>{this._withAIClient(T=>{T.unload(!0,()=>{this._aiCoreOrKey=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=E}),define(pe[222],ve([0,1,2,22,87,3,15,177,25,52,51,27,33,32,43]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(g,u,l){this._configurationService=u,this._productService=l,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new b.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,u){this._experimentProperties[g]=u}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;g=Math.min(g,l)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,u=g.sessionID,l=g["common.machineId"],f=g["common.firstSessionDate"],r=g["common.msftInternal"];return{sessionId:u,machineId:l,firstSessionDate:f,msftInternal:r}}dispose(){this._disposables.dispose()}_log(g,u,l,f){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(r=>{l=(0,t.mixin)(l,r),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,o=>{if(typeof o=="string")return this._cleanupInfo(o,f)}),this._appenders.forEach(o=>o.log(g,l))},r=>{console.error(r)})}publicLog(g,u,l){return this._log(g,3,u,l)}publicLog2(g,u,l){return this.publicLog(g,u,l)}publicLogError(g,u){return this._sendErrorTelemetry?this._log(g,2,u,!0):Promise.resolve(void 0)}publicLogError2(g,u){return this.publicLogError(g,u)}_anonymizeFilePaths(g){let u=g;const l=[];for(const n of this._cleanupPatterns)for(;;){const i=n.exec(g);if(!i)break;l.push([i.index,n.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(u="";;){const n=r.exec(g);if(!n)break;!f.test(n[0])&&l.every(([i,s])=>n.index<i||n.index>=s)&&(u+=g.substring(o,n.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<g.length&&(u+=g.substr(o)),u}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const u=g.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const f of l)if(f.regex.test(u))return`<REDACTED: ${f.label}>`;return g}_cleanupInfo(g,u){let l=g;u&&(l=this._anonymizeFilePaths(l));for(const f of this._cleanupPatterns)l=l.replace(f,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=Re([_e(1,p.IConfigurationService),_e(2,R.IProductService)],I),e.TelemetryService=I;function y(){const d=(0,E.localize)(0,null,T.default.nameLong),g=T.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",T.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=C.isWeb?"":(0,E.localize)(3,null),l=(0,E.localize)(4,null),f=(0,E.localize)(5,null),r=(0,E.localize)(6,null),o=(0,E.localize)(7,null),n=`
|       | ${l} | ${f} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,E.localize)(8,null);return`
${d} ${g} ${u}

&nbsp;

${o}
${n}

&nbsp;

${i}
`}w.Registry.as(S.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(S.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:T.default.privacyStatementUrl?(0,E.localize)(16,null,T.default.nameLong,T.default.privacyStatementUrl):(0,E.localize)(15,null,T.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[223],ve([0,1,25,5,27,32,222,43]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let p=class extends k.TelemetryService{constructor(T,R,w,v){super(T,w,v);this._injectedTelemetryLevel=R}publicLog(T,R,w){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(T,R,w)}publicLog2(T,R,w){return this.publicLog(T,R,w)}publicLogError(T,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(T,R)}publicLogError2(T,R){return this.publicLogError(T,R)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,T):T,this._injectedTelemetryLevel===0&&this.dispose()}};p=Re([_e(2,b.IConfigurationService),_e(3,D.IProductService)],p),e.ServerTelemetryService=p,e.ServerNullTelemetryService=new class extends E.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(C.ITelemetryService)}),define(pe[224],ve([0,1,268,221]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends t.AbstractOneDataSystemAppender{constructor(k,E,p,S){const T={sendPOST:(R,w)=>{const v={method:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data)}};try{const h=b.request(R.urlString,v,I=>{I.on("data",function(y){w(I.statusCode??200,I.headers,y.toString())}),I.on("error",function(y){w(0,{})})});h.write(R.data),h.end()}catch{w(0,{})}}};super(k,E,p,S,T)}}e.OneDataSystemAppender=D}),define(pe[225],ve([0,1,11,217]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class D extends t.default{installErrorListeners(){(0,b.setUnexpectedErrorHandler)(E=>console.error(E));const k=[];process.on("unhandledRejection",(E,p)=>{k.push(p),setTimeout(()=>{const S=k.indexOf(p);S>=0&&p.catch(T=>{k.splice(S,1),(0,b.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),E&&(0,b.onUnexpectedError)(E))})},1e3)}),process.on("rejectionHandled",E=>{const p=k.indexOf(E);p>=0&&k.splice(p,1)}),process.on("uncaughtException",E=>{(0,b.onUnexpectedError)(E)})}}e.default=D}),define(pe[226],ve([0,1,14,20,7,2,13]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let E=class extends C.Disposable{constructor(S,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=S===void 0?15e3:S}createRequest(S){return new Promise((T,R)=>{const w=++this._lastRequestId;this._pendingRequests.set(w,T),this._onCreateRequest.fire({requestId:w,...S});const v=new t.CancellationTokenSource;(0,b.timeout)(this._timeout,v.token).then(()=>R(`Request ${w} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(w,[(0,C.toDisposable)(()=>v.cancel())])})}acceptReply(S,T){const R=this._pendingRequests.get(S);R?(this._pendingRequests.delete(S),(0,C.dispose)(this._pendingRequestDisposables.get(S)||[]),this._pendingRequestDisposables.delete(S),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};E=Re([_e(1,k.ILogService)],E),e.RequestStore=E}),define(pe[111],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(u){u.FileName="ptyhost"})(C=e.TerminalLogConstants||(e.TerminalLogConstants={}));var k;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(k=e.PosixShellType||(e.PosixShellType={}));var E;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(E=e.WindowsShellType||(e.WindowsShellType={}));var p;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(p=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,b.createDecorator)("ptyService");var T;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(u){u.TerminalView="view",u.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var I;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(I=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var d;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(pe[227],ve([0,1,30,10,22,6,3,28,15,12,21]),function(oe,e,b,t,D,C,k,E,p,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let f=0;return l&&l.length===4&&(f=parseInt(l[3])),f}e.getWindowsBuildNumber=R;async function w(l,f,r,o=E.env,n=T.Promises.exists){if(C.isAbsolute(l))return await n(l)?l:void 0;if(f===void 0&&(f=E.cwd()),C.dirname(l)!=="."){const c=C.join(f,l);return await n(c)?c:void 0}const s=(0,D.getCaseInsensitive)(o,"PATH");if(r===void 0&&(0,S.isString)(s)&&(r=s.split(C.delimiter)),r===void 0||r.length===0){const c=C.join(f,l);return await n(c)?c:void 0}for(const c of r){let m;if(C.isAbsolute(c)?m=C.join(c,l):m=C.join(f,c,l),await n(m))return m;if(k.isWindows){let P=m+".com";if(await n(P)||(P=m+".exe",await n(P)))return P}}const a=C.join(f,l);return await n(a)?a:void 0}e.findExecutable=w;function v(l,f,r){if(!f.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser||l.ignoreShellIntegration)return;const o=l.args,n=E.platform==="win32"?C.basename(l.executable).toLowerCase():C.basename(l.executable),i=C.dirname(t.FileAccess.asFileUri("",oe).fsPath);let s;const a={VSCODE_INJECTION:"1"};if(k.isWindows){if(n==="pwsh.exe")return!o||g(o)?s=e.shellIntegrationArgs.get(h.WindowsPwsh):d(o)&&(s=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),s?(s&&(s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i,"")),{newArgs:s,envMixin:a}):void 0;r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(n){case"bash":return!o||o.length===0?s=e.shellIntegrationArgs.get(h.Bash):u(o)&&(a.VSCODE_SHELL_LOGIN="1",s=e.shellIntegrationArgs.get(h.Bash)),s?(s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i),{newArgs:s,envMixin:a}):void 0;case"pwsh":return!o||g(o)?s=e.shellIntegrationArgs.get(h.Pwsh):d(o)&&(s=e.shellIntegrationArgs.get(h.PwshLogin)),s?(s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i,""),{newArgs:s,envMixin:a}):void 0;case"zsh":{if(!o||o.length===0?s=e.shellIntegrationArgs.get(h.Zsh):u(o)?s=e.shellIntegrationArgs.get(h.ZshLogin):(o===e.shellIntegrationArgs.get(h.Zsh)||o===e.shellIntegrationArgs.get(h.ZshLogin))&&(s=o),!s)return;s=[...s],s[s.length-1]=(0,p.format)(s[s.length-1],i);const c=C.join(b.tmpdir(),"vscode-zsh");a.ZDOTDIR=c;const m=[];return m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.join(c,".zshrc")}),m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.join(c,".zprofile")}),m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.join(c,".zshenv")}),m.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.join(c,".zlogin")}),{newArgs:s,envMixin:a,filesToCopy:m}}}r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=v;var h;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],y=["-nol","-nologo"];function d(l){return typeof l=="string"?I.includes(l.toLowerCase()):l.length===1&&I.includes(l[0].toLowerCase())||l.length===2&&(I.includes(l[0].toLowerCase())||I.includes(l[1].toLowerCase()))&&(y.includes(l[0].toLowerCase())||y.includes(l[1].toLowerCase()))}function g(l){return typeof l=="string"?y.includes(l.toLowerCase()):l.length===0||l?.length===1&&y.includes(l[0].toLowerCase())}function u(l){return l==="string"&&I.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&I.includes(l[0].toLowerCase())}}),define(pe[228],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var b;(function(C){C.DARK="dark",C.LIGHT="light",C.HIGH_CONTRAST_DARK="hcDark",C.HIGH_CONTRAST_LIGHT="hcLight"})(b=e.ColorScheme||(e.ColorScheme={}));function t(C){return C===b.HIGH_CONTRAST_DARK||C===b.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(C){return C===b.DARK||C===b.HIGH_CONTRAST_DARK}e.isDark=D}),define(pe[112],ve([0,1,40,7,2,5,33,228]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var p;(function(y){function d(g){return g&&typeof g=="object"&&typeof g.id=="string"}y.isThemeColor=d})(p=e.ThemeColor||(e.ThemeColor={}));function S(y){return{id:y}}e.themeColorFromId=S;var T;(function(y){function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||p.isThemeColor(i.color))}y.isThemeIcon=d;const g=new RegExp(`^\\$\\((${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const s=g.exec(i);if(!s)return;const[,a]=s;return{id:a}}y.fromString=u;function l(i){return{id:i}}y.fromId=l;function f(i,s){let a=i.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),s&&(a=`${a}~${s}`),{id:a}}y.modify=f;function r(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}y.getModifier=r;function o(i,s){return i.id===s.id&&i.color?.id===s.color?.id}y.isEqual=o;function n(i,s){return{id:i.id,color:s?S(s):void 0}}y.asThemeIcon=n,y.asClassNameArray=b.CSSIcon.asClassNameArray,y.asClassName=b.CSSIcon.asClassName,y.asCSSSelector=b.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=b.Codicon.file,e.FolderThemeIcon=b.Codicon.folder;function R(y){switch(y){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,D.toDisposable)(()=>{const g=this.themingParticipants.indexOf(d);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new w;k.Registry.add(e.Extensions.ThemingContribution,v);function h(y){return v.onColorThemeChange(y)}e.registerThemingParticipant=h;class I extends D.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,g){let u=this.theme.getColor(d);return u&&g&&(u=g(u,this.theme)),u?u.toString():null}}e.Themable=I}),define(pe[229],ve([0,1,40,4,179,112]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(w,v){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...w.map(I=>({name:I.profileName,description:E(I)}))),v&&h.push(...v.map(I=>({name:I.title,description:p(I)}))),{values:h.map(I=>I.name),markdownDescriptions:h.map(I=>I.description)}}e.createProfileSchemaEnums=k;function E(w){let v=`$(${C.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:b.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?v+=`
- args: "${w.args}"`:v+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(v+=`
- overrideName: ${w.overrideName}`),w.color&&(v+=`
- color: ${w.color}`),w.env&&(v+=`
- env: ${JSON.stringify(w.env)}`),v}function p(w){return`$(${C.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:b.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function S(w,v){if(!w&&!v)return!0;if(typeof w=="string"&&typeof v=="string")return w===v;if(Array.isArray(w)&&Array.isArray(v)){if(w.length!==v.length)return!1;for(let h=0;h<w.length;h++)if(w[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function T(w,v){if(!w&&!v)return!0;if(!w||!v)return!1;if(C.ThemeIcon.isThemeIcon(w)&&C.ThemeIcon.isThemeIcon(v))return w.id===v.id&&w.color===v.color;if(typeof w=="object"&&w&&"light"in w&&"dark"in w&&typeof v=="object"&&v&&"light"in v&&"dark"in v){const h=w,I=v;if((t.URI.isUri(h.light)||R(h.light))&&(t.URI.isUri(h.dark)||R(h.dark))&&(t.URI.isUri(I.light)||R(I.light))&&(t.URI.isUri(I.dark)||R(I.dark)))return h.light.path===I.light.path&&h.dark.path===I.dark.path}if(t.URI.isUri(w)&&t.URI.isUri(v)||R(w)||R(v)){const h=w,I=v;return h.path===I.path&&h.scheme===I.scheme}return!1}e.terminalIconsEqual=T;function R(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=R}),define(pe[230],ve([0,1,40,178,52,33,229]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(b.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(b.Codicon.getAll(),l=>`$(${l.id})`)};const E={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...E}},S={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...E}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),I=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...E}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...E}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...E}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...E}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.Registry.as(D.Extensions.Configuration).registerConfiguration(y),u()}e.registerTerminalPlatformConfiguration=d;let g;function u(l,f){const r=C.Registry.as(D.Extensions.Configuration);let o;l&&(o=(0,k.createProfileSchemaEnums)(l?.profiles,f));const n=g;g={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?o?.values:void 0,markdownEnumDescriptions:l?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?o?.values:void 0,markdownEnumDescriptions:l?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?o?.values:void 0,markdownEnumDescriptions:l?.os===1?o?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[g],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(pe[231],ve([0,1,49,40,6,3,21,92,227,112]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function w(o,n,i,s,a=process.env,c,m,P,_){return c=c||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},C.isWindows?v(i,c,a,m,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),_,P):l(c,m,i,o&&typeof o=="object"?{...o}:s.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,P,a)}e.detectAvailableProfiles=w;async function v(o,n,i,s,a,c,m,P,_){const W=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),K=`${process.env.windir}\\${W?"Sysnative":"System32"}`;let se=!1;(0,p.getWindowsBuildNumber)()>=16299&&(se=!0),await y(P);const F=new Map;o&&(F.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${K}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),F.set("Command Prompt",{path:`${K}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),f(c,F);const Q=await h(F.entries(),m,n,i,s,_);if(o||!o&&a)try{const re=await g(`${K}\\${se?"wsl":"bash"}.exe`,m);for(const G of re)(!c||!(G.profileName in c))&&Q.push(G)}catch{R&&(s?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return Q}async function h(o,n,i,s=process.env,a,c){const m=[];for(const[P,_]of o){if(_===null)continue;let W,K,se;if("source"in _){const re=T?.get(_.source);if(!re)continue;W=re.paths,K=_.args||re.args,_.icon?se=I(_.icon):re.icon&&(se=re.icon)}else W=Array.isArray(_.path)?_.path:[_.path],K=C.isWindows||Array.isArray(_.args)?_.args:void 0,se=I(_.icon);const F=await c?.(W)||W.slice(),Q=await r(P,n,F,i,s,K,_.env,_.overrideName,_.isAutoDetected,a);Q?(Q.isAutoDetected=_.isAutoDetected,Q.icon=se,Q.color=_.color,m.push(Q)):a?.debug("Terminal profile not validated",P,W)}return a?.debug("Validated terminal profiles",m),m}function I(o){return typeof o=="string"?{id:o}:o}async function y(o){T&&!o||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:o||await d(),icon:S.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function d(){const o=[];for await(const n of(0,E.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function g(o,n){const i=[],s=await new Promise((m,P)=>{b.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,W)=>{if(_)return P("Problem occurred when getting wsl distros");m(W)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),c=s.split(a).filter(m=>m.trim().length>0&&m!=="");for(const m of c){if(m===""||m.startsWith("docker-desktop"))continue;const P=`${m} (WSL)`,_={profileName:P,path:o,args:["-d",`${m}`],isDefault:P===n,icon:u(m),isAutoDetected:!1};i.push(_)}return i}function u(o){return o.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):o.includes("Debian")?S.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(o,n,i,s,a,c,m,P){const _=new Map;if(i){const W=(await o.readFile("/etc/shells")).toString(),K=c||W.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),se=new Map;for(const F of K){let Q=(0,D.basename)(F),re=se.get(Q)||0;re++,re>1&&(Q=`${Q} (${re})`),se.set(Q,re),_.set(Q,{path:F,isAutoDetected:!0})}}return f(s,_),await h(_.entries(),a,o,P,n,m)}function f(o,n){if(!!o)for(const[i,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(i):(s.icon=s.icon||n.get(i)?.icon,n.set(i,s))}async function r(o,n,i,s,a,c,m,P,_,W){if(i.length===0)return Promise.resolve(void 0);const K=i.shift();if(K==="")return r(o,n,i,s,a,c,m,P,_);const se={profileName:o,path:K,args:c,env:m,overrideName:P,isAutoDetected:_,isDefault:o===n};if((0,D.basename)(K)===K){const Q=a.PATH?a.PATH.split(D.delimiter):void 0,re=await(0,p.findExecutable)(K,void 0,Q,void 0,s.existsFile);return re?(se.path=re,se.isFromPath=!0,se):r(o,n,i,s,a,c)}return await s.existsFile((0,D.normalize)(K))?se:r(o,n,i,s,a,c,m,P,_)}}),define(pe[232],ve([0,1,7,2,10,3,42,96,25,26,97,77,13,102,226,111,230,231]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let u=0,l=class extends t.Disposable{constructor(r,o,n,i){super();this._reconnectConstants=r,this._configurationService=o,this._environmentService=n,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new b.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new b.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new b.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new b.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new b.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new b.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new b.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new b.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new b.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new b.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new b.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new b.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(C.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?r.debugBrk=o.port:!o.break&&o.port&&(r.debug=o.port));const n=new E.Client(D.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,r);this._onPtyHostStart.fire(),k.ProxyChannel.toService(n.getChannel(I.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(c=>{this._onPtyHostExit.fire(c.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const s=n.getChannel(I.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const a=k.ProxyChannel.toService(n.getChannel(I.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(c=>this._onProcessData.fire(c))),this._register(a.onProcessReady(c=>this._onProcessReady.fire(c))),this._register(a.onProcessExit(c=>this._onProcessExit.fire(c))),this._register(a.onDidChangeProperty(c=>this._onDidChangeProperty.fire(c))),this._register(a.onProcessReplay(c=>this._onProcessReplay.fire(c))),this._register(a.onProcessOrphanQuestion(c=>this._onProcessOrphanQuestion.fire(c))),this._register(a.onDidRequestDetach(c=>this._onDidRequestDetach.fire(c))),[n,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,o,n,i,s,a,c,m,P,_,W){const K=setTimeout(()=>this._handleUnresponsiveCreateProcess(),I.HeartbeatConstants.CreateProcessTimeout),se=await this._proxy.createProcess(r,o,n,i,s,a,c,m,P,_,W);return clearTimeout(K),u=Math.max(u,se),se}updateTitle(r,o,n){return this._proxy.updateTitle(r,o,n)}updateIcon(r,o,n){return this._proxy.updateIcon(r,o,n)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r,o){return this._proxy.detachFromProcess(r,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,o){return this._proxy.shutdown(r,o)}input(r,o){return this._proxy.input(r,o)}processBinary(r,o){return this._proxy.processBinary(r,o)}resize(r,o,n){return this._proxy.resize(r,o,n)}acknowledgeDataEvent(r,o){return this._proxy.acknowledgeDataEvent(r,o)}setUnicodeVersion(r,o){return this._proxy.setUnicodeVersion(r,o)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,o){return this._proxy.installAutoReply(r,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,o,n,i=!1){const s=await this._shellEnv;return(0,d.detectAvailableProfiles)(o,n,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}getRevivedPtyNewId(r){return this._proxy.getRevivedPtyNewId(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,o){return this._proxy.requestDetachInstance(r,o)}async acceptDetachInstanceReply(r,o){return this._proxy.acceptDetachInstanceReply(r,o)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,o){return this._proxy.reviveTerminalProcesses(r,o)}async refreshProperty(r,o){return this._proxy.refreshProperty(r,o)}async updateProperty(r,o,n){return this._proxy.updateProperty(r,o,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier+I.HeartbeatConstants.BeatInterval*I.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${I.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:o})}async acceptPtyHostResolvedVariables(r,o){this._resolveVariablesRequestStore.acceptReply(r,o)}};l=Re([_e(1,p.IConfigurationService),_e(2,S.IEnvironmentService),_e(3,w.ILogService)],l),e.PtyHostService=l}),define(pe[39],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,b.createDecorator)("IUriIdentityService")}),define(pe[233],ve([0,1,7,2,4,26,34,17,13,39]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(w,v,h,I,y){super();this.extensionsManagementService=w,this.logService=I,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(g=>this.onInstallExtension(g))),this._register(w.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(w.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const d=D.URI.file(h.extensionsPath);this._register(v.watch(d)),this._register(b.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(u=>this.doesChangeAffects(u,d)))(()=>this.onDidChange()))}doesChangeAffects(w,v){return w.type!==1&&w.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(w.resource),v)?!1:this.uriIdentityService.extUri.isEqual(w.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(w.resource).startsWith(".")}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtensions(w){for(const v of w)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(v=>!(0,k.areSameExtensions)(v,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,k.areSameExtensions)(v,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(),v=w.filter(I=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,k.areSameExtensions)(y,I.identifier))?!1:I.installedTimestamp&&I.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",I.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",I.identifier.id),!1)),h=this.installedExtensions.filter(I=>this.installingExtensions.some(y=>(0,k.areSameExtensions)(y,I))?!1:w.every(y=>!(0,k.areSameExtensions)(y.identifier,I))?(this.logService.info("Detected extension removed from another source",I.id),!0):!1);this.installedExtensions=w.map(I=>I.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};T=Re([_e(1,E.IFileService),_e(2,C.INativeEnvironmentService),_e(3,p.ILogService),_e(4,S.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(pe[113],ve([0,1,39,194,17,19,136,7,2]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(w){this.uri=w,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let T=class{constructor(w){this._fileService=w,this._dispooables=new p.DisposableStore,this._limit=2**16;const v=new Map,h=I=>{let y=v.get(I.scheme);return y===void 0&&(y=w.hasProvider(I)&&!this._fileService.hasCapability(I,1024),v.set(I.scheme,y)),y};this._dispooables.add(E.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(I=>{v.delete(I.scheme)})),this.extUri=new C.ExtUri(h),this._canonicalUris=new k.SkipList((I,y)=>this.extUri.compare(I,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,C.normalizePath)(w));const v=this._canonicalUris.get(w);return v?v.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new S(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((h,I)=>h[1].touch<I[1].touch?1:h[1].touch>I[1].touch?-1:0);S._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(w[h][0],w[h][1].touch())}};T=Re([_e(0,D.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(b.IUriIdentityService,T,!0)}),define(pe[78],ve([0,1,181,6,24,19,4,5,10]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function S(n){const i=n;return typeof i?.id=="string"&&k.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=S;function T(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=T;function R(n){const i=n;return typeof i?.id=="string"&&k.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=R;function w(n){const i=n;if(i?.uri)return{id:i.id,uri:k.URI.revive(i.uri)};const s=n;if(s?.configPath)return{id:s.id,configPath:k.URI.revive(s.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=w;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=h;function I(n){const i=n;return!!(i&&typeof i=="object"&&k.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=I;class y{constructor(i,s,a,c,m){this._id=i,this._transient=a,this._configuration=c,this._ignorePathCasing=m,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class d{constructor(i,s){this.raw=s,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,C.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function g(n){return new d({uri:n,index:0,name:(0,C.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(n,i){return C.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function f(n){let i;return k.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=f;function r(n,i){return!l(n,i)&&!f(n)}e.isSavedWorkspace=r;function o(n){return(typeof n=="string"?(0,t.extname)(n):(0,C.extname)(n))===u}e.hasWorkspaceFileExtension=o}),define(pe[37],ve([0,1,88,7,2,19,12,4,180,26,17,5,13,78,24,39,14,23,15]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function u(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&E.URI.isUri(n.location)&&E.URI.isUri(n.globalStorageHome)&&E.URI.isUri(n.settingsResource)&&E.URI.isUri(n.keybindingsResource)&&E.URI.isUri(n.tasksResource)&&E.URI.isUri(n.snippetsHome)&&((0,k.isUndefined)(n.extensionsResource)||E.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=u,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function l(o,n){return{id:o.id,isDefault:o.isDefault,name:o.name,location:E.URI.revive(o.location).with({scheme:n}),globalStorageHome:E.URI.revive(o.globalStorageHome).with({scheme:n}),settingsResource:E.URI.revive(o.settingsResource).with({scheme:n}),keybindingsResource:E.URI.revive(o.keybindingsResource).with({scheme:n}),tasksResource:E.URI.revive(o.tasksResource).with({scheme:n}),snippetsHome:E.URI.revive(o.snippetsHome).with({scheme:n}),extensionsResource:E.URI.revive(o.extensionsResource)?.with({scheme:n}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=l,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function f(o,n,i,s){return{id:(0,b.hash)(n.path).toString(16),name:o,location:n,isDefault:!1,globalStorageHome:(0,C.joinPath)(n,"globalStorage"),settingsResource:(0,C.joinPath)(n,"settings.json"),keybindingsResource:(0,C.joinPath)(n,"keybindings.json"),tasksResource:(0,C.joinPath)(n,"tasks.json"),snippetsHome:(0,C.joinPath)(n,"snippets"),extensionsResource:(0,C.joinPath)(n,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i,isTransient:s}}e.toUserDataProfile=f;let r=class extends D.Disposable{constructor(n,i,s,a){super();this.environmentService=n,this.fileService=i,this.uriIdentityService=s,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(c=>f(c.name,c.location,c.useDefaultFlags)):[];let i;const s=new h.ResourceMap,a=f((0,p.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),n.length){const c=this.getStoredProfileAssociations();if(c.workspaces)for(const[m,P]of Object.entries(c.workspaces)){const _=E.URI.parse(m),W=E.URI.parse(P),K=n.find(se=>this.uriIdentityService.extUri.isEqual(se.location,W));K&&s.set(_,K)}if(c.emptyWindow){const m=E.URI.parse(c.emptyWindow);i=n.find(P=>this.uriIdentityService.extUri.isEqual(P.location,m))}}this._profilesObject={profiles:n,workspaces:s,emptyWindow:i}}return this._profilesObject}async createTransientProfile(n){const i="Temp",s=new RegExp(`${(0,g.escapeRegExpCharacters)(i)}\\s(\\d+)`);let a=0;for(const m of this.profiles){const P=s.exec(m.name),_=P?parseInt(P[1]):0;a=_>a?_:a}const c=`${i} ${a+1}`;return this.createProfile(c,void 0,n,!0)}async createProfile(n,i,s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=await this.doCreateProfile(n,i,a);return s&&await this.setProfileForWorkspace(s,c),c}async doCreateProfile(n,i,s){let a=this.profileCreationPromises.get(n);return a||(a=(async()=>{try{const c=this.profiles.find(_=>_.name===n);if(c)return c;const m=f(n,(0,C.joinPath)(this.profilesHome,(0,b.hash)((0,d.generateUuid)()).toString(16)),i,s);await this.fileService.createFolder(m.location);const P=[];return this._onWillCreateProfile.fire({profile:m,join(_){P.push(_)}}),await y.Promises.settled(P),this.updateProfiles([m],[],[]),m}finally{this.profileCreationPromises.delete(n)}})(),this.profileCreationPromises.set(n,a)),a}async updateProfile(n,i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(c=>c.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=f(i,a.location,s),this.updateProfiles([],[],[a]),a}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(a=>a.id===n.id);if(!i)throw new Error(`Profile '${n.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:i,join(a){s.push(a)}}),await y.Promises.settled(s),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(n,i=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(n);return s||(s=i,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,s)),s}async setProfileForWorkspace(n,i){this.setProfileForWorkspaceSync(n,i)}setProfileForWorkspaceSync(n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(a=>a.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);this.updateWorkspaceAssociation(n,s)}unsetWorkspace(n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,i)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(i=>i.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,i.resource))).map(i=>this.fileService.del(i.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(i=>!this.isProfileAssociatedToWorkspace(i));await Promise.allSettled(n.map(i=>this.removeProfile(i)))}getProfileForWorkspace(n){const i=this.getWorkspace(n);return E.URI.isUri(i)?this.transientProfilesObject.workspaces.get(i)??this.profilesObject.workspaces.get(i):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,n.location)))}updateProfiles(n,i,s){const a=[...this.profiles,...n],c=[];this.transientProfilesObject.profiles=[];for(let m of a)m.isDefault||i.some(P=>m.id===P.id)||(m=s.find(P=>m.id===P.id)??m,m.isTransient?this.transientProfilesObject.profiles.push(m):c.push({location:m.location,name:m.name,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(c),this._profilesObject=void 0,this.triggerProfilesChanges(n,i,s)}triggerProfilesChanges(n,i,s){this._onDidChangeProfiles.fire({added:n,removed:i,updated:s,all:this.profiles})}updateWorkspaceAssociation(n,i,s){s=i?.isTransient?!0:s,s||this.updateWorkspaceAssociation(n,void 0,!0);const a=this.getWorkspace(n),c=s?this.transientProfilesObject:this.profilesObject;E.URI.isUri(a)?(c.workspaces.delete(a),i&&c.workspaces.set(a,i)):c.emptyWindow=i,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[s,a]of this.profilesObject.workspaces.entries())n[s.toString()]=a.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};r.PROFILES_KEY="userDataProfiles",r.PROFILE_ASSOCIATIONS_KEY="profileAssociations",r=Re([_e(0,S.IEnvironmentService),_e(1,T.IFileService),_e(2,I.IUriIdentityService),_e(3,w.ILogService)],r),e.UserDataProfilesService=r}),define(pe[234],ve([0,1,18,14,20,11,7,2,3,4,161,31,34,36,13,27,32,37]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends E.Disposable{constructor(n,i,s,a,c){super();this.galleryService=n,this.telemetryService=i,this.logService=s,this.productService=a,this.userDataProfilesService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(m=>m.cancel()),this.uninstallingExtensions.forEach(m=>m.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const i=await this.getTargetPlatform();return n.allTargetPlatforms.some(s=>(0,R.isTargetPlatformCompatible)(s,n.allTargetPlatforms,i))}async installFromGallery(n,i={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(T.localize(0,null),R.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(n,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,i)}catch(s){throw f(this.telemetryService,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(n),error:s}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(s),l(s)}}async uninstall(n,i={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,i)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const i=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:i,compatible:!0},D.CancellationToken.None);if(!s)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,i,s){const a=W=>`${w.ExtensionKey.create(W).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!S.URI.isUri(i)){const W=this.installingExtensions.get(a(i));if(W){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:K}=await W.waitUntilTaskIsFinished();return K}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const c=[],m=[],P=this.createInstallExtensionTask(n,i,s);S.URI.isUri(i)||this.installingExtensions.set(a(i),P),this._onInstallExtension.fire({identifier:P.identifier,source:i,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",P.identifier.id),c.push({task:P,manifest:n});let _=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const K=await this.getAllDepsAndPackExtensionsToInstall(P.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation);for(const{gallery:se,manifest:F}of K){_=_||!!F.extensionDependencies?.some(re=>(0,w.areSameExtensions)({id:re},P.identifier));const Q=a(se);if(this.installingExtensions.has(Q))this.logService.info("Extension is already requested to install",se.identifier.id);else{const re=this.createInstallExtensionTask(F,se,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(Q,re),this._onInstallExtension.fire({identifier:re.identifier,source:se,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",re.identifier.id),c.push({task:re,manifest:F})}}}catch(K){if(S.URI.isUri(P.source))(0,b.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",P.identifier.id,K.message),(0,b.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",P.identifier.id,K.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),K}const W=c.reduce((K,{task:se,manifest:F})=>(K.set(se.identifier.id.toLowerCase(),{task:se,manifest:F}),K),new Map);for(;W.size;){let K;const se=[...W.values()].filter(({manifest:F})=>!F.extensionDependencies?.some(Q=>W.has(Q.toLowerCase())));se.length?K=W.size===1?se:se.filter(({task:F})=>!(F===P&&!_)):(this.logService.info("Found extensions with circular dependencies",se.map(({task:F})=>F.identifier.id)),K=[...W.values()]),await this.joinAllSettled(K.map(async({task:F})=>{const Q=new Date().getTime();try{const{local:re}=await F.run();if(await this.joinAllSettled(this.participants.map(G=>G.postInstall(re,F.source,s,D.CancellationToken.None))),!S.URI.isUri(F.source)){const G=F.operation===3,de=G?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(f(this.telemetryService,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-Q,durationSinceUpdate:de}),p.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}m.push({local:re,identifier:F.identifier,operation:F.operation,source:F.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw S.URI.isUri(F.source)||f(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-Q,error:re}),this.logService.error("Error while installing the extension:",F.identifier.id),re}finally{W.delete(F.identifier.id.toLowerCase())}}))}return m.forEach(({identifier:K})=>this.logService.info("Extension installed successfully:",K.id)),this._onDidInstallExtensions.fire(m),m.filter(({identifier:K})=>(0,w.areSameExtensions)(K,P.identifier))[0].local}catch(W){if(c.forEach(({task:K})=>K.cancel()),m.length)try{const K=await Promise.allSettled(m.map(({local:se})=>this.createUninstallExtensionTask(se,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let se=0;se<K.length;se++){const F=K[se],{identifier:Q}=m[se];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Q.id):this.logService.warn("Rollback: Error while uninstalling extension",Q.id,(0,C.getErrorMessage)(F.reason))}}catch(K){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(K),m.map(({identifier:se})=>se.id))}throw this._onDidInstallExtensions.fire(c.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:s.context,profileLocation:s.profileLocation}))),W}finally{for(const{task:W}of c)if(!S.URI.isUri(W.source)){const K=a(W.source);this.installingExtensions.delete(K)||this.logService.warn("Installation task is not found in the cache",K)}}}async joinAllSettled(n){const i=[],s=[],a=await Promise.allSettled(n);for(const c of a)c.status==="fulfilled"?i.push(c.value):s.push(c.reason);if(s.length)throw u(s);return i}async getAllDepsAndPackExtensionsToInstall(n,i,s,a,c){if(!this.galleryService.isEnabled())return[];let m=await this.getInstalled(void 0,c);const P=[n,...m.map(K=>K.identifier)],_=[],W=async(K,se)=>{const F=se.extensionDependencies||[],Q=[...F];if(se.extensionPack){const re=s?m.find(G=>(0,w.areSameExtensions)(G.identifier,K)):void 0;for(const G of se.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(de=>(0,w.areSameExtensions)({id:de},{id:G}))||Q.every(de=>!(0,w.areSameExtensions)({id:de},{id:G}))&&Q.push(G)}if(Q.length){const re=[...P,..._.map(de=>de.gallery.identifier)],G=Q.filter(de=>re.every(J=>!(0,w.areSameExtensions)(J,{id:de})));if(G.length){const de=await this.galleryService.getExtensions(G.map(J=>({id:J,preRelease:a})),D.CancellationToken.None);for(const J of de){if(re.find(B=>(0,w.areSameExtensions)(B,J.identifier)))continue;const U=F.some(B=>(0,w.areSameExtensions)({id:B},J.identifier));let O;try{O=await this.checkAndGetCompatibleVersion(J,!1,a)}catch(B){if(B instanceof R.ExtensionManagementError&&B.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",J.identifier.id);continue}else throw B}_.push({gallery:O.extension,manifest:O.manifest}),await W(O.extension.identifier,O.manifest)}}}};return await W(n,i),m=await this.getInstalled(void 0,c),_.filter(K=>!m.some(se=>(0,w.areSameExtensions)(se.identifier,K.gallery.identifier)))}async checkAndGetCompatibleVersion(n,i,s){if((await this.getExtensionsControlManifest()).malicious.some(P=>(0,w.areSameExtensions)(n.identifier,P)))throw new R.ExtensionManagementError(T.localize(3,null,n.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const P=await this.getTargetPlatform();throw new R.ExtensionManagementError(T.localize(4,null,n.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(P)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(n,i,s);if(c){if(s&&!i&&n.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(T.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],D.CancellationToken.None))[0]?new R.ExtensionManagementError(T.localize(6,null,n.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(T.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const m=await this.galleryService.getManifest(c,D.CancellationToken.None);if(m===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(m.version!==c.version)throw new R.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:m}}async getCompatibleVersion(n,i,s){const a=await this.getTargetPlatform();let c=null;return!i&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==s&&(c=(await this.galleryService.getExtensions([{...n.identifier,preRelease:s}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!c&&await this.galleryService.isExtensionCompatible(n,s,a)&&(c=n),c||(i?c=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:c=await this.galleryService.getCompatibleExtension(n,s,a)),c}async uninstallExtension(n,i){const s=W=>`${W.id.toLowerCase()}${i.versionOnly?`-${n.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(s(n.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),a.waitUntilTaskIsFinished();const c=(W,K)=>{const se=this.createUninstallExtensionTask(W,K);return this.uninstallingExtensions.set(s(se.extension.identifier),se),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${W.identifier.id}@${W.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${W.identifier.id}@${W.manifest.version}`),this._onUninstallExtension.fire({identifier:W.identifier,profileLocation:i.profileLocation,applicationScoped:W.isApplicationScoped}),se},m=(W,K)=>{K?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${W.identifier.id}@${W.manifest.version}`,i.profileLocation.toString(),K.message):this.logService.error("Failed to uninstall extension:",`${W.identifier.id}@${W.manifest.version}`,K.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${W.identifier.id}@${W.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${W.identifier.id}@${W.manifest.version}`),f(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(W),error:K}),this._onDidUninstallExtension.fire({identifier:W.identifier,version:W.manifest.version,error:K?.code,profileLocation:i.profileLocation,applicationScoped:W.isApplicationScoped})},P=[],_=[];try{P.push(c(n,i));const W=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const K=this.getAllPackExtensionsToUninstall(n,W);for(const se of K)this.uninstallingExtensions.has(s(se.identifier))?this.logService.info("Extensions is already requested to uninstall",se.identifier.id):P.push(c(se,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(P.map(K=>K.extension),W,n),await this.joinAllSettled(P.map(async K=>{try{if(await K.run(),await this.joinAllSettled(this.participants.map(se=>se.postUninstall(K.extension,i,D.CancellationToken.None))),K.extension.identifier.uuid)try{await this.galleryService.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,"uninstall")}catch{}m(K.extension)}catch(se){const F=se instanceof R.ExtensionManagementError?se:new R.ExtensionManagementError((0,C.getErrorMessage)(se),R.ExtensionManagementErrorCode.Internal);throw m(K.extension,F),F}finally{_.push(K)}}))}catch(W){const K=W instanceof R.ExtensionManagementError?W:new R.ExtensionManagementError((0,C.getErrorMessage)(W),R.ExtensionManagementErrorCode.Internal);for(const se of P){try{se.cancel()}catch{}_.includes(se)||m(se.extension,K)}throw K}finally{for(const W of P)this.uninstallingExtensions.delete(s(W.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",W.extension.identifier.id)}}checkForDependents(n,i,s){for(const a of n){const c=this.getDependents(a,i);if(c.length){const m=c.filter(P=>!n.some(_=>(0,w.areSameExtensions)(_.identifier,P.identifier)));if(m.length)throw new Error(this.getDependentsErrorMessage(a,m,s))}}}getDependentsErrorMessage(n,i,s){return s===n?i.length===1?T.localize(8,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?T.localize(9,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):T.localize(10,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?T.localize(11,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?T.localize(12,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):T.localize(13,null,s.manifest.displayName||s.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(n,i,s=[]){if(s.indexOf(n)!==-1)return[];s.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const c=i.filter(P=>!P.isBuiltin&&a.some(_=>(0,w.areSameExtensions)({id:_},P.identifier))),m=[];for(const P of c)m.push(...this.getAllPackExtensionsToUninstall(P,i,s));return[...c,...m]}return[]}getDependents(n,i){return i.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(a=>(0,w.areSameExtensions)({id:a},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,i,s){return s.profileLocation&&(0,v.isApplicationScopedExtension)(n)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,i,s)}createUninstallExtensionTask(n,i){return i.profileLocation&&n.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,i)}};g=Re([_e(0,R.IExtensionGalleryService),_e(1,y.ITelemetryService),_e(2,h.ILogService),_e(3,I.IProductService),_e(4,d.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function u(o){const n=Array.isArray(o)?o:[o];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((i,s)=>new Error(`${i.message}${i.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=u;function l(o){if(o instanceof R.ExtensionManagementError)return o;const n=new R.ExtensionManagementError(o.message,R.ExtensionManagementErrorCode.Internal);return n.stack=o.stack,n}function f(o,n,{extensionData:i,duration:s,error:a,durationSinceUpdate:c}){const m=a?a instanceof R.ExtensionManagementError?a.code:R.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(n,{...i,success:!a,duration:s,errorcode:m,durationSinceUpdate:c})}e.reportTelemetry=f;class r{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((i,s)=>{const a=n.onCancellationRequested(()=>{a.dispose(),s(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(pe[55],ve([0,1,18,14,22,16,11,65,144,2,10,6,3,19,50,67,12,4,165,26,34,36,70,17,5,13,27,7,41,53,37,39,192]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f,r,o,n,i,s,a,c,m,P,_,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(J){function U(O,B){if(O===B)return!0;const X=Object.keys(O),ce=new Set;for(const ue of Object.keys(B))ce.add(ue);if(X.length!==ce.size)return!1;for(const ue of X){if(O[ue]!==B[ue])return!1;ce.delete(ue)}return ce.size===0}J.equals=U})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let se=class extends S.Disposable{constructor(U,O,B,X,ce,ue,Y,ie,L,N,q){super();this.systemExtensionsLocation=U,this.userExtensionsLocation=O,this.extensionsControlLocation=B,this.cacheLocation=X,this.userDataProfilesService=ce,this.extensionsProfileScannerService=ue,this.fileService=Y,this.logService=ie,this.environmentService=L,this.productService=N,this.instantiationService=q,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,v.joinPath)(this.cacheLocation,f.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,v.joinPath)(this.cacheLocation,f.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Q,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(U,O,B){const[X,ce]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions(O)]),ue=B?await this.scanExtensionsUnderDevelopment(U,[...X,...ce]):[];return this.dedupExtensions(X,ce,ue,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const O=[];O.push(this.scanDefaultSystemExtensions(!!U.useCache,U.language)),O.push(this.scanDevSystemExtensions(U.language,!!U.checkControlFile));const[B,X]=await Promise.all(O);return this.applyScanOptions([...B,...X],0,U,!1)}async scanUserExtensions(U){this.logService.trace("Started scanning user extensions");const O=await this.createExtensionScannerInput(U.profileLocation??this.userExtensionsLocation,!!U.profileLocation,1,!U.includeUninstalled,U.language);let X=await(U.useCache&&!O.devMode&&O.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(O);return X=await this.applyScanOptions(X,1,U,!0),this.logService.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(U,O){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(X=>X.scheme===T.Schemas.file).map(async X=>{const ce=await this.createExtensionScannerInput(X,!1,1,!0,U.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ce)).map(Y=>(Y.type=O.find(ie=>(0,l.areSameExtensions)(ie.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,ce)))}))).flat();return this.applyScanOptions(B,"development",U,!0)}return[]}async scanExistingExtension(U,O,B){const X=await this.createExtensionScannerInput(U,!1,O,!0,B.language),ce=await this.extensionsScanner.scanExtension(X);return!ce||!B.includeInvalid&&!ce.isValid?null:ce}async scanOneOrMultipleExtensions(U,O,B){const X=await this.createExtensionScannerInput(U,!1,O,!0,B.language),ce=await this.extensionsScanner.scanOneOrMultipleExtensions(X);return this.applyScanOptions(ce,O,B,!0)}async scanMetadata(U){const O=(0,v.joinPath)(U,"package.json"),B=(await this.fileService.readFile(O)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(U,O){const B=(0,v.joinPath)(U,"package.json"),X=(await this.fileService.readFile(B)).value.toString(),ce=JSON.parse(X);O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0,ce.__metadata={...ce.__metadata,...O},await this.fileService.writeFile((0,v.joinPath)(U,"package.json"),C.VSBuffer.fromString(JSON.stringify(ce,null,"	")))}async applyScanOptions(U,O,B,X){return B.includeAllVersions||(U=this.dedupExtensions(O===0?U:void 0,O===1?U:void 0,O==="development"?U:void 0,await this.getTargetPlatform(),X)),B.includeInvalid||(U=U.filter(ce=>ce.isValid)),U.sort((ce,ue)=>{const Y=R.basename(ce.location.fsPath),ie=R.basename(ue.location.fsPath);return Y<ie?-1:Y>ie?1:0})}dedupExtensions(U,O,B,X,ce){const ue=(ie,L,N)=>{if(ie.isValid&&!L.isValid)return!1;if(ie.isValid===L.isValid){if(ce&&h.gt(ie.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(h.eq(ie.manifest.version,L.manifest.version)){if(ie.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===X)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${ie.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${ie.location.path} with ${L.location.path}.`),!0},Y=new Map;return U?.forEach(ie=>{const L=f.ExtensionIdentifier.toKey(ie.identifier.id),N=Y.get(L);(!N||ue(N,ie,!1))&&Y.set(L,ie)}),O?.forEach(ie=>{const L=f.ExtensionIdentifier.toKey(ie.identifier.id),N=Y.get(L);if(!N&&U&&ie.type===0){this.logService.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!N||ue(N,ie,!1))&&Y.set(L,ie)}),B?.forEach(ie=>{const L=f.ExtensionIdentifier.toKey(ie.identifier.id),N=Y.get(L);(!N||ue(N,ie,!0))&&Y.set(L,ie),Y.set(L,ie)}),[...Y.values()]}async scanDefaultSystemExtensions(U,O){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,O),ce=await(U&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",ce.length),ce}async scanDevSystemExtensions(U,O){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const X=O?await this.getBuiltInExtensionControl():{},ce=[],ue=d.URI.file(R.normalize(R.join(T.FileAccess.asFileUri("",oe).fsPath,"..",".build","builtInExtensions")));for(const ie of B){const L=X[ie.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":ce.push((0,v.joinPath)(ue,ie.name));break;default:ce.push(d.URI.file(L));break}}const Y=await Promise.all(ce.map(async ie=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ie,!1,0,!0,U))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,b.coalesce)(Y)}async getBuiltInExtensionControl(){try{const U=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(U.value.toString())}catch{return{}}}async createExtensionScannerInput(U,O,B,X,ce,ue=!0){const Y=await this.getTranslations(ce??w.language),ie=await this.getMtime(U),L=O?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=L?await this.getMtime(L):void 0;return new F(U,ie,L,N,O,B,X,ue,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ce,Y)}async getMtime(U){try{const O=await this.fileService.stat(U);if(typeof O.mtime=="number")return O.mtime}catch{}}};se=Re([_e(4,P.IUserDataProfilesService),_e(5,m.IExtensionsProfileScannerService),_e(6,o.IFileService),_e(7,i.ILogService),_e(8,u.IEnvironmentService),_e(9,s.IProductService),_e(10,n.IInstantiationService)],se),e.AbstractExtensionsScannerService=se;class F{constructor(U,O,B,X,ce,ue,Y,ie,L,N,q,te,fe,ye){this.location=U,this.mtime=O,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=X,this.profile=ce,this.type=ue,this.excludeObsolete=Y,this.validate=ie,this.productVersion=L,this.productDate=N,this.productCommit=q,this.devMode=te,this.language=fe,this.translations=ye}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,O){return(0,v.isEqual)(U.location,O.location)&&U.mtime===O.mtime&&(0,v.isEqual)(U.applicationExtensionslocation,O.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===O.applicationExtensionslocationMtime&&U.profile===O.profile&&U.type===O.type&&U.excludeObsolete===O.excludeObsolete&&U.validate===O.validate&&U.productVersion===O.productVersion&&U.productDate===O.productDate&&U.productCommit===O.productCommit&&U.devMode===O.devMode&&U.language===O.language&&K.equals(U.translations,O.translations)}}let Q=class extends S.Disposable{constructor(U,O,B,X,ce){super();this.obsoleteFile=U,this.extensionsProfileScannerService=O,this.uriIdentityService=B,this.fileService=X,this.logService=ce}async scanExtensions(U){const O=U.profile?await this.scanExtensionsFromProfile(U):await this.scanExtensionsFromLocation(U);let B={};if(U.excludeObsolete&&U.type===1)try{const X=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(X)}catch{}return(0,y.isEmptyObject)(B)?O:O.filter(X=>!B[l.ExtensionKey.create(X).toString()])}async scanExtensionsFromLocation(U){const O=await this.fileService.resolve(U.location);if(!O.children?.length)return[];const B=await Promise.all(O.children.map(async X=>{if(!X.isDirectory||U.type===1&&(0,v.basename)(X.resource).indexOf(".")===0)return null;const ce=new F(X.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ce)}));return(0,b.coalesce)(B).sort((X,ce)=>X.location.path<ce.location.path?-1:1)}async scanExtensionsFromProfile(U){let O=await this.scanExtensionsFromProfileResource(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(U.location,U.applicationExtensionslocation)){O=O.filter(X=>!X.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(U.applicationExtensionslocation,X=>!!X.metadata?.isApplicationScoped,U);O.push(...B)}return O}async scanExtensionsFromProfileResource(U,O,B){const X=await this.extensionsProfileScannerService.scanProfileExtensions(U);if(!X.length)return[];const ce=await Promise.all(X.map(async ue=>{if(O(ue)){const Y=new F(ue.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,ue.metadata)}return null}));return(0,b.coalesce)(ce)}async scanOneOrMultipleExtensions(U){try{if(await this.fileService.exists((0,v.joinPath)(U.location,"package.json"))){const O=await this.scanExtension(U);return O?[O]:[]}else return await this.scanExtensions(U)}catch(O){return this.logService.error(`Error scanning extensions at ${U.location.path}:`,(0,k.getErrorMessage)(O)),[]}}async scanExtension(U,O){try{let B=await this.scanExtensionManifest(U.location);if(B){B.publisher||(B.publisher=f.UNDEFINED_PUBLISHER),O=O??B.__metadata,delete B.__metadata;const X=(0,l.getGalleryExtensionId)(B.publisher,B.name),ce=O?.id?{id:X,uuid:O.id}:{id:X},ue=O?.isSystem?0:U.type,Y=ue===0||!!O?.isBuiltin;B=await this.translateManifest(U.location,B,F.createNlsConfiguration(U));const ie={type:ue,identifier:ce,manifest:B,location:U.location,isBuiltin:Y,targetPlatform:O?.targetPlatform??"undefined",metadata:O,isValid:!0,validations:[]};return U.validate?this.validate(ie,U):ie}}catch(B){U.type!==0&&this.logService.error(B)}return null}validate(U,O){let B=!0;const X=(0,r.validateExtensionManifest)(O.productVersion,O.productDate,O.location,U.manifest,U.isBuiltin);for(const[ce,ue]of X)ce===I.default.Error&&(B=!1,this.logService.error(this.formatMessage(O.location,ue)));return U.isValid=B,U.validations=X,U}async scanExtensionManifest(U){const O=(0,v.joinPath)(U,"package.json");let B;try{B=(await this.fileService.readFile(O)).value.toString()}catch(ce){return(0,o.toFileOperationResult)(ce)!==1&&this.logService.error(this.formatMessage(U,(0,g.localize)(0,null,O.path,ce.message))),null}let X;try{X=JSON.parse(B)}catch{const ue=[];(0,E.parse)(B,ue);for(const Y of ue)this.logService.error(this.formatMessage(U,(0,g.localize)(1,null,O.path,Y.offset,Y.length,(0,p.getParseErrorMessage)(Y.error))));return null}return(0,E.getNodeType)(X)!=="object"?(this.logService.error(this.formatMessage(U,(0,g.localize)(2,null,O.path))),null):X}async translateManifest(U,O,B){const X=await this.getLocalizedMessages(U,O,B);if(X)try{const ce=[],ue=await this.resolveOriginalMessageBundle(X.default,ce);if(ce.length>0)return ce.forEach(ie=>{this.logService.error(this.formatMessage(U,(0,g.localize)(3,null,X.default?.path,(0,p.getParseErrorMessage)(ie.error))))}),O;if((0,E.getNodeType)(X)!=="object")return this.logService.error(this.formatMessage(U,(0,g.localize)(4,null,X.default?.path))),O;const Y=X.values||Object.create(null);return(0,W.localizeManifest)(O,Y,ue)}catch{}return O}async getLocalizedMessages(U,O,B){const X=(0,v.joinPath)(U,"package.nls.json"),ce=(L,N)=>{N.forEach(q=>{this.logService.error(this.formatMessage(U,(0,g.localize)(5,null,L?.path,(0,p.getParseErrorMessage)(q.error))))})},ue=L=>{this.logService.error(this.formatMessage(U,(0,g.localize)(6,null,L?.path)))},Y=`${O.publisher}.${O.name}`,ie=B.translations[Y];if(ie)try{const L=d.URI.file(ie),N=(await this.fileService.readFile(L)).value.toString(),q=[],te=(0,E.parse)(N,q);return q.length>0?(ce(L,q),{values:void 0,default:X}):(0,E.getNodeType)(te)!=="object"?(ue(L),{values:void 0,default:X}):{values:te.contents?te.contents.package:void 0,default:X}}catch{return{values:void 0,default:X}}else{if(!await this.fileService.exists(X))return;let N;try{N=await this.findMessageBundles(U,B)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const q=(await this.fileService.readFile(N.localized)).value.toString(),te=[],fe=(0,E.parse)(q,te);return te.length>0?(ce(N.localized,te),{values:void 0,default:N.original}):(0,E.getNodeType)(fe)!=="object"?(ue(N.localized),{values:void 0,default:N.original}):{values:fe,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(U,O){if(U)try{const B=(await this.fileService.readFile(U)).value.toString();return(0,E.parse)(B,O)}catch{}}findMessageBundles(U,O){return new Promise((B,X)=>{const ce=ue=>{const Y=(0,v.joinPath)(U,`package.nls.${ue}.json`);this.fileService.exists(Y).then(ie=>{ie&&B({localized:Y,original:(0,v.joinPath)(U,"package.nls.json")});const L=ue.lastIndexOf("-");L===-1?B({localized:(0,v.joinPath)(U,"package.nls.json"),original:null}):(ue=ue.substring(0,L),ce(ue))})};if(O.devMode||O.pseudo||!O.language)return B({localized:(0,v.joinPath)(U,"package.nls.json"),original:null});ce(O.language)})}formatMessage(U,O){return`[${U.path}]: ${O}`}};Q=Re([_e(1,m.IExtensionsProfileScannerService),_e(2,_.IUriIdentityService),_e(3,o.IFileService),_e(4,i.ILogService)],Q);let re=class extends Q{constructor(U,O,B,X,ce,ue){super(O,B,X,ce,ue);this.cacheFile=U,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(U){const O=await this.readExtensionCache();if(this.input=U,O&&O.input&&F.equals(O.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),O.result.map(X=>(X.location=d.URI.revive(X.location),X));const B=await super.scanExtensions(U);return await this.writeExtensionCache({input:U,result:B}),B}async readExtensionCache(){try{const U=await this.fileService.readFile(this.cacheFile),O=JSON.parse(U.value.toString());return{result:O.result,input:(0,c.revive)(O.input)}}catch(U){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(U))}return null}async writeExtensionCache(U){try{await this.fileService.writeFile(this.cacheFile,C.VSBuffer.fromString(JSON.stringify(U)))}catch(O){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(O))}}async validateCache(){if(!this.input)return;const U=await this.readExtensionCache();if(!U)return;const O=U.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(B,O))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(X){this.logService.error(X)}}};re=Re([_e(2,m.IExtensionsProfileScannerService),_e(3,_.IUriIdentityService),_e(4,o.IFileService),_e(5,i.ILogService)],re);function G(J,U){const O=(0,l.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:O,identifier:new f.ExtensionIdentifier(O),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:U,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=G;class de extends se{constructor(U,O,B,X,ce,ue,Y,ie,L,N,q){super(U,O,(0,v.joinPath)(B,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(X,f.MANIFEST_CACHE_FOLDER),ce,ue,Y,ie,L,N,q);this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const te=await this.fileService.readFile(d.URI.file(w.translationsConfigFile));return JSON.parse(te.value.toString())}catch{}return Object.create(null)})()}getTranslations(U){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(pe[235],ve([0,1,49,14,38,7,2,10,6,21,13,37]),function(oe,e,b,t,D,C,k,E,p,S,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends k.Disposable{constructor(h,I){super();this.userDataProfilesService=h,this.logService=I,this.processesLimiter=new t.Limiter(5)}async postUninstall(h){const I=this.parseScript(h,"uninstall");return I&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(I.script,"uninstall",I.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),S.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(h,I){const y=`vscode:${I}`;if(h.location.scheme===E.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const d=h.manifest.scripts[y].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,p.join)(h.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(h,I,y,d,g){return new Promise((u,l)=>{const f=this.start(h,I,y,g);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?l(n):u(void 0)};f.on("error",n=>{o((0,D.toErrorMessage)(n)||"Unknown")}),f.on("exit",(n,i)=>{o(n?`post-${I} process exited with code ${n}`:void 0)}),d&&(r=setTimeout(()=>{r=null,f.kill(),l("timed out")},5e3))})}start(h,I,y,d){const g={silent:!0,execArgv:void 0},u=(0,b.fork)(h,[`--type=extension-post-${I}`,...y],g);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const l=C.Event.fromNodeEventEmitter(u.stdout,"data"),f=C.Event.fromNodeEventEmitter(u.stderr,"data");l(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${I}`,n)),f(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${I}`,n));const r=C.Event.any(C.Event.map(l,n=>({data:`%c${n}`,format:[""]})),C.Event.map(f,n=>({data:`%c${n}`,format:["color: red"]})));return C.Event.debounce(r,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}getExtensionStoragePath(h){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};w=Re([_e(0,R.IUserDataProfilesService),_e(1,T.ILogService)],w),e.ExtensionsLifecycle=w}),define(pe[236],ve([0,1,14,7,2,47,12,154,5,37]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const T="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var R;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));class h extends D.Disposable{constructor(u={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=u,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new b.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,b.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,l){if(l===T){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:l,target:this.getKeyTargets(u)[l]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,l,f){return this.getStorage(l)?.get(u,f)}getBoolean(u,l,f){return this.getStorage(l)?.getBoolean(u,f)}getNumber(u,l,f){return this.getStorage(l)?.getNumber(u,f)}store(u,l,f,r){if((0,k.isUndefinedOrNull)(l)){this.remove(u,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,f,r),this.getStorage(f)?.set(u,l)})}remove(u,l){this.withPausedEmitters(()=>{this.updateKeyTarget(u,l,void 0),this.getStorage(l)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,l){const f=[],r=this.getKeyTargets(u);for(const o of Object.keys(r))r[o]===l&&f.push(o);return f}updateKeyTarget(u,l,f){const r=this.getKeyTargets(l);typeof f=="number"?r[u]!==f&&(r[u]=f,this.getStorage(l)?.set(T,JSON.stringify(r))):typeof r[u]=="number"&&(delete r[u],this.getStorage(l)?.set(T,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const l=this.get(T,u);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=R.NONE){this._onWillSaveState.fire({reason:u});const l=this.getStorage(-1),f=this.getStorage(0),r=this.getStorage(1);switch(u){case R.NONE:await b.Promises.settled([l?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await b.Promises.settled([l?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return d(u,l,f,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,l){return this.emitWillSaveState(R.NONE),(0,S.isUserDataProfile)(u)?this.switchToProfile(u,l):this.switchToWorkspace(u,l)}canSwitchProfile(u,l){return!(u.id===l.id||I(l)&&I(u))}switchData(u,l,f,r){this.withPausedEmitters(()=>{if(r)for(const[o,n]of u)l.set(o,n);else{const o=new Set;for(const[n,i]of u)o.add(n),l.get(n)!==i&&this.emitDidChangeValue(f,n);for(const[n]of l.items)o.has(n)||this.emitDidChangeValue(f,n)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function I(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=I;class y extends h{constructor(){super();this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=y;async function d(g,u,l,f,r,o){const n=K=>{try{return JSON.parse(K)}catch{return K}},i=new Map,s=new Map;g.forEach((K,se)=>{i.set(se,K),s.set(se,n(K))});const a=new Map,c=new Map;u.forEach((K,se)=>{a.set(se,K),c.set(se,n(K))});const m=new Map,P=new Map;l.forEach((K,se)=>{m.set(se,K),P.set(se,n(K))}),console.group(f!==r?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const _=[];if(i.forEach((K,se)=>{_.push({key:se,value:K})}),console.table(_),console.groupEnd(),console.log(s),f!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const K=[];a.forEach((se,F)=>{K.push({key:F,value:se})}),console.table(K),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const W=[];m.forEach((K,se)=>{W.push({key:se,value:K})}),console.table(W),console.groupEnd(),console.log(P)}e.logStorage=d}),define(pe[114],ve([0,1,18,20,11,3,28,12,4,25,26,31,34,70,17,13,27,54,220,236,32]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=C.isWeb?"web":(0,R.getTargetPlatform)(C.platform,k.arch);var r;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function o(...L){return String(L.reduce((N,q)=>N|q,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class m{constructor(N=c){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new m({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const te=[...this.state.criteria,...q.length?q.map(fe=>({filterType:N,value:fe})):[{filterType:N}]];return new m({...this.state,criteria:te})}withSortBy(N){return new m({...this.state,sortBy:N})}withSortOrder(N){return new m({...this.state,sortOrder:N})}withFlags(...N){return new m({...this.state,flags:N.reduce((q,te)=>q|te,0)})}withAssetTypes(...N){return new m({...this.state,assetTypes:N})}withSource(N){return new m({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:te,sortBy:fe,sortOrder:ye,flags:j,assetTypes:Z}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:te,sortBy:fe,sortOrder:ye}],assetTypes:Z,flags:j}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===n.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function P(L,N){const q=(L||[]).filter(te=>te.statisticName===N)[0];return q?q.value:0}function _(L){const N="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(te=>te.assetType.indexOf(N)===0).reduce((te,fe)=>{const ye=se(L,fe.assetType);return ye&&te.push([fe.assetType.substring(N.length),ye]),te},[])}function W(L){if(L.properties){const N=L.properties.filter(fe=>fe.key===i.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=N.filter(fe=>q.test(fe.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return se(L,i.Repository)}function K(L){return{uri:`${L.fallbackAssetUri}/${i.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${i.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function se(L,N){return L.files.filter(te=>te.assetType===N)[0]?{uri:`${L.assetUri}/${N}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${N}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function F(L,N){const q=L.properties?L.properties.filter(fe=>fe.key===N):[],te=q.length>0&&q[0].value;return te?te.split(",").map(fe=>(0,w.adoptToGalleryExtensionId)(fe)):[]}function Q(L){const N=L.properties?L.properties.filter(q=>q.key===s.Engine):[];return N.length>0&&N[0].value||""}function re(L){const N=L.properties?L.properties.filter(q=>q.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function G(L){const N=L.properties?L.properties.filter(te=>te.key===s.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function de(L){return L.properties?.find(N=>N.key===s.SponsorLink)?.value}function J(L){return L.indexOf("preview")!==-1}function U(L){return L.targetPlatform?(0,R.toTargetPlatform)(L.targetPlatform):"undefined"}function O(L){const N=(0,b.distinct)(L.versions.map(U)),q=!!L.tags?.includes(R.WEB_EXTENSION_TAG),te=N.indexOf("web");return q?te===-1&&N.push("web"):te!==-1&&N.splice(te,1),N}function B(L,N){const q=(0,R.getFallbackTargetPlarforms)(N);for(let te=0;te<L.length;te++){const fe=L[te];if(fe.version===L[te-1]?.version){let ye=te;const j=U(fe);if(j===N)for(;ye>0&&L[ye-1].version===fe.version;)ye--;else if(q.includes(j))for(;ye>0&&L[ye-1].version===fe.version&&U(L[ye-1])!==N;)ye--;ye!==te&&(L.splice(te,1),L.splice(ye,0,fe))}}return L}e.sortExtensionVersions=B;function X(L,N,q){L.telemetryData={index:N,querySource:q}}function ce(L,N,q){const te=L.versions[0],fe={manifest:se(N,i.Manifest),readme:se(N,i.Details),changelog:se(N,i.Changelog),license:se(N,i.License),repository:W(N),download:K(N),icon:se(N,i.Icon),coreTranslations:_(N)};return{identifier:{id:(0,w.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:N.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:de(te),description:L.shortDescription||"",installCount:P(L.statistics,"install"),rating:P(L.statistics,"averagerating"),ratingCount:P(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:q,assets:fe,properties:{dependencies:F(N,s.Dependency),extensionPack:F(N,s.ExtensionPack),engine:Q(N),localizedLanguages:G(N),targetPlatform:U(N),isPreReleaseVersion:re(N)},hasPreReleaseVersion:re(te),hasReleaseVersion:!0,preview:J(L.flags)}}let ue=class{constructor(N,q,te,fe,ye,j,Z,ne){this.requestService=q,this.logService=te,this.environmentService=fe,this.telemetryService=ye,this.fileService=j,this.productService=Z,this.configurationService=ne;const z=Z.extensionsGallery;this.extensionsGalleryUrl=z&&z.serviceUrl,this.extensionsControlUrl=z&&z.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(Z.version,Z,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q,te){const fe=t.CancellationToken.isCancellationToken(q)?{}:q,ye=t.CancellationToken.isCancellationToken(q)?q:te,j=[],Z=[],ne=[],z=[];let V=!0;for(const le of N){le.uuid?Z.push(le.uuid):j.push(le.id);const ge=!!(le.version||le.preRelease);ne.push({id:le.id,uuid:le.uuid,includePreRelease:ge}),le.version&&z.push({id:le.id,uuid:le.uuid,version:le.version}),V=V&&!!le.hasPreRelease&&!ge}if(!Z.length&&!j.length)return[];let $=new m().withPage(1,N.length);Z.length&&($=$.withFilter(n.ExtensionId,...Z)),j.length&&($=$.withFilter(n.ExtensionName,...j)),(fe.queryAllVersions||V)&&($=$.withFlags($.flags,r.IncludeVersions)),fe.source&&($=$.withSource(fe.source));const{extensions:x}=await this.queryGalleryExtensions($,{targetPlatform:fe.targetPlatform??f,includePreRelease:ne,versions:z,compatible:!!fe.compatible},ye);return fe.source&&x.forEach((le,ge)=>X(le,ge,fe.source)),x}async getCompatibleExtension(N,q,te){if((0,R.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(N,q,te))return N;const fe=new m().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,N.identifier.uuid),{extensions:ye}=await this.queryGalleryExtensions(fe,{targetPlatform:te,compatible:!0,includePreRelease:q},t.CancellationToken.None);return ye[0]||null}async isExtensionCompatible(N,q,te){if(!(0,R.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,te)||!q&&N.properties.isPreReleaseVersion)return!1;let fe=N.properties.engine;if(!fe){const ye=await this.getManifest(N,t.CancellationToken.None);if(!ye)throw new Error("Manifest was not found");fe=ye.engines.vscode}return(0,v.isEngineValid)(fe,this.productService.version,this.productService.date)}async isValidVersion(N,q,te,fe,ye){if(!(0,R.isTargetPlatformCompatible)(U(N),fe,ye)||q!=="any"&&re(N)!==(q==="prerelease"))return!1;if(te)try{const j=await this.getEngine(N);if(!(0,v.isEngineValid)(j,this.productService.version,this.productService.date))return!1}catch(j){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,D.getErrorMessage)(j)),!1}return!0}async query(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let te=N.text||"";const fe=N.pageSize??50;let ye=new m().withPage(1,fe);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,$,x)=>(ye=ye.withFilter(n.Category,x||$),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,$,x)=>(ye=ye.withFilter(n.Tag,x||$),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(ye=ye.withFilter(n.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),ye=ye.withFilter(n.SearchText,te)),ye=ye.withSortBy(0)):N.ids?ye=ye.withFilter(n.ExtensionId,...N.ids):N.names?ye=ye.withFilter(n.ExtensionName,...N.names):ye=ye.withSortBy(4),typeof N.sortBy=="number"&&(ye=ye.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(ye=ye.withSortOrder(N.sortOrder)),N.source&&(ye=ye.withSource(N.source));const j=async(V,$)=>{const{extensions:x,total:le}=await this.queryGalleryExtensions(V,{targetPlatform:f,compatible:!1,includePreRelease:!!N.includePreRelease},$);return x.forEach((ge,Pe)=>X(ge,(V.pageNumber-1)*V.pageSize+Pe,N.source)),{extensions:x,total:le}},{extensions:Z,total:ne}=await j(ye,q),z=async(V,$)=>{if($.isCancellationRequested)throw new D.CancellationError;const{extensions:x}=await j(ye.withPage(V+1),$);return x};return{firstPage:Z,total:ne,pageSize:ye.pageSize,getPage:z}}async queryGalleryExtensions(N,q,te){const fe=N.flags;!!(N.flags&r.IncludeLatestVersionOnly)&&!!(N.flags&r.IncludeVersions)&&(N=N.withFlags(N.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(N.flags&r.IncludeLatestVersionOnly)&&!(N.flags&r.IncludeVersions)&&(N=N.withFlags(N.flags,r.IncludeLatestVersionOnly)),q.versions?.length&&(N=N.withFlags(N.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),N=N.withFlags(N.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:ye,total:j}=await this.queryRawGalleryExtensions(N,te);if(!(N.flags&r.IncludeLatestVersionOnly)){const V=[];for(const $ of ye){const x=await this.toGalleryExtensionWithCriteria($,q);x&&V.push(x)}return{extensions:V,total:j}}const ne=[],z=new Map;for(let V=0;V<ye.length;V++){const $=ye[V],x={id:(0,w.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},le=(0,E.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Pe=>(0,w.areSameExtensions)(Pe,x))?.includePreRelease;if(q.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(O($),q.targetPlatform))continue;const ge=await this.toGalleryExtensionWithCriteria($,q);!ge||ge.properties.isPreReleaseVersion&&(!le||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==q.targetPlatform&&ge.hasPreReleaseVersion?z.set($.extensionId,V):ne.push([V,ge])}if(z.size){const V=new Date().getTime(),$=new m().withFlags(fe&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,z.size).withFilter(n.ExtensionId,...z.keys()),{extensions:x}=await this.queryGalleryExtensions($,q,te);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-V,count:z.size});for(const le of x){const ge=z.get(le.identifier.uuid);ne.push([ge,le])}}return{extensions:ne.sort((V,$)=>V[0]-$[0]).map(([,V])=>V),total:j}}async toGalleryExtensionWithCriteria(N,q){const te={id:(0,w.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},fe=q.versions?.find(ne=>(0,w.areSameExtensions)(ne,te))?.version,ye=(0,E.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ne=>(0,w.areSameExtensions)(ne,te))?.includePreRelease,j=O(N),Z=B(N.versions,q.targetPlatform);if(q.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(j,q.targetPlatform))return null;for(let ne=0;ne<Z.length;ne++){const z=Z[ne];if(!(fe&&z.version!==fe)){if(await this.isValidVersion(z,ye?"any":"release",q.compatible,j,q.targetPlatform))return ce(N,z,j);if(fe&&z.version===fe)return null}}return fe||q.compatible?null:ce(N,N.versions[0],j)}async queryRawGalleryExtensions(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,o(r.Unpublished));const te=await this.commonHeadersPromise,fe=JSON.stringify(N.raw),ye={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(fe.length)},j=new Date().getTime();let Z,ne,z=0;try{if(Z=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:fe,headers:ye},q),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:z};const V=await(0,d.asJson)(Z);if(V){const $=V.results[0],x=$.extensions,le=$.resultMetadata&&$.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return z=le&&le.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:z}}return{galleryExtensions:[],total:z}}catch(V){throw ne=V,V}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(fe.length),duration:new Date().getTime()-j,success:!!Z&&(0,d.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:ne?(0,D.isCancellationError)(ne)?"canceled":(0,D.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(z)})}}async reportStatistic(N,q,te,fe){if(!this.isEnabled())return;const ye=C.isWeb?this.api(`/itemName/${N}.${q}/version/${te}/statType/${fe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${te}/stats?statType=${fe}`),j=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.commonHeadersPromise,Accept:j};try{await this.requestService.request({type:"POST",url:ye,headers:ne},t.CancellationToken.None)}catch{}}async download(N,q,te){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const fe=(0,w.getGalleryExtensionTelemetryData)(N),ye=new Date().getTime(),j=V=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...fe,duration:V}),Z=te===2?"install":te===3?"update":"",ne=Z?{uri:`${N.assets.download.uri}${p.URI.parse(N.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${N.assets.download.fallbackUri}${p.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:N.assets.download,z=await this.getAsset(ne);await this.fileService.writeFile(q,z.stream),j(new Date().getTime()-ye)}async getReadme(N,q){if(N.assets.readme){const te=await this.getAsset(N.assets.readme,{},q);return await(0,d.asTextOrError)(te)||""}return""}async getManifest(N,q){if(N.assets.manifest){const te=await this.getAsset(N.assets.manifest,{},q),fe=await(0,d.asTextOrError)(te);return fe?JSON.parse(fe):null}return null}async getManifestFromRawExtensionVersion(N,q){const te=se(N,i.Manifest);if(!te)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},ye=await this.getAsset(te,{headers:fe});return await(0,d.asJson)(ye)}async getCoreTranslation(N,q){const te=N.assets.coreTranslations.filter(fe=>fe[0]===q.toUpperCase())[0];if(te){const fe=await this.getAsset(te[1]),ye=await(0,d.asTextOrError)(fe);return ye?JSON.parse(ye):null}return null}async getChangelog(N,q){if(N.assets.changelog){const te=await this.getAsset(N.assets.changelog,{},q);return await(0,d.asTextOrError)(te)||""}return""}async getAllCompatibleVersions(N,q,te){let fe=new m().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?fe=fe.withFilter(n.ExtensionId,N.identifier.uuid):fe=fe.withFilter(n.ExtensionName,N.identifier.id);const{galleryExtensions:ye}=await this.queryRawGalleryExtensions(fe,t.CancellationToken.None);if(!ye.length)return[];const j=O(ye[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)(j,te))return[];const Z=[];await Promise.all(ye[0].versions.map(async V=>{try{await this.isValidVersion(V,q?"any":"release",!0,j,te)&&Z.push(V)}catch{}}));const ne=[],z=new Set;for(const V of B(Z,te))z.has(V.version)||(z.add(V.version),ne.push({version:V.version,date:V.lastUpdated,isPreReleaseVersion:re(V)}));return ne}async getAsset(N,q={},te=t.CancellationToken.None){const fe=await this.commonHeadersPromise,ye={type:"GET"},j={...fe,...q.headers||{}};q={...q,...ye,headers:j};const Z=N.uri,ne=N.fallbackUri,z={...q,url:Z};try{const V=await this.requestService.request(z,te);if(V.res.statusCode===200)return V;const $=await(0,d.asTextOrError)(V);throw new Error(`Expected 200, got back ${V.res.statusCode} instead.

${$}`)}catch(V){if((0,D.isCancellationError)(V))throw V;const $=(0,D.getErrorMessage)(V);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Z,message:$});const x={...q,url:ne};return this.requestService.request(x,te)}}async getEngine(N){let q=Q(N);if(!q){const te=await this.getManifestFromRawExtensionVersion(N,t.CancellationToken.None);if(!te)throw new Error("Manifest was not found");q=te.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,d.asJson)(N),te=[],fe={};if(q){for(const ye of q.malicious)te.push({id:ye});if(q.migrateToPreRelease)for(const[ye,j]of Object.entries(q.migrateToPreRelease))(!j.engine||(0,v.isEngineValid)(j.engine,this.productService.version,this.productService.date))&&(fe[ye.toLowerCase()]={disallowInstall:!0,extension:{id:j.id,displayName:j.displayName,autoMigrate:{storage:!!j.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[ye,j]of Object.entries(q.deprecated))j&&(fe[ye.toLowerCase()]=(0,E.isBoolean)(j)?{}:j)}return{malicious:te,deprecated:fe}}};ue=Re([_e(1,d.IRequestService),_e(2,I.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,h.IFileService),_e(6,y.IProductService),_e(7,S.IConfigurationService)],ue);let Y=class extends ue{constructor(N,q,te,fe,ye,j,Z,ne){super(N,q,te,fe,ye,j,Z,ne)}};Y=Re([_e(0,u.IStorageService),_e(1,d.IRequestService),_e(2,I.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,h.IFileService),_e(6,y.IProductService),_e(7,S.IConfigurationService)],Y),e.ExtensionGalleryService=Y;let ie=class extends ue{constructor(N,q,te,fe,ye,j,Z){super(void 0,N,q,te,fe,ye,j,Z)}};ie=Re([_e(0,d.IRequestService),_e(1,I.ILogService),_e(2,T.IEnvironmentService),_e(3,l.ITelemetryService),_e(4,h.IFileService),_e(5,y.IProductService),_e(6,S.IConfigurationService)],ie),e.ExtensionGalleryServiceWithNoStorageService=ie}),define(pe[115],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,b.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(C,k){this._exitInfo.set(C,k)}getExitInfo(C){return this._exitInfo.get(C)||null}}e.ExtensionHostStatusService=t}),define(pe[237],ve([0,1,7,14]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function D(k){let E=0,p=0,S=0;k>=1e3&&(S=Math.floor(k/1e3),k-=S*1e3),S>=60&&(p=Math.floor(S/60),S-=p*60),p>=60&&(E=Math.floor(p/60),p-=E*60);const T=E?`${E}h`:"",R=p?`${p}m`:"",w=S?`${S}s`:"",v=k?`${k}ms`:"";return`${T}${R}${w}${v}`}e.printTime=D;class C{constructor(E,p,S,T){this._logService=E,this._reconnectionToken=p,this._onClose=new b.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=S,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${D(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${D(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${D(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(E){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${E}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${D(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const E=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),E.end(),this._onClose.fire(void 0)}acceptReconnection(E,p,S){this._remoteAddress=E,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(p,S),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(pe[116],ve([0,1,29,10,6,137,51]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const E=D.join(t.FileAccess.asFileUri("",oe).fsPath,"nls.metadata.json"),p=new Map;function S(w){return new Promise(v=>b.exists(w,v))}function T(w,v){return S(E).then(h=>{if(!h||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const I=`${w}||${v}`;let y=p.get(I);return y||(y=C.getNLSConfiguration(k.default.commit,v,E,w).then(d=>(R.is(d)&&(d._languagePackSupport=!0),d)),p.set(I,y)),y})}e.getNLSConfiguration=T;var R;(function(w){function v(h){const I=h;return I&&typeof I._languagePackId=="string"}w.is=v})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(pe[117],ve([0,1,19,4,26,53,55,36,17,5,13,27,37,116]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends k.AbstractExtensionsScannerService{constructor(y,d,g,u,l,f,r){super(t.URI.file(l.builtinExtensionsPath),t.URI.file(l.extensionsPath),(0,b.joinPath)(l.userHome,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(t.URI.file(l.userDataPath),E.MANIFEST_CACHE_FOLDER),y,d,g,u,l,f,r);this.nativeEnvironmentService=l}async getTranslations(y){const d=await(0,v.getNLSConfiguration)(y,this.nativeEnvironmentService.userDataPath);if(v.InternalNLSConfiguration.is(d))try{const g=await this.fileService.readFile(t.URI.file(d._translationsConfigFile));return JSON.parse(g.value.toString())}catch{}return Object.create(null)}};h=Re([_e(0,w.IUserDataProfilesService),_e(1,C.IExtensionsProfileScannerService),_e(2,p.IFileService),_e(3,T.ILogService),_e(4,D.INativeEnvironmentService),_e(5,R.IProductService),_e(6,S.IInstantiationService)],h),e.ExtensionsScannerService=h}),define(pe[238],ve([0,1,239,29,6,23,10,21]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z-]+$/;var S;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(S=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(g){return!0}}e.NoneServerConnectionToken=T;class R{constructor(g){this.value=g,this.type=1}validate(g){return g===this.value}}e.OptionalServerConnectionToken=R;class w{constructor(g){this.value=g,this.type=2}validate(g){return g===this.value}}e.MandatoryServerConnectionToken=w;class v{constructor(g){this.message=g}}e.ServerConnectionTokenParseError=v;async function h(d,g){const u=d["without-connection-token"],l=d["connection-token"],f=d["connection-token-file"],r=d.compatibility==="1.63";if(u)return typeof l!="undefined"||typeof f!="undefined"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof f!="undefined"){if(typeof l!="undefined")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=t.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${f}'.`)}return p.test(o)?new w(o):new v(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l!="undefined"?p.test(l)?r?new R(l):new w(l):new v(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):r?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await g())):new w(await g())}e.parseServerConnectionToken=h;async function I(d){return h(d,async()=>{if(!d["user-data-dir"])return(0,C.generateUuid)();const u=D.join(d["user-data-dir"],"token");try{const r=(await E.Promises.readFile(u)).toString().replace(/\r?\n$/,"");if(p.test(r))return r}catch{}const l=(0,C.generateUuid)();try{await E.Promises.writeFile(u,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=I;function y(d,g,u){if(d.validate(u.query[k.connectionTokenQueryName]))return!0;const l=b.parse(g.headers.cookie||"");return d.validate(l[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=y}),define(pe[44],ve([0,1,182,191,58,5,26]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:b.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:b.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:b.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:b.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:b.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:b.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:b.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:b.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:b.localize(8,null)},"user-data-dir":D.OPTIONS["user-data-dir"],"enable-smoke-test-driver":D.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":D.OPTIONS["disable-telemetry"],"disable-workspace-trust":D.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:D.OPTIONS.log,logsPath:D.OPTIONS.logsPath,"force-disable-user-env":D.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:b.localize(9,null)},"default-workspace":{type:"string",description:b.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":D.OPTIONS["extensions-dir"],"extensions-download-dir":D.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":D.OPTIONS["builtin-extensions-dir"],"install-extension":D.OPTIONS["install-extension"],"install-builtin-extension":D.OPTIONS["install-builtin-extension"],"uninstall-extension":D.OPTIONS["uninstall-extension"],"list-extensions":D.OPTIONS["list-extensions"],"locate-extension":D.OPTIONS["locate-extension"],"show-versions":D.OPTIONS["show-versions"],category:D.OPTIONS.category,force:D.OPTIONS.force,"do-not-sync":D.OPTIONS["do-not-sync"],"pre-release":D.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:b.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:D.OPTIONS.help,version:D.OPTIONS.version,"locate-shell-integration-path":D.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:D.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(k.IEnvironmentService);class E extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=E}),define(pe[240],ve([0,1,29,84,76,239,109,35,66,3,13,44,6,10,23,27,54,20,4,16,12,75]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const r={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(c,m,P,_){m.writeHead(P,{"Content-Type":"text/plain"}),m.end(_)}e.serveError=o;var n;(function(c){c[c.NO_CACHING=0]="NO_CACHING",c[c.ETAG=1]="ETAG",c[c.NO_EXPIRY=2]="NO_EXPIRY"})(n=e.CacheControl||(e.CacheControl={}));async function i(c,m,P,_,W,K){try{const se=await b.promises.stat(c);if(m===1){const F=`W/"${[se.ino,se.size,se.mtime.getTime()].join("-")}"`;if(_.headers["if-none-match"]===F)return W.writeHead(304),W.end();K.Etag=F}else m===2?K["Cache-Control"]="public, max-age=31536000":m===0&&(K["Cache-Control"]="no-store");K["Content-Type"]=r[(0,w.extname)(c)]||(0,p.getMediaMime)(c)||"text/plain",W.writeHead(200,K),(0,b.createReadStream)(c).pipe(W)}catch(se){return se.code!=="ENOENT"?(P.error(se),console.error(se.toString())):console.error(`File not found: ${c}`),W.writeHead(404,{"Content-Type":"text/plain"}),W.end("Not found")}}e.serveFile=i;const s=(0,w.dirname)(v.FileAccess.asFileUri("",oe).fsPath);let a=class{constructor(m,P,_,W,K){this._connectionToken=m,this._environmentService=P,this._logService=_,this._requestService=W,this._productService=K,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const se=(0,f.getRemoteServerRootPath)(K);this._staticRoute=`${se}/static`,this._callbackRoute=`${se}/callback`,this._webExtensionRoute=`${se}/web-extension-resource`}async handle(m,P,_){try{const W=_.pathname;return W.startsWith(this._staticRoute)&&W.charCodeAt(this._staticRoute.length)===47?this._handleStatic(m,P,_):W==="/"?this._handleRoot(m,P,_):W===this._callbackRoute?this._handleCallback(P):W.startsWith(this._webExtensionRoute)&&W.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(m,P,_):o(m,P,404,"Not found.")}catch(W){return this._logService.error(W),console.error(W.toString()),o(m,P,500,"Internal Server Error.")}}async _handleStatic(m,P,_){const W=Object.create(null),se=decodeURIComponent(_.pathname).substring(this._staticRoute.length+1),F=(0,w.join)(s,se);return(0,E.isEqualOrParent)(F,s,!S.isLinux)?i(F,this._environmentService.isBuilt?2:1,this._logService,m,P,W):o(m,P,400,"Bad request.")}_getResourceURLTemplateAuthority(m){const P=m.authority.indexOf(".");return P!==-1?m.authority.substring(P+1):void 0}async _handleWebExtensionResource(m,P,_){if(!this._webExtensionResourceUrlTemplate)return o(m,P,500,"No extension gallery service configured.");const W=decodeURIComponent(_.pathname),K=(0,w.normalize)(W.substring(this._webExtensionRoute.length+1)),se=g.URI.parse(K).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:K.substring(0,K.indexOf("/")),path:K.substring(K.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(se))return o(m,P,403,"Request Forbidden");const F={},Q=O=>{const B=m.headers[O];B&&((0,l.isString)(B)||B[0])?F[O]=(0,l.isString)(B)?B:B[0]:O!==O.toLowerCase()&&Q(O.toLowerCase())};Q("X-Client-Name"),Q("X-Client-Version"),Q("X-Machine-Id"),Q("X-Client-Commit");const re=await this._requestService.request({type:"GET",url:se.toString(!0),headers:F},d.CancellationToken.None),G=re.res.statusCode||500;if(G!==200){let O=null;try{O=await(0,y.asTextOrError)(re)}catch{}return o(m,P,G,O||`Request failed with status ${G}`)}const de=Object.create(null),J=O=>{const B=re.res.headers[O];B?de[O]=B:O!==O.toLowerCase()&&J(O.toLowerCase())};J("Cache-Control"),J("Content-Type"),P.writeHead(200,de);const U=await(0,u.streamToBuffer)(re.stream);return P.end(U.buffer)}async _handleRoot(m,P,_){const W=_.query[v.connectionTokenQueryName];if(typeof W=="string"){const ue=Object.create(null);ue["Set-Cookie"]=C.serialize(v.connectionTokenCookieName,W,{sameSite:"lax",maxAge:60*60*24*7});const Y=Object.create(null);for(const L in _.query)L!==v.connectionTokenQueryName&&(Y[L]=_.query[L]);const ie=D.format({pathname:"/",query:Y});return ue.Location=ie,P.writeHead(302,ue),P.end()}const K=ue=>{const Y=m.headers[ue];return Array.isArray(Y)?Y[0]:Y},se=K("x-original-host")||K("x-forwarded-host")||m.headers.host;if(!se)return o(m,P,400,"Bad request.");function F(ue){return JSON.stringify(ue).replace(/"/g,"&quot;")}let Q;this._environmentService.args["enable-smoke-test-driver"]&&(Q=!1);const re=ue=>ue&&g.URI.file(t.resolve(ue)).with({scheme:v.Schemas.vscodeRemote,authority:se}),G=v.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",oe).fsPath,de=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,h.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,J={remoteAuthority:se,_wrapWebWorkerExtHostInIframe:Q,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:re(this._environmentService.args["default-folder"]),workspaceUri:re(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:se,path:`${this._webExtensionRoute}/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0},callbackRoute:this._callbackRoute},U=this._productService.extensionsGallery?.nlsBaseUrl,O={WORKBENCH_WEB_CONFIGURATION:F(J),WORKBENCH_AUTH_SESSION:de?F(de):"",WORKBENCH_WEB_BASE_URL:this._staticRoute,WORKBENCH_NLS_BASE_URL:U?`${U}${U.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""};let B;try{B=(await b.promises.readFile(G)).toString().replace(/\{\{([^}]+)\}\}/g,(Y,ie)=>O[ie]??"undefined")}catch{return P.writeHead(404,{"Content-Type":"text/plain"}),P.end("Not found")}const X=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(B).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${se};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),ce={"Content-Type":"text/html","Content-Security-Policy":X};return this._connectionToken.type!==0&&(ce["Set-Cookie"]=C.serialize(v.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),P.writeHead(200,ce),P.end(B)}_getScriptCspHashes(m){const P=/<script>([\s\S]+?)<\/script>/img,_=[];let W;for(;W=P.exec(m);){const K=k.createHash("sha256"),se=W[1].replace(/\r\n/g,`
`),F=K.update(Buffer.from(se)).digest().toString("base64");_.push(`'sha256-${F}'`)}return _}async _handleCallback(m){const P=v.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",oe).fsPath,_=(await b.promises.readFile(P)).toString(),W=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(_).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return m.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":W}),m.end(_)}};a=Re([_e(1,R.IServerEnvironmentService),_e(2,T.ILogService),_e(3,y.IRequestService),_e(4,I.IProductService)],a),e.WebClientServer=a}),define(pe[241],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t});var Rt=this&&this.__classPrivateFieldSet||function(oe,e,b,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,b):D?D.value=b:e.set(oe,b),b},nt=this&&this.__classPrivateFieldGet||function(oe,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(oe):t?t.value:e.get(oe)};define(pe[118],ve([0,1,18,11,90,24,66,15,12,4,23,17,106]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";var v,h,I,y,d,g,u,l,f,r,o,n,i,s,a,c,m,P,_,W,K,se,F;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function Q(M){function A(){return Reflect.construct(M,arguments,this.constructor)}return Object.defineProperty(A,"name",Object.getOwnPropertyDescriptor(M,"name")),Object.setPrototypeOf(A,M),Object.setPrototypeOf(A.prototype,M.prototype),A}let re=g=class{constructor(A){v.set(this,void 0),Rt(this,v,A,"f")}static from(...A){let ee=A;return new g(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}dispose(){typeof nt(this,v,"f")=="function"&&(nt(this,v,"f").call(this),Rt(this,v,void 0,"f"))}};v=new WeakMap,re=g=Re([Q],re),e.Disposable=re;let G=u=class{constructor(A,ee){if(A<0)throw(0,t.illegalArgument)("line must be non-negative");if(ee<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=A,this._character=ee}static Min(...A){if(A.length===0)throw new TypeError;let ee=A[0];for(let Ee=1;Ee<A.length;Ee++){const ze=A[Ee];ze.isBefore(ee)&&(ee=ze)}return ee}static Max(...A){if(A.length===0)throw new TypeError;let ee=A[0];for(let Ee=1;Ee<A.length;Ee++){const ze=A[Ee];ze.isAfter(ee)&&(ee=ze)}return ee}static isPosition(A){if(!A)return!1;if(A instanceof u)return!0;const{line:ee,character:Ee}=A;return typeof ee=="number"&&typeof Ee=="number"}static of(A){if(A instanceof u)return A;if(this.isPosition(A))return new u(A.line,A.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<A._character}isBeforeOrEqual(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<=A._character}isAfter(A){return!this.isBeforeOrEqual(A)}isAfterOrEqual(A){return!this.isBefore(A)}isEqual(A){return this._line===A._line&&this._character===A._character}compareTo(A){return this._line<A._line?-1:this._line>A.line?1:this._character<A._character?-1:this._character>A._character?1:0}translate(A,ee=0){if(A===null||ee===null)throw(0,t.illegalArgument)();let Ee;return typeof A=="undefined"?Ee=0:typeof A=="number"?Ee=A:(Ee=typeof A.lineDelta=="number"?A.lineDelta:0,ee=typeof A.characterDelta=="number"?A.characterDelta:0),Ee===0&&ee===0?this:new u(this.line+Ee,this.character+ee)}with(A,ee=this.character){if(A===null||ee===null)throw(0,t.illegalArgument)();let Ee;return typeof A=="undefined"?Ee=this.line:typeof A=="number"?Ee=A:(Ee=typeof A.line=="number"?A.line:this.line,ee=typeof A.character=="number"?A.character:this.character),Ee===this.line&&ee===this.character?this:new u(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};G=u=Re([Q],G),e.Position=G;let de=l=class{constructor(A,ee,Ee,ze){let Ge,Xe;if(typeof A=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof ze=="number"?(Ge=new G(A,ee),Xe=new G(Ee,ze)):G.isPosition(A)&&G.isPosition(ee)&&(Ge=G.of(A),Xe=G.of(ee)),!Ge||!Xe)throw new Error("Invalid arguments");Ge.isBefore(Xe)?(this._start=Ge,this._end=Xe):(this._start=Xe,this._end=Ge)}static isRange(A){return A instanceof l?!0:A?G.isPosition(A.start)&&G.isPosition(A.end):!1}static of(A){if(A instanceof l)return A;if(this.isRange(A))return new l(A.start,A.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(A){return l.isRange(A)?this.contains(A.start)&&this.contains(A.end):G.isPosition(A)?!(G.of(A).isBefore(this._start)||this._end.isBefore(A)):!1}isEqual(A){return this._start.isEqual(A._start)&&this._end.isEqual(A._end)}intersection(A){const ee=G.Max(A.start,this._start),Ee=G.Min(A.end,this._end);if(!ee.isAfter(Ee))return new l(ee,Ee)}union(A){if(this.contains(A))return this;if(A.contains(this))return A;const ee=G.Min(A.start,this._start),Ee=G.Max(A.end,this.end);return new l(ee,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(A,ee=this.end){if(A===null||ee===null)throw(0,t.illegalArgument)();let Ee;return A?G.isPosition(A)?Ee=A:(Ee=A.start||this.start,ee=A.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ee.isEqual(this.end)?this:new l(Ee,ee)}toJSON(){return[this.start,this.end]}};de=l=Re([Q],de),e.Range=de;let J=f=class extends de{constructor(A,ee,Ee,ze){let Ge,Xe;if(typeof A=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof ze=="number"?(Ge=new G(A,ee),Xe=new G(Ee,ze)):G.isPosition(A)&&G.isPosition(ee)&&(Ge=G.of(A),Xe=G.of(ee)),!Ge||!Xe)throw new Error("Invalid arguments");super(Ge,Xe);this._anchor=Ge,this._active=Xe}static isSelection(A){return A instanceof f?!0:A?de.isRange(A)&&G.isPosition(A.anchor)&&G.isPosition(A.active)&&typeof A.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};J=f=Re([Q],J),e.Selection=J;class U{constructor(A,ee,Ee){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,t.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,t.illegalArgument)("connectionToken");this.host=A,this.port=Math.round(ee),this.connectionToken=Ee}}e.ResolvedAuthority=U;class O extends Error{constructor(A,ee=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(A);this._message=A,this._code=ee,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable(A,ee){return new O(A,w.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(A){return new O(A,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var B;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var X;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=r=class{constructor(A,ee){this._range=A,this._newText=ee}static isTextEdit(A){return A instanceof r?!0:A?de.isRange(A)&&typeof A.newText=="string":!1}static replace(A,ee){return new r(A,ee)}static insert(A,ee){return r.replace(new de(A,A),ee)}static delete(A){return r.replace(A,"")}static setEndOfLine(A){const ee=new r(new de(new G(0,0),new G(0,0)),"");return ee.newEol=A,ee}get range(){return this._range}set range(A){if(A&&!de.isRange(A))throw(0,t.illegalArgument)("range");this._range=A}get newText(){return this._newText||""}set newText(A){if(A&&typeof A!="string")throw(0,t.illegalArgument)("newText");this._newText=A}get newEol(){return this._newEol}set newEol(A){if(A&&typeof A!="number")throw(0,t.illegalArgument)("newEol");this._newEol=A}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ce=r=Re([Q],ce),e.TextEdit=ce;let ue=o=class{constructor(A,ee){this.range=A,this.newCells=ee}static isNotebookCellEdit(A){return A instanceof o?!0:A?bt.isNotebookRange(A)&&Array.isArray(A.newCells):!1}static replaceCells(A,ee){return new o(A,ee)}static insertCells(A,ee){return new o(new bt(A,A),ee)}static deleteCells(A){return new o(A,[])}static updateCellMetadata(A,ee){const Ee=new o(new bt(A,A),[]);return Ee.newCellMetadata=ee,Ee}static updateNotebookMetadata(A){const ee=new o(new bt(0,0),[]);return ee.newNotebookMetadata=A,ee}};ue=o=Re([Q],ue),e.NotebookEdit=ue;var Y;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(Y=e.FileEditType||(e.FileEditType={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(A,ee,Ee,ze){this._edits.push({_type:1,from:A,to:ee,options:Ee,metadata:ze})}createFile(A,ee,Ee){this._edits.push({_type:1,from:void 0,to:A,options:ee,metadata:Ee})}deleteFile(A,ee,Ee){this._edits.push({_type:1,from:A,to:void 0,options:ee,metadata:Ee})}replaceNotebookMetadata(A,ee,Ee){this._edits.push({_type:3,metadata:Ee,uri:A,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(A,ee,Ee,ze,Ge){let Xe,et,ot=[],ct;if(bt.isNotebookRange(ee)&&Tt.isNotebookCellDataArray(Ee)&&!Tt.isNotebookCellDataArray(ze)?(Xe=ee.start,et=ee.end,ot=Ee,ct=ze):typeof ee=="number"&&typeof Ee=="number"&&Tt.isNotebookCellDataArray(ze)&&(Xe=ee,et=Ee,ot=ze,ct=Ge),Xe===void 0||et===void 0)throw new Error("Invalid arguments");(Xe!==et||ot.length>0)&&this._edits.push({_type:5,uri:A,index:Xe,count:et-Xe,cells:ot,metadata:ct})}replaceNotebookCellMetadata(A,ee,Ee,ze){this._edits.push({_type:3,metadata:ze,uri:A,edit:{editType:8,index:ee,metadata:Ee}})}replace(A,ee,Ee,ze){typeof Ee=="string"?this._edits.push({_type:2,uri:A,edit:new ce(ee,Ee),metadata:ze}):this._edits.push({_type:6,uri:A,range:ee,edit:Ee,metadata:ze})}insert(A,ee,Ee,ze){this.replace(A,new de(ee,ee),Ee,ze)}delete(A,ee,Ee){this.replace(A,ee,"",Ee)}has(A){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===A.toString())}set(A,ee){if(ee)for(const Ee of ee)Ee&&(ue.isNotebookCellEdit(Ee)?Ee.newCellMetadata?this.replaceNotebookCellMetadata(A,Ee.range.start,Ee.newCellMetadata):Ee.newNotebookMetadata?this.replaceNotebookMetadata(A,Ee.newNotebookMetadata):this.replaceNotebookCells(A,Ee.range,Ee.newCells):this._edits.push({_type:2,uri:A,edit:Ee}));else{for(let Ee=0;Ee<this._edits.length;Ee++){const ze=this._edits[Ee];ze._type===2&&ze.uri.toString()===A.toString()&&(this._edits[Ee]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(A){const ee=[];for(const Ee of this._edits)Ee._type===2&&Ee.uri.toString()===A.toString()&&ee.push(Ee.edit);return ee}entries(){const A=new C.ResourceMap;for(const ee of this._edits)if(ee._type===2){let Ee=A.get(ee.uri);Ee||(Ee=[ee.uri,[]],A.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...A.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ie=Re([Q],ie),e.WorkspaceEdit=ie;let L=n=class{constructor(A){this._tabstop=1,this.value=A||""}static isSnippetString(A){return A instanceof n?!0:A?typeof A.value=="string":!1}static _escape(A){return A.replace(/\$|}|\\/g,"\\$&")}appendText(A){return this.value+=n._escape(A),this}appendTabstop(A=this._tabstop++){return this.value+="$",this.value+=A,this}appendPlaceholder(A,ee=this._tabstop++){if(typeof A=="function"){const Ee=new n;Ee._tabstop=this._tabstop,A(Ee),this._tabstop=Ee._tabstop,A=Ee.value}else A=n._escape(A);return this.value+="${",this.value+=ee,this.value+=":",this.value+=A,this.value+="}",this}appendChoice(A,ee=this._tabstop++){const Ee=A.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(A,ee){if(typeof ee=="function"){const Ee=new n;Ee._tabstop=this._tabstop,ee(Ee),this._tabstop=Ee._tabstop,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=A,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};L=n=Re([Q],L),e.SnippetString=L;var N;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var q;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let te=i=class{constructor(A,ee){if(this.uri=A,ee)if(de.isRange(ee))this.range=de.of(ee);else if(G.isPosition(ee))this.range=new de(ee,ee);else throw new Error("Illegal argument")}static isLocation(A){return A instanceof i?!0:A?de.isRange(A.range)&&S.URI.isUri(A.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};te=i=Re([Q],te),e.Location=te;let fe=class{constructor(A,ee){this.location=A,this.message=ee}static is(A){return A?typeof A.message=="string"&&A.location&&de.isRange(A.location.range)&&S.URI.isUri(A.location.uri):!1}static isEqual(A,ee){return A===ee?!0:!A||!ee?!1:A.message===ee.message&&A.location.range.isEqual(ee.location.range)&&A.location.uri.toString()===ee.location.uri.toString()}};fe=Re([Q],fe),e.DiagnosticRelatedInformation=fe;let ye=class{constructor(A,ee,Ee=q.Error){if(!de.isRange(A))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=A,this.message=ee,this.severity=Ee}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(A,ee){return A===ee?!0:!A||!ee?!1:A.message===ee.message&&A.severity===ee.severity&&A.code===ee.code&&A.severity===ee.severity&&A.source===ee.source&&A.range.isEqual(ee.range)&&(0,b.equals)(A.tags,ee.tags)&&(0,b.equals)(A.relatedInformation,ee.relatedInformation,fe.isEqual)}};ye=Re([Q],ye),e.Diagnostic=ye;let j=class{constructor(A,ee){if(!A)throw new Error("Illegal argument, contents must be defined");Array.isArray(A)?this.contents=A:this.contents=[A],this.range=ee}};j=Re([Q],j),e.Hover=j;var Z;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(A,ee=Z.Text){this.range=A,this.kind=ee}toJSON(){return{range:this.range,kind:Z[this.kind]}}};ne=Re([Q],ne),e.DocumentHighlight=ne;var z;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(z=e.SymbolKind||(e.SymbolKind={}));var V;(function(M){M[M.Deprecated=1]="Deprecated"})(V=e.SymbolTag||(e.SymbolTag={}));let $=s=class{constructor(A,ee,Ee,ze,Ge){this.name=A,this.kind=ee,this.containerName=Ge,typeof Ee=="string"&&(this.containerName=Ee),ze instanceof te?this.location=ze:Ee instanceof de&&(this.location=new te(ze,Ee)),s.validate(this)}static validate(A){if(!A.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:z[this.kind],location:this.location,containerName:this.containerName}}};$=s=Re([Q],$),e.SymbolInformation=$;let x=a=class{constructor(A,ee,Ee,ze,Ge){this.name=A,this.detail=ee,this.kind=Ee,this.range=ze,this.selectionRange=Ge,this.children=[],a.validate(this)}static validate(A){if(!A.name)throw new Error("name must not be falsy");if(!A.range.contains(A.selectionRange))throw new Error("selectionRange must be contained in fullRange");A.children?.forEach(a.validate)}};x=a=Re([Q],x),e.DocumentSymbol=x;var le;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(le=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(A,ee){this.title=A,this.kind=ee}};ge=Re([Q],ge),e.CodeAction=ge;let Pe=c=class{constructor(A){this.value=A}append(A){return new c(this.value?this.value+c.sep+A:A)}intersects(A){return this.contains(A)||A.contains(this)}contains(A){return this.value===A.value||A.value.startsWith(this.value+c.sep)}};Pe.sep=".",Pe=c=Re([Q],Pe),e.CodeActionKind=Pe,Pe.Empty=new Pe(""),Pe.QuickFix=Pe.Empty.append("quickfix"),Pe.Refactor=Pe.Empty.append("refactor"),Pe.RefactorExtract=Pe.Refactor.append("extract"),Pe.RefactorInline=Pe.Refactor.append("inline"),Pe.RefactorRewrite=Pe.Refactor.append("rewrite"),Pe.Source=Pe.Empty.append("source"),Pe.SourceOrganizeImports=Pe.Source.append("organizeImports"),Pe.SourceFixAll=Pe.Source.append("fixAll");let ke=class{constructor(A,ee){if(this.range=A,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=Re([Q],ke),e.SelectionRange=ke;class Me{constructor(A,ee,Ee,ze,Ge,Xe){this.kind=A,this.name=ee,this.detail=Ee,this.uri=ze,this.range=Ge,this.selectionRange=Xe}}e.CallHierarchyItem=Me;class Be{constructor(A,ee){this.fromRanges=ee,this.from=A}}e.CallHierarchyIncomingCall=Be;class me{constructor(A,ee){this.fromRanges=ee,this.to=A}}e.CallHierarchyOutgoingCall=me;var be;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let we=class{constructor(A,ee){this.range=A,this.command=ee}get isResolved(){return!!this.command}};we=Re([Q],we),e.CodeLens=we;let Oe=m=class{constructor(A,ee=!1){h.set(this,void 0),Rt(this,h,new D.MarkdownString(A,{supportThemeIcons:ee}),"f")}static isMarkdownString(A){return A instanceof m?!0:A&&A.appendCodeblock&&A.appendMarkdown&&A.appendText&&A.value!==void 0}get value(){return nt(this,h,"f").value}set value(A){nt(this,h,"f").value=A}get isTrusted(){return nt(this,h,"f").isTrusted}set isTrusted(A){nt(this,h,"f").isTrusted=A}get supportThemeIcons(){return nt(this,h,"f").supportThemeIcons}set supportThemeIcons(A){nt(this,h,"f").supportThemeIcons=A}get supportHtml(){return nt(this,h,"f").supportHtml}set supportHtml(A){nt(this,h,"f").supportHtml=A}get baseUri(){return nt(this,h,"f").baseUri}set baseUri(A){nt(this,h,"f").baseUri=A}appendText(A){return nt(this,h,"f").appendText(A),this}appendMarkdown(A){return nt(this,h,"f").appendMarkdown(A),this}appendCodeblock(A,ee){return nt(this,h,"f").appendCodeblock(ee??"",A),this}};h=new WeakMap,Oe=m=Re([Q],Oe),e.MarkdownString=Oe;let Ne=class{constructor(A,ee){this.label=A,this.documentation=ee}};Ne=Re([Q],Ne),e.ParameterInformation=Ne;let Je=class{constructor(A,ee){this.label=A,this.documentation=ee,this.parameters=[]}};Je=Re([Q],Je),e.SignatureInformation=Je;let We=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};We=Re([Q],We),e.SignatureHelp=We;var qe;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var je;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(je=e.InlayHintKind||(e.InlayHintKind={}));let He=class{constructor(A){this.value=A}};He=Re([Q],He),e.InlayHintLabelPart=He;let Ke=class{constructor(A,ee,Ee){this.position=A,this.label=ee,this.kind=Ee}};Ke=Re([Q],Ke),e.InlayHint=Ke;var ae;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Te;(function(M){M[M.Deprecated=1]="Deprecated"})(Te=e.CompletionItemTag||(e.CompletionItemTag={}));let Ae=class{constructor(A,ee){this.label=A,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ae=Re([Q],Ae),e.CompletionItem=Ae;let Fe=class{constructor(A=[],ee=!1){this.items=A,this.isIncomplete=ee}};Fe=Re([Q],Fe),e.CompletionList=Fe;let Ue=class{constructor(A,ee,Ee){this.insertText=A,this.range=ee,this.command=Ee}};Ue=Re([Q],Ue),e.InlineSuggestion=Ue;let xe=class{constructor(A){this.commands=void 0,this.items=A}};xe=Re([Q],xe),e.InlineSuggestionList=xe;let Qe=class{constructor(A,ee,Ee){this.insertText=A,this.range=ee,this.command=Ee}};Qe=Re([Q],Qe),e.InlineSuggestionNew=Qe;let Ze=class{constructor(A,ee){this.items=A,this.commands=ee}};Ze=Re([Q],Ze),e.InlineSuggestionsNew=Ze;var tt;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var it;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var rt;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var gt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(gt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var It;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function A(ee){switch(ee){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=A}(It=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Pt=class{constructor(A,ee){if(ee&&!S.URI.isUri(ee))throw(0,t.illegalArgument)("target");if(!de.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.target=ee}};Pt=Re([Q],Pt),e.DocumentLink=Pt;let yt=class{constructor(A,ee,Ee,ze){this.red=A,this.green=ee,this.blue=Ee,this.alpha=ze}};yt=Re([Q],yt),e.Color=yt;let st=class{constructor(A,ee){if(ee&&!(ee instanceof yt))throw(0,t.illegalArgument)("color");if(!de.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.color=ee}};st=Re([Q],st),e.ColorInformation=st;let ut=class{constructor(A){if(!A||typeof A!="string")throw(0,t.illegalArgument)("label");this.label=A}};ut=Re([Q],ut),e.ColorPresentation=ut;var ht;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(ht=e.ColorFormat||(e.ColorFormat={}));var At;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(At=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ft;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(Ft=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(A,ee,Ee){if(this.startIndex=A,this.length=ee,this.tooltip=Ee,typeof A!="number"||A<0)throw(0,t.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,t.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Se;var Ie;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Ie=e.TerminalLocation||(e.TerminalLocation={}));class he{constructor(A){if(this.options=A,typeof A!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=he;var H;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(H=e.TaskRevealKind||(e.TaskRevealKind={}));var De;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(De=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=P=class{constructor(A,ee){if(this.label=ee,typeof A!="string"||typeof ee!="string")throw(0,t.illegalArgument)("name");this._id=A}static from(A){switch(A){case"clean":return P.Clean;case"build":return P.Build;case"rebuild":return P.Rebuild;case"test":return P.Test;default:return}}get id(){return this._id}};Le.Clean=new P("clean","Clean"),Le.Build=new P("build","Build"),Le.Rebuild=new P("rebuild","Rebuild"),Le.Test=new P("test","Test"),Le=P=Re([Q],Le),e.TaskGroup=Le;function Ye(M){let A="";for(let ee=0;ee<M.length;ee++)A+=M[ee].replace(/,/g,",,")+",";return A}let Ve=class{constructor(A,ee,Ee){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=A,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=Ee):this._options=ee)}get process(){return this._process}set process(A){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._process=A}get args(){return this._args}set args(A){Array.isArray(A)||(A=[]),this._args=A}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("process"),this._process!==void 0&&A.push(this._process),this._args&&this._args.length>0)for(const ee of this._args)A.push(ee);return Ye(A)}};Ve=Re([Q],Ve),e.ProcessExecution=Ve;let $e=class{constructor(A,ee,Ee){if(this._args=[],Array.isArray(ee)){if(!A)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A,this._args=ee,this._options=Ee}else{if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(A){if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A}get command(){return this._command?this._command:""}set command(A){if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A}get args(){return this._args}set args(A){this._args=A||[]}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("shell"),this._commandLine!==void 0&&A.push(this._commandLine),this._command!==void 0&&A.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ee of this._args)A.push(typeof ee=="string"?ee:ee.value);return Ye(A)}};$e=Re([Q],$e),e.ShellExecution=$e;var lt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class vt{constructor(A){this._callback=A}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(A){this._callback=A}get callback(){return this._callback}}e.CustomExecution=vt;let at=_=class{constructor(A,ee,Ee,ze,Ge,Xe){this.__deprecated=!1,this._definition=this.definition=A;let et;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=Ee,this.execution=ze,et=Ge,this.__deprecated=!0):ee===Et.Global||ee===Et.Workspace?(this.target=ee,this._name=this.name=Ee,this._source=this.source=ze,this.execution=Ge,et=Xe):(this.target=ee,this._name=this.name=Ee,this._source=this.source=ze,this.execution=Ge,et=Xe),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(A){this.__id=A}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ve?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof $e?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(A){if(A==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=A}get scope(){return this._scope}set target(A){this.clear(),this._scope=A}get name(){return this._name}set name(A){if(typeof A!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=A}get execution(){return this._execution}set execution(A){A===null&&(A=void 0),this.clear(),this._execution=A;const ee=this._definition.type;(_.EmptyType===ee||_.ProcessType===ee||_.ShellType===ee||_.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(A){if(Array.isArray(A))this.clear(),this._problemMatchers=A,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(A){A!==!0&&A!==!1&&(A=!1),this.clear(),this._isBackground=A}get source(){return this._source}set source(A){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=A}get group(){return this._group}set group(A){A===null&&(A=void 0),this.clear(),this._group=A}get detail(){return this._detail}set detail(A){A===null&&(A=void 0),this._detail=A}get presentationOptions(){return this._presentationOptions}set presentationOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._presentationOptions=A}get runOptions(){return this._runOptions}set runOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._runOptions=A}};at.ExtensionCallbackType="customExecution",at.ProcessType="process",at.ShellType="shell",at.EmptyType="$empty",at=_=Re([Q],at),e.Task=at;var St;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let Wt=W=class{constructor(A,ee=Mt.None){this.collapsibleState=ee,S.URI.isUri(A)?this.resourceUri=A:this.label=A}static isTreeItem(A){if(A instanceof W)return!0;const ee=A;if(ee.label!==void 0&&!(0,p.isString)(ee.label)&&!ee.label?.label)return console.log("INVALID tree item, invalid label",ee.label),!1;if(ee.id!==void 0&&!(0,p.isString)(ee.id))return console.log("INVALID tree item, invalid id",ee.id),!1;if(ee.iconPath!==void 0&&!(0,p.isString)(ee.iconPath)&&!S.URI.isUri(ee.iconPath)&&(!ee.iconPath||!(0,p.isString)(ee.iconPath.id))){const Ee=ee.iconPath;if(!Ee||!(0,p.isString)(Ee.light)&&!S.URI.isUri(Ee.light)&&!(0,p.isString)(Ee.dark)&&!S.URI.isUri(Ee.dark))return console.log("INVALID tree item, invalid iconPath",ee.iconPath),!1}return ee.description!==void 0&&!(0,p.isString)(ee.description)&&typeof ee.description!="boolean"?(console.log("INVALID tree item, invalid description",ee.description),!1):ee.resourceUri!==void 0&&!S.URI.isUri(ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ee.resourceUri),!1):ee.tooltip!==void 0&&!(0,p.isString)(ee.tooltip)&&!(ee.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",ee.tooltip),!1):ee.command!==void 0&&!ee.command.command?(console.log("INVALID tree item, invalid command",ee.command),!1):ee.collapsibleState!==void 0&&ee.collapsibleState<Mt.None&&ee.collapsibleState>Mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ee.collapsibleState),!1):ee.contextValue!==void 0&&!(0,p.isString)(ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",ee.contextValue),!1):ee.accessibilityInformation!==void 0&&!ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ee.accessibilityInformation),!1):!0}};Wt=W=Re([Q],Wt),e.TreeItem=Wt;var Mt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let $t=class{constructor(A){this.value=A}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};$t=Re([Q],$t),e.DataTransferItem=$t;let jt=class{constructor(A){I.set(this,new Map);for(const[ee,Ee]of A??[]){const ze=nt(this,I,"f").get(ee);ze?ze.push(Ee):nt(this,I,"f").set(ee,[Ee])}}get(A){return nt(this,I,"f").get(A)?.[0]}set(A,ee){nt(this,I,"f").set(A,[ee])}forEach(A,ee){for(const[Ee,ze]of nt(this,I,"f"))for(const Ge of ze)A.call(ee,Ge,Ee,this)}*[(I=new WeakMap,Symbol.iterator)](){for(const[A,ee]of nt(this,I,"f"))for(const Ee of ee)yield[A,Ee]}};jt=Re([Q],jt),e.DataTransfer=jt;let Ht=class{constructor(A){this.insertText=A}};Ht=Re([Q],Ht),e.DocumentDropEdit=Ht;let Vt=class{constructor(A){this.insertText=A}};Vt=Re([Q],Vt),e.DocumentPasteEdit=Vt;let kt=class{constructor(A,ee){this.id=A,this.color=ee}};kt=Re([Q],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let qt=class{constructor(A){this.id=A}};qt=Re([Q],qt),e.ThemeColor=qt;var En;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(En=e.ConfigurationTarget||(e.ConfigurationTarget={}));let xt=class{constructor(A,ee){if(typeof A!="string"&&(!A||!S.URI.isUri(A)&&!S.URI.isUri(A.uri)))throw(0,t.illegalArgument)("base");if(typeof ee!="string")throw(0,t.illegalArgument)("pattern");typeof A=="string"?this.baseUri=S.URI.file(A):S.URI.isUri(A)?this.baseUri=A:this.baseUri=A.uri,this.pattern=ee}get base(){return this._base}set base(A){this._base=A,this._baseUri=S.URI.file(A)}get baseUri(){return this._baseUri}set baseUri(A){this._baseUri=A,this._base=A.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};xt=Re([Q],xt),e.RelativePattern=xt;let _t=class{constructor(A,ee,Ee,ze){this.enabled=typeof A=="boolean"?A:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};_t=Re([Q],_t),e.Breakpoint=_t;let Gt=class extends _t{constructor(A,ee,Ee,ze,Ge){super(ee,Ee,ze,Ge);if(A===null)throw(0,t.illegalArgument)("location");this.location=A}};Gt=Re([Q],Gt),e.SourceBreakpoint=Gt;let Kt=class extends _t{constructor(A,ee,Ee,ze,Ge){super(ee,Ee,ze,Ge);this.functionName=A}};Kt=Re([Q],Kt),e.FunctionBreakpoint=Kt;let Qt=class extends _t{constructor(A,ee,Ee,ze,Ge,Xe,et){super(ze,Ge,Xe,et);if(!ee)throw(0,t.illegalArgument)("dataId");this.label=A,this.dataId=ee,this.canPersist=Ee}};Qt=Re([Q],Qt),e.DataBreakpoint=Qt;let Xt=class{constructor(A,ee,Ee){this.command=A,this.args=ee||[],this.options=Ee}};Xt=Re([Q],Xt),e.DebugAdapterExecutable=Xt;let Yt=class{constructor(A,ee){this.port=A,this.host=ee}};Yt=Re([Q],Yt),e.DebugAdapterServer=Yt;let Jt=class{constructor(A){this.path=A}};Jt=Re([Q],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(A){this.implementation=A}};Zt=Re([Q],Zt),e.DebugAdapterInlineImplementation=Zt;let en=class{constructor(A,ee){this.range=A,this.expression=ee}};en=Re([Q],en),e.EvaluatableExpression=en;var Sn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Sn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var bn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(bn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let tn=class{constructor(A,ee){this.range=A,this.text=ee}};tn=Re([Q],tn),e.InlineValueText=tn;let nn=class{constructor(A,ee,Ee=!0){this.range=A,this.variableName=ee,this.caseSensitiveLookup=Ee}};nn=Re([Q],nn),e.InlineValueVariableLookup=nn;let rn=class{constructor(A,ee){this.range=A,this.expression=ee}};rn=Re([Q],rn),e.InlineValueEvaluatableExpression=rn;let sn=class{constructor(A,ee){this.frameId=A,this.stoppedLocation=ee}};sn=Re([Q],sn),e.InlineValueContext=sn;var Cn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Cn=e.FileChangeType||(e.FileChangeType={}));let on=K=class extends Error{constructor(A,ee=R.FileSystemProviderErrorCode.Unknown,Ee){super(S.URI.isUri(A)?A.toString(!0):A);this.code=Ee?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(A){return new K(A,R.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(A){return new K(A,R.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(A){return new K(A,R.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(A){return new K(A,R.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(A){return new K(A,R.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(A){return new K(A,R.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}};on=K=Re([Q],on),e.FileSystemError=on;let an=class{constructor(A,ee,Ee){this.start=A,this.end=ee,this.kind=Ee}};an=Re([Q],an),e.FoldingRange=an;var In;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(In=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Dn;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var kn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(kn=e.CommentThreadState||(e.CommentThreadState={}));class Tn{constructor(A,ee=[]){this.tokenTypes=A,this.tokenModifiers=ee}}e.SemanticTokensLegend=Tn;function Rn(M){return typeof M=="undefined"||(0,p.isStringArray)(M)}class ln{constructor(A){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,A){this._hasLegend=!0;for(let ee=0,Ee=A.tokenTypes.length;ee<Ee;ee++)this._tokenTypeStrToInt.set(A.tokenTypes[ee],ee);for(let ee=0,Ee=A.tokenModifiers.length;ee<Ee;ee++)this._tokenModifierStrToInt.set(A.tokenModifiers[ee],ee)}}push(A,ee,Ee,ze,Ge){if(typeof A=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof ze=="number"&&(typeof Ge=="number"||typeof Ge=="undefined"))return typeof Ge=="undefined"&&(Ge=0),this._pushEncoded(A,ee,Ee,ze,Ge);if(de.isRange(A)&&typeof ee=="string"&&Rn(Ee))return this._push(A,ee,Ee);throw(0,t.illegalArgument)()}_push(A,ee,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(A.start.line!==A.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const ze=A.start.line,Ge=A.start.character,Xe=A.end.character-A.start.character,et=this._tokenTypeStrToInt.get(ee);let ot=0;if(Ee)for(const ct of Ee){if(!this._tokenModifierStrToInt.has(ct))throw new Error("`tokenModifier` is not in the provided legend");const mt=this._tokenModifierStrToInt.get(ct);ot|=1<<mt>>>0}this._pushEncoded(ze,Ge,Xe,et,ot)}_pushEncoded(A,ee,Ee,ze,Ge){if(this._dataIsSortedAndDeltaEncoded&&(A<this._prevLine||A===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ot=this._data.length/5|0;let ct=0,mt=0;for(let wt=0;wt<ot;wt++){let Ct=this._data[5*wt],Ot=this._data[5*wt+1];Ct===0?(Ct=ct,Ot+=mt):Ct+=ct,this._data[5*wt]=Ct,this._data[5*wt+1]=Ot,ct=Ct,mt=Ot}}let Xe=A,et=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ge,this._prevLine=A,this._prevChar=ee}static _sortAndDeltaEncode(A){const ee=[],Ee=A.length/5|0;for(let et=0;et<Ee;et++)ee[et]=et;ee.sort((et,ot)=>{const ct=A[5*et],mt=A[5*ot];if(ct===mt){const wt=A[5*et+1],Ct=A[5*ot+1];return wt-Ct}return ct-mt});const ze=new Uint32Array(A.length);let Ge=0,Xe=0;for(let et=0;et<Ee;et++){const ot=5*ee[et],ct=A[ot+0],mt=A[ot+1],wt=A[ot+2],Ct=A[ot+3],Ot=A[ot+4],yn=ct-Ge,hi=yn===0?mt-Xe:mt,Nt=5*et;ze[Nt+0]=yn,ze[Nt+1]=hi,ze[Nt+2]=wt,ze[Nt+3]=Ct,ze[Nt+4]=Ot,Ge=ct,Xe=mt}return ze}build(A){return this._dataIsSortedAndDeltaEncoded?new cn(new Uint32Array(this._data),A):new cn(ln._sortAndDeltaEncode(this._data),A)}}e.SemanticTokensBuilder=ln;class cn{constructor(A,ee){this.resultId=ee,this.data=A}}e.SemanticTokens=cn;class An{constructor(A,ee,Ee){this.start=A,this.deleteCount=ee,this.data=Ee}}e.SemanticTokensEdit=An;class _n{constructor(A,ee){this.resultId=ee,this.edits=A}}e.SemanticTokensEdits=_n;var Ln;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Ln=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new kt("arrow-left")},Ut=Re([Q],Ut),e.QuickInputButtons=Ut;var Fn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var On;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(On=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Nn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(Nn=e.ExtensionKind||(e.ExtensionKind={}));class Mn{constructor(A,ee,Ee){this.badge=A,this.tooltip=ee,this.color=Ee}static validate(A){if(A.badge){let ee=(0,E.nextCharLength)(A.badge,0);if(ee<A.badge.length&&(ee+=(0,E.nextCharLength)(A.badge,ee)),A.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!A.color&&!A.badge&&!A.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Mn;let un=class{constructor(A){this.kind=A}};un=Re([Q],un),e.ColorTheme=un;var Un;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Un=e.ColorThemeKind||(e.ColorThemeKind={}));class bt{constructor(A,ee){if(A<0)throw(0,t.illegalArgument)("start must be positive");if(ee<0)throw(0,t.illegalArgument)("end must be positive");A<=ee?(this._start=A,this._end=ee):(this._start=ee,this._end=A)}static isNotebookRange(A){return A instanceof bt?!0:A?typeof A.start=="number"&&typeof A.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(A){let ee=this._start,Ee=this._end;return A.start!==void 0&&(ee=A.start),A.end!==void 0&&(Ee=A.end),ee===this._start&&Ee===this._end?this:new bt(ee,Ee)}}e.NotebookRange=bt;class Tt{constructor(A,ee,Ee,ze,Ge,Xe,et){this.kind=A,this.value=ee,this.languageId=Ee,this.mime=ze,this.outputs=Ge??[],this.metadata=Xe,this.executionSummary=et,Tt.validate(this)}static validate(A){if(typeof A.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof A.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof A.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(A){return Array.isArray(A)&&A.every(ee=>Tt.isNotebookCellData(ee))}static isNotebookCellData(A){return!0}}e.NotebookCellData=Tt;class Bn{constructor(A){this.cells=A}}e.NotebookData=Bn;class dt{constructor(A,ee){this.data=A,this.mime=ee;const Ee=(0,k.normalizeMimeType)(ee,!0);if(!Ee)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(A){return A instanceof dt?!0:A?typeof A.mime=="string"&&A.data instanceof Uint8Array:!1}static error(A){const ee={name:A.name,message:A.message,stack:A.stack};return dt.json(ee,"application/vnd.code.notebook.error")}static stdout(A){return dt.text(A,"application/vnd.code.notebook.stdout")}static stderr(A){return dt.text(A,"application/vnd.code.notebook.stderr")}static bytes(A,ee="application/octet-stream"){return new dt(A,ee)}static text(A,ee=k.Mimes.text){const Ee=nt(dt,y,"f",d).encode(String(A));return new dt(Ee,ee)}static json(A,ee="text/x-json"){const Ee=JSON.stringify(A,void 0,"	");return dt.text(Ee,ee)}}e.NotebookCellOutputItem=dt,y=dt,d={value:new TextEncoder};class Bt{constructor(A,ee,Ee){this.items=Bt.ensureUniqueMimeTypes(A,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,T.generateUuid)(),this.metadata=ee??Ee)}static isNotebookCellOutput(A){return A instanceof Bt?!0:!A||typeof A!="object"?!1:typeof A.id=="string"&&Array.isArray(A.items)}static ensureUniqueMimeTypes(A,ee=!1){const Ee=new Set,ze=new Set;for(let Ge=0;Ge<A.length;Ge++){const Xe=A[Ge],et=(0,k.normalizeMimeType)(Xe.mime);if(!Ee.has(et)){Ee.add(et);continue}ze.add(Ge),ee&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?A:A.filter((Ge,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=Bt;var zn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(zn=e.NotebookCellKind||(e.NotebookCellKind={}));var Wn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Wn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var $n;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})($n=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var jn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(jn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Hn{constructor(A,ee){this.text=A,this.alignment=ee}}e.NotebookCellStatusBarItem=Hn;var Vn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class qn{constructor(A,ee=[]){this.uri=A,this.provides=(0,b.asArray)(ee)}}e.NotebookRendererScript=qn;let fn=class{constructor(A,ee){this.label=A,this.timestamp=ee}};fn=Re([Q],fn),e.TimelineItem=fn;var xn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(xn=e.ExtensionMode||(e.ExtensionMode={}));var Gn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Gn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Kn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(Kn=e.StandardTokenType||(e.StandardTokenType={}));class Qn{constructor(A,ee){this.ranges=A,this.wordPattern=ee}}e.LinkedEditingRanges=Qn;class Xn{constructor(A,ee){this._port=A,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Xn;var Yn;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(Yn=e.TestResultState||(e.TestResultState={}));var Jn;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(Jn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let hn=class{constructor(A=void 0,ee=void 0,Ee=void 0){this.include=A,this.exclude=ee,this.profile=Ee}};hn=Re([Q],hn),e.TestRunRequest=hn;let dn=se=class{constructor(A){this.message=A}static diff(A,ee,Ee){const ze=new se(A);return ze.expectedOutput=ee,ze.actualOutput=Ee,ze}};dn=se=Re([Q],dn),e.TestMessage=dn;let mn=class{constructor(A){this.id=A}};mn=Re([Q],mn),e.TestTag=mn;let Lt=class{constructor(A,ee){this.covered=A,this.total=ee}};Lt=Re([Q],Lt),e.CoveredCount=Lt;let gn=F=class{constructor(A,ee,Ee,ze){this.uri=A,this.statementCoverage=ee,this.branchCoverage=Ee,this.functionCoverage=ze}static fromDetails(A,ee){const Ee=new Lt(0,0),ze=new Lt(0,0),Ge=new Lt(0,0);for(const et of ee)if("branches"in et){Ee.total+=1,Ee.covered+=et.executionCount>0?1:0;for(const ot of et.branches)ze.total+=1,ze.covered+=ot.executionCount>0?1:0}else Ge.total+=1,Ge.covered+=et.executionCount>0?1:0;const Xe=new F(A,Ee,ze.total>0?ze:void 0,Ge.total>0?Ge:void 0);return Xe.detailedCoverage=ee,Xe}};gn=F=Re([Q],gn),e.FileCoverage=gn;let pn=class{constructor(A,ee,Ee=[]){this.executionCount=A,this.location=ee,this.branches=Ee}};pn=Re([Q],pn),e.StatementCoverage=pn;let vn=class{constructor(A,ee){this.executionCount=A,this.location=ee}};vn=Re([Q],vn),e.BranchCoverage=vn;let wn=class{constructor(A,ee){this.executionCount=A,this.location=ee}};wn=Re([Q],wn),e.FunctionCoverage=wn;var Zn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(Zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ei;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(ei=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ti;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(ti=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ni{constructor(A,ee,Ee,ze,Ge,Xe){this.kind=A,this.name=ee,this.detail=Ee,this.uri=ze,this.range=Ge,this.selectionRange=Xe}}e.TypeHierarchyItem=ni;class ii{constructor(A){this.uri=A}}e.TextTabInput=ii;class ri{constructor(A,ee){this.original=A,this.modified=ee}}e.TextDiffTabInput=ri;class si{constructor(A,ee,Ee,ze){this.base=A,this.input1=ee,this.input2=Ee,this.result=ze}}e.TextMergeTabInput=si;class oi{constructor(A,ee){this.uri=A,this.viewType=ee}}e.CustomEditorTabInput=oi;class ai{constructor(A){this.viewType=A}}e.WebviewEditorTabInput=ai;class li{constructor(A,ee){this.uri=A,this.notebookType=ee}}e.NotebookEditorTabInput=li;class ci{constructor(A,ee,Ee){this.original=A,this.modified=ee,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=ci;class ui{constructor(){}}e.TerminalEditorTabInput=ui;class fi{constructor(A,ee){this.uri=A,this.inputBoxUri=ee}}e.InteractiveWindowInput=fi}),define(pe[63],ve([0,1,69]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(C){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:C,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function D(C){return new b.URITransformer(t(C))}e.createURITransformer=D}),define(pe[242],ve([0,1,4,63,61,6,207]),function(oe,e,b,t,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class E extends k.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new D.DiskFileSystemProvider(T),T);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,w=!1){if(w&&R.path==="/vscode-resource"&&R.query){const v=JSON.parse(R.query).requestResourcePath;return b.URI.from({scheme:"file",path:v})}return b.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new p(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=E;class p extends k.AbstractSessionFileWatcher{constructor(T,R,w,v){super(T,R,w,v)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const w=R.split(C.delimiter),v=Number(w[0]);if(v>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:v}}}getExtraExcludes(T){if(T.extensionsPath)return[C.posix.join(T.extensionsPath,"**")]}}}),define(pe[79],ve([0,1,183,12,4,2,5,33,17,18,10]),function(oe,e,b,t,D,C,k,E,p,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,b.localize)(0,null),providerDisplayName:(0,b.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var w;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})(w=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function v(U){const O=U;return!!O&&typeof O.getSelection=="function"&&!!O.onDidChangeSelection}e.isEditorPaneWithSelection=v;function h(U,O,B){for(const X of B.visibleEditorPanes)if(X.group.id===O&&U.matches(X.input))return X.getViewState()}e.findViewStateForEditor=h;function I(U){if(i(U))return!1;const O=U;return D.URI.isUri(O?.resource)}e.isResourceEditorInput=I;function y(U){if(i(U))return!1;const O=U;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=y;function d(U){if(i(U)||y(U))return!1;const O=U;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function g(U){if(i(U))return!1;const O=U;return O?O.resource===void 0||O.resource.scheme===T.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function u(U){if(i(U))return!1;const O=U;return D.URI.isUri(O?.base?.resource)&&D.URI.isUri(O?.input1?.resource)&&D.URI.isUri(O?.input2?.resource)&&D.URI.isUri(O?.result?.resource)}e.isResourceMergeEditorInput=u;var l;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var f;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(O,B){let X=this.mapIdToSaveSource.get(O);return X||(X={source:O,label:B},this.mapIdToSaveSource.set(O,X)),X.source}getSourceLabel(O){return this.mapIdToSaveSource.get(O)?.label??O}}e.SaveSourceRegistry=new r;var o;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends C.Disposable{}e.AbstractEditorInput=n;function i(U){return U instanceof n}e.isEditorInput=i;function s(U){const O=U;return D.URI.isUri(O?.preferredResource)}function a(U){const O=U;return i(O?.primary)&&i(O?.secondary)}e.isSideBySideEditorInput=a;function c(U){const O=U;return i(O?.modified)&&i(O?.original)}e.isDiffEditorInput=c;function m(U){return i(U?.editor)}e.isEditorInputWithOptions=m;function P(U){const O=U;return m(U)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function _(U){const O=U;return typeof O?.groupId=="number"&&i(O.editor)}e.isEditorIdentifier=_;var W;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(W=e.EditorCloseContext||(e.EditorCloseContext={}));var K;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LOCKED=2]="GROUP_LOCKED",U[U.EDITOR_OPEN=3]="EDITOR_OPEN",U[U.EDITOR_CLOSE=4]="EDITOR_CLOSE",U[U.EDITOR_MOVE=5]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=7]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=9]="EDITOR_PIN",U[U.EDITOR_STICKY=10]="EDITOR_STICKY",U[U.EDITOR_DIRTY=11]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(K=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var se;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(se=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(O,B){if(!O)return;if(u(O))return e.EditorResourceAccessor.getOriginalUri(O.result,B);if(B?.supportSideBySide){const{primary:ce,secondary:ue}=this.getSideEditors(O);if(ce&&ue){if(B?.supportSideBySide===se.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===se.ANY)return this.getOriginalUri(ce,{filterByScheme:B.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:B.filterByScheme});O=B.supportSideBySide===se.PRIMARY?ce:ue}}if(y(O)||d(O)||u(O))return;const X=s(O)?O.preferredResource:O.resource;return!X||!B||!B.filterByScheme?X:this.filterUri(X,B.filterByScheme)}getSideEditors(O){return a(O)||d(O)?{primary:O.primary,secondary:O.secondary}:c(O)||y(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,B){if(!O)return;if(u(O))return e.EditorResourceAccessor.getCanonicalUri(O.result,B);if(B?.supportSideBySide){const{primary:ce,secondary:ue}=this.getSideEditors(O);if(ce&&ue){if(B?.supportSideBySide===se.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===se.ANY)return this.getCanonicalUri(ce,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:B.filterByScheme});O=B.supportSideBySide===se.PRIMARY?ce:ue}}if(y(O)||d(O)||u(O))return;const X=O.resource;return!X||!B||!B.filterByScheme?X:this.filterUri(X,B.filterByScheme)}filterUri(O,B){if(Array.isArray(B)){if(B.some(X=>O.scheme===X))return O}else if(B===O.scheme)return O}}e.EditorResourceAccessor=new F;var Q;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(Q=e.CloseDirection||(e.CloseDirection={}));class re{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const B=this.instantiationService=O.get(k.IInstantiationService);for(const[X,ce]of this.editorSerializerConstructors)this.createEditorSerializer(X,ce,B);this.editorSerializerConstructors.clear()}createEditorSerializer(O,B,X){const ce=X.createInstance(B);this.editorSerializerInstances.set(O,ce)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,B){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,B,this.instantiationService):this.editorSerializerConstructors.set(O,B),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new re);async function G(U,O){if(!U||!U.length)return[];const B=await Promise.all(U.map(async X=>{const ce=D.URI.revive(X.fileUri);if(!ce||!await O.canHandleResource(ce))return;let Y=X.exists,ie=X.type;if(typeof Y!="boolean"||typeof ie!="number")try{ie=(await O.stat(ce)).isDirectory?p.FileType.Directory:p.FileType.Unknown,Y=!0}catch{Y=!1}if(!Y&&X.openOnlyIfExists||ie===p.FileType.Directory)return;const L={...X.options,pinned:!0};let N;return Y?N={resource:ce,options:L}:N={resource:ce,options:L,forceUntitled:!0},N}));return(0,S.coalesce)(B)}e.pathsToEditors=G;var de;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(de=e.EditorsOrder||(e.EditorsOrder={}));function J(U){const O=U;if(!O)return!1;const B=O;if(B.modified)return J(B.modified);const X=O;return!!(X.contributionsState&&X.viewState&&Array.isArray(X.cursorState))}e.isTextEditorViewState=J}),define(pe[243],ve([0,1,16,68,45,66,10,6,3,98]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var T;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json",C.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(a){a[a.Unconfirmed=1]="Unconfirmed",a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var I;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeCellLanguage=5]="ChangeCellLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var y;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(y=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var g;(function(a){a.scheme=k.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${c.join("")}]+`),P=7;function _(G,de){const J=de.toString(P),O=`${J.length<c.length?c[J.length-1]:"z"}${J}s${(0,b.encodeBase64)(b.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:a.scheme,fragment:O})}a.generate=_;function W(G){if(G.scheme!==a.scheme)return;const de=G.fragment.indexOf("s");if(de<0)return;const J=parseInt(G.fragment.substring(0,de).replace(m,""),P),U=(0,b.decodeBase64)(G.fragment.substring(de+1)).toString();if(!isNaN(J))return{handle:J,notebook:G.with({scheme:U,fragment:null})}}a.parse=W;const K=/^(\d{8,})(\w[\w\d+.-]*)$/;function se(G,de){return G.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${G.scheme!==k.Schemas.file?G.scheme:""}`})}a.generateCellOutputUri=se;function F(G){if(G.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!de)return;const J=de[1]&&de[1]!==""?de[1]:void 0,U=de[2];return{outputId:J,notebook:G.with({scheme:U||k.Schemas.file,fragment:null})}}a.parseCellOutputUri=F;function Q(G,de,J){return G.with({scheme:J,fragment:`ch${de.toString().padStart(7,"0")}${G.scheme!==k.Schemas.file?G.scheme:""}`})}a.generateCellUri=Q;function re(G,de){if(G.scheme!==de)return;const J=K.exec(G.fragment);return J?{handle:Number(J[1]),notebook:G.with({scheme:G.fragment.substring(J[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parseCellUri=re})(g=e.CellUri||(e.CellUri={}));const u=a=>p.isWindows?a.replace(/\//g,"\\"):a;class l{constructor(c=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(c)].map(P=>({pattern:P,matches:t.parse(u(P))}))}sort(c){const m=new Map(D.Iterable.map(c,_=>[_,u(_)]));let P=[];for(const{matches:_}of this.order)for(const[W,K]of m)if(_(K)){P.push(W),m.delete(W);break}return m.size&&(P=P.concat([...m.keys()].sort((_,W)=>this.defaultOrder.indexOf(_)-this.defaultOrder.indexOf(W)))),P}prioritize(c,m){const P=this.findIndex(c);if(P===-1){this.order.unshift({pattern:c,matches:t.parse(u(c))});return}const _=new Set(m.map(K=>this.findIndex(K,P)));_.delete(-1);const W=Array.from(_).sort();this.order.splice(P+1,0,...W.map(K=>this.order[K]));for(let K=W.length-1;K>=0;K--)this.order.splice(W[K],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,m=this.order.length){const P=u(c);for(let _=0;_<m;_++)if(this.order[_].matches(P))return _;return-1}}e.MimeTypeDisplayOrder=l;function f(a,c,m,P=(_,W)=>_===W){const _=[];function W(F,Q,re){if(Q===0&&re.length===0)return;const G=_[_.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=Q,G.toInsert.push(...re)):_.push({start:F,deleteCount:Q,toInsert:re})}let K=0,se=0;for(;;){if(K===a.length){W(K,0,c.slice(se));break}if(se===c.length){W(K,a.length-K,[]);break}const F=a[K],Q=c[se];if(P(F,Q)){K+=1,se+=1;continue}m(Q)?(W(K,1,[]),K+=1):(W(K,0,[Q]),se+=1)}return _}e.diff=f,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const c=a;return!!((typeof c.include=="string"||t.isRelativePattern(c.include))&&(typeof c.exclude=="string"||t.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=o;function n(a,c,m){if(Array.isArray(a.viewType)&&a.viewType.indexOf(c)>=0||a.viewType===c)return!0;if(a.filenamePattern){const P=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,_=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(t.match(P,(0,E.basename)(m.fsPath).toLowerCase()))return!(_&&t.match(_,(0,E.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(c){return`${s._prefix}${c}`}static parse(c){if(c.startsWith(s._prefix))return c.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(pe[119],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,b.createDecorator)("environmentVariableService");var t;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(pe[244],ve([0,1,3,119]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(p){this.collections=p,this.map=new Map,p.forEach((S,T)=>{const R=S.map.entries();let w=R.next();for(;!w.done;){const v=w.value[0];let h=this.map.get(v);if(h||(h=[],this.map.set(v,h)),h.length>0&&h[0].type===t.EnvironmentVariableMutatorType.Replace){w=R.next();continue}const I=w.value[1];h.unshift({extensionIdentifier:T,value:I.value,type:I.type}),w=R.next()}})}async applyToProcessEnvironment(p,S){let T;b.isWindows&&(T={},Object.keys(p).forEach(R=>T[R.toLowerCase()]=R));for(const[R,w]of this.map){const v=b.isWindows&&T[R.toLowerCase()]||R;for(const h of w){const I=S?await S(h.value):h.value;switch(h.type){case t.EnvironmentVariableMutatorType.Append:p[v]=(p[v]||"")+I;break;case t.EnvironmentVariableMutatorType.Prepend:p[v]=I+(p[v]||"");break;case t.EnvironmentVariableMutatorType.Replace:p[v]=I;break}}}}diff(p){const S=new Map,T=new Map,R=new Map;if(p.map.forEach((w,v)=>{const h=this.map.get(v),I=C(w,h);I&&S.set(v,I)}),this.map.forEach((w,v)=>{const h=p.map.get(v),I=C(w,h);I&&R.set(v,I)}),this.map.forEach((w,v)=>{const h=p.map.get(v),I=k(w,h);I&&T.set(v,I)}),!(S.size===0&&T.size===0&&R.size===0))return{added:S,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=D;function C(E,p){if(!p)return E;const S=new Set;p.forEach(R=>S.add(R.extensionIdentifier));const T=[];return E.forEach(R=>{S.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function k(E,p){if(!p)return;const S=new Map;p.forEach(R=>S.set(R.extensionIdentifier,R));const T=[];return E.forEach(R=>{const w=S.get(R.extensionIdentifier);w&&(R.type!==w.type||R.value!==w.value)&&T.push(w)}),T.length===0?void 0:T}}),define(pe[120],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=b;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t;function D(k){return Array.from(k.entries()).map(E=>[E[0],b(E[1].map)])}e.serializeEnvironmentVariableCollections=D;function C(k){return new Map(k.map(E=>[E[0],{map:t(E[1])}]))}e.deserializeEnvironmentVariableCollections=C}),define(pe[245],ve([0,1,6,56,3]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function C(l,f){if(!!f)if(D.isWindows)for(const r in f){let o=r;for(const i in l)if(r.toLowerCase()===i.toLowerCase()){o=i;break}const n=f[r];n!==void 0&&k(l,o,n)}else Object.keys(f).forEach(r=>{const o=f[r];o!==void 0&&k(l,r,o)})}e.mergeEnvironments=C;function k(l,f,r){typeof r=="string"?l[f]=r:delete l[f]}function E(l,f,r,o){l.TERM_PROGRAM="vscode",f&&(l.TERM_PROGRAM_VERSION=f),T(l,o)&&(l.LANG=R(r)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=E;function p(l,f){if(!!f)for(const r of Object.keys(f)){const o=f[r];o&&(l[r]=o)}}async function S(l,f){return await Promise.all(Object.entries(f).map(async([r,o])=>{if(typeof o=="string")try{f[r]=await l(o)}catch{f[r]=o}})),f}function T(l,f){if(f==="on")return!0;if(f==="auto"){const r=l.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function R(l){const f=l?l.split("-"):[],r=f.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};f[0]in o&&f.push(o[f[0]])}else f[1]=f[1].toUpperCase();return f.join("_")+".UTF-8"}e.getLangEnvVariable=R;async function w(l,f,r,o,n,i){if(l.cwd){const a=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,c=await v(a,r);return h(c||a)}let s;return!l.ignoreConfigurationCwd&&n&&(r&&(n=await v(n,r,i)),n&&(b.isAbsolute(n)?s=n:o&&(s=b.join(o.fsPath,n)))),s||(s=o?o.fsPath:f||""),h(s)}e.getCwd=w;async function v(l,f,r){if(f)try{return await f(l)}catch(o){r?.error("Could not resolve terminal cwd",o);return}return l}function h(l){return D.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function I(l,f,r){if(!!r)return o=>r.resolveWithEnvironment(f,l,o)}e.createVariableResolver=I;async function y(l,f,r,o,n,i,s,a=D.platform){let c;s&&(c=g(l,"automationShell",a)),c||(c=g(l,"shell",a));let m=c||f;if(a===3&&!r&&o){const P=b.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();m&&m.toLowerCase().indexOf(P)===0&&(m=b.join(o,"System32",m.substr(P.length+1)))}if(m&&a===3&&(m=m.replace(/\//g,"\\")),n)try{m=await n(m)}catch(P){i.error("Could not resolve shell",P)}return m}e.getDefaultShell=y;async function d(l,f,r,o,n=D.platform){if(f&&g(l,"automationShell",n))return[];const i=n===3?"windows":n===1?"osx":"linux";let s=l(`terminal.integrated.shellArgs.${i}`);if(!s)return[];if(typeof s=="string"&&n===3)return r?await r(s):s;if(r){const a=[];for(const c of s)try{a.push(await r(c))}catch(m){o.error(`Could not resolve terminal.integrated.shellArgs.${i}`,m),a.push(c)}s=a}return s}e.getDefaultShellArgs=d;function g(l,f,r=D.platform){return l(`terminal.integrated.${f}.${r===3?"windows":r===1?"osx":"linux"}`)}async function u(l,f,r,o,n,i){const s={};if(l.strictEnv)p(s,l.env);else{p(s,i);const a={...f};r&&(a&&await S(r,a),l.env&&await S(r,l.env)),(0,t.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI"),C(s,a),C(s,l.env),E(s,o,D.locale,n)}return s}e.createTerminalEnvironment=u}),define(pe[80],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var b;(function(C){C.Delimiter="\0"})(b=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(k,E=k.length){if(this.path=k,this.viewEnd=E,k.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,E,p=k.parent){if(k.id===E)return new D([E]);const S=[k.id];for(let T=p;T&&T.id!==E;T=T.parent)S.push(T.id);return S.push(E),new D(S.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const E=k.indexOf("\0");return E===-1?k:k.slice(0,E)}static fromString(k){return new D(k.split("\0"))}static join(k,E){return new D([...k.path,E])}static joinToString(k,E){return k.toString()+"\0"+E}static compare(k,E){return k===E?0:E.startsWith(k+"\0")?2:k.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new D(this.path,k)}compare(k){if(typeof k=="string")return D.compare(this.toString(),k);for(let E=0;E<k.viewEnd&&E<this.viewEnd;E++)if(k.path[E]!==this.path[E])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=D}),define(pe[81],ve([0,1,4,48]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:t.Range.lift(a.range),uri:b.URI.revive(a.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var E;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var p;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&k.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&k.deserialize(a.location)})})(p=e.ITestErrorMessage||(e.ITestErrorMessage={}));var S;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&k.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&k.deserialize(a.location)})})(S=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(s){s.serialize=a=>a.type===0?p.serialize(a):S.serialize(a),s.deserialize=a=>a.type===0?p.deserialize(a):S.deserialize(a)})(T=e.ITestMessage||(e.ITestMessage={}));var R;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(T.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(T.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const w="\0",v=(s,a)=>s+w+a;e.namespaceTestTag=v;const h=s=>{const a=s.indexOf(w);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=h;var I;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?b.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(I=e.ITestItem||(e.ITestItem={}));var y;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));var d;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:I.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:I.deserialize(a.item)})})(d=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=a=>{let c;return a.item&&(c={},a.item.label!==void 0&&(c.label=a.item.label),a.item.tags!==void 0&&(c.tags=a.item.tags),a.item.busy!==void 0&&(c.busy=a.item.busy),a.item.uri!==void 0&&(c.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(c.range=a.item.range?.toJSON()),a.item.description!==void 0&&(c.description=a.item.description),a.item.error!==void 0&&(c.error=a.item.error),a.item.sortText!==void 0&&(c.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:c}},s.deserialize=a=>{let c;return a.item&&(c={},a.item.label!==void 0&&(c.label=a.item.label),a.item.tags!==void 0&&(c.tags=a.item.tags),a.item.busy!==void 0&&(c.busy=a.item.busy),a.item.range!==void 0&&(c.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(c.description=a.item.description),a.item.error!==void 0&&(c.error=a.item.error),a.item.sortText!==void 0&&(c.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:c}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const u=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=u;var l;(function(s){s.serializeWithoutMessages=a=>({...d.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(R.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...d.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(R.serialize),retired:a.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var f;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(f=e.DetailType||(e.DetailType={}));var r;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:d.deserialize(a.item)}:a.op===1?{op:a.op,item:g.deserialize(a.item)}:a,s.serialize=a=>a.op===0?{op:a.op,item:d.serialize(a.item)}:a.op===1?{op:a.op,item:g.serialize(a.item)}:a})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(a){}update(a){}remove(a,c){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const c=this.createChangeCollector();for(const m of a)switch(m.op){case 0:{const P=d.deserialize(m.item);if(P.parent){if(this.items.has(P.parent)){const _=this.items.get(P.parent);_.children.add(P.item.extId);const W=this.createItem(P,_);this.items.set(P.item.extId,W),c.add(W)}}else{const _=this.createItem(P);this.roots.add(_),this.items.set(P.item.extId,_),c.add(_)}P.expand===2&&this.busyControllerCount++;break}case 1:{const P=g.deserialize(m.item),_=this.items.get(P.extId);if(!_)break;P.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,P.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,P),c.update(_);break}case 2:{const P=this.items.get(m.itemId);if(!P)break;P.parent?this.items.get(P.parent).children.delete(P.item.extId):this.roots.delete(P);const _=[[m.itemId]];for(;_.length;)for(const W of _.pop()){const K=this.items.get(W);K&&(_.push(K.children),this.items.delete(W),c.remove(K,K!==P),K.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}c.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(pe[121],ve([0,1,14,7,2,82,81,80]),function(oe,e,b,t,D,C,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk"})(p=e.TestItemEventOp||(e.TestItemEventOp={}));const S=(d,g)=>d===g,T={range:(d,g)=>d===g?!0:!d||!g?!1:d.equalsRange(g),busy:S,label:S,description:S,error:S,tags:(d,g)=>!(d.length!==g.length||d.some(u=>!g.includes(u)))},R=(d,g)=>{let u;for(const[l,f]of Object.entries(T))f(d[l],g[l])||(u?u[l]=g[l]:u={[l]:g[l]});return u};class w extends D.Disposable{constructor(g){super();this.options=g,this.debounceSendDiff=this._register(new b.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const u of this.tree.values())this.updateExpandability(u)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const u=this.diff[this.diff.length-1];if(u&&g.op===1){if(u.op===1&&u.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(u.item,g.item);return}if(u.op===0&&u.item.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(u.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,u){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const f=this.resolveChildren(l);return f.isOpen()?this.expandChildren(l,u-1):f.wait().then(()=>this.expandChildren(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,u-1)):this.expandChildren(l,u-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,u){switch(u.op){case 3:this.removeItem(E.TestId.joinToString(g.fullId,u.id));break;case 0:this.upsertItem(u.item,g);break;case 5:for(const l of u.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(u.new,u.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:u.update}});break;default:(0,C.assertNever)(u)}}upsertItem(g,u){const l=E.TestId.fromExtHostTestItem(g,this.root.id,u?.actual),f=this.options.getApiFor(g);f.parent&&f.parent!==u?.actual&&this.options.getChildren(f.parent).delete(g.id);let r=this.tree.get(l.toString());if(!r){r={fullId:l,actual:g,parent:u?l.parentId:null,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(g,u),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,r,u);return}if(r.actual===g){this.connectItem(g,r,u);return}const o=this.options.getChildren(r.actual),n=r.actual,i=R(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,r.actual=g,r.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,l.toString()),delete i.tags),this.onTestItemEvent(r,{op:4,update:i})),this.connectItemAndChildren(g,r,u);for(const[s,a]of o)this.options.getChildren(g).get(a.id)||this.removeItem(E.TestId.joinToString(l,a.id))}diffTagRefs(g,u,l){const f=new Set(u.map(r=>r.id));for(const r of g)f.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(r=>(0,k.namespaceTestTag)(this.options.controllerId,r.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const u=this.tags.get(g.id);u?u.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const u=this.tags.get(g);u&&!--u.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,k.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,u){this.options.getApiFor(g).parent=u&&u.actual!==this.root?u.actual:void 0}connectItem(g,u,l){this.setItemParent(g,l);const f=this.options.getApiFor(g);f.parent=l?.actual,f.listener=r=>this.onTestItemEvent(u,r),this.updateExpandability(u)}connectItemAndChildren(g,u,l){this.connectItem(g,u,l);for(const[f,r]of this.options.getChildren(g))this.upsertItem(r,u)}updateExpandability(g){let u;this._resolveHandler?g.resolveBarrier?u=g.resolveBarrier.isOpen()?3:2:u=g.actual.canResolveChildren?1:0:u=0,u!==g.expand&&(g.expand=u,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:u}}),u===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,u){if(u<0)return;const l=[];for(const[f,r]of this.options.getChildren(g.actual)){const o=this.expand(E.TestId.joinToString(g.fullId,r.id),u);(0,b.isThenable)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const r=new b.Barrier;return r.open(),r}g.expand=2,this.pushExpandStateUpdate(g);const u=g.resolveBarrier=new b.Barrier,l=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let f;try{f=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(r){l(r)}return(0,b.isThenable)(f)?f.catch(l).then(()=>{u.open(),this.updateExpandability(g)}):(u.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const u=this.tree.get(g);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[u];for(;l.length;){const f=l.pop();if(!!f){this.options.getApiFor(f.actual).listener=void 0;for(const r of f.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(f.fullId.toString());for(const[r,o]of this.options.getChildren(f.actual))l.push(this.tree.get(E.TestId.joinToString(f.fullId,o.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=w;class v extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=v;class h extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class I extends Error{constructor(g,u,l){super(`TestItem with ID "${g}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=I;const y=(d,g,u)=>{let l=new Map;return{get size(){return l.size},forEach(f,r){for(const o of l.values())f.call(r,o,this)},[Symbol.iterator](){return l.entries()},replace(f){const r=new Map,o=new Set(l.keys()),n={op:5,ops:[]};for(const i of f){if(!(i instanceof u))throw new h(i.id);const s=g(i).controllerId;if(s!==d.controllerId)throw new I(i.id,s,d.controllerId);if(r.has(i.id))throw new v(i.id);r.set(i.id,i),o.delete(i.id),n.ops.push({op:0,item:i})}for(const i of o.keys())n.ops.push({op:3,id:i});d.listener?.(n),l=r},add(f){if(!(f instanceof u))throw new h(f.id);l.set(f.id,f),d.listener?.({op:0,item:f})},delete(f){l.delete(f)&&d.listener?.({op:3,id:f})},get(f){return l.get(f)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=y}),define(pe[122],ve([0,1,121]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(k,E)=>{const p={controllerId:E};return t.set(k,p),p};e.createPrivateApiFor=D;const C=k=>{const E=t.get(k);if(!E)throw new b.InvalidTestItemError(k?.id||"<unknown>");return E};e.getPrivateApiFor=C}),define(pe[246],ve([0,1,25,5]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(b.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(pe[123],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,b.createDecorator)("configurationResolverService");var t;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(k,E){super(E);this.variable=k}}e.VariableError=D}),define(pe[247],ve([0,1,6,28,12,22,3,151,184,123,15]),function(oe,e,b,t,D,C,k,E,p,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(v,h,I,y){this._contributedVariables=new Map,this._context=v,this._labelService=h,this._userHomePromise=I,y&&(this._envVariablesPromise=y.then(d=>this.prepareEnv(d)))}prepareEnv(v){if(k.isWindows){const h=Object.create(null);return Object.keys(v).forEach(I=>{h[I.toLowerCase()]=v[I]}),h}return v}resolveWithEnvironment(v,h,I){return this.recursiveResolve({env:this.prepareEnv(v),userHome:void 0},h?h.uri:void 0,I)}async resolveAsync(v,h){const I={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(I,v?v.uri:void 0,h)}async resolveAnyBase(v,h,I,y){const d=C.deepClone(h);k.isWindows&&d.windows?Object.keys(d.windows).forEach(u=>d[u]=d.windows[u]):k.isMacintosh&&d.osx?Object.keys(d.osx).forEach(u=>d[u]=d.osx[u]):k.isLinux&&d.linux&&Object.keys(d.linux).forEach(u=>d[u]=d.linux[u]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,v?v.uri:void 0,d,I,y)}async resolveAnyAsync(v,h,I){return this.resolveAnyBase(v,h,I)}async resolveAnyMap(v,h,I){const y=new Map;return{newConfig:await this.resolveAnyBase(v,h,I,y),resolvedVariables:y}}resolveWithInteractionReplace(v,h,I,y){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,h,I,y){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,h){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,h)}async recursiveResolve(v,h,I,y,d){if(D.isString(I))return this.resolveString(v,h,I,y,d);if(Array.isArray(I))return Promise.all(I.map(g=>this.recursiveResolve(v,h,g,y,d)));if(D.isObject(I)){const g=Object.create(null),u=await Promise.all(Object.keys(I).map(async l=>[await this.resolveString(v,h,l,y,d),await this.recursiveResolve(v,h,I[l],y,d)]));for(const[l,f]of u)g[l]=f;return g}return I}resolveString(v,h,I,y,d){return(0,T.replaceAsync)(I,R.VARIABLE_REGEXP,async(g,u)=>{if(u.includes(R.VARIABLE_LHS))return g;let l=await this.evaluateSingleVariable(v,g,u,h,y);return d?.set(u,l),l!==g&&D.isString(l)&&l.match(R.VARIABLE_REGEXP)&&(l=await this.resolveString(v,h,l,y,d)),l})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}async evaluateSingleVariable(v,h,I,y,d){let g;const u=I.split(":");u.length>1&&(I=u[0],g=u[1]);const l=o=>{const n=this._context.getFilePath();if(n)return n;throw new S.VariableError(o,(0,p.localize)(0,null,h))},f=o=>{const n=l(o);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new S.VariableError(o,(0,p.localize)(1,null,h,b.basename(n)))},r=o=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new S.VariableError(o,(0,p.localize)(2,null,h,g))}if(y)return y;throw this._context.getWorkspaceFolderCount()>1?new S.VariableError(o,(0,p.localize)(3,null,h)):new S.VariableError(o,(0,p.localize)(4,null,h))};switch(I){case"env":if(g){if(v.env){const o=v.env[k.isWindows?g.toLowerCase():g];if(D.isString(o))return o}return""}throw new S.VariableError(S.VariableKind.Env,(0,p.localize)(5,null,h));case"config":if(g){const o=this._context.getConfigurationValue(y,g);if(D.isUndefinedOrNull(o))throw new S.VariableError(S.VariableKind.Config,(0,p.localize)(6,null,h,g));if(D.isObject(o))throw new S.VariableError(S.VariableKind.Config,(0,p.localize)(7,null,h,g));return o}throw new S.VariableError(S.VariableKind.Config,(0,p.localize)(8,null,h));case"command":return this.resolveFromMap(S.VariableKind.Command,h,g,d,"command");case"input":return this.resolveFromMap(S.VariableKind.Input,h,g,d,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new S.VariableError(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,h,g));return this.fsPath(o.extensionLocation)}throw new S.VariableError(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,h));default:switch(I){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(r(S.VariableKind.WorkspaceFolder)));case"cwd":return y||g?(0,E.normalizeDriveLetter)(this.fsPath(r(S.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(r(S.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(v.userHome)return v.userHome;throw new S.VariableError(S.VariableKind.UserHome,(0,p.localize)(11,null,h))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new S.VariableError(S.VariableKind.LineNumber,(0,p.localize)(12,null,h))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new S.VariableError(S.VariableKind.SelectedText,(0,p.localize)(13,null,h))}case"file":return l(S.VariableKind.File);case"fileWorkspaceFolder":return f(S.VariableKind.FileWorkspaceFolder);case"relativeFile":return y||g?b.relative(this.fsPath(r(S.VariableKind.RelativeFile)),l(S.VariableKind.RelativeFile)):l(S.VariableKind.RelativeFile);case"relativeFileDirname":{const o=b.dirname(l(S.VariableKind.RelativeFileDirname));if(y||g){const n=b.relative(this.fsPath(r(S.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return b.dirname(l(S.VariableKind.FileDirname));case"fileExtname":return b.extname(l(S.VariableKind.FileExtname));case"fileBasename":return b.basename(l(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=b.basename(l(S.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-b.extname(o).length)}case"fileDirnameBasename":return b.basename(b.dirname(l(S.VariableKind.FileDirnameBasename)));case"execPath":{const o=this._context.getExecPath();return o||h}case"execInstallFolder":{const o=this._context.getAppRoot();return o||h}case"pathSeparator":return b.sep;default:try{const o=g?`${I}:${g}`:I;return this.resolveFromMap(S.VariableKind.Unknown,h,o,d,void 0)}catch{return h}}}}resolveFromMap(v,h,I,y,d){if(I&&y){const g=d===void 0?y[I]:y[d+":"+I];if(typeof g=="string")return g;throw new S.VariableError(v,(0,p.localize)(14,null,h))}return h}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[248],ve([0,1,5,79]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var D;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var E;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var p;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(p=e.MergeGroupMode||(e.MergeGroupMode={}));function S(h){const I=h;return(0,t.isEditorInput)(I?.editor)&&(0,t.isEditorInput)(I?.replacement)}e.isEditorReplacement=S;var T;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function w(h){const I=h;return!!I&&typeof I.id=="number"&&Array.isArray(I.editors)}e.isEditorGroup=w;function v(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(pe[124],ve([0,1,5,248]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const k=C;return typeof C=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=D}),define(pe[125],ve([0,1,18,16,90,24,135,41,22,12,4,48,156,208,122,79,243,80,81,124,118,64]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Se){function Ie(H){const{selectionStartLineNumber:De,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:Ve}=H,$e=new l.Position(De-1,Le-1),lt=new l.Position(Ye-1,Ve-1);return new l.Selection($e,lt)}Se.to=Ie;function he(H){const{anchor:De,active:Le}=H;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=he})(r=e.Selection||(e.Selection={}));var o;(function(Se){function Ie(H){if(!H)return;const{start:De,end:Le}=H;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Ie;function he(H){if(!H)return;const{startLineNumber:De,startColumn:Le,endLineNumber:Ye,endColumn:Ve}=H;return new l.Range(De-1,Le-1,Ye-1,Ve-1)}Se.to=he})(o=e.Range||(e.Range={}));var n;(function(Se){function Ie(he){switch(he){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=Ie})(n=e.TokenType||(e.TokenType={}));var i;(function(Se){function Ie(H){return new l.Position(H.lineNumber-1,H.column-1)}Se.to=Ie;function he(H){return{lineNumber:H.line+1,column:H.character+1}}Se.from=he})(i=e.Position||(e.Position={}));var s;(function(Se){function Ie(De,Le){return(0,b.coalesce)((0,b.asArray)(De).map(Ye=>he(Ye,Le)))}Se.from=Ie;function he(De,Le){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:H(De.scheme,Le),pattern:ae.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function H(De,Le){return Le&&typeof De=="string"?Le.transformOutgoingScheme(De):De}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function Ie(H){switch(H){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function he(H){switch(H){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=he})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Se){function Ie(H){let De;return H.code&&((0,S.isString)(H.code)||(0,S.isNumber)(H.code)?De=String(H.code):De={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:De,severity:P.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(m.from),tags:Array.isArray(H.tags)?(0,b.coalesce)(H.tags.map(a.from)):void 0}}Se.from=Ie;function he(H){const De=new l.Diagnostic(o.to(H),H.message,P.to(H.severity));return De.source=H.source,De.code=(0,S.isString)(H.code)?H.code:H.code?.value,De.relatedInformation=H.relatedInformation&&H.relatedInformation.map(m.to),De.tags=H.tags&&(0,b.coalesce)(H.tags.map(a.to)),De}Se.to=he})(c=e.Diagnostic||(e.Diagnostic={}));var m;(function(Se){function Ie(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Se.from=Ie;function he(H){return new l.DiagnosticRelatedInformation(new l.Location(H.resource,o.to(H)),H.message)}Se.to=he})(m=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var P;(function(Se){function Ie(H){switch(H){case l.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}Se.from=Ie;function he(H){switch(H){case v.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=he})(P=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var _;(function(Se){function Ie(H){return typeof H=="number"&&H>=l.ViewColumn.One?H-1:H===l.ViewColumn.Beside?u.SIDE_GROUP:u.ACTIVE_GROUP}Se.from=Ie;function he(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=he})(_=e.ViewColumn||(e.ViewColumn={}));function W(Se){return typeof Se.range!="undefined"}function K(Se){return Se.length===0?!0:!!W(Se[0])}e.isDecorationOptionsArr=K;var se;(function(Se){function Ie(Ve){return Ve.map(Se.from)}Se.fromMany=Ie;function he(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function H(Ve){let $e;if(he(Ve)){const{language:at,value:St}=Ve;$e={value:"```"+at+`
`+St+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ve)?$e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?$e={value:Ve}:$e={value:""};const lt=Object.create(null);$e.uris=lt;const Et=at=>{try{let St=T.URI.parse(at,!0);St=St.with({query:De(St.query,lt)}),lt[at]=St}catch{}return""},vt=new k.marked.Renderer;return vt.link=Et,vt.image=at=>typeof at=="string"?Et(D.parseHrefAndDimensions(at).href):"",(0,k.marked)($e.value,{renderer:vt}),$e}Se.from=H;function De(Ve,$e){if(!Ve)return Ve;let lt;try{lt=(0,E.parse)(Ve)}catch{}if(!lt)return Ve;let Et=!1;return lt=(0,p.cloneAndChange)(lt,vt=>{if(T.URI.isUri(vt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return $e[at]=vt,Et=!0,at}else return}),Et?JSON.stringify(lt):Ve}function Le(Ve){const $e=new l.MarkdownString(Ve.value,Ve.supportThemeIcons);return $e.isTrusted=Ve.isTrusted,$e.supportHtml=Ve.supportHtml,$e.baseUri=Ve.baseUri?T.URI.from(Ve.baseUri):void 0,$e}Se.to=Le;function Ye(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Se.from(Ve)}Se.fromStrict=Ye})(se=e.MarkdownString||(e.MarkdownString={}));function F(Se){return K(Se)?Se.map(Ie=>({range:o.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?se.fromMany(Ie.hoverMessage):Ie.hoverMessage?se.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:o.from(Ie)}))}e.fromRangeOrRangeWithMessage=F;function Q(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?T.URI.file(Se):Se}e.pathOrURIToURI=Q;var re;(function(Se){function Ie(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?Q(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Se.from=Ie})(re=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var G;(function(Se){function Ie(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Q(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?re.from(he.before):void 0,after:he.after?re.from(he.after):void 0}}Se.from=Ie})(G=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var de;(function(Se){function Ie(he){if(typeof he=="undefined")return he;switch(he){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var J;(function(Se){function Ie(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?de.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?G.from(he.light):void 0,dark:he.dark?G.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Q(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?re.from(he.before):void 0,after:he.after?re.from(he.after):void 0}}Se.from=Ie})(J=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(Se){function Ie(H){return{text:H.newText,eol:H.newEol&&We.from(H.newEol),range:o.from(H.range)}}Se.from=Ie;function he(H){const De=new l.TextEdit(o.to(H.range),H.text);return De.newEol=typeof H.eol=="undefined"?void 0:We.to(H.eol),De}Se.to=he})(U=e.TextEdit||(e.TextEdit={}));var O;(function(Se){function Ie(H,De,Le){const Ye={edits:[]};if(H instanceof l.WorkspaceEdit){const Ve=new C.ResourceSet;for(const $e of H._allEntries())$e._type===1&&T.URI.isUri($e.to)&&$e.from===void 0&&Ve.add($e.to);for(const $e of H._allEntries())if($e._type===1)Ye.edits.push({oldResource:$e.from,newResource:$e.to,options:$e.options,metadata:$e.metadata});else if($e._type===2)Ye.edits.push({resource:$e.uri,textEdit:U.from($e.edit),versionId:Ve.has($e.uri)?void 0:De?.getTextDocumentVersion($e.uri),metadata:$e.metadata});else if($e._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",$e);continue}Ye.edits.push({resource:$e.uri,textEdit:{range:o.from($e.range),text:$e.edit.value,insertAsSnippet:!0},versionId:Ve.has($e.uri)?void 0:De?.getTextDocumentVersion($e.uri),metadata:$e.metadata})}else $e._type===3?Ye.edits.push({metadata:$e.metadata,resource:$e.uri,cellEdit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Ye.edits.push({metadata:$e.metadata,resource:$e.uri,notebookVersionId:De?.getNotebookDocumentVersion($e.uri),cellEdit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(Qe.from)}})}return Ye}Se.from=Ie;function he(H){const De=new l.WorkspaceEdit;for(const Le of H.edits)Le.textEdit?De.replace(T.URI.revive(Le.resource),o.to(Le.textEdit.range),Le.textEdit.text):De.renameFile(T.URI.revive(Le.oldResource),T.URI.revive(Le.newResource),Le.options);return De}Se.to=he})(O=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(Se){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function he(De){return typeof Ie[De]=="number"?Ie[De]:6}Se.from=he;function H(De){for(const Le in Ie)if(Ie[Le]===De)return Number(Le);return l.SymbolKind.Property}Se.to=H})(B=e.SymbolKind||(e.SymbolKind={}));var X;(function(Se){function Ie(H){switch(H){case l.SymbolTag.Deprecated:return 1}}Se.from=Ie;function he(H){switch(H){case 1:return l.SymbolTag.Deprecated}}Se.to=he})(X=e.SymbolTag||(e.SymbolTag={}));var ce;(function(Se){function Ie(H){return{name:H.name,kind:B.from(H.kind),tags:H.tags&&H.tags.map(X.from),containerName:H.containerName,location:N.from(H.location)}}Se.from=Ie;function he(H){const De=new l.SymbolInformation(H.name,B.to(H.kind),H.containerName,N.to(H.location));return De.tags=H.tags&&H.tags.map(X.to),De}Se.to=he})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ue;(function(Se){function Ie(H){const De={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:B.from(H.kind),tags:H.tags?.map(X.from)??[]};return H.children&&(De.children=H.children.map(Ie)),De}Se.from=Ie;function he(H){const De=new l.DocumentSymbol(H.name,H.detail,B.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,b.isNonEmptyArray)(H.tags)&&(De.tags=H.tags.map(X.to)),H.children&&(De.children=H.children.map(he)),De}Se.to=he})(ue=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Se){function Ie(H){const De=new l.CallHierarchyItem(B.to(H.kind),H.name,H.detail||"",T.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return De._sessionId=H._sessionId,De._itemId=H._itemId,De}Se.to=Ie;function he(H,De,Le){if(De=De??H._sessionId,Le=Le??H._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,name:H.name,detail:H.detail,kind:B.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(X.from)}}Se.from=he})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Se){function Ie(he){return new l.CallHierarchyIncomingCall(Y.to(he.from),he.fromRanges.map(H=>o.to(H)))}Se.to=Ie})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Se){function Ie(he){return new l.CallHierarchyOutgoingCall(Y.to(he.to),he.fromRanges.map(H=>o.to(H)))}Se.to=Ie})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var N;(function(Se){function Ie(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Se.from=Ie;function he(H){return new l.Location(T.URI.revive(H.uri),o.to(H.range))}Se.to=he})(N=e.location||(e.location={}));var q;(function(Se){function Ie(H){const De=H,Le=H;return{originSelectionRange:De.originSelectionRange?o.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Le.uri,range:o.from(De.targetRange?De.targetRange:Le.range),targetSelectionRange:De.targetSelectionRange?o.from(De.targetSelectionRange):void 0}}Se.from=Ie;function he(H){return{targetUri:T.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Se.to=he})(q=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(Se){function Ie(H){return{range:o.from(H.range),contents:se.fromMany(H.contents)}}Se.from=Ie;function he(H){return new l.Hover(H.contents.map(se.to),o.to(H.range))}Se.to=he})(te=e.Hover||(e.Hover={}));var fe;(function(Se){function Ie(H){return{range:o.from(H.range),expression:H.expression}}Se.from=Ie;function he(H){return new l.EvaluatableExpression(o.to(H.range),H.expression)}Se.to=he})(fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(Se){function Ie(H){if(H instanceof l.InlineValueText)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function he(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Se.to=he})(ye=e.InlineValue||(e.InlineValue={}));var j;(function(Se){function Ie(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Se.from=Ie;function he(H){return new l.InlineValueContext(H.frameId,o.to(H.stoppedLocation))}Se.to=he})(j=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Se){function Ie(H){return{range:o.from(H.range),kind:H.kind}}Se.from=Ie;function he(H){return new l.DocumentHighlight(o.to(H.range),H.kind)}Se.to=he})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ne;(function(Se){function Ie(he){switch(he){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=Ie})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var z;(function(Se){function Ie(he){return{triggerKind:ne.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Se.to=Ie})(z=e.CompletionContext||(e.CompletionContext={}));var V;(function(Se){function Ie(H){switch(H){case l.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function he(H){switch(H){case 1:return l.CompletionItemTag.Deprecated}}Se.to=he})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Se){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function he(Le){return Ie.get(Le)??9}Se.from=he;const H=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function De(Le){return H.get(Le)??l.CompletionItemKind.Property}Se.to=De})($=e.CompletionItemKind||(e.CompletionItemKind={}));var x;(function(Se){function Ie(he,H){const De=new l.CompletionItem(he.label);return De.insertText=he.insertText,De.kind=$.to(he.kind),De.tags=he.tags?.map(V.to),De.detail=he.detail,De.documentation=D.isMarkdownString(he.documentation)?se.to(he.documentation):he.documentation,De.sortText=he.sortText,De.filterText=he.filterText,De.preselect=he.preselect,De.commitCharacters=he.commitCharacters,R.Range.isIRange(he.range)?De.range=o.to(he.range):typeof he.range=="object"&&(De.range={inserting:o.to(he.range.insert),replacing:o.to(he.range.replace)}),De.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?De.insertText=new l.SnippetString(he.insertText):(De.insertText=he.insertText,De.textEdit=De.range instanceof l.Range?new l.TextEdit(De.range,De.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(De.additionalTextEdits=he.additionalTextEdits.map(Le=>U.to(Le))),De.command=H&&he.command?H.fromInternal(he.command):void 0,De}Se.to=Ie})(x=e.CompletionItem||(e.CompletionItem={}));var le;(function(Se){function Ie(H){return{label:H.label,documentation:se.fromStrict(H.documentation)}}Se.from=Ie;function he(H){return{label:H.label,documentation:D.isMarkdownString(H.documentation)?se.to(H.documentation):H.documentation}}Se.to=he})(le=e.ParameterInformation||(e.ParameterInformation={}));var ge;(function(Se){function Ie(H){return{label:H.label,documentation:se.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(le.from):[],activeParameter:H.activeParameter}}Se.from=Ie;function he(H){return{label:H.label,documentation:D.isMarkdownString(H.documentation)?se.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(le.to):[],activeParameter:H.activeParameter}}Se.to=he})(ge=e.SignatureInformation||(e.SignatureInformation={}));var Pe;(function(Se){function Ie(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ge.from):[]}}Se.from=Ie;function he(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ge.to):[]}}Se.to=he})(Pe=e.SignatureHelp||(e.SignatureHelp={}));var ke;(function(Se){function Ie(he,H){const De=new l.InlayHint(i.to(H.position),typeof H.label=="string"?H.label:H.label.map(Me.to.bind(void 0,he)),H.kind&&Be.to(H.kind));return De.textEdits=H.textEdits&&H.textEdits.map(U.to),De.tooltip=D.isMarkdownString(H.tooltip)?se.to(H.tooltip):H.tooltip,De.paddingLeft=H.paddingLeft,De.paddingRight=H.paddingRight,De}Se.to=Ie})(ke=e.InlayHint||(e.InlayHint={}));var Me;(function(Se){function Ie(he,H){const De=new l.InlayHintLabelPart(H.label);return De.tooltip=D.isMarkdownString(H.tooltip)?se.to(H.tooltip):H.tooltip,w.Command.is(H.command)&&(De.command=he.fromInternal(H.command)),H.location&&(De.location=N.to(H.location)),De}Se.to=Ie})(Me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Be;(function(Se){function Ie(H){return H}Se.from=Ie;function he(H){return H}Se.to=he})(Be=e.InlayHintKind||(e.InlayHintKind={}));var me;(function(Se){function Ie(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Se.from=Ie;function he(H){let De;if(H.url)try{De=typeof H.url=="string"?T.URI.parse(H.url,!0):T.URI.revive(H.url)}catch{}return new l.DocumentLink(o.to(H.range),De)}Se.to=he})(me=e.DocumentLink||(e.DocumentLink={}));var be;(function(Se){function Ie(H){const De=new l.ColorPresentation(H.label);return H.textEdit&&(De.textEdit=U.to(H.textEdit)),H.additionalTextEdits&&(De.additionalTextEdits=H.additionalTextEdits.map(Le=>U.to(Le))),De}Se.to=Ie;function he(H){return{label:H.label,textEdit:H.textEdit?U.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(De=>U.from(De)):void 0}}Se.from=he})(be=e.ColorPresentation||(e.ColorPresentation={}));var we;(function(Se){function Ie(H){return new l.Color(H[0],H[1],H[2],H[3])}Se.to=Ie;function he(H){return[H.red,H.green,H.blue,H.alpha]}Se.from=he})(we=e.Color||(e.Color={}));var Oe;(function(Se){function Ie(H){return{range:o.from(H.range)}}Se.from=Ie;function he(H){return new l.SelectionRange(o.to(H.range))}Se.to=he})(Oe=e.SelectionRange||(e.SelectionRange={}));var Ne;(function(Se){function Ie(he){switch(he){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Ne=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Se){function Ie(H){switch(H){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function he(H){switch(H){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=he})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var We;(function(Se){function Ie(H){if(H===l.EndOfLine.CRLF)return 1;if(H===l.EndOfLine.LF)return 0}Se.from=Ie;function he(H){if(H===1)return l.EndOfLine.CRLF;if(H===0)return l.EndOfLine.LF}Se.to=he})(We=e.EndOfLine||(e.EndOfLine={}));var qe;(function(Se){function Ie(he){if(typeof he=="object")return he.viewId;switch(he){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(qe=e.ProgressLocation||(e.ProgressLocation={}));var je;(function(Se){function Ie(he){const H={start:he.start+1,end:he.end+1};return he.kind&&(H.kind=He.from(he.kind)),H}Se.from=Ie})(je=e.FoldingRange||(e.FoldingRange={}));var He;(function(Se){function Ie(he){if(he)switch(he){case l.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Se.from=Ie})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ke;(function(Se){function Ie(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?o.from(he.selection):void 0,override:typeof he.override=="boolean"?I.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(Ke=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ae;(function(Se){function Ie(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:he(Le)||H(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Ie;function he(Le){const Ye=Le;return Ye?T.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function H(Le){const Ye=Le;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function De(Le){return typeof Le=="string"?Le:new l.RelativePattern(T.URI.revive(Le.baseUri),Le.pattern)}Se.to=De})(ae=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Se){function Ie(he){if(he){if(Array.isArray(he))return he.map(Ie);if(typeof he=="string")return he;{const H=he;return{language:H.language,scheme:H.scheme,pattern:ae.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Se.from=Ie})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var Te;(function(Se){function Ie(H){return{start:H.start,end:H.end}}Se.from=Ie;function he(H){return new l.NotebookRange(H.start,H.end)}Se.to=he})(Te=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Se){function Ie(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Se.to=Ie;function he(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Se.from=he})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Fe;(function(Se){function Ie(he){if(he===y.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(he===y.NotebookCellExecutionState.Pending)return;if(he===y.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Se.to=Ie})(Fe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ue;(function(Se){function Ie(H){switch(H){case l.NotebookCellKind.Markup:return y.CellKind.Markup;case l.NotebookCellKind.Code:default:return y.CellKind.Code}}Se.from=Ie;function he(H){switch(H){case y.CellKind.Markup:return l.NotebookCellKind.Markup;case y.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=he})(Ue=e.NotebookCellKind||(e.NotebookCellKind={}));var xe;(function(Se){function Ie(H){const De={metadata:H.metadata??Object.create(null),cells:[]};for(const Le of H.cells)l.NotebookCellData.validate(Le),De.cells.push(Qe.from(Le));return De}Se.from=Ie;function he(H){const De=new l.NotebookData(H.cells.map(Qe.to));return(0,S.isEmptyObject)(H.metadata)||(De.metadata=H.metadata),De}Se.to=he})(xe=e.NotebookData||(e.NotebookData={}));var Qe;(function(Se){function Ie(H){return{cellKind:Ue.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Ae.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(tt.from):[]}}Se.from=Ie;function he(H){return new l.NotebookCellData(Ue.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(tt.to):void 0,H.metadata,H.internalMetadata?Ae.to(H.internalMetadata):void 0)}Se.to=he})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var Ze;(function(Se){function Ie(H){return{mime:H.mime,valueBytes:t.VSBuffer.wrap(H.data)}}Se.from=Ie;function he(H){return new l.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}Se.to=he})(Ze=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var tt;(function(Se){function Ie(H){return{outputId:H.id,items:H.items.map(Ze.from),metadata:H.metadata}}Se.from=Ie;function he(H){const De=H.items.map(Ze.to);return new l.NotebookCellOutput(De,H.outputId,H.metadata)}Se.to=he})(tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Se){function Ie(De){return H(De)?{include:(0,S.withNullAsUndefined)(ae.from(De.include)),exclude:(0,S.withNullAsUndefined)(ae.from(De.exclude))}:(0,S.withNullAsUndefined)(ae.from(De))}Se.from=Ie;function he(De){return H(De)?{include:ae.to(De.include),exclude:ae.to(De.exclude)}:ae.to(De)}Se.to=he;function H(De){const Le=De;return Le?!(0,S.isUndefinedOrNull)(Le.include)&&!(0,S.isUndefinedOrNull)(Le.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Se){function Ie(he,H,De){const Le=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Le,De),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Se.from=Ie})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Se){function Ie(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Se.from=Ie})(ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var gt;(function(Se){function Ie(H){return{uri:H.uri,provides:H.provides}}Se.from=Ie;function he(H){return new l.NotebookRendererScript(T.URI.revive(H.uri),H.provides)}Se.to=he})(gt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var It;(function(Se){function Ie(H){return{message:se.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Se.from=Ie;function he(H){const De=new l.TestMessage(typeof H.message=="string"?H.message:se.to(H.message));return De.actualOutput=H.actual,De.expectedOutput=H.expected,De.location=H.location?N.to(H.location):void 0,De}Se.to=he})(It=e.TestMessage||(e.TestMessage={}));var Dt;(function(Se){Se.namespace=g.namespaceTestTag,Se.denamespace=g.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var pt;(function(Se){function Ie(H){const De=(0,h.getPrivateApiFor)(H).controllerId;return{extId:d.TestId.fromExtHostTestItem(H,De).toString(),label:H.label,uri:T.URI.revive(H.uri),busy:!1,tags:H.tags.map(Le=>Dt.namespace(De,Le.id)),range:R.Range.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&se.fromStrict(H.error)||null}}Se.from=Ie;function he(H){return{parent:void 0,error:void 0,id:d.TestId.fromString(H.extId).localId,label:H.label,uri:T.URI.revive(H.uri),tags:(H.tags||[]).map(De=>{const{tagId:Le}=Dt.denamespace(De);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:!1,description:H.description||void 0,sortText:H.sortText||void 0}}Se.toPlain=he})(pt=e.TestItem||(e.TestItem={})),function(Se){function Ie(H){return{id:H.id}}Se.from=Ie;function he(H){return new l.TestTag(H.id)}Se.to=he}(Dt=e.TestTag||(e.TestTag={}));var Pt;(function(Se){const Ie=(H,De)=>{const Le=[];for(const[Ve,$e]of De)d.TestId.compare($e.item.extId,Ve)===2&&(De.delete(Ve),Le.push($e));const Ye={...pt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter($e=>$e.type===0).map(It.to)})),children:Le.map(Ve=>Ie(Ve,De))};for(const Ve of Ye.children)Ve.parent=Ye;return Ye};function he(H){const De=[],Le=new Map;for(const Ye of H.items)Le.set(Ye.item.extId,Ye),H.request.targets.some(Ve=>Ve.controllerId===Ye.controllerId&&Ve.testIds.includes(Ye.item.extId))&&De.push(Ye);return{completedAt:H.completedAt,results:De.map(Ye=>Ie(Ye,Le))}}Se.to=he})(Pt=e.TestResults||(e.TestResults={}));var yt;(function(Se){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function he(Le){return"line"in Le?i.from(Le):o.from(Le)}function H(Le){return"branches"in Le?{count:Le.executionCount,location:he(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&he(Ye.location)})):void 0}:{type:0,count:Le.executionCount,location:he(Le.location)}}Se.fromDetailed=H;function De(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(H)}}Se.fromFile=De})(yt=e.TestCoverage||(e.TestCoverage={}));var st;(function(Se){function Ie(he){switch(he){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=Ie})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ut;(function(Se){function Ie(H){const De=new l.TypeHierarchyItem(B.to(H.kind),H.name,H.detail||"",T.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return De._sessionId=H._sessionId,De._itemId=H._itemId,De}Se.to=Ie;function he(H,De,Le){if(De=De??H._sessionId,Le=Le??H._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,kind:B.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(X.from)}}Se.from=he})(ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var ht;(function(Se){function Ie(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}Se.from=Ie})(ht=e.ViewBadge||(e.ViewBadge={}));var At;(function(Se){function Ie(he,H){const De=he.fileData;return De?new class extends l.DataTransferItem{asFile(){return{name:De.name,uri:T.URI.revive(De.uri),data:(0,f.once)(()=>H())}}}(""):new l.DataTransferItem(he.asString)}Se.toDataTransferItem=Ie})(At=e.DataTransferItem||(e.DataTransferItem={}));var Ft;(function(Se){function Ie(H,De){const Le=H.items.map(([Ye,Ve],$e)=>[Ye,At.toDataTransferItem(Ve,()=>De($e))]);return new l.DataTransfer(Le)}Se.toDataTransfer=Ie;async function he(H){const De={items:[]},Le=[];return H.forEach((Ye,Ve)=>{Le.push((async()=>{const $e=await Ye.asString(),lt=Ye.asFile();De.items.push([Ve,{asString:$e,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(Le),De}Se.toDataTransferDTO=he})(Ft=e.DataTransfer||(e.DataTransfer={}))}),define(pe[249],ve([0,1,48,122,80,121,81,125,4]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const S=(u,l,f,r)=>{let o=l;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!f(o,n)){const i=o;o=n,u.listener?.(r(n,i))}}}},T=(u,l)=>u===l,R={range:(u,l)=>u===l?!0:!u||!l?!1:u.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(u,l)=>!(u.length!==l.length||u.some(f=>!l.find(r=>f.id===r.id)))},w=u=>l=>({op:4,update:u(l)}),v=(u,l)=>({range:S(u,void 0,R.range,w(f=>({range:b.Range.lift(E.Range.from(f))}))),label:S(u,l,R.label,w(f=>({label:f}))),description:S(u,void 0,R.description,w(f=>({description:f}))),sortText:S(u,void 0,R.sortText,w(f=>({sortText:f}))),canResolveChildren:S(u,!1,R.canResolveChildren,f=>({op:2,state:f})),busy:S(u,!1,R.busy,w(f=>({busy:f}))),error:S(u,void 0,R.error,w(f=>({error:E.MarkdownString.fromStrict(f)||null}))),tags:S(u,[],R.tags,(f,r)=>({op:1,new:f.map(E.TestTag.from),old:r.map(E.TestTag.from)}))}),h=u=>{const l=D.TestId.fromString(u.extId),f=new y(l.controllerId,l.localId,u.label,p.URI.revive(u.uri)||void 0);return f.range=E.Range.to(u.range||void 0),f.description=u.description||void 0,f.sortText=u.sortText||void 0,f.tags=u.tags.map(r=>E.TestTag.to({id:(0,k.denamespaceTestTag)(r).tagId})),f},I=u=>{let l;for(const f of u.tests){const r=h(f.item);(0,t.getPrivateApiFor)(r).parent=l,l=r}return l};e.toItemFromContext=I;class y{constructor(l,f,r,o){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const n=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof d?void 0:n.parent}},children:{value:(0,C.createTestItemChildren)(n,t.getPrivateApiFor,y),enumerable:!0,writable:!1},...v(n,r)})}}e.TestItemImpl=y;class d extends y{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=d;class g extends C.TestItemCollection{constructor(l,f){super({controllerId:l,getApiFor:t.getPrivateApiFor,getChildren:r=>r.children,root:new d(l,f),toITestItem:E.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(pe[250],ve([0,1,12,246,13,106,78,120,123,79,124,10,204,119]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let h=class{constructor(y,d,g,u,l,f,r,o,n,i){this._remoteAuthority=y,this._channel=d,this._configurationService=g,this._workspaceContextService=u,this._resolverService=l,this._environmentVariableService=f,this._remoteAuthorityResolverService=r,this._logService=o,this._editorService=n,this._labelService=i}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(y,d,g,u,l,f,r,o){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),i=g?(0,b.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(g)):void 0;let s;try{s=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:y,configuration:d})).resolvedVariables}catch(F){this._logService.error(F)}if(s)for(const[F,Q]of s.entries())(/^config:/.test(F)||F==="selectedText"||F==="lineNumber")&&(n[F]=Q);const a=[];for(const[F,Q]of this._environmentVariableService.collections.entries())a.push([F,(0,E.serializeEnvironmentVariableCollection)(Q.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),m=c.options&&c.options.extensionHostEnv,P=this._workspaceContextService.getWorkspace(),_=P.folders,W=g?this._workspaceContextService.getWorkspaceFolder(g):null,K=S.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:S.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),se={configuration:d,resolvedVariables:n,envVariableCollections:a,shellLaunchConfig:y,workspaceId:P.id,workspaceName:this._labelService.getWorkspaceLabel(P),workspaceFolders:_,activeWorkspaceFolder:W,activeFileResource:K,shouldPersistTerminal:l,options:u,cols:f,rows:r,unicodeVersion:o,resolverEnv:m};return await this._channel.call("$createProcess",se)}requestDetachInstance(y,d){return this._channel.call("$requestDetachInstance",[y,d])}acceptDetachInstanceReply(y,d){return this._channel.call("$acceptDetachInstanceReply",[y,d])}attachToProcess(y){return this._channel.call("$attachToProcess",[y])}detachFromProcess(y,d){return this._channel.call("$detachFromProcess",[y,d])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(y,d){return this._channel.call("$processBinary",[y,d])}start(y){return this._channel.call("$start",[y])}input(y,d){return this._channel.call("$input",[y,d])}acknowledgeDataEvent(y,d){return this._channel.call("$acknowledgeDataEvent",[y,d])}setUnicodeVersion(y,d){return this._channel.call("$setUnicodeVersion",[y,d])}shutdown(y,d){return this._channel.call("$shutdown",[y,d])}resize(y,d,g){return this._channel.call("$resize",[y,d,g])}getInitialCwd(y){return this._channel.call("$getInitialCwd",[y])}getCwd(y){return this._channel.call("$getCwd",[y])}orphanQuestionReply(y){return this._channel.call("$orphanQuestionReply",[y])}sendCommandResult(y,d,g){return this._channel.call("$sendCommandResult",[y,d,g])}installAutoReply(y,d){return this._channel.call("$installAutoReply",[y,d])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(y){return this._channel.call("$getDefaultSystemShell",[y])}getProfiles(y,d,g){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,y,d,g])}acceptPtyHostResolvedVariables(y,d){return this._channel.call("$acceptPtyHostResolvedVariables",[y,d])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(y){return this._channel.call("$getWslPath",[y])}setTerminalLayoutInfo(y){const g={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:y?y.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",g)}updateTitle(y,d,g){return this._channel.call("$updateTitle",[y,d,g])}updateIcon(y,d,g){return this._channel.call("$updateIcon",[y,d,g])}refreshProperty(y,d){return this._channel.call("$refreshProperty",[y,d])}updateProperty(y,d,g){return this._channel.call("$updateProperty",[y,d,g])}getTerminalLayoutInfo(){const d={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(y,d){return this._channel.call("$reviveTerminalProcesses",[y,d])}getRevivedPtyNewId(y){return this._channel.call("$getRevivedPtyNewId",[y])}serializeTerminalState(y){return this._channel.call("$serializeTerminalState",[y])}};h=Re([_e(2,t.IWorkbenchConfigurationService),_e(3,k.IWorkspaceContextService),_e(4,p.IConfigurationResolverService),_e(5,v.IEnvironmentVariableService),_e(6,C.IRemoteAuthorityResolverService),_e(7,D.ILogService),_e(8,T.IEditorService),_e(9,w.ILabelService)],h),e.RemoteTerminalChannelClient=h}),define(pe[251],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var b;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(b=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(R){this.pipeName=R,this.type=1}serialize(R){R[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(R){R[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class C{constructor(){this.type=3}serialize(R){R[C.ENV_KEY]="1"}}e.MessagePortExtHostConnection=C,C.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(T){delete T[t.ENV_KEY],delete T[D.ENV_KEY],delete T[C.ENV_KEY]}function E(T,R){k(R),T.serialize(R)}e.writeExtHostConnection=E;function p(T){if(T[t.ENV_KEY])return S(T,new t(T[t.ENV_KEY]));if(T[D.ENV_KEY])return S(T,new D);if(T[C.ENV_KEY])return S(T,new C);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function S(T,R){return k(T),R}}),define(pe[126],ve([0,1,49,85,116,10,6,16,7,57,77,13,44,3,56,115,2,251]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function g(n={},i,s,a,c){const m=await(0,D.getNLSConfiguration)(s,a.userDataPath);let P={};if(i)try{P=await(0,T.getResolvedShellEnv)(c,a.args,process.env)}catch(Q){c.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",Q)}const W={...process.env,...P,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(m,void 0,0),...n},K=a.isBuilt?(0,k.join)(a.appRoot,"bin"):(0,k.join)(a.appRoot,"resources","server","bin-dev"),se=(0,k.join)(K,"remote-cli");let F=f(W,"PATH");return F?F=se+k.delimiter+F:F=se,r(W,"PATH",F),a.args["without-browser-env-var"]||(W.BROWSER=(0,k.join)(K,"helpers",v.isWindows?"browser.cmd":"browser.sh")),o(W),W}e.buildUserEnvironment=g;class u{constructor(i,s){this.socket=i,this.initialDataChunk=s}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,s,a;return this.socket instanceof S.NodeSocket?(i=!0,s=!1,a=E.VSBuffer.alloc(0)):(i=!1,s=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:s,inflateBytes:a.buffer.toString("base64")}}}let l=class{constructor(i,s,a,c,m,P,_){this._reconnectionToken=i,this._environmentService=m,this._logService=P,this._extensionHostStatusService=_,this._onClose=new p.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!v.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=s,this._extensionHostProcess=null,this._connectionData=new u(a,c),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(i){this._logService.info(`${this._logPrefix}${i}`)}_logError(i){this._logService.error(`${this._logPrefix}${i}`)}async _pipeSockets(i,s){const a=new y.DisposableStore;a.add(s.socket),a.add((0,y.toDisposable)(()=>{i.destroy()}));const c=()=>{a.dispose()};a.add(s.socket.onEnd(c)),a.add(s.socket.onClose(c)),a.add(p.Event.fromNodeEventEmitter(i,"end")(c)),a.add(p.Event.fromNodeEventEmitter(i,"close")(c)),a.add(p.Event.fromNodeEventEmitter(i,"error")(c)),a.add(s.socket.onData(m=>i.write(m.buffer))),a.add(p.Event.fromNodeEventEmitter(i,"data")(m=>{s.socket.write(E.VSBuffer.wrap(m))})),s.initialDataChunk.byteLength>0&&i.write(s.initialDataChunk.buffer)}async _sendSocketToExtensionHost(i,s){await s.socketDrain();const a=s.toIExtHostSocketMessage();let c;s.socket instanceof S.NodeSocket?c=s.socket.socket:c=s.socket.socket.socket,i.send(a,c)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(i)}acceptReconnection(i,s,a){this._remoteAddress=i,this._log("The client has reconnected.");const c=new u(s,a);if(!this._extensionHostProcess){this._connectionData=c;return}this._sendSocketToExtensionHost(this._extensionHostProcess,c)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(i){try{let s=[];i.port&&!process.pkg&&(s=[`--inspect${i.break?"-brk":""}=${i.port}`]);const a=await g(i.env,!0,i.language,this._environmentService,this._logService);(0,h.removeDangerousEnvVariables)(a);let c;if(this._canSendSocket)(0,d.writeExtHostConnection)(new d.SocketExtHostConnection,a),c=null;else{const{namedPipeServer:F,pipeName:Q}=await this._listenOnPipe();(0,d.writeExtHostConnection)(new d.IPCExtHostConnection(Q),a),c=F}const m={env:a,execArgv:s,silent:!0},P=["--type=extensionHost","--transformURIs"],_=this._environmentService.args["use-host-proxy"];P.push(`--useHostProxy=${_?"true":"false"}`),this._extensionHostProcess=b.fork(C.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,P,m);const W=this._extensionHostProcess.pid;this._log(`<${W}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const K=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),se=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(K(F=>this._log(`<${W}> ${F}`)),se(F=>this._log(`<${W}><stderr> ${F}`)),this._extensionHostProcess.on("error",F=>{this._logError(`<${W}> Extension Host Process had an error`),this._logService.error(F),this._cleanResources()}),this._extensionHostProcess.on("exit",(F,Q)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:F,signal:Q}),this._log(`<${W}> Extension Host Process exited with code: ${F}, signal: ${Q}.`),this._cleanResources()}),c)c.on("connection",F=>{c.close(),this._pipeSockets(F,this._connectionData)});else{const F=Q=>{Q.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",F),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",F)}}catch(s){console.error("ExtensionHostConnection errored"),s&&console.error(s)}}_listenOnPipe(){return new Promise((i,s)=>{const a=(0,S.createRandomIPCHandle)(),c=t.createServer();c.on("error",s),c.listen(a,()=>{c?.removeListener("error",s),i({pipeName:a,namedPipeServer:c})})})}};l=Re([_e(4,w.IServerEnvironmentService),_e(5,R.ILogService),_e(6,I.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function f(n,i){const s=Object.keys(n).filter(c=>c.toLowerCase()===i.toLowerCase()),a=s.length>0?s[0]:i;return n[a]}function r(n,i,s){const a=Object.keys(n).filter(m=>m.toLowerCase()===i.toLowerCase()),c=a.length>0?a[0]:i;n[c]=s}function o(n){for(const i of Object.keys(n))n[i]===null&&delete n[i]}}),define(pe[252],ve([0,1,36,185,50]),function(oe,e,b,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function C(k,E,p,S){const T=new Map;k.forEach(w=>{const v=b.ExtensionIdentifier.toKey(w.identifier),h=T.get(v);h&&S.warn((0,t.localize)(0,null,h.extensionLocation.fsPath,w.extensionLocation.fsPath)),T.set(v,w)}),E.forEach(w=>{const v=b.ExtensionIdentifier.toKey(w.identifier),h=T.get(v);if(h)if(h.isBuiltin){if(D.gte(h.version,w.version)){S.warn(`Skipping extension ${w.extensionLocation.path} in favour of the builtin extension ${h.extensionLocation.path}.`);return}w.isBuiltin=!0}else S.warn((0,t.localize)(1,null,h.extensionLocation.fsPath,w.extensionLocation.fsPath));else if(w.isBuiltin){S.warn(`Skipping obsolete builtin extension ${w.extensionLocation.path}`);return}T.set(v,w)}),p.forEach(w=>{S.info((0,t.localize)(2,null,w.extensionLocation.fsPath));const v=b.ExtensionIdentifier.toKey(w.identifier),h=T.get(v);h&&h.isBuiltin&&(w.isBuiltin=!0),T.set(v,w)});const R=[];return T.forEach(w=>R.push(w)),R}e.dedupExtensions=C}),define(pe[253],ve([0,1,3,47,4,63,10,69,98,94,219,6,28,55,252]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class I{constructor(d,g,u,l,f,r,o){if(this._connectionToken=d,this._environmentService=g,this._userDataProfilesService=u,this._logService=f,this._extensionHostStatusService=r,this._extensionsScannerService=o,g.args["install-builtin-extension"]){const i={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],g.args["install-builtin-extension"],i,!!g.args.force).then(null,s=>{f.error(s)})}else this.whenExtensionsReady=Promise.resolve();const n=g.args["install-extension"];if(n){const i=n.map(s=>/\.vsix$/i.test(s)?D.URI.file((0,R.isAbsolute)(s)?s:(0,R.join)((0,w.cwd)(),s)):s);this.whenExtensionsReady.then(()=>l.installExtensions(i,[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]},!!g.args.force)).then(null,s=>{f.error(s)})}}async call(d,g,u){switch(g){case"getEnvironmentData":{const l=u,f=(0,C.createURITransformer)(l.remoteAuthority);let r=await this._getEnvironmentData();return r=(0,E.transformOutgoingURIs)(r,f),r}case"getExtensionHostExitInfo":{const l=u;return this._extensionHostStatusService.getExitInfo(l.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const l=u,f=l.language;this._logService.trace(`Scanning extensions using UI language: ${f}`);const r=(0,C.createURITransformer)(l.remoteAuthority),o=l.extensionDevelopmentPath&&l.extensionDevelopmentPath.map(s=>D.URI.revive(r.transformIncoming(s))),n=o?o.filter(s=>s.scheme===k.Schemas.file).map(s=>s.fsPath):void 0;let i=await this._scanExtensions(f,n);return i=(0,E.transformOutgoingURIs)(i,r),this._logService.trace("Scanned Extensions",i),I._massageWhenConditions(i),i}case"scanSingleExtension":{await this.whenExtensionsReady;const l=u,f=l.language,r=l.isBuiltin,o=(0,C.createURITransformer)(l.remoteAuthority),n=D.URI.revive(o.transformIncoming(l.extensionLocation)),i=n.scheme===k.Schemas.file?n.fsPath:null;if(!i)return null;let s=await this._scanSingleExtension(i,r,f);return s?(s=(0,E.transformOutgoingURIs)(s,o),I._massageWhenConditions([s]),s):null}case"getDiagnosticInfo":{const l=u,f={machineInfo:(0,T.getMachineInfo)()},r=l.includeProcesses?(0,S.listProcesses)(process.pid):Promise.resolve();let o=[];const n={};if(l.folders){const i=(0,C.createURITransformer)("");o=l.folders.map(a=>D.URI.revive(i.transformIncoming(a))).filter(a=>a.scheme==="file").map(a=>(0,T.collectWorkspaceStats)(a.fsPath,["node_modules",".git"]).then(c=>{n[(0,R.basename)(a.fsPath)]=c}))}return Promise.all([r,...o]).then(([i,s])=>(f.processes=i||void 0,f.workspaceMetadata=l.folders?n:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(d,g,u){throw new Error("Not supported")}static _massageWhenConditions(d){const g=(n,i)=>n.replace(/file/g,"vscode-remote"),u=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(g(n.source,!0),i)},l=new class{mapDefined(n){return p.ContextKeyDefinedExpr.create(n)}mapNot(n){return p.ContextKeyNotExpr.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyEqualsExpr.create(n,g(i,!1)):p.ContextKeyEqualsExpr.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.ContextKeyNotEqualsExpr.create(n,g(i,!1)):p.ContextKeyNotEqualsExpr.create(n,i)}mapGreater(n,i){return p.ContextKeyGreaterExpr.create(n,i)}mapGreaterEquals(n,i){return p.ContextKeyGreaterEqualsExpr.create(n,i)}mapSmaller(n,i){return p.ContextKeySmallerExpr.create(n,i)}mapSmallerEquals(n,i){return p.ContextKeySmallerEqualsExpr.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?p.ContextKeyRegexExpr.create(n,u(i)):p.ContextKeyRegexExpr.create(n,i)}mapIn(n,i){return p.ContextKeyInExpr.create(n,i)}mapNotIn(n,i){return p.ContextKeyNotInExpr.create(n,i)}},f=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=p.ContextKeyExpr.deserialize(n.when);if(!i)return;const s=i.map(l);n.when=s.serialize()},r=n=>{if(Array.isArray(n))for(const i of n)f(i);else f(n)},o=n=>{for(const i in n)r(n[i])};d.forEach(n=>{n.contributes&&(n.contributes.menus&&o(n.contributes.menus),n.contributes.keybindings&&r(n.contributes.keybindings),n.contributes.views&&o(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:D.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:D.URI.file(this._environmentService.logsPath),extensionsPath:D.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:D.URI.file((0,R.join)(this._environmentService.logsPath,`exthost${I._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:b.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(d,g){const[u,l,f]=await Promise.all([this._scanBuiltinExtensions(d),this._scanInstalledExtensions(d),this._scanDevelopedExtensions(d,g)]);return(0,h.dedupExtensions)(u,l,f,this._logService)}async _scanDevelopedExtensions(d,g){return g?(await Promise.all(g.map(u=>this._extensionsScannerService.scanOneOrMultipleExtensions(D.URI.file((0,R.resolve)(u)),1,{language:d})))).flat().map(u=>(0,v.toExtensionDescription)(u,!0)):[]}async _scanBuiltinExtensions(d){return(await this._extensionsScannerService.scanSystemExtensions({language:d,useCache:!0})).map(u=>(0,v.toExtensionDescription)(u,!1))}async _scanInstalledExtensions(d){return(await this._extensionsScannerService.scanUserExtensions({language:d,useCache:!0})).map(u=>(0,v.toExtensionDescription)(u,!1))}async _scanSingleExtension(d,g,u){const l=D.URI.file((0,R.resolve)(d)),f=g?0:1,r=await this._extensionsScannerService.scanExistingExtension(l,f,{language:u});return r?(0,v.toExtensionDescription)(r,!1):null}}e.RemoteAgentEnvironmentChannel=I,I._namePool=1}),define(pe[127],ve([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const t=[];function D(E){const p=new b(E);return t[p.nid]=p,p}e.createProxyIdentifier=D;function C(E){return t[E].sid}e.getStringIdentifierForProxy=C;class k{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=k}),define(pe[254],ve([0,1,41,127]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var k;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(k=e.TabModelOperationKind||(e.TabModelOperationKind={}));var E;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var p;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(p=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(g){return g._id=w._n++,g}}e.IdObject=w,w._n=0;var v;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function I(d){return d&&d.edits&&(0,b.revive)(d),d}e.reviveWorkspaceEditDto=I;var y;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,t.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,t.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,t.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,t.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,t.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,t.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,t.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,t.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,t.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,t.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,t.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,t.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,t.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,t.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,t.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,t.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,t.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,t.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,t.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,t.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,t.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,t.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,t.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,t.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,t.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,t.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,t.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,t.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,t.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,t.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,t.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,t.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,t.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,t.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,t.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,t.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,t.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,t.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,t.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,t.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,t.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,t.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,t.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,t.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,t.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,t.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,t.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,t.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,t.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,t.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,t.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,t.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,t.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,t.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,t.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,t.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,t.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,t.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,t.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,t.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,t.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,t.createProxyIdentifier)("ExtHostTelemetry")}});var Rt=this&&this.__classPrivateFieldSet||function(oe,e,b,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,b):D?D.value=b:e.set(oe,b),b},nt=this&&this.__classPrivateFieldGet||function(oe,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(oe):t?t.value:e.get(oe)};define(pe[255],ve([0,1,12,118,125,22,254,18,13,41,48,86,4,2,5,241,249,16,127,38]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u){"use strict";var l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(c,m){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,f.set(this,void 0),Rt(this,l,c.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=m,Rt(this,f,c.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,P=>{const _=this._apiCommands.get(P);return _?.result===i.Void?_:void 0},m),this._argumentProcessors=[{processArgument(P){return(0,S.revive)(P)}},{processArgument(P){return(0,C.cloneAndChange)(P,function(_){if(T.Range.isIRange(_))return D.Range.to(_);if(R.Position.isIPosition(_))return D.Position.to(_);if(T.Range.isIRange(_.range)&&w.URI.isUri(_.uri))return D.location.to(_);if(_ instanceof d.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const m=this.registerCommand(!1,c.id,async(...P)=>{const _=c.args.map((K,se)=>{if(!K.validate(P[se]))throw new Error(`Invalid argument '${K.name}' when running '${c.id}', received: ${P[se]}`);return K.convert(P[se])}),W=await this.executeCommand(c.internalId,..._);return c.result.convert(W,P,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{m.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,m,P,_,W,K){if(this._logService.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this._commands.has(m))throw new Error(`command '${m}' already exists`);return this._commands.set(m,{callback:P,thisArg:_,description:W,extension:K}),c&&nt(this,l,"f").$registerCommand(m),new t.Disposable(()=>{this._commands.delete(m)&&c&&nt(this,l,"f").$unregisterCommand(m)})}executeCommand(c,...m){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,m,!0)}async _doExecuteCommand(c,m,P){if(this._commands.has(c))return nt(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,m,!1);{let _=!1;const W=(0,C.cloneAndChange)(m,function(K){if(K instanceof t.Position)return D.Position.from(K);if(K instanceof t.Range)return D.Range.from(K);if(K instanceof t.Location)return D.location.from(K);if(t.NotebookRange.isNotebookRange(K))return D.NotebookRange.from(K);if(K instanceof ArrayBuffer)return _=!0,d.VSBuffer.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return _=!0,d.VSBuffer.wrap(K);if(K instanceof d.VSBuffer)return _=!0,K;if(!Array.isArray(K))return K});try{const K=await nt(this,l,"f").$executeCommand(c,_?new g.SerializableObjectWithBuffers(W):W,P);return(0,S.revive)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this._doExecuteCommand(c,m,!1);throw K}}}async _executeContributedCommand(c,m,P){const _=this._commands.get(c);if(!_)throw new Error("Unknown command");this._reportTelemetry(_,c);const{callback:W,thisArg:K,description:se}=_;if(se)for(let F=0;F<se.args.length;F++)try{(0,b.validateConstraint)(m[F],se.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${se.args[F].name}' - ${se.args[F].description}`)}try{return await W.apply(K,m)}catch(F){if(c===this.converter.delegatingCommandId){const Q=this.converter.getActualCommand(...m);Q&&(c=Q.command)}throw this._logService.error(F,c,_.extension?.identifier),P?new class extends Error{constructor(){super((0,u.toErrorMessage)(F));this.id=c,this.source=_.extension?.displayName??_.extension?.name}}:F}}_reportTelemetry(c,m){!c.extension||c.extension.isBuiltin||nt(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:m})}$executeContributedCommand(c,...m){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(m=m.map(P=>this._argumentProcessors.reduce((_,W)=>W.processArgument(_),P)),this._executeContributedCommand(c,m,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),nt(this,l,"f").$getCommands().then(m=>(c&&(m=m.filter(P=>P[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[m,P]of this._commands){const{description:_}=P;_&&(c[m]=_)}return Promise.resolve(c)}};l=new WeakMap,f=new WeakMap,r=Re([_e(0,I.IExtHostRpcService),_e(1,p.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class o{constructor(c,m,P){this._commands=c,this._lookupApiCommand=m,this._logService=P,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,m){if(!c)return;const P={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return P;const _=this._lookupApiCommand(c.command);if(_)P.id=_.internalId,P.arguments=_.args.map((W,K)=>W.convert(c.arguments&&c.arguments[K]));else if((0,E.isNonEmptyArray)(c.arguments)){const W=++this._cachIdPool;this._cache.set(W,c),m.add((0,v.toDisposable)(()=>{this._cache.delete(W),this._logService.trace("CommandsConverter#DISPOSE",W)})),P.$ident=W,P.id=this.delegatingCommandId,P.arguments=[W],this._logService.trace("CommandsConverter#CREATE",c.command,W)}return P}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const m=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],m?m.command:"MISSING"),m?this._commands.executeCommand(m.command,...m.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class n{constructor(c,m,P,_){this.name=c,this.description=m,this.validate=P,this.convert=_}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,m){return new n(c??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",a=>w.URI.isUri(a),a=>a),n.Position=new n("position","A position in a text document",a=>t.Position.isPosition(a),D.Position.from),n.Range=new n("range","A range in a text document",a=>t.Range.isRange(a),D.Range.from),n.Selection=new n("selection","A selection in a text document",a=>t.Selection.isSelection(a),D.Selection.from),n.Number=new n("number","",a=>typeof a=="number",a=>a),n.String=new n("string","",a=>typeof a=="string",a=>a),n.CallHierarchyItem=new n("item","A call hierarchy item",a=>a instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",a=>a instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",a=>a instanceof y.TestItemImpl,D.TestItem.from);class i{constructor(c,m){this.description=c,this.convert=m}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class s{constructor(c,m,P,_,W){this.id=c,this.internalId=m,this.description=P,this.args=_,this.result=W}}e.ApiCommand=s}),define(pe[256],ve([0,1,57,269,29,255,4,13,78]),function(oe,e,b,t,D,C,k,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class S{constructor(w,v,h){this._commands=w,this.logService=v,this._ipcHandlePath=h,this._server=t.createServer((I,y)=>this.onRequest(I,y)),this.setup().catch(I=>(v.error(I),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,v){const h=(y,d)=>{v.writeHead(y,{"content-type":"application/json"}),v.end(JSON.stringify(d||null),g=>g&&this.logService.error(g))},I=[];w.setEncoding("utf8"),w.on("data",y=>I.push(y)),w.on("end",async()=>{try{const y=JSON.parse(I.join(""));let d;switch(y.type){case"open":d=await this.open(y);break;case"openExternal":d=await this.openExternal(y);break;case"status":d=await this.getStatus(y);break;case"extensionManagement":d=await this.manageExtensions(y);break;default:h(404,`Unknown message type: ${y.type}`);break}h(200,d)}catch(y){const d=y instanceof Error?y.message:JSON.stringify(y);h(500,d),this.logService.error("Error while processing pipe request",y)}})}async open(w){const{fileURIs:v,folderURIs:h,forceNewWindow:I,diffMode:y,mergeMode:d,addMode:g,forceReuseWindow:u,gotoLineMode:l,waitMarkerFilePath:f,remoteAuthority:r}=w,o=[];if(Array.isArray(h))for(const a of h)try{o.push({folderUri:k.URI.parse(a)})}catch{}if(Array.isArray(v))for(const a of v)try{(0,p.hasWorkspaceFileExtension)(a)?o.push({workspaceUri:k.URI.parse(a)}):o.push({fileUri:k.URI.parse(a)})}catch{}const n=f?k.URI.file(f):void 0,s={forceNewWindow:I,diffMode:y,mergeMode:d,addMode:g,gotoLineMode:l,forceReuseWindow:u,preferNewWindow:!u&&!n&&!g,waitMarkerFileURI:n,remoteAuthority:r};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(w){for(const v of w.uris){const h=k.URI.parse(v),I=h.scheme==="file"?h:v;await this._commands.executeCommand("_remoteCLI.openExternal",I)}}async manageExtensions(w){const v=I=>I?.map(y=>/\.vsix$/i.test(y)?k.URI.parse(y):y),h={list:w.list,install:v(w.install),uninstall:v(w.uninstall),force:w.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",h)}async getStatus(w){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=S;let T=class extends S{constructor(w,v){super(w,v,(0,b.createRandomIPCHandle)())}};T=Re([_e(0,C.IExtHostCommands),_e(1,E.ILogService)],T),e.CLIServer=T}),define(pe[257],ve([0,1,30,7,22,2,6,3,4,57,63,256,244,120,245,247,126]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends I.AbstractVariableResolverService{constructor(l,f,r,o,n){super({getFolderUri:i=>{const s=f.filter(a=>a.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(i,s)=>o[`config:${s}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(r)return k.normalize(r.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async i=>{const a=(await n.getInstalled()).find(c=>c.identifier.id===i);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(b.homedir()),Promise.resolve(l))}}class g extends C.Disposable{constructor(l,f,r,o,n){super();this._environmentService=l,this._logService=f,this._ptyService=r,this._productService=o,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,f,r){switch(f){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const o=(0,T.createURITransformer)(l.remoteAuthority);return this._createProcess(o,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,r);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,r);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,r);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,r);case"$getRevivedPtyNewId":return this._ptyService.getRevivedPtyNewId.apply(this._ptyService,r);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,r);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,r);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(r[0],r[1])}throw new Error(`IPC Command ${f} not found`)}listen(l,f,r){switch(f){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,f){const r={name:f.shellLaunchConfig.name,executable:f.shellLaunchConfig.executable,args:f.shellLaunchConfig.args,cwd:typeof f.shellLaunchConfig.cwd=="string"||typeof f.shellLaunchConfig.cwd=="undefined"?f.shellLaunchConfig.cwd:p.URI.revive(l.transformIncoming(f.shellLaunchConfig.cwd)),env:f.shellLaunchConfig.env,useShellEnvironment:f.shellLaunchConfig.useShellEnvironment,reconnectionProperties:f.shellLaunchConfig.reconnectionProperties,type:f.shellLaunchConfig.type,isFeatureTerminal:f.shellLaunchConfig.isFeatureTerminal},o=await(0,y.buildUserEnvironment)(f.resolverEnv,!!f.shellLaunchConfig.useShellEnvironment,E.language,this._environmentService,this._logService);this._logService.trace("baseEnv",o);const n=G=>({uri:p.URI.revive(l.transformIncoming(G.uri)),name:G.name,index:G.index,toResource:()=>{throw new Error("Not implemented")}}),i=f.workspaceFolders.map(n),s=f.activeWorkspaceFolder?n(f.activeWorkspaceFolder):void 0,a=f.activeFileResource?p.URI.revive(l.transformIncoming(f.activeFileResource)):void 0,c=new d(o,i,a,f.resolvedVariables,this._extensionManagementService),m=h.createVariableResolver(s,process.env,c),P=await h.getCwd(r,b.homedir(),m,s?.uri,f.configuration["terminal.integrated.cwd"],this._logService);r.cwd=P;const _=E.isWindows?"terminal.integrated.env.windows":E.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",W=f.configuration[_],K=await h.createTerminalEnvironment(r,W,m,this._productService.version,f.configuration["terminal.integrated.detectLocale"],o);if(!r.strictEnv){const G=[];for(const[U,O]of f.envVariableCollections)G.push([U,{map:(0,v.deserializeEnvironmentVariableCollection)(O)}]);const de=new Map(G);await new w.MergedEnvironmentVariableCollection(de).applyToProcessEnvironment(K,m)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:P,cols:f.cols,rows:f.rows,env:K});const se=(0,S.createRandomIPCHandle)();K.VSCODE_IPC_HOOK_CLI=se;const F=await this._ptyService.createProcess(r,P,f.cols,f.rows,f.unicodeVersion,K,o,f.options,f.shouldPersistTerminal,f.workspaceId,f.workspaceName),Q={executeCommand:(G,...de)=>this._executeCommand(F,G,de,l)},re=new R.CLIServerBase(Q,this._logService,se);return this._ptyService.onProcessExit(G=>G.id===F&&re.dispose()),{persistentTerminalId:F,resolvedShellLaunchConfig:r}}_executeCommand(l,f,r,o){let n,i;const s=new Promise((m,P)=>{n=m,i=P}),a=++this._lastReqId;this._pendingCommands.set(a,{resolve:n,reject:i,uriTransformer:o});const c=(0,D.cloneAndChange)(r,m=>{if(m&&m.$mid===1)return o.transformOutgoing(m);if(m&&m instanceof p.URI)return o.transformOutgoingURI(m)});return this._onExecuteCommand.fire({reqId:a,persistentProcessId:l,commandId:f,commandArgs:c}),s}_sendCommandResult(l,f,r){const o=this._pendingCommands.get(l);if(!o)return;this._pendingCommands.delete(l);const n=(0,D.cloneAndChange)(r,i=>{if(i&&i.$mid===1)return o.uriTransformer.transformIncoming(i)});f?o.reject(n):o.resolve(n)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,f,r,o){return this._ptyService.getProfiles?.(l,f,r,o)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=g}),define(pe[128],ve([0,1,5]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(pe[258],ve([0,1,11,2,10,199]),function(oe,e,b,t,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends C.DiskFileSystemProviderClient{static register(p,S,T){const R=p.getConnection();if(!R)return t.Disposable.None;const w=new t.DisposableStore,v=(async()=>{try{const h=await p.getRawEnvironment();h?S.registerProvider(D.Schemas.vscodeRemote,w.add(new k(h,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(h){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,b.getErrorMessage)(h))}})();return w.add(S.onWillActivateFileSystemProvider(h=>{h.scheme===D.Schemas.vscodeRemote&&h.join(v)})),w}constructor(p,S){super(S.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:p.os===3})}}e.RemoteFileSystemProviderClient=k}),define(pe[129],ve([0,1,29,14,6,12,21,157,270,271]),function(oe,e,b,t,D,C,k,E,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=o}}e.ExtractError=T;function R(f){const r=f.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function w(f){if(f instanceof T)return f;let r;return/end of central directory record signature not found/.test(f.message)&&(r="CorruptZip"),new T(r,f)}function v(f,r,o,n,i,s){const a=D.dirname(r),c=D.join(n,a);if(!c.startsWith(n))return Promise.reject(new Error(E.localize(0,null,r)));const m=D.join(n,r);let P;return s.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(k.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((_,W)=>{if(!s.isCancellationRequested)try{P=(0,b.createWriteStream)(m,{mode:o}),P.once("close",()=>_()),P.once("error",W),f.once("error",W),f.pipe(P)}catch(K){W(K)}}))}function h(f,r,o,n){let i=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{i.cancel(),f.close()}),new Promise((a,c)=>{const m=new t.Sequencer,P=_=>{_.isCancellationRequested||(s++,f.readEntry())};f.once("error",c),f.once("close",()=>i.then(()=>{n.isCancellationRequested||f.entryCount===s?a():c(new T("Incomplete",new Error(E.localize(1,null,s,f.entryCount))))},c)),f.readEntry(),f.on("entry",_=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(_.fileName)){P(n);return}const W=_.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(W)){const F=D.join(r,W);i=(0,t.createCancelablePromise)(Q=>k.Promises.mkdir(F,{recursive:!0}).then(()=>P(Q)).then(void 0,c));return}const K=y(f,_),se=R(_);i=(0,t.createCancelablePromise)(F=>m.queue(()=>K.then(Q=>v(Q,W,se,r,o,F).then(()=>P(F)))).then(null,c))})})}function I(f,r=!1){return new Promise((o,n)=>{(0,p.open)(f,r?{lazyEntries:!0}:void 0,(i,s)=>{i?n(w(i)):o((0,C.assertIsDefined)(s))})})}function y(f,r){return new Promise((o,n)=>{f.openReadStream(r,(i,s)=>{i?n(w(i)):o((0,C.assertIsDefined)(s))})})}function d(f,r){return new Promise((o,n)=>{const i=new S.ZipFile;r.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const s=(0,b.createWriteStream)(f);i.outputStream.pipe(s),i.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(f))})}e.zip=d;function g(f,r,o={},n){const i=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=I(f,!0);return o.overwrite&&(s=s.then(a=>k.Promises.rm(r).then(()=>a))),s.then(a=>h(a,r,{sourcePathRegex:i},n))}e.extract=g;function u(f,r){return I(f).then(o=>new Promise((n,i)=>{o.on("entry",s=>{s.fileName===r&&y(o,s).then(a=>n(a),a=>i(a))}),o.once("close",()=>i(new Error(E.localize(2,null,r))))}))}function l(f,r){return u(f,r).then(o=>new Promise((n,i)=>{const s=[];o.once("error",i),o.on("data",a=>s.push(a)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=l}),define(pe[259],ve([0,1,129,167]),function(oe,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(C){return(0,b.buffer)(C,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=D}),define(pe[130],ve([0,1,14,38,11,2,10,6,3,19,50,12,4,23,21,129,166,72,26,234,31,34,53,55,212,235,259,213,233,36,70,17,5,13,27,32,39,37]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f,r,o,n,i,s,a,c,m,P,_,W,K,se,F,Q,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,W.refineServiceDecorator)(l.IServerExtensionManagementService);let G=class extends u.AbstractExtensionManagementService{constructor(Y,ie,L,N,q,te,fe,ye,j,Z,ne,z){super(Y,ie,L,Z,z);this.extensionsScannerService=q,this.extensionsProfileScannerService=te,this.downloadService=fe,this.fileService=j,this.installGalleryExtensionsTasks=new Map;const V=this._register(ye.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(ye.createInstance(de,x=>V.postUninstall(x))),this.manifestCache=this._register(new a.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(ye.createInstance(n.ExtensionsDownloader));const $=this._register(new c.ExtensionsWatcher(this,j,N,L,ne));this._register($.onDidChangeExtensionsByAnotherSource(({added:x,removed:le})=>{x.length&&this._onDidInstallExtensions.fire(x.map(ge=>({identifier:ge.identifier,operation:1,local:ge}))),le.forEach(ge=>this._onDidUninstallExtension.fire({identifier:ge}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Y){this.logService.trace("ExtensionManagementService#zip",Y.identifier.id);const ie=await this.collectFiles(Y),L=await(0,I.zip)((0,S.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,ie);return w.URI.file(L)}async unzip(Y){return this.logService.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:ie,cleanup:L}=await this.downloadVsix(Y),N=E.resolve(ie.fsPath);try{return await(0,s.getManifest)(N)}finally{await L()}}getInstalled(Y,ie){return this.extensionsScanner.scanExtensions(Y??null,ie)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(Y,ie={}){this.logService.trace("ExtensionManagementService#install",Y.toString());const{location:L,cleanup:N}=await this.downloadVsix(Y);try{const q=await(0,s.getManifest)(E.resolve(L.fsPath));if(q.engines&&q.engines.vscode&&!(0,P.isEngineValid)(q.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,f.getGalleryExtensionId)(q.publisher,q.name),this.productService.version));return await this.installExtension(q,L,ie)}finally{await N()}}getMetadata(Y){return this.extensionsScannerService.scanMetadata(Y.location)}async updateMetadata(Y,ie){this.logService.trace("ExtensionManagementService#updateMetadata",Y.identifier.id);const L={...ie};return ie.isPreReleaseVersion&&(L.preRelease=!0),Y=await this.extensionsScanner.updateMetadata(Y,L),this.manifestCache.invalidate(),Y}async updateExtensionScope(Y,ie){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Y.identifier.id),Y=await this.extensionsScanner.updateMetadata(Y,{isMachineScoped:ie}),this.manifestCache.invalidate(),Y}removeUninstalledExtensions(Y){return this.extensionsScanner.cleanUp(Y)}async downloadVsix(Y){if(Y.scheme===k.Schemas.file)return{location:Y,async cleanup(){}};this.logService.trace("Downloading extension from",Y.toString());const ie=(0,S.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(Y,ie),this.logService.info("Downloaded extension to",ie.toString()),{location:ie,cleanup:async()=>{try{await this.fileService.del(ie)}catch(N){this.logService.error(N)}}}}doCreateInstallExtensionTask(Y,ie,L){let N;if(w.URI.isUri(ie))N=new O(Y,ie,L,this.galleryService,this.extensionsScanner,this.logService);else{const q=f.ExtensionKey.create(ie).toString();N=this.installGalleryExtensionsTasks.get(q),N||(this.installGalleryExtensionsTasks.set(q,N=new U(Y,ie,L,this.extensionsDownloader,this.extensionsScanner,this.logService)),N.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(q)))}return L.profileLocation?new B(N,L.profileLocation,this.extensionsProfileScannerService):N}doCreateUninstallExtensionTask(Y,ie){return ie.profileLocation?new ce(Y,ie.profileLocation,this.extensionsProfileScannerService):new X(Y,ie,this.extensionsScanner)}async collectFiles(Y){const ie=async N=>{let q=await h.Promises.readdir(N);q=q.map(ye=>E.join(N,ye));const te=await Promise.all(q.map(ye=>h.Promises.stat(ye)));let fe=Promise.resolve([]);return te.forEach((ye,j)=>{const Z=q[j];ye.isFile()&&(fe=fe.then(ne=>[...ne,Z])),ye.isDirectory()&&(fe=fe.then(ne=>ie(Z).then(z=>[...ne,...z])))}),fe};return(await ie(Y.location.fsPath)).map(N=>({path:`extension/${E.relative(Y.location.fsPath,N)}`,localPath:N}))}};G=Re([_e(0,l.IExtensionGalleryService),_e(1,F.ITelemetryService),_e(2,K.ILogService),_e(3,g.INativeEnvironmentService),_e(4,o.IExtensionsScannerService),_e(5,r.IExtensionsProfileScannerService),_e(6,d.IDownloadService),_e(7,W.IInstantiationService),_e(8,_.IFileService),_e(9,se.IProductService),_e(10,Q.IUriIdentityService),_e(11,re.IUserDataProfilesService)],G),e.ExtensionManagementService=G;let de=class extends C.Disposable{constructor(Y,ie,L,N){super();this.beforeRemovingExtension=Y,this.fileService=ie,this.extensionsScannerService=L,this.logService=N,this.uninstalledPath=(0,S.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new b.Queue}async cleanUp(Y){await this.removeUninstalledExtensions(),Y&&await this.removeOutdatedExtensions()}async scanExtensions(Y,ie){const L={includeInvalid:!0,profileLocation:ie};let N=[];return Y===null||Y===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):Y===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(L)),N=Y!==null?N.filter(q=>q.type===Y):N,Promise.all(N.map(q=>this.toLocalExtension(q)))}async scanUserExtensions(Y){const ie=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(ie.map(L=>this.toLocalExtension(L)))}async extractUserExtension(Y,ie,L,N){const q=Y.toString(),te=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),fe=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await h.Promises.rm(fe)}catch{throw new l.ExtensionManagementError(y.localize(1,null,fe,Y.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(Y,ie,te,N),L={...L,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(w.URI.file(te),L);try{await this.rename(Y,te,fe,Date.now()+2*60*1e3),this.logService.info("Renamed to",fe)}catch(ye){try{await h.Promises.rm(te)}catch{}if(ye.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(ye)}. Deleted from extracted location`,te),ye}return this.scanLocalExtension(w.URI.file(fe),1)}async updateMetadata(Y,ie){return await this.extensionsScannerService.updateMetadata(Y.location,ie),this.scanLocalExtension(Y.location,Y.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...Y){const ie=Y.map(L=>f.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>{ie.forEach(N=>L[N.toString()]=!0)})}async setInstalled(Y){await this.withUninstalledExtensions(N=>delete N[Y.toString()]);const L=(await this.scanUserExtensions(!0)).find(N=>f.ExtensionKey.create(N).equals(Y))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(Y,ie){this.logService.trace(`Deleting ${ie} extension from disk`,Y.identifier.id,Y.location.fsPath),await h.Promises.rm(Y.location.fsPath),this.logService.info("Deleted from disk",Y.identifier.id,Y.location.fsPath)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.withUninstalledExtensions(ie=>delete ie[f.ExtensionKey.create(Y).toString()])}async withUninstalledExtensions(Y){return this.uninstalledFileLimiter.queue(async()=>{let ie;try{ie=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let L={};if(ie)try{L=JSON.parse(ie)}catch{}return Y&&(Y(L),Object.keys(L).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(L)):await h.Promises.rm(this.uninstalledPath)),L})}async extractAtLocation(Y,ie,L,N){this.logService.trace(`Started extracting the extension from ${ie} to ${L}`);try{await h.Promises.rm(L)}catch(q){throw new l.ExtensionManagementError(this.joinErrors(q).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,I.extract)(ie,L,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${L}:`,Y.id)}catch(q){try{await h.Promises.rm(L)}catch{}let te=l.ExtensionManagementErrorCode.Extract;throw q instanceof I.ExtractError&&(q.type==="CorruptZip"?te=l.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&(te=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(q.message,te)}}async rename(Y,ie,L,N){try{await h.Promises.rename(ie,L)}catch(q){if(p.isWindows&&q&&q.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${ie} to ${L} with 'EPERM' error. Trying again...`,Y.id),this.rename(Y,ie,L,N);throw new l.ExtensionManagementError(q.message||y.localize(2,null,ie,L),q.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Y,ie){const L=await this.extensionsScannerService.scanExistingExtension(Y,ie,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(y.localize(3,null,Y.path))}async toLocalExtension(Y){const ie=await this.fileService.resolve(Y.location);let L,N;return ie.children&&(L=ie.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,N=ie.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:L,changelogUrl:N,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated}}async removeUninstalledExtensions(){const Y=await this.getUninstalledExtensions(),ie=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const te of ie)Y[f.ExtensionKey.create(te).toString()]||L.add(te.identifier.id.toLowerCase());const N=(0,f.groupByExtension)(ie,te=>te.identifier);await b.Promises.settled(N.map(async te=>{const fe=te.sort((ye,j)=>T.rcompare(ye.manifest.version,j.manifest.version))[0];L.has(fe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(fe))}));const q=ie.filter(te=>Y[f.ExtensionKey.create(te).toString()]);await b.Promises.settled(q.map(te=>this.removeUninstalledExtension(te)))}async removeOutdatedExtensions(){const Y=await this.extensionsScannerService.scanSystemExtensions({}),ie=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=[],N=await this.extensionsScannerService.getTargetPlatform(),q=(0,f.groupByExtension)(ie,te=>te.identifier);for(const te of q)if(te.length>1&&L.push(...te.sort((fe,ye)=>{const j=T.rcompare(fe.manifest.version,ye.manifest.version);return j!==0?j:fe.targetPlatform===N?-1:1}).slice(1)),te[0].type===0){const fe=Y.find(ye=>(0,f.areSameExtensions)(ye.identifier,te[0].identifier));(!fe||T.gte(fe.manifest.version,te[0].manifest.version))&&L.push(te[0])}await b.Promises.settled(L.map(te=>this.removeExtension(te,"outdated")))}joinErrors(Y){const ie=Array.isArray(Y)?Y:[Y];return ie.length===1?ie[0]instanceof Error?ie[0]:new Error(ie[0]):ie.reduce((L,N)=>new Error(`${L.message}${L.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};de=Re([_e(1,_.IFileService),_e(2,o.IExtensionsScannerService),_e(3,K.ILogService)],de);class J extends u.AbstractExtensionTask{constructor(Y,ie,L,N,q){super();this.identifier=Y,this.source=ie,this.options=L,this.extensionsScanner=N,this.logService=q,this._operation=2}get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(Y,ie){try{const L=await this.unsetUninstalledAndGetLocal(Y.key);if(L)return Y.metadata?this.extensionsScanner.updateMetadata(L,Y.metadata):L}catch{throw p.isMacintosh?new l.ExtensionManagementError(y.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(y.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(Y,ie)}async unsetUninstalledAndGetLocal(Y){if(!await this.isUninstalled(Y))return null;this.logService.trace("Removing the extension from uninstalled list:",Y.id);const L=await this.extensionsScanner.setInstalled(Y);return this.logService.info("Removed the extension from uninstalled list:",Y.id),L}async isUninstalled(Y){return!!(await this.extensionsScanner.getUninstalledExtensions())[Y.toString()]}async extract({zipPath:Y,key:ie,metadata:L},N){const q=await this.extensionsScanner.extractUserExtension(ie,Y,L,N);return this.logService.info("Extracting completed.",ie.id),q}}class U extends J{constructor(Y,ie,L,N,q,te){super(ie.identifier,ie,L,q,te);this.manifest=Y,this.gallery=ie,this.extensionsDownloader=N}async doRun(Y){const L=(await this.extensionsScanner.scanExtensions(null,void 0)).find(te=>(0,f.areSameExtensions)(te.identifier,this.gallery.identifier));L&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,m.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(L,N),metadata:N};const q=await this.downloadExtension(this.gallery,this._operation);try{const te=await this.installExtension({zipPath:q,key:f.ExtensionKey.create(this.gallery),metadata:N},Y);return L&&!this.options.profileLocation&&(L.targetPlatform!==te.targetPlatform||T.neq(L.manifest.version,te.manifest.version))&&await this.extensionsScanner.setUninstalled(L),{local:te,metadata:N}}catch(te){throw await this.deleteDownloadedVSIX(q),te}}async deleteDownloadedVSIX(Y){try{await this.extensionsDownloader.delete(w.URI.file(Y))}catch(ie){this.logService.warn("Error while deleting the downloaded vsix",Y.toString(),(0,D.getErrorMessage)(ie))}}async downloadExtension(Y,ie){let L;try{this.logService.trace("Started downloading extension:",Y.identifier.id),L=(await this.extensionsDownloader.downloadExtension(Y,ie)).fsPath,this.logService.info("Downloaded extension:",Y.identifier.id,L)}catch(N){throw new l.ExtensionManagementError((0,u.joinErrors)(N).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(L),L}catch(N){throw await this.deleteDownloadedVSIX(L),new l.ExtensionManagementError((0,u.joinErrors)(N).message,l.ExtensionManagementErrorCode.Invalid)}}}class O extends J{constructor(Y,ie,L,N,q,te){super({id:(0,f.getGalleryExtensionId)(Y.publisher,Y.name)},ie,L,q,te);this.manifest=Y,this.location=ie,this.galleryService=N}async doRun(Y){const ie=new f.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,void 0)).find(fe=>(0,f.areSameExtensions)(this.identifier,fe.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,Y);if(q.isApplicationScoped=(0,m.isApplicationScopedExtension)(this.manifest),q.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=3,ie.equals(new f.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&T.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const fe=await this.unsetUninstalledAndGetLocal(ie);if(fe)try{await this.extensionsScanner.removeExtension(fe,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:E.resolve(this.location.fsPath),key:ie,metadata:q},Y),metadata:q}}async getMetadata(Y,ie,L){try{let[N]=await this.galleryService.getExtensions([{id:Y,version:ie}],L);if(N||([N]=await this.galleryService.getExtensions([{id:Y}],L)),N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(Y,ie,L){this.task=Y,this.profileLocation=ie,this.extensionsProfileScannerService=L,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const Y=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[Y.local,Y.metadata]],this.profileLocation),Y}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class X extends u.AbstractExtensionTask{constructor(Y,ie,L){super();this.extension=Y,this.options=ie,this.extensionsScanner=L}async doRun(Y){const ie=[],L=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=f.ExtensionKey.create(this.extension);ie.push(...L.filter(q=>N.equals(f.ExtensionKey.create(q))))}else ie.push(...L.filter(N=>(0,f.areSameExtensions)(N.identifier,this.extension.identifier)));if(!ie.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ie),this.options.remove)for(const N of ie)try{Y.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(q){throw new Error(y.localize(9,null,(0,t.toErrorMessage)(q)))}}}class ce extends u.AbstractExtensionTask{constructor(Y,ie,L){super();this.extension=Y,this.profileLocation=ie,this.extensionsProfileScannerService=L}async doRun(Y){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(pe[131],ve([0,1,76,14,16,11,2,12,25,26,77,13,216,272]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends k.Disposable{constructor(y,d,g){super();this.environmentService=d,this.logService=g,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,d){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:g,strictSSL:u}=this;let l;try{l=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const f={...process.env,...l},r=y.agent?y.agent:await(0,w.getProxyAgent)(y.url||"",f,{proxyUrl:g,strictSSL:u});y.agent=r,y.strictSSL=u,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(y,d);return this.logService.trace("RequestService#request (node) - success",y.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",y.url,o),o}}async getNodeRequest(y){return((0,b.parse)(y.url).protocol==="https:"?await new Promise((u,l)=>{oe(["https"],u,l)}):await new Promise((u,l)=>{oe(["http"],u,l)})).request}_request(y,d){return t.Promises.withAsyncBody(async(g,u)=>{const l=(0,b.parse)(y.url),f=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),r={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,E.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(r.auth=y.user+":"+y.password);const o=f(r,n=>{const i=(0,E.isNumber)(y.followRedirects)?y.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...y,url:n.headers.location,followRedirects:i-1},d).then(g,u);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,v.createGunzip)())),g({res:n,stream:(0,D.streamToBufferReadableStream)(s)})}});o.on("error",u),y.timeout&&o.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&o.write(y.data),o.end(),d.onCancellationRequested(()=>{o.abort(),u(new C.CancellationError)})})}async resolveProxy(y){}};h=Re([_e(0,p.IConfigurationService),_e(1,S.INativeEnvironmentService),_e(2,R.ILogService)],h),e.RequestService=h}),define(pe[260],ve([0,1,73,13,59,105,25,54,131,43,32,31,114,130,100,51,2,101,61,10,17,27,103,128,44,107,74,108,11,4,6,28,214,72,39,113,58,3,55,117,37,53,62]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f,r,o,n,i,s,a,c,m,P,_,W,K,se,F,Q,re,G,de,J,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class B extends y.Disposable{constructor(Y,ie){super();this.args=Y,this.remoteDataFolder=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async ie=>{const L=ie.get(t.ILogService),N=ie.get(R.IExtensionManagementCLIService);try{await this.doRun(N)}catch(q){throw L.error(q),console.error((0,c.getErrorMessage)(q)),q}})}async initServices(){const Y=new b.ServiceCollection,ie={_serviceBrand:void 0,...I.default};Y.set(f.IProductService,ie);const L=new n.ServerEnvironmentService(this.args,ie);Y.set(n.IServerEnvironmentService,L);const N=new t.LogService(new r.SpdLogLogger(o.RemoteExtensionLogFileName,(0,P.join)(L.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(L)));Y.set(t.ILogService,N),N.trace(`Remote configuration data at ${this.remoteDataFolder}`),N.trace("process arguments:",this.args);const q=this._register(new d.FileService(N));Y.set(l.IFileService,q),q.registerProvider(u.Schemas.file,this._register(new g.DiskFileSystemProvider(N)));const te=new F.UriIdentityService(q);Y.set(se.IUriIdentityService,te);const fe=this._register(new J.UserDataProfilesService(L,q,te,N));Y.set(J.IUserDataProfilesService,fe);const ye=this._register(new C.ConfigurationService(fe.defaultProfile.settingsResource,q,new O.NullPolicyService,N));return await ye.initialize(),Y.set(k.IConfigurationService,ye),Y.set(E.IRequestService,new D.SyncDescriptor(p.RequestService)),Y.set(K.IDownloadService,new D.SyncDescriptor(W.DownloadService)),Y.set(T.ITelemetryService,S.NullTelemetryService),Y.set(R.IExtensionGalleryService,new D.SyncDescriptor(w.ExtensionGalleryServiceWithNoStorageService)),Y.set(U.IExtensionsProfileScannerService,new D.SyncDescriptor(U.ExtensionsProfileScannerService)),Y.set(G.IExtensionsScannerService,new D.SyncDescriptor(de.ExtensionsScannerService)),Y.set(v.INativeServerExtensionManagementService,new D.SyncDescriptor(v.ExtensionManagementService)),Y.set(R.IExtensionManagementCLIService,new D.SyncDescriptor(i.ExtensionManagementCLIService)),Y.set(s.ILanguagePackService,new D.SyncDescriptor(a.NativeLanguagePackService)),new h.InstantiationService(Y)}async doRun(Y){if(this.args["list-extensions"])return Y.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const ie={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return Y.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],ie,!!this.args.force)}else{if(this.args["uninstall-extension"])return Y.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return Y.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(Y){return Y.map(ie=>/\.vsix$/i.test(ie)?m.URI.file((0,P.isAbsolute)(ie)?ie:(0,P.join)((0,_.cwd)(),ie)):ie)}}function X(ue){setTimeout(()=>process.exit(ue),0)}async function ce(ue,Y,ie){if(ue.help){const N=I.default.serverApplicationName+(re.isWindows?".cmd":"");console.log((0,Q.buildHelpMessage)(I.default.nameLong,N,I.default.version,ie,{noInputFiles:!0,noPipe:!0}));return}if(ue.version){console.log((0,Q.buildVersionMessage)(I.default.version,I.default.commit));return}const L=new B(ue,Y);try{await L.run(),X(0)}catch{X(1)}finally{L.dispose()}}e.run=ce}),define(pe[261],ve([0,1,30,7,2,10,6,91,21,42,25,105,71,209,186,72,187,197,188,26,114,31,107,198,130,17,101,61,59,100,73,74,108,13,102,103,51,27,54,215,131,110,32,43,225,111,232,39,113,253,242,218,223,257,63,44,250,128,258,115,55,117,53,37,62,224]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f,r,o,n,i,s,a,c,m,P,_,W,K,se,F,Q,re,G,de,J,U,O,B,X,ce,ue,Y,ie,L,N,q,te,fe,ye,j,Z,ne,z,V,$,x,le,ge,Pe,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Me="monacoworkbench";async function Be(qe,je,He,Ke){const ae=new P.ServiceCollection,Ce=new we,Te={_serviceBrand:void 0,...Q.default};ae.set(re.IProductService,Te);const Ae=new j.ServerEnvironmentService(je,Te);ae.set(u.IEnvironmentService,Ae),ae.set(u.INativeEnvironmentService,Ae);const Fe=new K.LogService(new F.SpdLogLogger(ne.RemoteExtensionLogFileName,k.join(Ae.logsPath,`${ne.RemoteExtensionLogFileName}.log`),!0,!1,(0,K.getLogLevel)(Ae))),Ue=new K.MultiplexLogService([new Oe((0,K.getLogLevel)(Ae)),Fe]);ae.set(K.ILogService,Ue),setTimeout(()=>We(Ae.logsPath).then(null,st=>Ue.error(st)),1e4),Ue.trace(`Remote configuration data at ${He}`),Ue.trace("process arguments:",Ae.args),Array.isArray(Te.serverGreeting)&&Fe.info(`

${Te.serverGreeting.join(`
`)}

`),Ce.registerChannel(h.ExtensionHostDebugBroadcastChannel.ChannelName,new h.ExtensionHostDebugBroadcastChannel);const xe=new S.StaticRouter(st=>st.clientId==="renderer");Ce.registerChannel("logger",new se.LogLevelChannel(Ue));const Qe=Ke.add(new s.FileService(Ue));ae.set(i.IFileService,Qe),Qe.registerProvider(C.Schemas.file,Ke.add(new a.DiskFileSystemProvider(Ue)));const Ze=new ie.UriIdentityService(Qe);ae.set(Y.IUriIdentityService,Ze);const tt=new ge.UserDataProfilesService(Ae,Qe,Ze,Ue);ae.set(ge.IUserDataProfilesService,tt);const it=new R.ConfigurationService(Ae.machineSettingsResource,Qe,new Pe.NullPolicyService,Ue);ae.set(T.IConfigurationService,it),await it.initialize();const rt=new V.ExtensionHostStatusService;ae.set(V.IExtensionHostStatusService,rt),ae.set(G.IRequestService,new c.SyncDescriptor(J.RequestService));let ft=B.NullAppender;const gt=await(0,E.getMachineId)(),It=(0,B.isInternalTelemetry)(Te,it);if((0,B.supportsTelemetry)(Te,Ae)){Te.aiConfig&&Te.aiConfig.ariaKey&&(ft=new ke.OneDataSystemAppender(It,Me,null,Te.aiConfig.ariaKey),Ke.add((0,D.toDisposable)(()=>ft?.flush())));const st={appenders:[ft],commonProperties:(0,U.resolveCommonProperties)(Qe,(0,b.release)(),(0,b.hostname)(),process.arch,Te.commit,Te.version+"-remote",gt,It,Ae.installSourcePath,"remoteAgent"),piiPaths:(0,B.getPiiPathsFromEnvironment)(Ae)},ut=Ae.args["telemetry-level"];let ht=3;ut==="all"?ht=3:ut==="error"?ht=2:ut==="crash"?ht=1:ut!==void 0&&(ht=0),ae.set(te.IServerTelemetryService,new c.SyncDescriptor(te.ServerTelemetryService,[st,ht]))}else ae.set(te.IServerTelemetryService,te.ServerNullTelemetryService);ae.set(f.IExtensionGalleryService,new c.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const Dt=Ce.getChannel("download",xe);ae.set(I.IDownloadService,new y.DownloadServiceChannelClient(Dt,()=>be("renderer"))),ae.set(le.IExtensionsProfileScannerService,new c.SyncDescriptor(le.ExtensionsProfileScannerService)),ae.set($.IExtensionsScannerService,new c.SyncDescriptor(x.ExtensionsScannerService)),ae.set(n.INativeServerExtensionManagementService,new c.SyncDescriptor(n.ExtensionManagementService));const pt=new m.InstantiationService(ae);ae.set(_.ILanguagePackService,pt.createInstance(W.NativeLanguagePackService));const Pt=pt.createInstance(r.ExtensionManagementCLIService);ae.set(f.IExtensionManagementCLIService,Pt);const yt=pt.createInstance(ue.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:it.getValue("terminal.integrated.persistentSessionScrollback")??100});return ae.set(ce.IPtyService,yt),ae.set(d.IEncryptionMainService,new c.SyncDescriptor(g.EncryptionMainService,[gt])),ae.set(w.ICredentialsMainService,new c.SyncDescriptor(v.CredentialsWebMainService)),pt.invokeFunction(st=>{const ut=st.get(n.INativeServerExtensionManagementService),ht=st.get($.IExtensionsScannerService),At=new L.RemoteAgentEnvironmentChannel(qe,Ae,tt,Pt,Ue,rt,ht);Ce.registerChannel("remoteextensionsenvironment",At);const Ft=new q.ServerTelemetryChannel(st.get(te.IServerTelemetryService),ft);Ce.registerChannel("telemetry",Ft),Ce.registerChannel(Z.REMOTE_TERMINAL_CHANNEL_NAME,new fe.RemoteTerminalChannel(Ae,Ue,yt,Te,ut));const Se=new N.RemoteAgentFileSystemProviderChannel(Ue,Ae);Ce.registerChannel(z.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Se),Ce.registerChannel("request",new de.RequestChannel(st.get(G.IRequestService)));const Ie=new o.ExtensionManagementChannel(ut,De=>be(De.remoteAuthority));Ce.registerChannel("extensions",Ie);const he=S.ProxyChannel.fromService(st.get(d.IEncryptionMainService));Ce.registerChannel("encryption",he);const H=S.ProxyChannel.fromService(st.get(w.ICredentialsMainService));return Ce.registerChannel("credentials",H),ut.removeUninstalledExtensions(!0),Ke.add(new X.default(st.get(O.ITelemetryService))),{telemetryService:st.get(O.ITelemetryService)}}),{socketServer:Ce,instantiationService:pt}}e.setupServerServices=Be;const me=Object.create(null);function be(qe){return me[qe]||(me[qe]=(0,ye.createURITransformer)(qe)),me[qe]}class we extends S.IPCServer{constructor(){const je=new t.Emitter;super(je.event);this._onDidConnectEmitter=je}acceptConnection(je,He){this._onDidConnectEmitter.fire({protocol:je,onDidClientDisconnect:He})}}e.SocketServer=we;class Oe extends K.AbstractLogger{constructor(je=K.DEFAULT_LOG_LEVEL){super();this.setLevel(je),this.useColors=Boolean(process.stdout.isTTY)}trace(je,...He){this.getLevel()<=K.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ne()}][0m`,je,...He):console.log(`[${Ne()}]`,je,...He))}debug(je,...He){this.getLevel()<=K.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ne()}][0m`,je,...He):console.log(`[${Ne()}]`,je,...He))}info(je,...He){this.getLevel()<=K.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ne()}][0m`,je,...He):console.log(`[${Ne()}]`,je,...He))}warn(je,...He){this.getLevel()<=K.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ne()}][0m`,je,...He):console.warn(`[${Ne()}]`,je,...He))}error(je,...He){this.getLevel()<=K.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ne()}][0m`,je,...He):console.error(`[${Ne()}]`,je,...He))}critical(je,...He){this.getLevel()<=K.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ne()}][0m`,je,...He):console.error(`[${Ne()}]`,je,...He))}dispose(){}flush(){}}function Ne(){const qe=new Date;return`${Je(qe.getHours())}:${Je(qe.getMinutes())}:${Je(qe.getSeconds())}`}function Je(qe){return qe<10?`0${qe}`:String(qe)}async function We(qe){const je=k.basename(qe),He=k.dirname(qe),Ce=(await p.Promises.readdir(He)).filter(Ae=>/^\d{8}T\d{6}$/.test(Ae)).sort().filter(Ae=>Ae!==je),Te=Ce.slice(0,Math.max(0,Ce.length-9));await Promise.all(Te.map(Ae=>p.Promises.rm(k.join(He,Ae))))}}),define(pe[262],ve([0,1,109,29,85,263,76,132,16,11,35,2,10,6,47,3,15,4,23,139,95,57,5,13,27,75,32,126,237,238,44,261,240]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w,v,h,I,y,d,g,u,l,f,r,o,n,i,s,a,c,m,P,_,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const K=5*60*1e3;let se=class extends R.Disposable{constructor(G,de,J,U,O,B,X,ce){super();this._socketServer=G,this._connectionToken=de,this._vsdaMod=J,this._environmentService=O,this._productService=B,this._logService=X,this._instantiationService=ce,this._webEndpointOriginChecker=Q.create(this._productService),this._serverRootPath=(0,i.getRemoteServerRootPath)(B),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=U?this._instantiationService.createInstance(W.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(G,de){if(G.method!=="GET")return(0,W.serveError)(G,de,405,`Unsupported method ${G.method}`);if(!G.url)return(0,W.serveError)(G,de,400,"Bad request.");const J=k.parse(G.url,!0);let U=J.pathname;if(!U)return(0,W.serveError)(G,de,400,"Bad request.");if(U.startsWith(this._serverRootPath)&&U.charCodeAt(this._serverRootPath.length)===47&&(U=U.substring(this._serverRootPath.length)),U==="/version")return de.writeHead(200,{"Content-Type":"text/plain"}),de.end(this._productService.commit||"");if(U==="/delay-shutdown")return this._delayShutdown(),de.writeHead(200),de.end("OK");if(!(0,m.requestHasValidConnectionToken)(this._connectionToken,G,J))return(0,W.serveError)(G,de,403,"Forbidden.");if(U==="/vscode-remote-resource"){const O=J.query.path;if(typeof O!="string")return(0,W.serveError)(G,de,400,"Bad request.");let B;try{B=d.URI.from({scheme:w.Schemas.file,path:O}).fsPath}catch{return(0,W.serveError)(G,de,400,"Bad request.")}const X=Object.create(null);this._environmentService.isBuilt&&((0,T.isEqualOrParent)(B,this._environmentService.builtinExtensionsPath,!I.isLinux)||(0,T.isEqualOrParent)(B,this._environmentService.extensionsPath,!I.isLinux))&&(X["Cache-Control"]="public, max-age=31536000"),X.Vary="Origin";const ce=G.headers.origin;return ce&&this._webEndpointOriginChecker.matches(ce)&&(X["Access-Control-Allow-Origin"]=ce),(0,W.serveFile)(B,1,this._logService,G,de,X)}if(this._webClientServer){this._webClientServer.handle(G,de,J);return}return de.writeHead(404,{"Content-Type":"text/plain"}),de.end("Not found")}handleUpgrade(G,de){let J=(0,g.generateUuid)(),U=!1,O=!1;if(G.url){const ie=k.parse(G.url,!0).query;typeof ie.reconnectionToken=="string"&&(J=ie.reconnectionToken),ie.reconnection==="true"&&(U=!0),ie.skipWebSocketFrames==="true"&&(O=!0)}if(G.headers.upgrade===void 0||G.headers.upgrade.toLowerCase()!=="websocket"){de.end("HTTP/1.1 400 Bad Request");return}const B=G.headers["sec-websocket-key"],X=b.createHash("sha1");X.update(B+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ce=X.digest("base64"),ue=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ce}`];let Y=!1;if(!O&&!this._environmentService.args["disable-websocket-compression"]&&G.headers["sec-websocket-extensions"]){const ie=Array.isArray(G.headers["sec-websocket-extensions"])?G.headers["sec-websocket-extensions"]:[G.headers["sec-websocket-extensions"]];for(const L of ie)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(L)){if(/\b(permessage-deflate)\b/.test(L)){Y=!0,ue.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(L)){Y=!0,ue.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}de.write(ue.join(`\r
`)+`\r
\r
`),de.setTimeout(0),de.setNoDelay(!0),O?this._handleWebSocketConnection(new f.NodeSocket(de,`server-connection-${J}`),U,J):this._handleWebSocketConnection(new f.WebSocketNodeSocket(new f.NodeSocket(de,`server-connection-${J}`),Y,null,!0),U,J)}handleServerError(G){this._logService.error("Error occurred in server"),this._logService.error(G)}_getRemoteAddress(G){let de;return G instanceof f.NodeSocket?de=G.socket:de=G.socket.socket,de.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(G,de,J){const U=de.getSocket();this._logService.error(`${G} ${J}.`);const O={type:"error",reason:J};de.sendControl(p.VSBuffer.fromString(JSON.stringify(O))),de.dispose(),await U.drain(),U.dispose()}_handleWebSocketConnection(G,de,J){const U=this._getRemoteAddress(G),O=`[${U}][${J.substr(0,8)}]`,B=new l.PersistentProtocol(G),X=this._vsdaMod?new this._vsdaMod.validator:null,ce=this._vsdaMod?new this._vsdaMod.signer:null;let ue;(function(N){N[N.WaitingForAuth=0]="WaitingForAuth",N[N.WaitingForConnectionType=1]="WaitingForConnectionType",N[N.Done=2]="Done",N[N.Error=3]="Error"})(ue||(ue={}));let Y=0;const ie=N=>{Y=3,L.dispose(),this._rejectWebSocketConnection(O,B,N)},L=B.onControlMessage(N=>{if(Y===0){let q;try{q=JSON.parse(N.toString())}catch{return ie("Malformed first message")}if(q.type!=="auth")return ie("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(q.auth))return ie("Unauthorized client refused: auth mismatch");let te=(0,g.generateUuid)();if(ce)try{te=ce.sign(q.data)}catch{}let fe=(0,g.generateUuid)();if(X)try{fe=X.createNewMessage(fe)}catch{}const ye={type:"sign",data:fe,signedData:te};B.sendControl(p.VSBuffer.fromString(JSON.stringify(ye))),Y=1}else if(Y===1){let q;try{q=JSON.parse(N.toString())}catch{return ie("Malformed second message")}if(q.type!=="connectionType")return ie("Invalid second message");if(typeof q.signedData!="string")return ie("Invalid second message field type");const te=q.commit,fe=this._productService.commit;if(te&&fe&&te!==fe)return ie("Client refused: version mismatch");let ye=!1;if(!X)ye=!0;else if(this._connectionToken.validate(q.signedData))ye=!0;else try{ye=X.validate(q.signedData)==="ok"}catch{}if(!ye){if(this._environmentService.isBuilt)return ie("Unauthorized client refused");this._logService.error(`${O} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const j in this._managementConnections)this._managementConnections[j].shortenReconnectionGraceTimeIfNecessary();for(const j in this._extHostConnections)this._extHostConnections[j].shortenReconnectionGraceTimeIfNecessary();Y=2,L.dispose(),this._handleConnectionType(U,O,B,G,de,J,q)}})}async _handleConnectionType(G,de,J,U,O,B,X){const ce=X.desiredConnectionType===1?`${de}[ManagementConnection]`:X.desiredConnectionType===2?`${de}[ExtensionHostConnection]`:de;if(X.desiredConnectionType===1)if(O){if(!this._managementConnections[B])return this._allReconnectionTokens.has(B)?this._rejectWebSocketConnection(ce,J,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ce,J,"Unknown reconnection token (never seen)");J.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ue=J.readEntireBuffer();J.dispose(),this._managementConnections[B].acceptReconnection(G,U,ue)}else{if(this._managementConnections[B])return this._rejectWebSocketConnection(ce,J,"Duplicate reconnection token");J.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ue=new c.ManagementConnection(this._logService,B,G,J);this._socketServer.acceptConnection(ue.protocol,ue.onClose),this._managementConnections[B]=ue,this._allReconnectionTokens.add(B),ue.onClose(()=>{delete this._managementConnections[B]})}else if(X.desiredConnectionType===2){const ue=X.args||{language:"en"},Y=await this._updateWithFreeDebugPort(ue);if(Y.port&&this._logService.trace(`${ce} - startParams debug port ${Y.port}`),this._logService.trace(`${ce} - startParams language: ${Y.language}`),this._logService.trace(`${ce} - startParams env: ${JSON.stringify(Y.env)}`),O){if(!this._extHostConnections[B])return this._allReconnectionTokens.has(B)?this._rejectWebSocketConnection(ce,J,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ce,J,"Unknown reconnection token (never seen)");J.sendPause(),J.sendControl(p.VSBuffer.fromString(JSON.stringify(Y.port?{debugPort:Y.port}:{})));const ie=J.readEntireBuffer();J.dispose(),this._extHostConnections[B].acceptReconnection(G,U,ie)}else{if(this._extHostConnections[B])return this._rejectWebSocketConnection(ce,J,"Duplicate reconnection token");J.sendPause(),J.sendControl(p.VSBuffer.fromString(JSON.stringify(Y.port?{debugPort:Y.port}:{})));const ie=J.readEntireBuffer();J.dispose();const L=this._instantiationService.createInstance(a.ExtensionHostConnection,B,G,U,ie);this._extHostConnections[B]=L,this._allReconnectionTokens.add(B),L.onClose(()=>{delete this._extHostConnections[B],this._onDidCloseExtHostConnection()}),L.start(Y)}}else if(X.desiredConnectionType===3){const ue=X.args;this._createTunnel(J,ue)}else return this._rejectWebSocketConnection(ce,J,"Unknown initial data received")}async _createTunnel(G,de){const J=G.getSocket().socket,U=G.readEntireBuffer();G.dispose(),J.pause();const O=await this._connectTunnelSocket(de.host,de.port);U.byteLength>0&&O.write(U.buffer),O.on("end",()=>J.end()),O.on("close",()=>J.end()),O.on("error",()=>J.destroy()),J.on("end",()=>O.end()),J.on("close",()=>O.end()),J.on("error",()=>O.destroy()),O.pipe(J),J.pipe(O)}_connectTunnelSocket(G,de){return new Promise((J,U)=>{const O=D.createConnection({host:G,port:de},()=>{O.removeListener("error",U),O.pause(),J(O)});O.once("error",U)})}_updateWithFreeDebugPort(G){return typeof G.port=="number"?(0,u.findFreePort)(G.port,10,5e3).then(de=>(G.port=de,G)):(G.debugId=void 0,G.port=void 0,G.break=void 0,Promise.resolve(G))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},K))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};se=Re([_e(4,P.IServerEnvironmentService),_e(5,n.IProductService),_e(6,o.ILogService),_e(7,r.IInstantiationService)],se),e.RemoteExtensionHostAgentServer=se;async function F(re,G,de){const J=await(0,m.determineServerConnectionToken)(G);J instanceof m.ServerConnectionTokenParseError&&(console.warn(J.message),process.exit(1));const U=new R.DisposableStore,{socketServer:O,instantiationService:B}=await(0,_.setupServerServices)(J,G,de,U);B.invokeFunction(q=>{const te=q.get(o.ILogService);(0,S.setUnexpectedErrorHandler)(fe=>{fe&&fe.code==="EPIPE"&&fe.syscall==="write"&&fe.stack&&/unexpectedErrorHandler/.test(fe.stack)||te.error(fe)}),process.on("SIGPIPE",()=>{(0,S.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),B.invokeFunction(q=>{const te=q.get(o.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const fe=(0,v.join)(process.env.HOMEDRIVE,"node_modules"),ye=(0,v.dirname)((0,v.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),j=(0,v.join)(ye,"node_modules");if(t.existsSync(fe)||t.existsSync(j)){const Z=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${fe}
* ${j}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;te.warn(Z),console.warn(Z),process.exit(0)}}});const X=B.invokeFunction(q=>{const te=q.get(o.ILogService);if(t.existsSync((0,v.join)(w.FileAccess.asFileUri("",oe).fsPath,"../node_modules/vsda")))try{return oe.__$__nodeRequire("vsda")}catch(ye){te.error(ye)}return null}),ce=t.existsSync(w.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",oe).fsPath);if(ce&&re&&typeof re!="string"){const q=J.type!==0?`?${w.connectionTokenQueryName}=${J.value}`:"";console.log(`Web UI available at http://localhost${re.port===80?"":`:${re.port}`}/${q}`)}const ue=B.createInstance(se,O,J,X,ce);h.mark("code/server/ready");const Y=C.performance.now(),ie=global.vscodeServerStartTime,L=global.vscodeServerListenTime,N=global.vscodeServerCodeLoadedTime;if(B.invokeFunction(q=>{q.get(s.ITelemetryService).publicLog2("serverStart",{startTime:ie,startedTime:L,codeLoadedTime:N,readyTime:Y})}),G["print-startup-performance"]){const q=E.LoaderStats.get();let te="";te+=`

### Load AMD-module
`,te+=E.LoaderStats.toMarkdownTable(["Module","Duration"],q.amdLoad),te+=`

### Load commonjs-module
`,te+=E.LoaderStats.toMarkdownTable(["Module","Duration"],q.nodeRequire),te+=`

### Invoke AMD-module factory
`,te+=E.LoaderStats.toMarkdownTable(["Module","Duration"],q.amdInvoke),te+=`

### Invoke commonjs-module
`,te+=E.LoaderStats.toMarkdownTable(["Module","Duration"],q.nodeEval),te+=`Start-up time: ${L-ie}
`,te+=`Code loading time: ${N-ie}
`,te+=`Initialized time: ${Y-ie}
`,te+=`
`,console.log(te)}return ue}e.createServer=F;class Q{constructor(G){this._originRegExp=G}static create(G){const de=G.webEndpointUrlTemplate,J=G.commit,U=G.quality;if(!de||!J||!U)return new Q(null);const O=(0,g.generateUuid)(),X=new URL(de.replace("{{uuid}}",O).replace("{{commit}}",J).replace("{{quality}}",U)).origin,ce=(0,y.escapeRegExpCharacters)(X).replace(O,"[a-zA-Z0-9\\-]+");try{const ue=(0,y.createRegExp)(`^${ce}$`,!0,{matchCase:!1});return new Q(ue)}catch{return new Q(null)}}matches(G){return this._originRegExp?this._originRegExp.test(G):!1}}}),define(pe[273],ve([0,1,30,29,10,260,262,58,6,263,44,51,47]),function(oe,e,b,t,D,C,k,E,p,S,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=S.performance.now();const v={onMultipleValues:(i,s)=>{console.error(`Option '${i}' can only be defined once. Using value ${s}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,s)=>{console.warn(`Option '${i}' is deprecated: ${s}`)}},h=(0,E.parseArgs)(process.argv.slice(2),T.serverOptions,v),I=h["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.join)(b.homedir(),R.default.serverDataFolderName||".vscode-remote"),y=(0,p.join)(I,"data"),d=(0,p.join)(y,"User"),g=(0,p.join)(d,"globalStorage"),u=(0,p.join)(d,"History"),l=(0,p.join)(y,"Machine");h["user-data-dir"]=y;const f=(0,p.dirname)(D.FileAccess.asFileUri("",oe).fsPath),r=(0,p.join)(f,"extensions");h["builtin-extensions-dir"]=r,h["extensions-dir"]=h["extensions-dir"]||(0,p.join)(I,"extensions"),[I,h["extensions-dir"],y,d,l,g,u].forEach(i=>{try{t.existsSync(i)||t.mkdirSync(i,{mode:448})}catch(s){console.error(s)}});function o(){(0,C.run)(h,I,T.serverOptions)}e.spawnCli=o;function n(i){return(0,k.createServer)(i,h,I)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/784b0177c56c607789f9638da7b6bf3230d47a8c/core/vs/server/node/server.main.js.map
